Package: HSAUR3
Title: A Handbook of Statistical Analyses Using R (3rd Edition)
Date: 2024-08-17
Version: 1.0-15
Authors@R: c(person("Torsten", "Hothorn", role = c("aut", "cre"),
                 email = "Torsten.Hothorn@R-project.org", comment = c(ORCID = "0000-0001-8301-0471")),
          person(given = c("Brian", "S."),
                 family = "Everitt",
                 role = "aut"))
Maintainer: Torsten Hothorn <Torsten.Hothorn@R-project.org>
Description: Functions, data sets, analyses and examples from the 
  third edition of the book 
  ''A Handbook of Statistical Analyses Using R'' (Torsten Hothorn and Brian S.
  Everitt, Chapman & Hall/CRC, 2014). The first chapter
  of the book, which is entitled ''An Introduction to R'', 
  is completely included in this package, for all other chapters,
  a vignette containing all data analyses is available. In addition,
  Sweave source code for slides of selected chapters is included in 
  this package (see HSAUR3/inst/slides). The publishers web page is 
  '<https://www.routledge.com/A-Handbook-of-Statistical-Analyses-using-R/Hothorn-Everitt/p/book/9781482204582>'.
Depends: R (>= 3.0.0)
Suggests: boot (>= 1.3-9), lattice (>= 0.20-23), MASS (>= 7.3-29), mgcv
        (>= 1.7-27), rpart (>= 4.1-4), survival (>= 2.37-4), ape (>=
        3.0-11), coin (>= 1.1-3), flexmix (>= 2.3-11), Formula (>=
        1.1-1), gamair (>= 0.0.8), gamlss.data (>= 4.2.6), gee (>=
        4.13-18), KernSmooth (>= 2.23-10), lme4 (>= 1.0-5), maps (>=
        2.3-6), mboost (>= 2.2-3), mclust (>= 4.2), mlbench (>= 2.1-1),
        mice (>= 2.18), multcomp (>= 1.3-1), mvtnorm (>= 0.9-9996),
        partykit (>= 0.8-0), quantreg (>= 5.05), randomForest (>=
        4.6-7), rmeta (>= 2.16), sandwich (>= 2.3-0), scatterplot3d (>=
        0.3-34), sf (>= 1.0-9), sp (>= 1.0-14), TH.data (>= 1.0-2),
        tools, vcd (>= 1.3-1), wordcloud (>= 2.4), HSAUR2
LazyData: yes
License: GPL-2
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2024-08-17 16:31:15 UTC; hothorn
Author: Torsten Hothorn [aut, cre] (<https://orcid.org/0000-0001-8301-0471>),
  Brian S. Everitt [aut]
Repository: CRAN
Date/Publication: 2024-08-17 17:30:01 UTC
Built: R 4.6.0; ; 2026-04-25 17:11:29 UTC; unix

Package: HSAUR3
Title: A Handbook of Statistical Analyses Using R (3rd Edition)
Date: 2024-08-17
Version: 1.0-15
Authors@R: c(person("Torsten", "Hothorn", role = c("aut", "cre"),
                 email = "Torsten.Hothorn@R-project.org", comment = c(ORCID = "0000-0001-8301-0471")),
          person(given = c("Brian", "S."),
                 family = "Everitt",
                 role = "aut"))
Maintainer: Torsten Hothorn <Torsten.Hothorn@R-project.org>
Description: Functions, data sets, analyses and examples from the 
  third edition of the book 
  ''A Handbook of Statistical Analyses Using R'' (Torsten Hothorn and Brian S.
  Everitt, Chapman & Hall/CRC, 2014). The first chapter
  of the book, which is entitled ''An Introduction to R'', 
  is completely included in this package, for all other chapters,
  a vignette containing all data analyses is available. In addition,
  Sweave source code for slides of selected chapters is included in 
  this package (see HSAUR3/inst/slides). The publishers web page is 
  '<https://www.routledge.com/A-Handbook-of-Statistical-Analyses-using-R/Hothorn-Everitt/p/book/9781482204582>'.
Depends: R (>= 3.0.0)
Suggests: boot (>= 1.3-9), lattice (>= 0.20-23), MASS (>= 7.3-29), mgcv
        (>= 1.7-27), rpart (>= 4.1-4), survival (>= 2.37-4), ape (>=
        3.0-11), coin (>= 1.1-3), flexmix (>= 2.3-11), Formula (>=
        1.1-1), gamair (>= 0.0.8), gamlss.data (>= 4.2.6), gee (>=
        4.13-18), KernSmooth (>= 2.23-10), lme4 (>= 1.0-5), maps (>=
        2.3-6), mboost (>= 2.2-3), mclust (>= 4.2), mlbench (>= 2.1-1),
        mice (>= 2.18), multcomp (>= 1.3-1), mvtnorm (>= 0.9-9996),
        partykit (>= 0.8-0), quantreg (>= 5.05), randomForest (>=
        4.6-7), rmeta (>= 2.16), sandwich (>= 2.3-0), scatterplot3d (>=
        0.3-34), sf (>= 1.0-9), sp (>= 1.0-14), TH.data (>= 1.0-2),
        tools, vcd (>= 1.3-1), wordcloud (>= 2.4), HSAUR2
LazyData: yes
License: GPL-2
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2024-08-17 16:31:15 UTC; hothorn
Author: Torsten Hothorn [aut, cre] (<https://orcid.org/0000-0001-8301-0471>),
  Brian S. Everitt [aut]
Repository: CRAN
Date/Publication: 2024-08-17 17:30:01 UTC

rm(list = ls())
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", width = 55, # digits = 4,
    SweaveHooks = list(leftpar = function()
        par(mai = par("mai") * c(1, 1.05, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)

### R code from vignette source 'Ch_gam.Rnw'

###################################################
### code chunk number 1: setup
###################################################
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })


###################################################
### code chunk number 2: singlebook
###################################################
book <- FALSE


###################################################
### code chunk number 3: packages
###################################################
library("mgcv")
library("mboost")
library("rpart")
library("wordcloud")


###################################################
### code chunk number 4: GAM-men1500m-plot
###################################################
plot(time ~ year, data = men1500m, xlab = "Year",
     ylab = "Winning time (sec)")


###################################################
### code chunk number 5: GAM-men1500m-lm
###################################################
men1500m1900 <- subset(men1500m, year >= 1900)
men1500m_lm <- lm(time ~ year, data = men1500m1900)
plot(time ~ year, data = men1500m1900, xlab = "Year",
     ylab = "Winning time (sec)")
abline(men1500m_lm)


###################################################
### code chunk number 6: GAM-men1500m-smooth
###################################################
x <- men1500m1900$year
y <- men1500m1900$time
men1500m_lowess <- lowess(x, y)
plot(time ~ year, data = men1500m1900, xlab = "Year",
     ylab = "Winning time (sec)")
lines(men1500m_lowess, lty = 2)
men1500m_cubic <- gam(y ~ s(x, bs = "cr"))
lines(x, predict(men1500m_cubic), lty = 3)


###################################################
### code chunk number 7: GAM-men1500m-quad
###################################################
men1500m_lm2 <- lm(time ~ year + I(year^2), 
                   data = men1500m1900)
plot(time ~ year, data = men1500m1900, xlab = "Year",
     ylab = "Winning time (sec)")
lines(men1500m1900$year, predict(men1500m_lm2))


###################################################
### code chunk number 8: GAM-men1500m-pred
###################################################
predict(men1500m_lm, 
        newdata = data.frame(year = c(2008, 2012)), 
        interval = "confidence")
predict(men1500m_lm2, 
        newdata = data.frame(year = c(2008, 2012)), 
        interval = "confidence")


###################################################
### code chunk number 9: GAM-USairpollution-boost
###################################################
library("mboost")
USair_boost <- gamboost(SO2 ~ ., data = USairpollution)
USair_aic <- AIC(USair_boost)
USair_aic


###################################################
### code chunk number 10: GAM-USairpollution-boostplot
###################################################
USair_gam <- USair_boost[mstop(USair_aic)]
layout(matrix(1:6, ncol = 3))
plot(USair_gam, ask = FALSE)


###################################################
### code chunk number 11: GAM-USairpollution-residplot
###################################################
SO2hat <- predict(USair_gam)
SO2 <- USairpollution$SO2
plot(SO2hat, SO2 - SO2hat, type = "n",         
     xlim = c(-20, max(SO2hat) * 1.1),
     ylim = range(SO2 - SO2hat) * c(2, 1))
textplot(SO2hat, SO2 - SO2hat, rownames(USairpollution), 
         show.lines = FALSE, new = FALSE)
abline(h = 0, lty = 2, col = "grey")


###################################################
### code chunk number 12: GAM-kyphosis-plot
###################################################
layout(matrix(1:3, nrow = 1))
spineplot(Kyphosis ~ Age, data = kyphosis, 
          ylevels = c("present", "absent"))
spineplot(Kyphosis ~ Number, data = kyphosis, 
          ylevels = c("present", "absent"))
spineplot(Kyphosis ~ Start, data = kyphosis, 
         ylevels = c("present", "absent"))


###################################################
### code chunk number 13: GAM-kyphosis-gam
###################################################
(kyphosis_gam <- gam(Kyphosis ~ s(Age, bs = "cr") + 
    s(Number, bs = "cr", k = 3) + s(Start, bs = "cr", k = 3),
    family = binomial, data = kyphosis))


###################################################
### code chunk number 14: GAM-kyphosis-gamplot
###################################################
trans <- function(x) 
    binomial()$linkinv(x)
layout(matrix(1:3, nrow = 1))
plot(kyphosis_gam, select = 1, shade = TRUE, trans = trans)
plot(kyphosis_gam, select = 2, shade = TRUE, trans = trans)
plot(kyphosis_gam, select = 3, shade = TRUE, trans = trans)


###################################################
### code chunk number 15: GAM-womensrole-gam
###################################################
data("womensrole", package = "HSAUR3")
fm1 <- cbind(agree, disagree) ~ s(education, by = gender)
womensrole_gam <- gam(fm1, data = womensrole, 
                      family = binomial())


###################################################
### code chunk number 16: GAM-womensrole-gamplot
###################################################
layout(matrix(1:2, nrow = 1))
plot(womensrole_gam, select = 1, shade = TRUE)
plot(womensrole_gam, select = 1, shade = TRUE)


###################################################
### code chunk number 17: GAM-plot-setup
###################################################
myplot <- function(role.fitted)  {    
    f <- womensrole$gender == "Female"
    plot(womensrole$education, role.fitted, type = "n",
         ylab = "Probability of agreeing",
         xlab = "Education", ylim = c(0,1))
    lines(womensrole$education[!f], role.fitted[!f], lty = 1)
    lines(womensrole$education[f], role.fitted[f], lty = 2)
    lgtxt <- c("Fitted (Males)", "Fitted (Females)")
    legend("topright", lgtxt, lty = 1:2, bty = "n")
    y <-  womensrole$agree / (womensrole$agree +
                              womensrole$disagree)
    size <- womensrole$agree + womensrole$disagree
    size <- size - min(size)
    size <- (size / max(size)) * 3 + 1
    text(womensrole$education, y, ifelse(f, "\\VE", "\\MA"),
         family = "HersheySerif", cex = size)
} 


###################################################
### code chunk number 18: GAM-womensrole-probplot
###################################################
myplot(predict(womensrole_gam, type = "response"))

### R code from vignette source 'Ch_multidimensional_scaling.Rnw'

###################################################
### code chunk number 1: setup
###################################################
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })


###################################################
### code chunk number 2: singlebook
###################################################
book <- FALSE


###################################################
### code chunk number 3: MDS-setup
###################################################
x <- library("ape")
library("wordcloud")


###################################################
### code chunk number 4: MDS-voles-cmdscale
###################################################
data("watervoles", package = "HSAUR3")
voles_mds <- cmdscale(watervoles, k = 13, eig = TRUE)
voles_mds$eig


###################################################
### code chunk number 5: MDS-voles-criterion1
###################################################
sum(abs(voles_mds$eig[1:2]))/sum(abs(voles_mds$eig)) 


###################################################
### code chunk number 6: MDS-voles-criterion2
###################################################
sum((voles_mds$eig[1:2])^2)/sum((voles_mds$eig)^2)


###################################################
### code chunk number 7: MDS-watervoles-plot
###################################################
x <- voles_mds$points[,1]
y <- voles_mds$points[,2]
plot(x, y, xlab = "Coordinate 1", ylab = "Coordinate 2",
     xlim = range(x)*1.2, type = "n")
textplot(x, y, words = colnames(watervoles), new = FALSE)


###################################################
### code chunk number 8: MDS-watervoles-mst
###################################################
library("ape")
st <- mst(watervoles)
plot(x, y, xlab = "Coordinate 1", ylab = "Coordinate 2",
     xlim = range(x)*1.2, type = "n")
for (i in 1:nrow(watervoles)) {
    w1 <- which(st[i, ] == 1)
    segments(x[i], y[i], x[w1], y[w1])
}
textplot(x, y, words = colnames(watervoles), new = FALSE)


###################################################
### code chunk number 9: MDS-voting
###################################################
library("MASS")
data("voting", package = "HSAUR3")
voting_mds <- isoMDS(voting)


###################################################
### code chunk number 10: MDS-voting-plot
###################################################
x <- voting_mds$points[,1]
y <- voting_mds$points[,2]
plot(x, y, xlab = "Coordinate 1", ylab = "Coordinate 2",
     xlim = range(voting_mds$points[,1])*1.2, type = "n")
textplot(x, y, words = colnames(voting), new = FALSE)
voting_sh <- Shepard(voting[lower.tri(voting)], 
                     voting_mds$points)


###################################################
### code chunk number 11: MDS-voting-Shepard
###################################################
plot(voting_sh, pch = ".", xlab = "Dissimilarity", 
     ylab = "Distance", xlim = range(voting_sh$x), 
     ylim = range(voting_sh$x))
lines(voting_sh$x, voting_sh$yf, type = "S")

### some tools that make life easier

### copy *Rout to *Rout.save
cpRoutsave <- function(Routdir = NULL, Routsavedir = NULL) {

    Routfiles <- list.files(path = Routdir, pattern = "\\.Rout$", 
                            full.names = FALSE)
    srcfiles <- file.path(Routdir, Routfiles)
    destfiles <- file.path(Routsavedir, 
                           paste(Routfiles, ".save", sep = ""))
    file.copy(srcfiles, destfiles, overwrite = TRUE)
}

### attach all data frames in the global environment
gattach <- function() {

    env <- globalenv()
    var <- eval(parse(text = "ls()"), envir = env)
    df <- sapply(var, function(x)
        eval(parse(text = 
            paste("is.data.frame(", x, ")", sep = "", collapse = "")), 
            envir = env))
    if (any(df)) {
      var <- var[df]
      out <- sapply(var, function(x) 
          eval(parse(text = 
              paste("attach(", x, ")", sep = "", collapse = "")),
              envir = env))
    }
}


### extract and check Robject or Rcmd LaTeX markup
extRact <- function(file, what = "Robject") {

    x <- readLines(file)
    indx <- grep(what, x)
    
    out <- sapply(indx, function(i) {
        obj <- NULL
        while (TRUE) {
            where <- regexpr(what, x[i])
            if (where != -1) {
                x[i] <- substring(x[i], where)
                dm <- delimMatch(x[i])
                obj <- c(obj, (substring(x[i], dm + 1, 
                         dm + attr(dm, "match.length") - 2)))
                x[i] <- substring(x[i], dm + attr(dm, "match.length"))
            } else {
                break
            }
        }
        return(obj)
    })
    cmds <- unique(gsub("\\\\", "", out))
    gattach()
    for (cmd in cmds) {
        a <- try(eval(parse(text = cmd)))
        if (inherits(a, "try-error")) print(a)
    }
    cmds
}

### try to polish S{in,out}put environments, this needs
### manual refinements in some places
prettyS <- function(file, texenvironment = c("Sinput", "Soutput"), 
                    width = 63, split = " ", write = TRUE) {

    ### handle Sinput or Soutput environments
    texenvironment <- match.arg(texenvironment)
    if (texenvironment == "Sinput" && split == " ")
        split <- c(", ", "/", " ")

    ### dirty hack: in `Makefile's I want to call `prettyS'
    ### right after weaving and thus have only `file.Rnw' available
    if (length(grep("Rnw$", file)) > 0) file <- gsub("Rnw$", "tex", file)

    ### read file
    x <- readLines(file)

    ### remove all end-line spaces
    x <- gsub("\\s+$", "", x)

    ### determine begin and end lines of environment
    start <- grep(paste("^\\\\begin\\{", texenvironment, "\\}$", 
                  sep = "", collapse = ""), x)
    end <- grep(paste("^\\\\end\\{", texenvironment, "\\}$", 
                  sep = "", collapse = ""), x)
    if (length(start) == 0) return(NULL)
    if (length(start) != length(end)) 
        stop("unbalanced begin and end statements")
    n <- length(start)

    for (i in 1:n) {
  
        ### iterate over all lines longer than width
        lines <- (start[i]):(end[i])
        lines <- lines[sapply(x[lines], nchar) > width]
        for (line in lines) {
            cat("prettyS: line ", line, " too long: \n", x[line], "\n")
            y <- x[line]
            add <- sapply(split, function(s) 
                ifelse(length(grep(s, y)) > 0, nchar(s), 0))
            if (all(add == 0)) next()
            s <- split[min(which(add > 0))]
            y <- unlist(strsplit(y, split = s))
            nc <- sapply(y, nchar) + add[min(which(add > 0))]
            pos <- cumsum(nc) <= width
            if (!any(pos)) next()
            newline <- cumsum(nc)[max(which(pos))]
            plus <- length(grep("^\\+", x[line])) > 0 && 
                    substr(x[line], newline - 1, newline) != ", "
            x[line] <- paste(substr(x[line], 1, newline), "\n",
                ifelse(texenvironment == "Sinput", options("continue"), ""),
                ifelse(plus, "    ", ""),
                "    ",
                substr(x[line], newline + 1, nchar(x[line])), sep = "", 
                collapse = "")
#            if (length(grep("^\\+", x[line + 1])) > 0 && 
#                (nchar(x[line + 1]) + (nchar(x[line]) - newline) < width)) {
#                y <- x[line + 1]
#                y <- gsub("^\\+   ", "", y)
#                x[line] <- paste(x[line], y, sep = "", collapse = "")
#                x[line + 1] <- ""
#            }
             cat("prettyS: ", x[line], "\n")
        }
    }
    if (write)
        writeLines(x, con = file)
}

### extract all Sinput environments from tex files
chkS <- function(file, texenvironment = "Sinput") {

    ### read file
    x <- readLines(file)

    ### determine begin and end lines of environment
    start <- grep(paste("^\\\\begin\\{", texenvironment, "\\}$", 
                  sep = "", collapse = ""), x)
    end <- grep(paste("^\\\\end\\{", texenvironment, "\\}$", 
                  sep = "", collapse = ""), x)
    if (length(start) == 0) return(NULL)
    if (length(start) != length(end)) 
        stop("unbalanced begin and end statements")
    n <- length(start)

    y <- NULL

    for (i in 1:n) {
  
        ### iterate over all lines longer than width
        lines <- (start[i] + 1):(end[i] - 1)
        x[lines] <- gsub("^R>", "", x[lines])
        x[lines] <- gsub("^\\+", "", x[lines])
        y <- c(y, x[lines])

    }
    y
}


### read in a BibTeX file and return as list
readBibtex <- function(file = NULL) {

    bib <- readLines(file)

    entries <- grep("^@", bib)
    labels <- gsub(",$", "", gsub("^@[A-Za-z].*\\{", "", bib[entries]))

    if (any(duplicated(labels))) {
        print(labels[duplicated(labels)])
        stop("non-unique BibTeX labels in ", file)
    }

    biblist <- vector(mode = "list", length = length(entries))

    for (i in 1:length(entries)) {
        nexte <- ifelse(i == length(entries), length(entries), 
                        entries[i + 1] - 1)
        biblist[[i]] <- bib[entries[i]:nexte]
        empty <- grep("^$", biblist[[i]])
        if (length(empty) > 0)
        biblist[[i]] <- biblist[[i]][-empty]
    }
    names(biblist) <- labels
    class(biblist) <- "txtBibtex"
    return(biblist)
}

### the subset of a BibTeX database actually used in `file'
extractBibtex <- function(file, bibtex) {

    if (!inherits(bibtex, "txtBibtex"))
        bibtex <- readBibtex(bibtex)
    tex <- readLines(file)
    tex <- tex[grep("\\cite", tex)]
    enames <- gsub("\\+", "\\\\+", names(bibtex))
    cited <- sapply(enames, function(name) length(grep(name, tex)) > 0)
    biblist <- bibtex[cited]
    class(biblist) <- "txtBibtex"
    return(biblist)
}

### output to a file
toBibtex.txtBibtex <- function(object, ...) {

    tmp <- lapply(object, function(bib) {
        cat(paste(bib, "\n"))
        cat("\n\n")
    })
}

### set package version in BibTeX (quick'n'dirty hack)
pkgversions <- function(file) {

    x <- readLines(file)
    indx <- grep("VERSION", x)

    for (i in indx) {
        xx <- strsplit(x[i], " ")[[1]]
        xx <- xx[grep("VERSION", xx)]
        pkg <- gsub("[},]", "", gsub("VERSION", "", xx))
        version <- packageDescription(pkg)$Version
        x[i] <- gsub(paste(pkg, "VERSION", sep = "", collapse = ""), version, 
                     x[i])
    }
    class(x) <- "Latex"
    x
}

### set package date in BibTeX (quick'n'dirty hack)
pkgyears <- function(file) {

    x <- readLines(file)
    indx <- grep("PKGYEAR", x)

    for (i in indx) {
        xx <- strsplit(x[i], " ")[[1]]
        xx <- xx[grep("PKGYEAR", xx)]
        pkg <- gsub("[{},]", "", gsub("PKGYEAR", "", xx))
        year <- format(as.Date(strsplit(packageDescription(pkg)$Built, ";")[[1]][3]),"%Y")        
        x[i] <- gsub(paste(pkg, "PKGYEAR", sep = "", collapse = ""), year, 
                     x[i])
    }
    class(x) <- "Latex"
    x
}

pkgs <- function()
 c("scatterplot3d", "alr3", "ape", "coin", "flexmix", "gee", "ipred", "lme4",
   "mclust", "party", "randomForest", "rmeta", "vcd", "gamair", "multcomp",
   "sandwich", "mboost")

### R code from vignette source 'Ch_analysing_longitudinal_dataI.Rnw'

###################################################
### code chunk number 1: setup
###################################################
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })


###################################################
### code chunk number 2: singlebook
###################################################
book <- FALSE


###################################################
### code chunk number 3: ALDI-setup
###################################################
library("lme4")
library("multcomp")
residuals <- function(object) {
    y <- getME(object, 'y')
    y - fitted(object)
}


###################################################
### code chunk number 4: ALDI-plot-BtheB
###################################################
data("BtheB", package = "HSAUR3")
layout(matrix(1:2, nrow = 1))
ylim <- range(BtheB[,grep("bdi", names(BtheB))], 
              na.rm = TRUE)
tau <- subset(BtheB, treatment == "TAU")[,
    grep("bdi", names(BtheB))]
boxplot(tau, main = "Treated as Usual", ylab = "BDI", 
        xlab = "Time (in months)", names = c(0, 2, 3, 5, 8), 
        ylim = ylim)
btheb <- subset(BtheB, treatment == "BtheB")[,
    grep("bdi", names(BtheB))]
boxplot(btheb, main = "Beat the Blues", ylab = "BDI", 
        xlab = "Time (in months)", names = c(0, 2, 3, 5, 8), 
        ylim = ylim)


###################################################
### code chunk number 5: ALDI-long-BtheB
###################################################
data("BtheB", package = "HSAUR3")
BtheB$subject <- factor(rownames(BtheB))
nobs <- nrow(BtheB)
BtheB_long <- reshape(BtheB, idvar = "subject", 
    varying = c("bdi.2m", "bdi.3m", "bdi.5m", "bdi.8m"),
    direction = "long") 
BtheB_long$time <- rep(c(2, 3, 5, 8), rep(nobs, 4)) 


###################################################
### code chunk number 6: ALDI-showlong-BtheB
###################################################
subset(BtheB_long, subject %in% c("1", "2", "3"))


###################################################
### code chunk number 7: ALDI-fit-BtheB
###################################################
library("lme4")
BtheB_lmer1 <- lmer(bdi ~ bdi.pre + time + treatment + drug + 
    length + (1 | subject), data = BtheB_long, 
    REML = FALSE, na.action = na.omit)
BtheB_lmer2 <- lmer(bdi ~ bdi.pre + time + treatment + drug + 
    length + (time | subject), data = BtheB_long, 
    REML = FALSE, na.action = na.omit)   
anova(BtheB_lmer1, BtheB_lmer2)


###################################################
### code chunk number 8: ALDI-summary-BtheB
###################################################
summary(BtheB_lmer1)


###################################################
### code chunk number 9: ALDI-summary-BtheB-p
###################################################
cftest(BtheB_lmer1)


###################################################
### code chunk number 10: ALDI-qqnorm-BtheB
###################################################
layout(matrix(1:2, ncol = 2))
qint <- ranef(BtheB_lmer1)$subject[["(Intercept)"]]
qres <- residuals(BtheB_lmer1)
qqnorm(qint, ylab = "Estimated random intercepts",
       xlim = c(-3, 3), ylim = c(-20, 20),
       main = "Random intercepts")
qqline(qint)
qqnorm(qres, xlim = c(-3, 3), ylim = c(-20, 20),
       ylab = "Estimated residuals",
       main = "Residuals")
qqline(qres)


###################################################
### code chunk number 11: ALDI-dropout
###################################################
bdi <- BtheB[, grep("bdi", names(BtheB))]
plot(1:4, rep(-0.5, 4), type = "n", axes = FALSE, 
     ylim = c(0, 50), xlab = "Months", ylab = "BDI")
axis(1, at = 1:4, labels = c(0, 2, 3, 5))
axis(2)
for (i in 1:4) {
    dropout <- is.na(bdi[,i + 1])
    points(rep(i, nrow(bdi)) + ifelse(dropout, 0.05, -0.05), 
           jitter(bdi[,i]), pch = ifelse(dropout, 20, 1))
}

HSAURcite <- function(pkg) {
    ct <- citation(pkg)
    attr(ct, "label") <- paste("PKG:", pkg, sep = "", collapse = "")
    for (n in c("note"))
        ct[[n]] <- gsub("R", "\\R{}", ct[[n]])
    class(ct) <- "HSAURcitation"
    return(ct)
}

toBibtex.HSAURcitation <-  function (object, ...) 
{
    z <- paste("@", attr(object, "entry"), "{", attr(object, "label"), 
               ",", sep = "")
    if ("author" %in% names(object)) {
        object$author <- toBibtex(object$author)
    }
    for (n in names(object)) z <- c(z, paste("  ", n, " = {", 
        object[[n]], "},", sep = ""))
    z <- c(z, "}")
    class(z) <- "Bibtex"
    z
}

Rwelcome <- function() {

    tversion <- paste(version$major, version$minor, sep = ".")
    tdate <- paste(version$year, version$month, version$day, sep = "-") 
    x <- c(paste("R : Copyright", version$year, "The R Foundation for Statistical Computing"),
           paste("Version", tversion, paste("(", tdate, "),", sep = ""), 
                 "ISBN 3-900051-07-0"),
           " ",
           "R is free software and comes with ABSOLUTELY NO WARRANTY.",
           "You are welcome to redistribute it under certain conditions.",
           "Type 'license()' or 'licence()' for distribution details.",
           " ",
           "R is a collaborative project with many contributors.",
           "Type 'contributors()' for more information and",
           "'citation()' on how to cite R or R packages in publications.",
           " ",
           "Type 'demo()' for some demos, 'help()' for on-line help, or",
           "'help.start()' for an HTML browser interface to help.",
           "Type 'q()' to quit R.",
           ">")
    cat(paste(x, collapse = "\n"))
}

exename <- function() {

    tversion <- paste(version$major, "0", substr(version$minor, 1, 1),
                      substr(version$minor,3,3), sep = "")
    return(paste("rw", tversion, ".exe", sep = ""))
}

isi2bibtex <- function(file) {

    journals <- rbind(c("J. Am. Stat. Assoc.", "Journal of the American Statistical Association", "JASA"),
                      c("J. Stat. Plan. Infer.", "Journal of Statistical Planning and Inference", "JSPI"),
                      c("Biom. J.", "Biometrical Journal", "BJ"),
                      c("Stat. Med.", "Statistics in Medicine", "SiM"))
    colnames(journals) <- c("Abbr", "Title", "ID")

    tfile <- tempfile()
    isitxt <- readLines(file)
    isitxt <- gsub("(^[A-Z][A-Z,0-9])", "\\1:", isitxt, perl = TRUE)
    writeLines(isitxt, con = tfile)

    isidcf <- read.dcf(tfile, fields = c("PT", "AU", "TI", "SO", "LA", "DT", "DE", "ID",
                       "AB", "C1", "RP", "EM", "NR", "TC", "PU", "PI", "PA", "SN",
                       "J9", "JI", "PD", "PY", "VL", "IS", "BP", "EP", "PG", "SC",
                       "GA", "UT"))

    ### journals only
    isidcf <- isidcf[isidcf[,"PT"] == "J",]

    ### missings
    isidcf <- isidcf[!apply(isidcf, 1, function(x) all(is.na(x))),]

    ### rename interesting fields
    cn <- colnames(isidcf)
    colnames(isidcf)[cn == "AU"] <- "author"
    colnames(isidcf)[cn == "TI"] <- "title"
    colnames(isidcf)[cn == "JI"] <- "journal"
    colnames(isidcf)[cn == "PD"] <- "month"
    colnames(isidcf)[cn == "PY"] <- "year"
    colnames(isidcf)[cn == "VL"] <- "volumne"
    colnames(isidcf)[cn == "IS"] <- "number"
    colnames(isidcf)[cn == "UT"] <- "isitag"
    colnames(isidcf)[cn == "DE"] <- "keywords"
    colnames(isidcf)[cn == "TC"] <- "timescited"
    colnames(isidcf)[cn == "AB"] <- "abstract"
    rownames(isidcf) <- 1:nrow(isidcf)
    isidcf[,"title"] <- gsub("\n", " ", isidcf[,"title"])

    ### author names
    for (i in 1:nrow(isidcf)) {
        au <- strsplit(isidcf[i,"author"], "\n")
        names <- strsplit(au[[1]], ", ")
        for (j in 1:length(names))
            names[[j]][2] <- paste(strsplit(names[[j]][2], "")[[1]], ". ", 
                                   sep = "", collapse = "")
        lastnames <- sapply(names, function(x) gsub(" ", "", x[1]))
        if (length(lastnames) > 3) lastnames <- lastnames[1:3]
        jour <- isidcf[i,"journal"]
        indx <- journals[, "Abbr"] == jour
        if (sum(indx) == 1) {
            isidcf[i, "journal"] <- journals[indx, "Title"]
            jkey <- journals[indx, "ID"]
        } else {
            jkey <- gsub("\\.* ", "", jour)
        }
        
        label <- paste(paste(lastnames, collapse = "+"), ":",
                 jkey, ":", isidcf[i,"year"], sep = "")
        rownames(isidcf)[i] <- label
        isidcf[i,"author"] <- paste(sapply(names, function(x) paste(x[2], x[1], sep = "")), 
                                    collapse = " and ")
        title <- isidcf[i, "title"]
        if (!identical(toupper(title), title)) {
            ttmp <- strsplit(title, " ")[[1]]
            lower <- tolower(ttmp) != ttmp
            lower[1] <- FALSE
            ttmp[lower] <- paste("{", ttmp[lower], "}", sep = "")
            isidcf[i, "title"] <- paste(ttmp, collapse = " ")
        }
    }

    tags <- c("author", "title", "journal", "month", "year", "volumne", "number", 
              "isitag", "abstract", "keywords", "timescited")
    isidcf[is.na(isidcf[,"month"]), "month"] <- ""
    for (tag in tags)
        isidcf[,tag] <- paste(tag, " = {", isidcf[,tag], "},", sep = "")
    
    pages <- paste("pages = {", isidcf[, "BP"], "--", isidcf[, "EP"], "},", sep = "")
    headerkey <- paste("@article{", rownames(isidcf), ",", sep = "")

    ret <- vector(mode = "list", length = nrow(isidcf))
    for (i in 1:nrow(isidcf))
        ret[[i]] <- c(headerkey[i], paste("   ", isidcf[i, tags]), 
                      paste("   ", pages[i]), "}", " ")

    unlist(ret)
}

isep <- function(x)
    paste(paste(x[-length(x)], "&", collapse = " "), 
          x[length(x)], collapse = " ")

caption <- function(xname, label, caption, pkg = NULL) {
    RET <- paste("\\caption{\\Robject{", xname, "} data", 
                 sep = "", collapse = "")
    if (!is.null(pkg))
        RET <- paste(RET, " (package \\Rpackage{", pkg, "})", 
                     sep = "", collapse = "")
    RET <- paste(RET, ". ", caption, sep = "", collapse = "")
    RET <- paste(RET, paste("\\label{", label, "}}", 
                 sep = "", collapse = ""))
    return(RET)
}


HSAURtable <- function(object, ...)
    UseMethod("HSAURtable")

HSAURtable.data.frame <- function(object, xname = deparse(substitute(object)),
                                  pkg = NULL, nrows = NULL,...) {

    digits <- 0:6
    table <- matrix("0", nrow = nrow(object), ncol = ncol(object))
    xcc <- object[complete.cases(object),]
    for (i in 1:ncol(object)) {
        if (is.numeric(xcc[[i]])) {
            d <- min(which(sapply(digits, 
                function(d) 
                    max(abs(xcc[[i]] - round(xcc[[i]], d))) < 
                            sqrt(.Machine$double.eps))))
            table[,i] <- formatC(object[[i]], digits = digits[d], format = "f")
        } else {
            table[,i] <- as.character(object[[i]])
        }
    }
    if (!is.null(nrows)) table <- rbind(table[1:nrows,,drop = FALSE], "$\\vdots$")

    RET <- list(xname = gsub("_", "\\\\_", xname),
                pkg = pkg, 
                varnames = colnames(object),
                rownames = rownames(object),
                data = table)
    class(RET) <- "dftab"
    return(RET)
}

HSAURtable.table <- function(object, xname = deparse(substitute(object)),
                             pkg = NULL,...) {

    xtab <- matrix(as.character(object), nrow = nrow(object), 
                   ncol = ncol(object))
    RET <- list(xname = gsub("_", "\\\\_", xname),
                pkg = pkg,
                varnames = names(dimnames(object)),
                data = rbind(c(" ", dimnames(object)[[2]]),
                             cbind(dimnames(object)[[1]], xtab)))
    class(RET) <- "tabtab"
    return(RET)
}

toLatex.tabtab <- function(object, caption = NULL, label = NULL, 
                           topcaption = TRUE, index = TRUE, ...) {

    RET <- c()
    nc <- ncol(object$data)
    object$varnames <- gsub("_", "\\\\_", object$varnames)

    if (index)
        RET <- c(RET, paste("\\index{", object$xname, " data@\\Robject{",
                            object$xname, "} data}", sep = ""))

    RET <- c(RET, "\\begin{center}")

    RET <- c(RET, paste("\\begin{longtable}",
        paste("{", paste(rep("r", nc + 1), collapse = ""), "}")))
    if (topcaption)
        RET <- c(RET, caption(object$xname, label, caption, object$pkg),
                 "\\\\")
    RET <- c(RET, paste(" & & \\multicolumn{", nc - 1, "}{c}{\\Robject{", 
              object$varnames[2], "}} \\\\", collapse = ""))
    object$data <- cbind(c(paste("\\Robject{", object$varnames[1], "}", 
                                 collapse = ""), 
                           rep(" ", nrow(object$data) - 1)), object$data)
    RET <- c(RET,  apply(object$data, 1, function(x) paste(isep(x), "\\\\"))) 
    if (!topcaption)
        RET <- c(RET, caption(object$xname, label, caption, object$pkg))
    RET <- c(RET, "\\end{longtable}")
    RET <- c(RET, "\\end{center}")
    class(RET) <- "Latex"
    return(RET)
}


toLatex.dftab <- function(object, pcol = 1, caption = NULL, 
    label = NULL, rownames = FALSE, topcaption = TRUE, index = TRUE, ...) {
    
    nc <- ncol(object$data)
    object$varnames <- gsub("_", "\\\\_", object$varnames)

    if (pcol > 1) {
        nr <- ceiling(nrow(object$data) / pcol)
        object$data <- rbind(object$data, matrix(" ", 
            nrow = nr * pcol - nrow(object$data), 
            ncol = nc))
        d <- NULL
        for (i in 1:pcol)
            d <- cbind(d, object$data[((i - 1) * nr + 1):(i * nr),])
        object$data <- d       
    }

    RET <- c()

    if (index)
        RET <- c(RET, paste("\\index{", object$xname, " data@\\Robject{",
                            object$xname, "} data}", sep = ""))

    RET <- c(RET, "\\begin{center}")
    if (rownames) 
        RET <- c(RET, 
            paste("\\begin{longtable}{l", paste(rep(paste(rep("r", nc), 
                                                          collapse = ""), pcol), 
                                                collapse = "|"), "}", 
                  collapse = ""))
    else 
        RET <- c(RET, 
            paste("\\begin{longtable}{", paste(rep(paste(rep("r", nc), 
                                                         collapse = ""), pcol), 
                                              collapse = "|"), "}", 
                  collapse = ""))
    if (topcaption)
        RET <- c(RET, caption(object$xname, label, caption, object$pkg),
                 "\\\\")
    RET <- c(RET, "\\hline")
    vn <- rep(object$varnames, pcol)
    vn <- paste(paste("\\Robject{", vn, sep = ""), "}", sep = "")
    if (rownames) {
        RET <- c(RET, paste("  & ", isep(vn), "\\\\ \\hline"))
        RET <- c(RET, "\\endfirsthead")
        RET <- c(RET, paste("\\caption[]{\\Robject{", object$xname, 
                            "} data (continued).} \\\\", 
                 sep = "", collapse = ""))
        RET <- c(RET, "\\hline")
        RET <- c(RET, paste("  & ", isep(vn), "\\\\ \\hline"))
        RET <- c(RET, "\\endhead")
        for (i in 1:nrow(object$data))
            RET <- c(RET, paste(object$rownames[i], "  & ", 
                                isep(object$data[i,]), "\\\\"))
    } else {
        RET <- c(RET, paste(isep(vn), "\\\\ \\hline"))
        RET <- c(RET, "\\endfirsthead")
        RET <- c(RET, paste("\\caption[]{\\Robject{", object$xname, 
                            "} data (continued).} \\\\", sep = "", collapse = ""))
        RET <- c(RET, "\\hline")
        RET <- c(RET, paste(isep(vn), "\\\\ \\hline"))
        RET <- c(RET, "\\endhead")
        RET <- c(RET, 
            apply(object$data, 1, function(x) paste(isep(x), "\\\\")))
    }
    RET <- c(RET, "\\hline")
    if (!topcaption)
        RET <- c(RET, caption(object$xname, label, caption, object$pkg))
    RET <- c(RET, "\\end{longtable}")
    RET <- c(RET, "\\end{center}")
    class(RET) <- "Latex"
    return(RET)
}

### R code from vignette source 'Ch_cluster_analysis.Rnw'

###################################################
### code chunk number 1: setup
###################################################
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })


###################################################
### code chunk number 2: singlebook
###################################################
book <- FALSE


###################################################
### code chunk number 3: thissetup
###################################################
library("mclust")
library("mvtnorm")
mai <- par("mai")
options(SweaveHooks = list(rmai = function() { par(mai = mai * c(1,1,1,2))}))
data("pottery", package = "HSAUR3")


###################################################
### code chunk number 4: CA-pottery-dist
###################################################
pottery_dist <- dist(pottery[, colnames(pottery) != "kiln"])
library("lattice")
levelplot(as.matrix(pottery_dist), xlab = "Pot Number", 
          ylab = "Pot Number")


###################################################
### code chunk number 5: CA-pottery-distplot
###################################################
trellis.par.set(standard.theme(color = FALSE))
plot(levelplot(as.matrix(pottery_dist), xlab = "Pot Number", ylab = "Pot Number"))


###################################################
### code chunk number 6: CA-pottery-hclust
###################################################
pottery_single <- hclust(pottery_dist, method = "single")
pottery_complete <- hclust(pottery_dist, method = "complete")
pottery_average <- hclust(pottery_dist, method = "average")
layout(matrix(1:3, ncol = 3))
plot(pottery_single, main = "Single Linkage", 
     sub = "", xlab = "")
plot(pottery_complete, main = "Complete Linkage", 
     sub = "", xlab = "")
plot(pottery_average, main = "Average Linkage", 
     sub = "", xlab = "")


###################################################
### code chunk number 7: pottery-cluster
###################################################
pottery_cluster <- cutree(pottery_average, h = 4)
xtabs(~ pottery_cluster + kiln, data = pottery)


###################################################
### code chunk number 8: CA-planets-scatter
###################################################
getOption("SweaveHooks")[["rmai"]]()
data("planets", package = "HSAUR3")
library("scatterplot3d")
scatterplot3d(log(planets$mass), log(planets$period), 
    log(planets$eccen + ifelse(planets$eccen == 0, 
                               0.001, 0)), 
    type = "h", angle = 55, pch = 16, 
    y.ticklabs = seq(0, 10, by = 2), 
    y.margin.add = 0.1, scale.y = 0.7,
    xlab = "log(mass)", ylab = "log(period)", 
    zlab = "log(eccen)")


###################################################
### code chunk number 9: CA-planet-ss
###################################################
rge <- apply(planets, 2, max) - apply(planets, 2, min)
planet.dat <- sweep(planets, 2, rge, FUN = "/")
n <- nrow(planet.dat)
wss <- rep(0, 10)
wss[1] <- (n - 1) * sum(apply(planet.dat, 2, var))
for (i in 2:10)
    wss[i] <- sum(kmeans(planet.dat, 
                         centers = i)$withinss)
plot(1:10, wss, type = "b", xlab = "Number of groups",
     ylab = "Within groups sum of squares")


###################################################
### code chunk number 10: CA-planets-kmeans3
###################################################
planet_kmeans3 <- kmeans(planet.dat, centers = 3)
table(planet_kmeans3$cluster)


###################################################
### code chunk number 11: CA-planets-ccent
###################################################
ccent <- function(cl) {
    f <- function(i) colMeans(planets[cl == i,])
    x <- sapply(sort(unique(cl)), f)
    colnames(x) <- sort(unique(cl))
    return(x)
}


###################################################
### code chunk number 12: CA-planets--kmeans3-ccent
###################################################
ccent(planet_kmeans3$cluster)


###################################################
### code chunk number 13: CA-planets-kmeans5
###################################################
planet_kmeans5 <- kmeans(planet.dat, centers = 5)
table(planet_kmeans5$cluster)
ccent(planet_kmeans5$cluster)


###################################################
### code chunk number 14: CA-planets-mclust
###################################################
library("mclust")
planet_mclust <- Mclust(planet.dat)


###################################################
### code chunk number 15: CA-planets-mclust-plot
###################################################
plot(planet_mclust, planet.dat, what = "BIC", col = "black", 
     ylab = "-BIC", ylim = c(0, 350))  


###################################################
### code chunk number 16: CA-planets-mclust-print
###################################################
print(planet_mclust)


###################################################
### code chunk number 17: CA-planets-mclust-scatter
###################################################
clPairs(planet.dat, 
    classification = planet_mclust$classification, 
    symbols = 1:3, col = "black")


###################################################
### code chunk number 18: CA-planets-mclust-scatterclust
###################################################
getOption("SweaveHooks")[["rmai"]]()
scatterplot3d(log(planets$mass), log(planets$period), 
    log(planets$eccen + ifelse(planets$eccen == 0, 
                               0.001, 0)), 
    type = "h", angle = 55,  scale.y = 0.7, 
    pch = planet_mclust$classification, 
    y.ticklabs = seq(0, 10, by = 2), y.margin.add = 0.1,
    xlab = "log(mass)", ylab = "log(period)", 
    zlab = "log(eccen)")


###################################################
### code chunk number 19: CA-planets-mclust-mu
###################################################
table(planet_mclust$classification)
ccent(planet_mclust$classification)

\documentclass{chapman}

%%% copy Sweave.sty definitions

%%% keeps `sweave' from adding `\usepackage{Sweave}': DO NOT REMOVE
%\usepackage{Sweave} 


\RequirePackage[T1]{fontenc}
\RequirePackage{graphicx,ae,fancyvrb}
\IfFileExists{upquote.sty}{\RequirePackage{upquote}}{}
\usepackage{relsize}

\DefineVerbatimEnvironment{Sinput}{Verbatim}{}
\DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                              fontshape=it,
                                              fontsize=\relsize{-1}}
\DefineVerbatimEnvironment{Scode}{Verbatim}{}
\newenvironment{Schunk}{}{}

%%% environment for raw output
\newcommand{\SchunkRaw}{\renewenvironment{Schunk}{}{}
    \DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                                  fontshape=it,
                                                  fontsize=\small}
    \rawSinput
}

%%% environment for labeled output
\newcommand{\nextcaption}{}
\newcommand{\SchunkLabel}{
  \renewenvironment{Schunk}{\begin{figure}[ht] }{\caption{\nextcaption}
  \end{figure} }
  \DefineVerbatimEnvironment{Sinput}{Verbatim}{frame = topline}
  \DefineVerbatimEnvironment{Soutput}{Verbatim}{frame = bottomline, 
                                                samepage = true,
                                                fontfamily=courier,
                                                fontshape=it,
                                                fontsize=\relsize{-1}}
}


%%% S code with line numbers
\DefineVerbatimEnvironment{Sinput}
{Verbatim}
{
%%  numbers=left
}

\newcommand{\numberSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{numbers=left}
}
\newcommand{\rawSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{}
}


%%% R / System symbols
\newcommand{\R}{\textsf{R}}
\newcommand{\rR}{{R}}
\renewcommand{\S}{\textsf{S}}
\newcommand{\SPLUS}{\textsf{S-PLUS}}
\newcommand{\rSPLUS}{{S-PLUS}}
\newcommand{\SPSS}{\textsf{SPSS}}
\newcommand{\EXCEL}{\textsf{Excel}}
\newcommand{\ACCESS}{\textsf{Access}}
\newcommand{\SQL}{\textsf{SQL}}
%%\newcommand{\Rpackage}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Robject}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\Rclass}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Rcmd}[1]{\hbox{\rm\texttt{#1}}}
\newcommand{\Rpackage}[1]{\index{#1 package@{\fontseries{b}\selectfont #1} package} {\fontseries{b}\selectfont #1}}
\newcommand{\rpackage}[1]{{\fontseries{b}\selectfont #1}}
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\Rclass}[1]{\index{#1 class@\textit{#1} class}\textit{#1}}
\newcommand{\Rcmd}[1]{\index{#1 function@\texttt{#1} function}\texttt{#1}}
\newcommand{\Roperator}[1]{\texttt{#1}}
\newcommand{\Rarg}[1]{\texttt{#1}}
\newcommand{\Rlevel}[1]{\texttt{#1}}


%%% other symbols
\newcommand{\file}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\stress}[1]{\index{#1}\textit{#1}} 
\newcommand{\stress}[1]{\textit{#1}} 
\newcommand{\booktitle}[1]{\textit{#1}} %%'

%%% Math symbols
\usepackage{amstext}
\usepackage{amsmath}
\newcommand{\E}{\mathsf{E}}   
\newcommand{\Var}{\mathsf{Var}}   
\newcommand{\Cov}{\mathsf{Cov}}   
\newcommand{\Cor}{\mathsf{Cor}}   
\newcommand{\x}{\mathbf{x}}   
\newcommand{\y}{\mathbf{y}}   
\renewcommand{\a}{\mathbf{a}}
\newcommand{\W}{\mathbf{W}}   
\newcommand{\C}{\mathbf{C}}   
\renewcommand{\H}{\mathbf{H}}   
\newcommand{\X}{\mathbf{X}}   
\newcommand{\B}{\mathbf{B}}   
\newcommand{\V}{\mathbf{V}}   
\newcommand{\I}{\mathbf{I}}   
\newcommand{\D}{\mathbf{D}}   
\newcommand{\bS}{\mathbf{S}}   
\newcommand{\N}{\mathcal{N}}   
\renewcommand{\L}{L}   
\renewcommand{\P}{\mathsf{P}}   
\newcommand{\K}{\mathbf{K}}
\newcommand{\m}{\mathbf{m}}
\newcommand{\argmin}{\operatorname{argmin}\displaylimits}
\newcommand{\argmax}{\operatorname{argmax}\displaylimits}

\newcommand{\bx}{\mathbf{x}}
\newcommand{\bbeta}{\mathbf{\beta}}


%%% links
\usepackage{hyperref}

\hypersetup{%
  pdftitle = {A Handbook of Statistical Analyses Using R (3rd Edition)},
  pdfsubject = {Book},
  pdfauthor = {Torsten Hothorn and Brian S. Everitt},
  colorlinks = {black},
  linkcolor = {black},
  citecolor = {black},
  urlcolor = {black},
  hyperindex = {true},
  linktocpage = {true},
}


%%% captions & tables
%% <FIXME>: conflics with figure definition in chapman.cls
%%\usepackage[format=hang,margin=10pt,labelfont=bf]{caption}
%% </FIMXE>
\usepackage{longtable}
\usepackage[figuresright]{rotating}

%%% R symbol in chapter 1
\usepackage{wrapfig}

%%% Bibliography
\usepackage[round,comma]{natbib}
\renewcommand{\refname}{References \addcontentsline{toc}{chapter}{References}}
\citeindexfalse

%%% texi2dvi complains that \newblock is undefined, hm...
\def\newblock{\hskip .11em plus .33em minus .07em}

%%% Example sections
\newcounter{exercise}[chapter]
\setcounter{exercise}{0}
\newcommand{\exercise}{\stepcounter{exercise} \item{Ex.~\arabic{chapter}.\arabic{exercise} }}


%% URLs
\newcommand{\curl}[1]{\begin{center} \url{#1} \end{center}}

%%% for manual corrections
%\renewcommand{\baselinestretch}{2}

%%% plot sizes
\setkeys{Gin}{width=0.95\textwidth}

%%% color
\usepackage{color}

%%% hyphenations
\hyphenation{drop-out}
\hyphenation{mar-gi-nal}

%%% new bidirectional quotes need 
\usepackage[utf8]{inputenc}

%\usepackage{setspace}
\definecolor{sidebox_todo}{rgb}{1,1,0.2}
\newcommand{\todo}[1]{
        \hspace{0pt}%
        \marginpar{% 
                        \fcolorbox{black}{sidebox_todo}{%
                                \parbox{\marginparwidth} {

\raggedright\sffamily\footnotesize{TODO: #1}%
                                }
                        }%
        }
}
\begin{document}

%% Title page

\title{A Handbook of Statistical Analyses Using \R{} --- 3rd Edition}

\author{Torsten Hothorn and Brian S. Everitt}

\maketitle
%%\VignetteIndexEntry{Chapter Logistic Regression and Generalized Linear Models}
%%\VignetteDepends{survival,MASS,multcomp,lattice}
\setcounter{chapter}{6}


\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE} 

<<setup, echo = FALSE, results = hide>>=
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })
@

\pagestyle{headings}
<<singlebook, echo = FALSE>>=
book <- FALSE
@

\chapter[Logistic Regression and Generalized Linear Models]{Logistic
Regression and Generalized Linear Models: Blood Screening, Women's Role in %'
Society, Colonic Polyps, Driving and Back Pain, and Happiness in China \label{GLM}}

\section{Introduction}



\section{Logistic Regression and Generalized Linear Models}


\section{Analysis Using \R{}}

\subsection{ESR and Plasma Proteins}


\begin{figure}
\begin{center}
<<GLM-plasma-plot, echo = TRUE, fig = TRUE, height = 4>>=
data("plasma", package = "HSAUR3")
layout(matrix(1:2, ncol = 2))
cdplot(ESR ~ fibrinogen, data = plasma)
cdplot(ESR ~ globulin, data = plasma)
@
\caption{Conditional density plots of 
 the erythrocyte sedimentation rate (ESR) given fibrinogen and globulin.
 \label{GLM:plasma1}}
\end{center}
\end{figure}

We can now fit a logistic regression model to the data using 
the \Rcmd{glm} function. We start with a model that includes 
only a single explanatory variable, \Robject{fibrinogen}. The 
code to fit the model is
<<GLM-plasma-fit1, echo = TRUE>>=
plasma_glm_1 <- glm(ESR ~ fibrinogen, data = plasma, 
                    family = binomial())
@
The formula implicitly defines a parameter for the global mean (the
intercept term) as discussed in \Sexpr{ch("ANOVA")} and \Sexpr{ch("MLR")}. The
distribution of the response is defined by the \Robject{family} argument, a
binomial distribution in our case.
\index{family argument@\Rcmd{family} argument}
\index{Binomial distribution}
(The default link function when the binomial family is requested 
is the logistic function.)



\renewcommand{\nextcaption}{\R{} output of the \Robject{summary} 
                            method for the logistic regression model fitted
                            to ESR and fibrigonen.
                            \label{GLM-plasma-summary-1}}
\SchunkLabel
<<GLM-plasma-summary-1, echo = TRUE>>=
summary(plasma_glm_1)
@
\SchunkRaw


From the results in Figure~\ref{GLM-plasma-summary-1} we 
see that the regression 
coefficient for fibrinogen is significant at the $5\%$ level. 
An increase 
of one unit in this variable increases the log-odds in favor 
of an ESR value greater than $20$ by an estimated
$\Sexpr{round(coef(plasma_glm_1)["fibrinogen"], 2)}$ with 95\% 
confidence interval 
<<GLM-plasma-confint, echo = FALSE, results = hide>>=
ci <- confint(plasma_glm_1)["fibrinogen",]
@
<<GLM-plasma-confint, echo = TRUE, results = hide>>=
confint(plasma_glm_1, parm = "fibrinogen")
@
<<GLM-plasma-confint, echo = FALSE>>=
print(ci) 
@
These values are more helpful 
if converted to the corresponding values for the odds themselves 
by exponentiating the estimate
<<GLM-plasma-exp, echo = TRUE>>=
exp(coef(plasma_glm_1)["fibrinogen"])
@
and the confidence interval 
<<GLM-plasma-exp-ci, echo = FALSE, results = hide>>=
ci <- exp(confint(plasma_glm_1, parm = "fibrinogen"))
@
<<GLM-plasma-exp-ci, echo = TRUE, results = hide>>=
exp(confint(plasma_glm_1, parm = "fibrinogen"))
@
<<GLM-plasma-exp-ci, echo = FALSE>>=
print(ci)
@
The confidence interval is very wide because there are few observations 
overall and very few where the ESR value is greater than $20$. 
Nevertheless it seems likely that increased values of fibrinogen 
lead to a greater probability of an ESR value greater than $20$.

We can now fit a logistic regression model that includes both 
explanatory variables using the code
<<GLM-plasma-fit2, echo = TRUE>>=
plasma_glm_2 <- glm(ESR ~ fibrinogen +  globulin, 
    data = plasma, family = binomial())
@
and the output of the \Rcmd{summary} method is shown in Figure
\ref{GLM-plasma-summary-2}.

\renewcommand{\nextcaption}{\R{} output of the \Robject{summary} 
                            method for the logistic regression model fitted
                            to ESR and both globulin and fibrinogen.
                            \label{GLM-plasma-summary-2}}
\SchunkLabel
<<GLM-plasma-summary-2, echo = TRUE>>=
summary(plasma_glm_2)
@
\SchunkRaw
<<GLM-plasma-anova-hide, echo = FALSE, results = hide>>=
plasma_anova <- anova(plasma_glm_1, plasma_glm_2, test = "Chisq")
@

The coefficient for gamma 
globulin is not significantly different from zero. Subtracting 
the residual deviance of the second model from the corresponding 
value for the first model we get a value of
$\Sexpr{round(plasma_anova$Deviance[2], 2)}$. Tested using a  
$\chi^2$-distribution with a single degree of freedom this is not significant 
at the 5\% level and so we conclude that gamma globulin is not 
associated with ESR level. In \R{}, the task of comparing the two nested
models can be performed using the \Rcmd{anova} function
<<GLM-plasma-anova, echo = TRUE>>=
anova(plasma_glm_1, plasma_glm_2, test = "Chisq")
@
Nevertheless we shall use the predicted 
values from the second model and plot them against the values 
of \stress{both} explanatory variables using a \stress{bubbleplot} to illustrate the use of the  \Rcmd{symbols} function. 
\index{Bubbleplot}
The estimated conditional probability of a ESR value larger $20$ for all
observations can be computed, following formula (\ref{GLM:logitexp}), by
<<GLM-plasma-predict, echo = TRUE>>=
prob <- predict(plasma_glm_2, type = "response")
@
and now we can assign a larger circle to observations with larger probability
as shown in Figure~\ref{GLM:bubble}. The plot clearly 
shows the increasing probability of an ESR value above $20$ (larger 
circles) as the values of fibrinogen, and to a lesser extent, 
gamma globulin, increase.

\begin{figure}
\begin{center}
<<GLM-plasma-bubble, echo = TRUE, fig = TRUE>>=
plot(globulin ~ fibrinogen, data = plasma, xlim = c(2, 6), 
     ylim = c(25, 55), pch = ".")
symbols(plasma$fibrinogen, plasma$globulin, circles = prob,
        add = TRUE)
@
\caption{Bubbleplot of fitted values for a logistic regression model
fitted to the \Robject{plasma} data. \label{GLM:bubble}}     
\end{center}
\end{figure}


\subsection{Women's Role in Society} %'

Originally the data in Table~\ref{GLM-womensrole-tab} 
would have been in a completely 
equivalent form to the data in Table~\ref{GLM-plasma-tab} 
data, but here 
the individual observations have been grouped into counts 
of numbers of agreements and disagreements for the two explanatory 
variables, \Robject{gender} and \Robject{education}.
To fit a logistic 
regression model to such grouped data using the \Rcmd{glm} function 
we need to specify the number of agreements and disagreements 
as a two-column matrix on the left-hand side of the model formula. 
We first fit a model that includes the two explanatory variables 
using the code
<<GLM-womensrole-fit1, echo = TRUE>>=
data("womensrole", package = "HSAUR3")
fm1 <- cbind(agree, disagree) ~ gender + education
womensrole_glm_1 <- glm(fm1, data = womensrole, 
                        family = binomial())
@

\renewcommand{\nextcaption}{\R{} output of the \Robject{summary}
                            method for the logistic regression model fitted
                            to the \Robject{womensrole} data.
                            \label{GLM-womensrole-summary-1}}
\SchunkLabel
<<GLM-womensrole-summary-1, echo = TRUE>>=
summary(womensrole_glm_1)
@
\SchunkRaw

From the \Rcmd{summary} output in Figure~\ref{GLM-womensrole-summary-1} 
it appears that education 
has a highly significant part to play in predicting whether a respondent 
will agree with the statement read to them, but the respondent's %'
gender is apparently unimportant. As years of education increase 
the probability of agreeing with the statement declines. 
We now are going to construct a plot comparing the observed proportions of
agreeing with those fitted by our fitted model. Because we will reuse this
plot for another fitted object later on, we define a function which plots
years of education against some fitted probabilities, e.g., 
<<GLM-womensrole-probfit, echo = TRUE>>=
role.fitted1 <- predict(womensrole_glm_1, type = "response")
@
and labels each observation with the person's gender: %%'
\numberSinput
<<GLM-plot-setup, echo = TRUE>>=
myplot <- function(role.fitted)  {
    f <- womensrole$gender == "Female"
    plot(womensrole$education, role.fitted, type = "n", 
         ylab = "Probability of agreeing",
         xlab = "Education", ylim = c(0,1))
    lines(womensrole$education[!f], role.fitted[!f], lty = 1)
    lines(womensrole$education[f], role.fitted[f], lty = 2)  
    lgtxt <- c("Fitted (Males)", "Fitted (Females)")
    legend("topright", lgtxt, lty = 1:2, bty = "n")
    y <-  womensrole$agree / (womensrole$agree + 
                              womensrole$disagree)
    size <- womensrole$agree + womensrole$disagree
    size <- size - min(size)
    size <- (size / max(size)) * 3 + 1
    text(womensrole$education, y, ifelse(f, "\\VE", "\\MA"),
         family = "HersheySerif", cex = size)         
} 
@
\rawSinput

\begin{figure}
\begin{center}
<<GLM-role-fitted1, echo = TRUE, fig = TRUE>>=
myplot(role.fitted1)
@
\caption{Fitted (from \Robject{womensrole\_glm\_1}) and observed probabilities of
         agreeing for the \Robject{womensrole} data. The size of the 
         symbols is proportional to the sample size. \label{GLM-role1plot}}
\end{center}
\end{figure}
In lines 3--5 of function \Rcmd{myplot}, an empty scatterplot of education and
fitted probabilities (\Rcmd{type = "n"}) is set up, basically to set the scene
for the following plotting actions. Then, two lines are drawn (using function
\Rcmd{lines} in lines 6 and 7), one for males (with line type 1) 
and one for females (with line type 2, i.e., a dashed line), where
the logical vector \Robject{f} describes both genders. In line 9 a legend
is added. Finally, in lines 12 onwards we plot `observed' values, i.e., 
the frequencies of agreeing in each of the groups (\Robject{y} as computed
in lines 10 and 11) and use the Venus and Mars symbols to indicate gender. The size
of the plotted symbol is proportional to the numbers of observations in the corresponding
group of gender and years of education.

The two curves 
for males and females in Figure~\ref{GLM-role1plot} 
are almost the same reflecting the non-significant 
value of the regression coefficient for gender in
\Robject{womensrole\_glm\_1}. But the observed values plotted on 
Figure~\ref{GLM-role1plot} suggest that 
there might be an interaction of education and gender, a possibility 
that can be investigated by applying a further logistic regression 
model using
\index{Interaction}
<<GLM-womensrole-fit2, echo = TRUE>>=   
fm2 <- cbind(agree,disagree) ~ gender * education
womensrole_glm_2 <- glm(fm2, data = womensrole, 
                        family = binomial())
@
The \Robject{gender} and \Robject{education}
interaction term is seen to be highly significant, as can be seen from the
\Rcmd{summary} output in Figure~\ref{GLM-womensrole-summary-2}.
\renewcommand{\nextcaption}{\R{} output of the \Robject{summary}
                            method for the logistic regression model fitted
                            to the \Robject{womensrole} data.
                            \label{GLM-womensrole-summary-2}}
\SchunkLabel
<<GLM-womensrole-summary-2, echo = TRUE>>=
summary(womensrole_glm_2)
@
\SchunkRaw


\begin{figure}
\begin{center}
<<GLM-role-fitted2, echo = TRUE, fig = TRUE>>=
role.fitted2 <- predict(womensrole_glm_2, type = "response")
myplot(role.fitted2)
@
\caption{Fitted (from \Robject{womensrole\_glm\_2}) and observed probabilities of
agreeing for the \Robject{womensrole} data. \label{GLM-role2plot}}
\end{center}
\end{figure}


We can obtain a plot of deviance residuals plotted against 
fitted values using the following code above Figure~\ref{GLM:devplot}.
\begin{figure}
\begin{center}
<<GLM-role-plot2, echo = TRUE, fig = TRUE>>=
res <- residuals(womensrole_glm_2, type = "deviance")
plot(predict(womensrole_glm_2), res,
     xlab="Fitted values", ylab = "Residuals", 
     ylim = max(abs(res)) * c(-1,1))
abline(h = 0, lty = 2)
@
\caption{Plot of deviance residuals from logistic
         regression model fitted to the \Robject{womensrole} data.
         \label{GLM:devplot}}
\end{center}
\end{figure}
The residuals fall into a horizontal band between $-2$ and $2$. 
This pattern does not suggest  a poor fit for any particular observation 
or subset of observations.


 
\subsection{Colonic Polyps}

The data on colonic polyps in Table~\ref{GLM-polyps-tab} 
involves \stress{count}
data. We could try to model this using multiple regression 
but there are two problems. The first is that a response that 
is a count can take only positive values, and secondly such a 
variable is unlikely to have a normal distribution. Instead we 
will apply a GLM with a log link function, ensuring that fitted 
values are positive, and a Poisson error distribution, i.e., 
\index{Poisson error distribution}
\index{Poisson regression}
\begin{eqnarray*}
\P(y) = \frac{e^{-\lambda}\lambda^y}{y!}.
\end{eqnarray*}
This type of GLM is often known as \stress{Poisson regression}. 
We can apply the model using
<<GLM-polyps-fit1, echo = TRUE>>=
data("polyps", package = "HSAUR3")
polyps_glm_1 <- glm(number ~ treat + age, data = polyps, 
                    family = poisson())
@
(The default link function when the Poisson family is requested 
is the log function.)

\renewcommand{\nextcaption}{\R{} output of the \Robject{summary}
                            method for the Poisson regression model fitted
                            to the \Robject{polyps} data.
                            \label{GLM-polyps-summary-1}}
\SchunkLabel
<<GLM-polyps-summary-1, echo = TRUE>>=
summary(polyps_glm_1)
@
\SchunkRaw


We can deal with overdispersion by using a procedure known 
as \stress{quasi-likelihood}, 
\index{Quasi-likelihood}
which allows the estimation of 
model parameters without fully knowing the error distribution 
of the response variable. \cite{HSAUR:McCullaghNelder1989} give full 
details of the quasi-likelihood approach. In many respects it 
simply allows for the estimation of $\phi$ 
from the data rather than defining it to be unity for the 
binomial and Poisson distributions. We can apply quasi-likelihood 
estimation to the colonic polyps data using the following \R{} code
<<GLM-polyp-quasi, echo = TRUE>>=
polyps_glm_2 <- glm(number ~ treat + age, data = polyps, 
                    family = quasipoisson())
summary(polyps_glm_2)
@
The regression coefficients 
for both explanatory variables remain significant but their estimated 
standard errors are now much greater than the values given in 
Figure~\ref{GLM-polyps-summary-1}. A possible reason for 
overdispersion in these data 
is that polyps do not occur independently of one another, but 
instead may `cluster' together. %'
\index{Overdispersion|)}


\subsection{Driving and Back Pain}

A frequently used design in medicine is the matched case-control study in which 
each patient suffering from a particular condition of interest included in the 
study is matched to one or more people without the condition.  The most commonly 
used matching variables are age, ethnic group, mental status, etc.  A design with $m$ 
controls per case is known as a $1:m$ matched study.  In many cases $m$ will be one, 
and it is the $1:1$ matched study that we shall concentrate on here where we analyze 
the data on low back pain given in Table~\ref{GLM-backpain-tab}.  
To begin we shall describe the form of the logistic model appropriate for 
case-control studies in the simplest case where there is only one binary explanatory 
variable.

With matched pairs data the form of the logistic model involves the probability, $\varphi$, 
that in matched pair number $i$, for a given value of the explanatory variable 
the member of the pair is a case.  Specifically the model is
\begin{eqnarray*}
\text{logit}(\varphi_i) = \alpha_i + \beta x.
\end{eqnarray*}
The odds that a subject with $x=1$ is a case equals $\exp(\beta)$ times the odds 
that a subject with $x=0$ is a case.

The model generalizes to the situation where there are $q$ explanatory variables as
\begin{eqnarray*}
\text{logit}(\varphi_i) = \alpha_i + \beta_1 x_1 + \beta_2 x_2 + \dots \beta_q x_q.
\end{eqnarray*}

Typically one $x$ is an explanatory variable of real interest, such as past 
exposure to a risk factor, with the others being used as a form of statistical 
control in addition to the variables already controlled by virtue of using them 
to form matched pairs. This is the case in our back pain example where it is the 
effect of car driving on lower back pain that is of most interest.

The problem with the model above is that the number of parameters increases at 
the same rate as the sample size with the consequence that maximum likelihood 
estimation is no longer viable.  We can overcome this problem if we regard 
the parameters $\alpha_i$ as of little interest and so are willing to forgo 
their estimation.  If we do, we can then create a \stress{conditional likelihood function} 
that will yield maximum likelihood estimators of the coefficients, $\beta_1, \dots, \beta_q$, 
that are consistent and asymptotically normally distributed. The mathematics behind 
this are described in \cite{HSAUR:Collett2003}.

The model can be fitted using the \Rcmd{clogit} function from
package \Rpackage{survival}; the results are shown in Figure~\ref{GLM-backpain-print}.
<<GLM-backpain-clogit, echo = TRUE>>=
library("survival")
backpain_glm <- clogit(I(status == "case") ~ 
    driver + suburban + strata(ID), data = backpain)
@
The response has to be a logical (\Rcmd{TRUE} for cases) and the
\Rcmd{strata} command specifies the matched pairs.

\renewcommand{\nextcaption}{\R{} output of the \Robject{print}
                            method for the conditional logistic regression model fitted
                            to the \Robject{backpain} data.
                            \label{GLM-backpain-print}}
\SchunkLabel
<<GLM-backpain-print, echo = TRUE>>=
print(backpain_glm)
@
\SchunkRaw

The estimate of the odds ratio of a herniated disc occurring
in a driver relative to a nondriver is $\Sexpr{round(exp(coef(backpain_glm)[1]),2)}$
with a $95\%$ confidence interval of 
$\Sexpr{paste("(", paste(round(exp(confint(backpain_glm)[1,]), 2), collapse = ","),")", sep = "")}$.
Conditional on residence we can say that the risk of a herniated disc
occurring in a driver is about twice that of a nondriver.
There is no evidence that where a person lives affects the risk
of lower back pain.

\subsection{Happiness in China}

We model the probability distribution of reported happiness using a
proportional odds model.  In \R{}, the function \Rcmd{polr} from the
\Rpackage{MASS} package \citep{HSAUR:VenablesRipley2002, PKG:MASS} implements such models, but in a
slightly different form as explained in Section~\ref{GLM:polr}. The model we are going to fit reads
\begin{eqnarray*}
\log\left(\frac{\P(y \le k | x_1, \dots, x_q)}{\P(y > k | x_1, \dots, x_q)}\right)
& = & \zeta_k - (\beta_1 x_1 + \dots + \beta_q x_q)
\end{eqnarray*}
and we have to take care when interpreting the signs of the estimated
regression coefficients.  Another issue needs our attention before we start. 
Three of the explanatory variables are itself ordered (\Robject{R\_edu}, the
level of education of the responding woman; \Robject{R\_health}, the health
status of the responding woman in the last year; and \Robject{A\_edu}, the
level of education of the woman's partner).  For unordered factors, the
default treatment contrasts, see Chapters~\ref{ANOVA}, \ref{MLR}, and
\ref{SIMC}, compares the effect of each level to the first level.  This
coding does not take the ordinal nature of an ordered factor into account. 
One more appropriate coding is called \stress{Helmert} contrasts.
\index{Helmert constrast}
Here, we compare each level $k$ to the average of the preceding levels,
i.e., the second level to the first, the third to the average of the first
and the second, and so on (these contrasts are also sometimes called
\stress{reverse Helmert contrasts}). The \Rcmd{option} function can be used
to specify the default contrasts for unordered (we don't change the 
default \Robject{contr.treatment} option) and ordered factors. The returned
\Robject{opts} variable stores the options before manipulation and can be used
to conveniently restore them after we fitted the proportional odds model:
<<GLM-CHFLS-polr, echo = TRUE>>=
library("MASS")
opts <- options(contrasts = c("contr.treatment", 
                              "contr.helmert"))
CHFLS_polr <- polr(R_happy ~ ., data = CHFLS, Hess = TRUE)
options(opts)
@

\renewcommand{\nextcaption}{\R{} output of the \Robject{summary}
                            method for the proportional odds model fitted 
                            to the \Robject{CHFLS} data.
                            \label{GLM-CHFLS-polr-summary}}
\SchunkLabel
<<GLM-CHFLS-polr, echo = TRUE>>=
summary(CHFLS_polr)
@
\SchunkRaw

As (almost) always, the \Rcmd{summary} function can be used to display the
fitted model, see Figure~\ref{GLM-CHFLS-polr-summary}. The largest absolute values
of the $t$-statistics are associated with the self-reported health variable. To interpret the results correctly, we first make sure to understand the definition of the Helmert contrasts.
<<GLM-CHFLS-polr-helmert, echo = TRUE>>=
H <- with(CHFLS, contr.helmert(table(R_health)))
rownames(H) <- levels(CHFLS$R_health)
colnames(H) <- paste(levels(CHFLS$R_health)[-1], "- avg")
H
@
Let's focus on the probability of being very unhappy.  A positive regression
coefficient for the first contrast of health means that the probability of
being very unhappy is smaller (because of the sign switch in the regression
coefficients) for women that reported their health as not good compared to women that
reported a poor health.  Thus, the results given in
Figure~\ref{GLM-CHFLS-polr-summary} indicate that better health leads to
happier women, a finding that sits well with our expectations.  The other
effects are less clear to interpret, also because formal inference is
difficult and no $p$-values are displayed in the summary output of
Figure~\ref{GLM-CHFLS-polr-summary}.  As a remedy, making use of the
asymptotic distribution of maximum-likelihood-based estimators,
we use the \Rcmd{cftest}
function from the \Rpackage{multcomp} package \citep{PKG:multcomp} to
compute normal $p$-values assuming that the estimated regression
coefficients follow a normal limiting distribution (which is, for
\Sexpr{nrow(CHFLS) - 3} observations, not completely unrealistic); the
results are given in Figure~\ref{GLM-CHFLS-polr-cftest}. 


%% mess with the output function
<<GLM-CHFLS-polr-cftest, echo = FALSE, results = hide>>=
library("multcomp")
op <- options(digits = 2)
cf <- cftest(CHFLS_polr)
cftest <- function(x, digits = max(3, getOption("digits") - 3)) {
    x <- cf
    cat("\n\t", "Simultaneous Tests for General Linear Hypotheses\n\n")
    if (!is.null(x$type)) 
        cat("Multiple Comparisons of Means:", x$type, "Contrasts\n\n\n")
    call <- if (isS4(x$model)) 
        x$model@call
    else x$model$call
    if (!is.null(call)) {
        cat("Fit: ")
        print(call)
        cat("\n")
    }
    pq <- x$test
    mtests <- cbind(pq$coefficients, pq$sigma, pq$tstat, pq$pvalues)
    error <- attr(pq$pvalues, "error")
    pname <- switch(x$alternativ, less = paste("Pr(<", ifelse(x$df == 
        0, "z", "t"), ")", sep = ""), greater = paste("Pr(>", 
        ifelse(x$df == 0, "z", "t"), ")", sep = ""), two.sided = paste("Pr(>|", 
        ifelse(x$df == 0, "z", "t"), "|)", sep = ""))
    colnames(mtests) <- c("Estimate", "Std. Error", ifelse(x$df == 
        0, "z value", "t value"), pname)
    type <- pq$type
    if (!is.null(error) && error > .Machine$double.eps) {
        sig <- which.min(abs(1/error - (10^(1:10))))
        sig <- 1/(10^sig)
    }
    else {
        sig <- .Machine$double.eps
    }
    cat("Linear Hypotheses:\n")
    alt <- switch(x$alternative, two.sided = "==", less = ">=", 
        greater = "<=")
    rownames(mtests) <- rownames(mtests)
    printCoefmat(mtests, digits = digits, has.Pvalue = TRUE, 
        P.values = TRUE, eps.Pvalue = sig)
    switch(type, univariate = cat("(Univariate p values reported)"), 
        `single-step` = cat("(Adjusted p values reported -- single-step method)"), 
        Shaffer = cat("(Adjusted p values reported -- Shaffer method)"), 
        Westfall = cat("(Adjusted p values reported -- Westfall method)"), 
        cat("(Adjusted p values reported --", type, "method)"))
    cat("\n\n")
    invisible(x)
}
@
\renewcommand{\nextcaption}{\R{} output of the \Robject{cftest}
                            function for the proportional odds model fitted 
                            to the \Robject{CHFLS} data.
                            \label{GLM-CHFLS-polr-cftest}}
\SchunkLabel
<<GLM-CHFLS-polr-cftest, echo = TRUE>>=
library("multcomp")
cftest(CHFLS_polr)
@
\SchunkRaw
<<GLM-CHFLS-polr-cftest, echo = FALSE, results = hide>>=
options(op)
@

There seem to be geographical differences and also older and larger women
seem to be happier.  Other than that, education and income don't seem to
contribute much in this model.  One remarkable thing about the proportional
odds model is that, similar to the quantile regression models presented in
Chapter~\ref{QR}, it directly formulates a regression problem in terms of
conditional distributions, not only conditional means (the same is trivially 
true for the binary case in logistic regression). Consequently, the model allows making
distributional predictions, in other words, we can infer the predicted distribution
or density of happiness in a woman with certain values for the explanatory variables
that entered the model. To do so, we focus on the woman corresponding to the first
row of the data set:

\clearpage


<<GLM-CHFLS-pred-1, echo = TRUE>>=
CHFLS[1,]
@
and repeat these values as often as there are levels in the \Robject{R\_health} factor, and each
row is assigned one of these levels
<<GLM-CHFLS-pred-2, echo = TRUE>>=
nd <- CHFLS[rep(1, nlevels(CHFLS$R_health)),]
nd$R_health <- ordered(levels(nd$R_health), 
                       labels = levels(nd$R_health))
@
We can now use the \Rcmd{predict} function to compute the density of
the response variable \Rcmd{R\_happy} for each of these five hypothetical women:
<<GLM-CHFLS-pred-3, echo = TRUE>>=
(dens <- predict(CHFLS_polr, newdata = nd, type = "probs"))
@
From each row, we get the predicted probability that the self-reported happiness
will correspond to the levels shown in the column name. These densities, one for each
row in \Robject{nd} and therefore for each level of health, can now be plotted, for 
example using a conditional barchart, see Figure~\ref{GLM-CHFLS-pred-plot}. We clearly
see that better health is associated with greater happiness.

\begin{figure}
\begin{center}
<<GLM-CHFLS-pred-plot, echo = TRUE, fig = TRUE>>=
library("lattice")
D <- expand.grid(R_health = nd$R_health, 
                 R_happy = ordered(LETTERS[1:4]))
D$dens <- as.vector(dens)
barchart(dens ~ R_happy | R_health, data = D, 
         ylab = "Density", xlab = "Happiness",)
@
\caption{Predicted distribution of happiness for hypothetical women with
         health conditions rating from poor to excellent, with the remaining
         explanatory variables being the same as for the woman corresponding
         to the first row in the \Robject{CHFLS} data frame. The levels
         of happiness have been abbreviated (A: very unhappy, B: not too happy,
         C: somewhat happy; D: very happy).
         \label{GLM-CHFLS-pred-plot}}
\end{center}
\end{figure}


We'll present an alternative and maybe simpler
model in Chapter~\ref{RP}.

\section{Summary of Findings}

<<GLM-findings, echo = FALSE, results = hide>>=
ci <- round(exp(confint(plasma_glm_1, parm = "fibrinogen")), 2)
ci <- paste("(", paste(ci, collapse = ","), ")", sep = "")
@


\begin{description}
\item[Blood screening]
Application of logistic regression shows that an increase of one unit in the
fibrinogen value produces approximately a six fold increase in the odds of
an ESR value greater than $20$.  However, because the number of observations  
is small the corresponding $95\%$ confidence interval for the odds is rather
wide namely, $\Sexpr{ci}$.  Gamma globulin values do not help in the
prediction of ESR values greater than $20$ over and above the fibrinogen
values.
\item[Women's role in society]
Modeling the probability of agreeing with the statement about women's role
in society using logistic regression demonstrates that it is the interaction
of education and gender which is of most importance; for fewer years of
education women have a higher probability of agreeing with the statement
than men, but when the years of education exceed about ten then this
situation reverses.
\item[Colonic polyps]
Fitting a Poisson regression allowing for overdispersion shows that the drug
treatment is effective in reducing the number of polyps 
with age having only a marginal effect.
\item[Driving and back pain]
Application of conditional logistic regression shows that the odds ratio of
a herniated disc occurring in a driver relative to a nondriver is 
$\Sexpr{round(exp(coef(backpain_glm)[1]),2)}$
with a $95\%$ confidence interval of
$\Sexpr{paste("(", paste(round(exp(confint(backpain_glm)[1,]), 2), collapse = ","),")", sep = "")}$.
There is no evidence that where a
person lives affects the risk of suffering lower back pain.
\item[Happiness in China] Better health is associated with greater happiness -- what a surprise!
\end{description}

     
\section{Final Comments}

Generalized linear models provide a very powerful and flexible framework
for the application of regression models to a variety of non-normal
response variables, for example, logistic regression to binary responses   
and Poisson regression to count data.


\bibliographystyle{LaTeXBibTeX/refstyle}
\bibliography{LaTeXBibTeX/HSAUR}   
\end{document}

\documentclass{chapman}

%%% copy Sweave.sty definitions

%%% keeps `sweave' from adding `\usepackage{Sweave}': DO NOT REMOVE
%\usepackage{Sweave} 


\RequirePackage[T1]{fontenc}
\RequirePackage{graphicx,ae,fancyvrb}
\IfFileExists{upquote.sty}{\RequirePackage{upquote}}{}
\usepackage{relsize}

\DefineVerbatimEnvironment{Sinput}{Verbatim}{}
\DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                              fontshape=it,
                                              fontsize=\relsize{-1}}
\DefineVerbatimEnvironment{Scode}{Verbatim}{}
\newenvironment{Schunk}{}{}

%%% environment for raw output
\newcommand{\SchunkRaw}{\renewenvironment{Schunk}{}{}
    \DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                                  fontshape=it,
                                                  fontsize=\small}
    \rawSinput
}

%%% environment for labeled output
\newcommand{\nextcaption}{}
\newcommand{\SchunkLabel}{
  \renewenvironment{Schunk}{\begin{figure}[ht] }{\caption{\nextcaption}
  \end{figure} }
  \DefineVerbatimEnvironment{Sinput}{Verbatim}{frame = topline}
  \DefineVerbatimEnvironment{Soutput}{Verbatim}{frame = bottomline, 
                                                samepage = true,
                                                fontfamily=courier,
                                                fontshape=it,
                                                fontsize=\relsize{-1}}
}


%%% S code with line numbers
\DefineVerbatimEnvironment{Sinput}
{Verbatim}
{
%%  numbers=left
}

\newcommand{\numberSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{numbers=left}
}
\newcommand{\rawSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{}
}


%%% R / System symbols
\newcommand{\R}{\textsf{R}}
\newcommand{\rR}{{R}}
\renewcommand{\S}{\textsf{S}}
\newcommand{\SPLUS}{\textsf{S-PLUS}}
\newcommand{\rSPLUS}{{S-PLUS}}
\newcommand{\SPSS}{\textsf{SPSS}}
\newcommand{\EXCEL}{\textsf{Excel}}
\newcommand{\ACCESS}{\textsf{Access}}
\newcommand{\SQL}{\textsf{SQL}}
%%\newcommand{\Rpackage}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Robject}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\Rclass}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Rcmd}[1]{\hbox{\rm\texttt{#1}}}
\newcommand{\Rpackage}[1]{\index{#1 package@{\fontseries{b}\selectfont #1} package} {\fontseries{b}\selectfont #1}}
\newcommand{\rpackage}[1]{{\fontseries{b}\selectfont #1}}
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\Rclass}[1]{\index{#1 class@\textit{#1} class}\textit{#1}}
\newcommand{\Rcmd}[1]{\index{#1 function@\texttt{#1} function}\texttt{#1}}
\newcommand{\Roperator}[1]{\texttt{#1}}
\newcommand{\Rarg}[1]{\texttt{#1}}
\newcommand{\Rlevel}[1]{\texttt{#1}}


%%% other symbols
\newcommand{\file}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\stress}[1]{\index{#1}\textit{#1}} 
\newcommand{\stress}[1]{\textit{#1}} 
\newcommand{\booktitle}[1]{\textit{#1}} %%'

%%% Math symbols
\usepackage{amstext}
\usepackage{amsmath}
\newcommand{\E}{\mathsf{E}}   
\newcommand{\Var}{\mathsf{Var}}   
\newcommand{\Cov}{\mathsf{Cov}}   
\newcommand{\Cor}{\mathsf{Cor}}   
\newcommand{\x}{\mathbf{x}}   
\newcommand{\y}{\mathbf{y}}   
\renewcommand{\a}{\mathbf{a}}
\newcommand{\W}{\mathbf{W}}   
\newcommand{\C}{\mathbf{C}}   
\renewcommand{\H}{\mathbf{H}}   
\newcommand{\X}{\mathbf{X}}   
\newcommand{\B}{\mathbf{B}}   
\newcommand{\V}{\mathbf{V}}   
\newcommand{\I}{\mathbf{I}}   
\newcommand{\D}{\mathbf{D}}   
\newcommand{\bS}{\mathbf{S}}   
\newcommand{\N}{\mathcal{N}}   
\renewcommand{\L}{L}   
\renewcommand{\P}{\mathsf{P}}   
\newcommand{\K}{\mathbf{K}}
\newcommand{\m}{\mathbf{m}}
\newcommand{\argmin}{\operatorname{argmin}\displaylimits}
\newcommand{\argmax}{\operatorname{argmax}\displaylimits}

\newcommand{\bx}{\mathbf{x}}
\newcommand{\bbeta}{\mathbf{\beta}}


%%% links
\usepackage{hyperref}

\hypersetup{%
  pdftitle = {A Handbook of Statistical Analyses Using R (3rd Edition)},
  pdfsubject = {Book},
  pdfauthor = {Torsten Hothorn and Brian S. Everitt},
  colorlinks = {black},
  linkcolor = {black},
  citecolor = {black},
  urlcolor = {black},
  hyperindex = {true},
  linktocpage = {true},
}


%%% captions & tables
%% <FIXME>: conflics with figure definition in chapman.cls
%%\usepackage[format=hang,margin=10pt,labelfont=bf]{caption}
%% </FIMXE>
\usepackage{longtable}
\usepackage[figuresright]{rotating}

%%% R symbol in chapter 1
\usepackage{wrapfig}

%%% Bibliography
\usepackage[round,comma]{natbib}
\renewcommand{\refname}{References \addcontentsline{toc}{chapter}{References}}
\citeindexfalse

%%% texi2dvi complains that \newblock is undefined, hm...
\def\newblock{\hskip .11em plus .33em minus .07em}

%%% Example sections
\newcounter{exercise}[chapter]
\setcounter{exercise}{0}
\newcommand{\exercise}{\stepcounter{exercise} \item{Ex.~\arabic{chapter}.\arabic{exercise} }}


%% URLs
\newcommand{\curl}[1]{\begin{center} \url{#1} \end{center}}

%%% for manual corrections
%\renewcommand{\baselinestretch}{2}

%%% plot sizes
\setkeys{Gin}{width=0.95\textwidth}

%%% color
\usepackage{color}

%%% hyphenations
\hyphenation{drop-out}
\hyphenation{mar-gi-nal}

%%% new bidirectional quotes need 
\usepackage[utf8]{inputenc}

%\usepackage{setspace}
\definecolor{sidebox_todo}{rgb}{1,1,0.2}
\newcommand{\todo}[1]{
        \hspace{0pt}%
        \marginpar{% 
                        \fcolorbox{black}{sidebox_todo}{%
                                \parbox{\marginparwidth} {

\raggedright\sffamily\footnotesize{TODO: #1}%
                                }
                        }%
        }
}
\begin{document}

%% Title page

\title{A Handbook of Statistical Analyses Using \R{} --- 3rd Edition}

\author{Torsten Hothorn and Brian S. Everitt}

\maketitle
%%\VignetteIndexEntry{Chapter Generalized Additive Models}
%%\VignetteDepends{mgcv,rpart,wordcloud,mboost}
\setcounter{chapter}{9}



\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE} 

<<setup, echo = FALSE, results = hide>>=
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })
@

\pagestyle{headings}
<<singlebook, echo = FALSE, results = hide>>=
book <- FALSE
@

<<packages, echo = FALSE, results = hide>>=
library("mgcv")
library("mboost")
library("rpart")
library("wordcloud")
@

\chapter[Scatterplot Smoothers and Additive Models]{Scatterplot 
  Smoothers and Generalized Additive Models: The Men's Olympic 1500m, 
  Air Pollution in the US, Risk Factors for Kyphosis, and Women's Role in %'
  Society \label{GAM}}

\section{Introduction}


\section{Scatterplot Smoothers and Generalized Additive Models}


\section{Analysis Using \R{}}

\subsection{Olympic 1500m Times}

To begin we will construct a scatterplot of winning time 
against the year the games were held. The \R{} code and the resulting plot 
are shown in Figure~\ref{GAM-men1500m-plot}.  There is a very clear downward trend in 
the times over the years, and, in addition there is a very clear 
outlier namely the winning time for 1896. We shall remove this 
time from the data set and now concentrate on the remaining times. 
First we will fit a simple linear regression to the data and 
plot the fit onto the scatterplot. The code and the resulting 
plot are shown in Figure~\ref{GAM-men1500m-lm}. Clearly the linear regression 
model captures in general terms the downward trend in the times. 
Now we can add the fits given by the lowess smoother and by a 
cubic spline smoother; the resulting graph and the extra \R{} code 
needed are shown in Figure~\ref{GAM-men1500m-smooth}. 


Both non-parametric fits suggest some distinct departure from 
linearity, and clearly point to a quadratic model being more 
sensible than a linear model here. And fitting a parametric model 
that includes both a linear and a quadratic effect for the year gives a 
prediction curve very similar to the non-parametric curves; see Figure~\ref{GAM-men1500m-quad}.

Here use of the non-parametric smoothers has effectively diagnosed 
our linear model and pointed the way to using a more suitable 
parametric model; this is often how such non-parametric models can be used most 
effectively. For these data, of course, it is clear that the simple linear 
model cannot be suitable if the investigator is interested in predicting 
future times since even the most basic knowledge of human physiology 
will tell us that times cannot continue to go down. There must be some 
lower limit to the time man can run 1500m. But in other situations 
use of the non-parametric smoothers may point to a parametric model 
that could not have been identified \emph{a priori}. 

\begin{figure}
\begin{center}
<<GAM-men1500m-plot, echo = TRUE, fig = TRUE, height = 5>>=
plot(time ~ year, data = men1500m, xlab = "Year",
     ylab = "Winning time (sec)")
@
\caption{Scatterplot of year and winning time. \label{GAM-men1500m-plot}}
\end{center}
\end{figure}

\begin{figure}
\begin{center}
<<GAM-men1500m-lm, echo = TRUE, fig = TRUE, height = 5>>=
men1500m1900 <- subset(men1500m, year >= 1900)
men1500m_lm <- lm(time ~ year, data = men1500m1900)
plot(time ~ year, data = men1500m1900, xlab = "Year",
     ylab = "Winning time (sec)")
abline(men1500m_lm)
@
\caption{Scatterplot of year and winning time with fitted values from
         a simple linear model. \label{GAM-men1500m-lm}}
\end{center}
\end{figure}

\begin{figure}
\begin{center}
<<GAM-men1500m-smooth, echo = TRUE, fig = TRUE, height = 5>>=
x <- men1500m1900$year
y <- men1500m1900$time
men1500m_lowess <- lowess(x, y)
plot(time ~ year, data = men1500m1900, xlab = "Year",
     ylab = "Winning time (sec)")
lines(men1500m_lowess, lty = 2)
men1500m_cubic <- gam(y ~ s(x, bs = "cr"))
lines(x, predict(men1500m_cubic), lty = 3)
@
\caption{Scatterplot of year and winning time with fitted values from a smooth
         non-parametric model. \label{GAM-men1500m-smooth}}
\end{center}
\end{figure}


\begin{figure}
\begin{center}
<<GAM-men1500m-quad, echo = TRUE, fig = TRUE, height = 5>>=
men1500m_lm2 <- lm(time ~ year + I(year^2), 
                   data = men1500m1900)
plot(time ~ year, data = men1500m1900, xlab = "Year",
     ylab = "Winning time (sec)")
lines(men1500m1900$year, predict(men1500m_lm2))
@
\caption{Scatterplot of year and winning time with fitted values from a 
         quadratic model. \label{GAM-men1500m-quad}}
\end{center}
\end{figure}


It is of some interest to look at the predictions of winning 
times in future Olympics from both the linear and quadratic models. 
For example, for 2008 and 2012 the predicted times and their $95\%$ 
confidence intervals can be found using the following code

\newpage

<<GAM-men1500m-pred, echo = TRUE>>=
predict(men1500m_lm, 
        newdata = data.frame(year = c(2008, 2012)), 
        interval = "confidence")
predict(men1500m_lm2, 
        newdata = data.frame(year = c(2008, 2012)), 
        interval = "confidence")
@

\newpage

For predictions far into the future both 
the quadratic and the linear model fail; we leave readers to get 
some more predictions to see what happens. We can compare
the first prediction with the time actually recorded by the winner
of the men's 1500m in Beijing 2008, 
Rashid Ramzi from Brunei, who won the event in $212.94$ seconds. The confidence
interval obtained from the simple linear model does not include this value
but the confidence interval for the prediction 
derived from the quadratic model does.


\subsection{Air Pollution in US Cities}

Unfortunately, we cannot fit an additive model for
describing the $\text{SO}_2$ concentration based on all six
covariates because this leads to more parameters than cities, 
i.e., more parameters than observations when using the
default parameterization of \Rpackage{mgcv}. Thus, before we can apply
the \Rcmd{gam} function from package \Rpackage{mgcv}, we have
to decide which covariates should enter the model and which
subset of these covariates should be allowed to deviate from
a linear regression relationship.

As briefly discussed in Section~\ref{GAM:VS}, we can
fit an additive model using the iterative boosting algorithm
as described by \cite{HSAUR:BuehlmannHothorn2007}. The complexity
of the model is determined by an AIC criterion, which can also be used
to determine an appropriate number of boosting iterations to choose.
The methodology is available
from package \Rpackage{mboost} \citep{PKG:mboost}. We start 
with a small number of boosting iterations ($100$ by default) and
compute the AIC of the corresponding $100$ models:
<<GAM-USairpollution-boost, echo = TRUE>>=
library("mboost")
USair_boost <- gamboost(SO2 ~ ., data = USairpollution)
USair_aic <- AIC(USair_boost)
USair_aic
@
The AIC suggests that the boosting algorithm should be stopped
after $\Sexpr{mstop(USair_aic)}$ iterations. The partial contributions of each
covariate to the predicted $\text{SO}_2$ concentration
are given in Figure~\ref{GAM-USairpollution-boostplot}.
The plot indicates that all six covariates enter the model and
the selection of a subset of covariates for modeling 
isn't appropriate in this case. However, the number of manufacturing
enterprises seems to add linearly to the $\text{SO}_2$ concentration, which
simplifies the model. Moreover, the average annual precipitation
contribution seems to deviate from zero only for some extreme observations
and one might refrain from using the covariate at all.

\begin{figure}
\begin{center}
<<GAM-USairpollution-boostplot, echo = TRUE, fig = TRUE, height = 4>>=
USair_gam <- USair_boost[mstop(USair_aic)]
layout(matrix(1:6, ncol = 3))
plot(USair_gam, ask = FALSE)
@
\caption{Partial contributions of six exploratory covariates
         to the predicted $\text{SO}_2$ concentration. \label{GAM-USairpollution-boostplot}}
\end{center}
\end{figure}

As always, an inspection of the model fit via a residual plot
is worth the effort. Here, we plot the fitted values against the residuals
and label the points with the name of the corresponding city using the \Rcmd{textplot} function from package \Rpackage{wordcloud}.
Figure~\ref{GAM-USairpollution-residplot} shows at least two
extreme observations. Chicago has a very large observed and fitted 
$\text{SO}_2$ concentration, which is due to the huge number of inhabitants and
manufacturing plants (see Figure~\ref{GAM-USairpollution-boostplot} also).
One smaller city, Providence, is associated with a rather large
positive residual indicating that the actual $\text{SO}_2$ concentration
is underestimated by the model. In fact, this small town has
a rather high $\text{SO}_2$ concentration which is hardly explained
by our model. Overall, the model doesn't fit the data very well,
so we should avoid overinterpreting the model structure 
too much. In addition, since each of the six covariates
contributes to the model, we aren't able to select a smaller subset
of the covariates for modeling and thus fitting a model using
\Rcmd{gam} is still complicated (and will not add much knowledge anyway).

\begin{figure}
\begin{center}
<<GAM-USairpollution-residplot, echo = TRUE, fig = TRUE>>=
SO2hat <- predict(USair_gam)
SO2 <- USairpollution$SO2
plot(SO2hat, SO2 - SO2hat, type = "n",         
     xlim = c(-20, max(SO2hat) * 1.1),
     ylim = range(SO2 - SO2hat) * c(2, 1))
textplot(SO2hat, SO2 - SO2hat, rownames(USairpollution), 
         show.lines = FALSE, new = FALSE)
abline(h = 0, lty = 2, col = "grey")
@
\caption{Residual plot of $\text{SO}_2$ concentration. 
         \label{GAM-USairpollution-residplot}}
\end{center}
\end{figure}


\subsection{Risk Factors for Kyphosis}

\index{Spinogram}
Before modeling the relationship between kyphosis and
the three exploratory variables age, starting vertebral level of
the surgery, and number of vertebrae involved, we investigate the
partial associations by so-called \stress{spinograms}, as
introduced in \Sexpr{ch("DAGD")}. The
numeric exploratory covariates are discretized and their
empirical relative frequencies are plotted against the
conditional frequency of kyphosis in the corresponding
group. Figure~\ref{GAM-kyphosis-plot} shows that kyphosis
is absent in very young or very old children, children
with a small starting vertebral level, and high number of vertebrae 
involved.

\begin{figure}
\begin{center}
<<GAM-kyphosis-plot, echo = TRUE, fig = TRUE, height = 4, width = 7>>=
layout(matrix(1:3, nrow = 1))
spineplot(Kyphosis ~ Age, data = kyphosis, 
          ylevels = c("present", "absent"))
spineplot(Kyphosis ~ Number, data = kyphosis, 
          ylevels = c("present", "absent"))
spineplot(Kyphosis ~ Start, data = kyphosis, 
         ylevels = c("present", "absent"))
@
\caption{Spinograms of the three exploratory variables and response variable
         \Robject{kyphosis}. \label{GAM-kyphosis-plot}}
\end{center}
\end{figure}

The logistic additive model needed to describe the conditional
probability of kyphosis given the exploratory variables
can be fitted using function \Rcmd{gam}. Here, the dimension
of the basis ($k$) has to be modified for \Robject{Number} and
\Robject{Start} since these variables are heavily tied. As for
generalized linear models, the \Robject{family} argument determines
the type of model to be fitted, a logistic model in our case:
<<GAM-kyphosis-gam, echo = TRUE>>=
(kyphosis_gam <- gam(Kyphosis ~ s(Age, bs = "cr") + 
    s(Number, bs = "cr", k = 3) + s(Start, bs = "cr", k = 3),
    family = binomial, data = kyphosis))
@
The partial contributions of each covariate to the conditional
probability of kyphosis with confidence bands are shown in 
Figure~\ref{GAM-kyphosis-gamplot}. In essence, the same conclusions
as drawn from Figure~\ref{GAM-kyphosis-plot} can be stated here.
The risk of kyphosis being present decreases with higher
starting vertebral level and lower number of vertebrae involved.
Children about $100$ months old are under higher risk compared
to younger or older children.

\begin{figure}
\begin{center}
<<GAM-kyphosis-gamplot, echo = TRUE, fig = TRUE, height = 4, width = 7>>=
trans <- function(x) 
    binomial()$linkinv(x)
layout(matrix(1:3, nrow = 1))
plot(kyphosis_gam, select = 1, shade = TRUE, trans = trans)
plot(kyphosis_gam, select = 2, shade = TRUE, trans = trans)
plot(kyphosis_gam, select = 3, shade = TRUE, trans = trans)
@
\caption{Partial contributions of three exploratory variables
         with confidence bands. \label{GAM-kyphosis-gamplot}}
\end{center}
\end{figure}

\subsection{Women's Role in Society} %'

In Chapter~\ref{GLM}, we saw that a logistic regression with an interaction between
gender and level of education described the data better than a main-effects only
model. Using an additive logistic regression model, we can fit separate, possibly
nonlinear, functions of levels of education to both genders:
<<GAM-womensrole-gam, echo = TRUE>>= 
data("womensrole", package = "HSAUR3")
fm1 <- cbind(agree, disagree) ~ s(education, by = gender)
womensrole_gam <- gam(fm1, data = womensrole, 
                      family = binomial())
@
The resulting model is best inspected by a plot
(Figure~\ref{GAM-womensrole-gamplot}).  For males, the log-odds of agreement
decreases linearly with each additional year of education.  For females,
the log-odds is more or less constant up to five years of education and only
then begins to decrease.  After 15 years, there seems to be no further
impact on the log-odds.  When we plot the resulting fitted probabilities in
a way similar to Figure~\ref{GLM-role2plot}, we see that the interaction is
even more pronounced in the additive compared to the linear model.  The flat
curve for women with less than five years of education can be explained by
the rather large variability of the answers in this area but the plateau to 
the right is due to two groups of highly educated women with a rather 
large proportion of agreement.


\begin{figure}
\begin{center}
<<GAM-womensrole-gamplot, echo = TRUE, fig = TRUE, height = 4, width = 7>>=
layout(matrix(1:2, nrow = 1))
plot(womensrole_gam, select = 1, shade = TRUE)
plot(womensrole_gam, select = 1, shade = TRUE)
@
\caption{Effects of level of education for males (right) and females (left)
         on the log-odds scale derived from an additive logistic regression model.
         The shaded area denotes confidence bands. \label{GAM-womensrole-gamplot}}
\end{center}
\end{figure}

<<GAM-plot-setup, echo = FALSE>>=  
myplot <- function(role.fitted)  {    
    f <- womensrole$gender == "Female"
    plot(womensrole$education, role.fitted, type = "n",
         ylab = "Probability of agreeing",
         xlab = "Education", ylim = c(0,1))
    lines(womensrole$education[!f], role.fitted[!f], lty = 1)
    lines(womensrole$education[f], role.fitted[f], lty = 2)
    lgtxt <- c("Fitted (Males)", "Fitted (Females)")
    legend("topright", lgtxt, lty = 1:2, bty = "n")
    y <-  womensrole$agree / (womensrole$agree +
                              womensrole$disagree)
    size <- womensrole$agree + womensrole$disagree
    size <- size - min(size)
    size <- (size / max(size)) * 3 + 1
    text(womensrole$education, y, ifelse(f, "\\VE", "\\MA"),
         family = "HersheySerif", cex = size)
} 
@


\begin{figure}
\begin{center}
<<GAM-womensrole-probplot, echo = TRUE, fig = TRUE>>=
myplot(predict(womensrole_gam, type = "response"))
@
\caption{Effects of level of education for males (right) and females (left)
         on the log-odds scale derived from an additive logistic regression model.
         The shaded area denotes confidence bands. \label{GAM-womensrole-probplot}}
\end{center}
\end{figure}


\section{Summary of Findings}

\begin{description}
\item[Olympic 1500m times]
Here the use of a generalized additive model suggested that a quadratic
model might best describe the data.  When such a model was fitted it made
reasonable predictions of the winner's times in the Olympic Games of 2008
and 2012.
\item[Air pollution data]
Finding a suitable model for these data was problematic because of the
outliers in the data and the high correlations between some pairs of
explanatory variables.  Except for wind, the fitted partial contributions
are well approximated by a linear function for most of the observations and
it might be questioned if the more complex additive model is really needed.
\item[Kyphosis]
The risk of kyphosis being present decreases with higher starting vertebral
level and lower number of vertebrae involved.  Children about 100 months old
are under higher risk compared to younger or older children.
\item[Women's role in society]
For males, the log-odds of agreement decreases linearly with each
additional year of education.  For females, the log-odds is more or less
constant up to five years of education and only then begins to decrease. 
After $15$ years, there seems to be no further impact on the log-odds.
\end{description}


\section{Final Comments}

Additive models offer flexible modeling tools for regression
problems. They stand between generalized linear models, where
the regression relationship is assumed to be linear, and
more complex models like random forests (see \Sexpr{ch("RP")})
where the regression relationship remains unspecified. Smooth
functions describing the influence of covariates on the response
can be easily interpreted. Variable
selection is a technically difficult problem in this class
of models; boosting methods are one possibility to deal with this
problem.

\section*{Exercises}

\begin{description}

\exercise 
Consider the body fat data introduced in \Sexpr{ch("RP")}, 
Table~\ref{RP-bodyfat-tab}. First fit a generalized additive
model assuming normal errors using function \Rcmd{gam}. Are 
all potential covariates informative? Check the results
against a generalized additive model that underwent
AIC-based variable selection (fitted using function \Rcmd{gamboost}).

\exercise
Again fit an additive model to the body fat data, but this time for
a log-transformed response. Compare the two models, which one is more appropriate?

\exercise
Try to fit a logistic additive model to the glaucoma data
discussed in \Sexpr{ch("RP")}. Which covariates should enter the
model and how is their influence on the probability of 
suffering from glaucoma?

\exercise
Investigate the use of different types of scatterplot smoothers on the
Hubble data in Table~\ref{MLR-hubble-tab} in Chapter~\ref{MLR-hubble-tab}.

\end{description}


\bibliographystyle{LaTeXBibTeX/refstyle}
\bibliography{LaTeXBibTeX/HSAUR}
\end{document}

\documentclass{chapman}

%%% copy Sweave.sty definitions

%%% keeps `sweave' from adding `\usepackage{Sweave}': DO NOT REMOVE
%\usepackage{Sweave} 


\RequirePackage[T1]{fontenc}
\RequirePackage{graphicx,ae,fancyvrb}
\IfFileExists{upquote.sty}{\RequirePackage{upquote}}{}
\usepackage{relsize}

\DefineVerbatimEnvironment{Sinput}{Verbatim}{}
\DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                              fontshape=it,
                                              fontsize=\relsize{-1}}
\DefineVerbatimEnvironment{Scode}{Verbatim}{}
\newenvironment{Schunk}{}{}

%%% environment for raw output
\newcommand{\SchunkRaw}{\renewenvironment{Schunk}{}{}
    \DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                                  fontshape=it,
                                                  fontsize=\small}
    \rawSinput
}

%%% environment for labeled output
\newcommand{\nextcaption}{}
\newcommand{\SchunkLabel}{
  \renewenvironment{Schunk}{\begin{figure}[ht] }{\caption{\nextcaption}
  \end{figure} }
  \DefineVerbatimEnvironment{Sinput}{Verbatim}{frame = topline}
  \DefineVerbatimEnvironment{Soutput}{Verbatim}{frame = bottomline, 
                                                samepage = true,
                                                fontfamily=courier,
                                                fontshape=it,
                                                fontsize=\relsize{-1}}
}


%%% S code with line numbers
\DefineVerbatimEnvironment{Sinput}
{Verbatim}
{
%%  numbers=left
}

\newcommand{\numberSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{numbers=left}
}
\newcommand{\rawSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{}
}


%%% R / System symbols
\newcommand{\R}{\textsf{R}}
\newcommand{\rR}{{R}}
\renewcommand{\S}{\textsf{S}}
\newcommand{\SPLUS}{\textsf{S-PLUS}}
\newcommand{\rSPLUS}{{S-PLUS}}
\newcommand{\SPSS}{\textsf{SPSS}}
\newcommand{\EXCEL}{\textsf{Excel}}
\newcommand{\ACCESS}{\textsf{Access}}
\newcommand{\SQL}{\textsf{SQL}}
%%\newcommand{\Rpackage}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Robject}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\Rclass}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Rcmd}[1]{\hbox{\rm\texttt{#1}}}
\newcommand{\Rpackage}[1]{\index{#1 package@{\fontseries{b}\selectfont #1} package} {\fontseries{b}\selectfont #1}}
\newcommand{\rpackage}[1]{{\fontseries{b}\selectfont #1}}
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\Rclass}[1]{\index{#1 class@\textit{#1} class}\textit{#1}}
\newcommand{\Rcmd}[1]{\index{#1 function@\texttt{#1} function}\texttt{#1}}
\newcommand{\Roperator}[1]{\texttt{#1}}
\newcommand{\Rarg}[1]{\texttt{#1}}
\newcommand{\Rlevel}[1]{\texttt{#1}}


%%% other symbols
\newcommand{\file}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\stress}[1]{\index{#1}\textit{#1}} 
\newcommand{\stress}[1]{\textit{#1}} 
\newcommand{\booktitle}[1]{\textit{#1}} %%'

%%% Math symbols
\usepackage{amstext}
\usepackage{amsmath}
\newcommand{\E}{\mathsf{E}}   
\newcommand{\Var}{\mathsf{Var}}   
\newcommand{\Cov}{\mathsf{Cov}}   
\newcommand{\Cor}{\mathsf{Cor}}   
\newcommand{\x}{\mathbf{x}}   
\newcommand{\y}{\mathbf{y}}   
\renewcommand{\a}{\mathbf{a}}
\newcommand{\W}{\mathbf{W}}   
\newcommand{\C}{\mathbf{C}}   
\renewcommand{\H}{\mathbf{H}}   
\newcommand{\X}{\mathbf{X}}   
\newcommand{\B}{\mathbf{B}}   
\newcommand{\V}{\mathbf{V}}   
\newcommand{\I}{\mathbf{I}}   
\newcommand{\D}{\mathbf{D}}   
\newcommand{\bS}{\mathbf{S}}   
\newcommand{\N}{\mathcal{N}}   
\renewcommand{\L}{L}   
\renewcommand{\P}{\mathsf{P}}   
\newcommand{\K}{\mathbf{K}}
\newcommand{\m}{\mathbf{m}}
\newcommand{\argmin}{\operatorname{argmin}\displaylimits}
\newcommand{\argmax}{\operatorname{argmax}\displaylimits}

\newcommand{\bx}{\mathbf{x}}
\newcommand{\bbeta}{\mathbf{\beta}}


%%% links
\usepackage{hyperref}

\hypersetup{%
  pdftitle = {A Handbook of Statistical Analyses Using R (3rd Edition)},
  pdfsubject = {Book},
  pdfauthor = {Torsten Hothorn and Brian S. Everitt},
  colorlinks = {black},
  linkcolor = {black},
  citecolor = {black},
  urlcolor = {black},
  hyperindex = {true},
  linktocpage = {true},
}


%%% captions & tables
%% <FIXME>: conflics with figure definition in chapman.cls
%%\usepackage[format=hang,margin=10pt,labelfont=bf]{caption}
%% </FIMXE>
\usepackage{longtable}
\usepackage[figuresright]{rotating}

%%% R symbol in chapter 1
\usepackage{wrapfig}

%%% Bibliography
\usepackage[round,comma]{natbib}
\renewcommand{\refname}{References \addcontentsline{toc}{chapter}{References}}
\citeindexfalse

%%% texi2dvi complains that \newblock is undefined, hm...
\def\newblock{\hskip .11em plus .33em minus .07em}

%%% Example sections
\newcounter{exercise}[chapter]
\setcounter{exercise}{0}
\newcommand{\exercise}{\stepcounter{exercise} \item{Ex.~\arabic{chapter}.\arabic{exercise} }}


%% URLs
\newcommand{\curl}[1]{\begin{center} \url{#1} \end{center}}

%%% for manual corrections
%\renewcommand{\baselinestretch}{2}

%%% plot sizes
\setkeys{Gin}{width=0.95\textwidth}

%%% color
\usepackage{color}

%%% hyphenations
\hyphenation{drop-out}
\hyphenation{mar-gi-nal}

%%% new bidirectional quotes need 
\usepackage[utf8]{inputenc}

%\usepackage{setspace}
\definecolor{sidebox_todo}{rgb}{1,1,0.2}
\newcommand{\todo}[1]{
        \hspace{0pt}%
        \marginpar{% 
                        \fcolorbox{black}{sidebox_todo}{%
                                \parbox{\marginparwidth} {

\raggedright\sffamily\footnotesize{TODO: #1}%
                                }
                        }%
        }
}
\begin{document}

%% Title page

\title{A Handbook of Statistical Analyses Using \R{} --- 3rd Edition}

\author{Torsten Hothorn and Brian S. Everitt}

\maketitle
%%\VignetteIndexEntry{Chapter Analyzing Longitudinal Data II}
%%\VignetteDepends{gee,lme4}
\setcounter{chapter}{13}


\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE} 

<<setup, echo = FALSE, results = hide>>=
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })
@

\pagestyle{headings}
<<singlebook, echo = FALSE>>=
book <- FALSE
@

<<setup, echo = FALSE, results = hide>>=
options(digits = 3)

if (!interactive()) {
print.summary.gee <- function (x, digits = NULL, quote = FALSE, prefix = "", ...) 
{
    if (is.null(digits)) 
        digits <- options()$digits
    else options(digits = digits)
    cat("...")
    cat("\nModel:\n")
    cat(" Link:                     ", x$model$link, "\n")
    cat(" Variance to Mean Relation:", x$model$varfun, "\n")
    if (!is.null(x$model$M)) 
        cat(" Correlation Structure:    ", x$model$corstr, ", M =", 
            x$model$M, "\n")
    else cat(" Correlation Structure:    ", x$model$corstr, "\n")
    cat("\n...")
    nas <- x$nas
    if (!is.null(nas) && any(nas)) 
        cat("\n\nCoefficients: (", sum(nas), " not defined because of singularities)\n", 
            sep = "")
    else cat("\n\nCoefficients:\n")
    print(x$coefficients, digits = digits)
    cat("\nEstimated Scale Parameter: ", format(round(x$scale, 
        digits)))
    cat("\n...\n")

    invisible(x)
}
}

@

\chapter[Analyzing Longitudinal Data II]{
         Analyzing Longitudinal Data II -- Generalized Estimation Equations and Linear Mixed Effect Models:
         Treating Respiratory Illness and Epileptic Seizures
         \label{ALDII}}

\section{Introduction}


\section{Methods for Non-normal Distributions}



\section{Analysis Using \R{}: GEE}

\subsection{Beat the Blues Revisited}


To use the \Rcmd{gee} function, package \Rpackage{gee} \citep{PKG:gee}
has to be installed and attached:
<<ALDII-gee, echo = TRUE>>=
library("gee")
@
The \Rcmd{gee} function is used in a similar way to the \Rcmd{lme} function 
met in \Sexpr{ch("ALDI")} with the addition of the features of the
\Rcmd{glm} function that specify the appropriate error distribution 
for the response and the implied link function, and an argument 
to specify the structure of the working correlation matrix. Here 
we will fit an independence structure and then an exchangeable 
structure. The \R{} code for fitting generalized estimation equations to the
\Robject{BtheB\_long} data (as constructed in \Sexpr{ch("ALDI")}) with
identity working correlation matrix is as follows (note that the \Rcmd{gee} function
assumes the rows of the \Rclass{data.frame} \Robject{BtheB\_long} to be
ordered with respect to subjects):
<<ALDII-BtheB-data, echo = FALSE, results = hide>>=
data("BtheB", package = "HSAUR3")
BtheB$subject <- factor(rownames(BtheB))
nobs <- nrow(BtheB)
BtheB_long <- reshape(BtheB, idvar = "subject",
    varying = c("bdi.2m", "bdi.3m", "bdi.5m", "bdi.8m"),
    direction = "long")
BtheB_long$time <- rep(c(2, 3, 5, 8), rep(nobs, 4))
names(BtheB_long)[names(BtheB_long) == "treatment"] <- "trt"
@
<<ALDII-BtheB-geefit-indep, echo = TRUE, results = hide>>=
osub <- order(as.integer(BtheB_long$subject))
BtheB_long <- BtheB_long[osub,]
btb_gee <- gee(bdi ~ bdi.pre + trt + length + drug, 
    data = BtheB_long, id = subject, family = gaussian,
    corstr = "independence")
@
and with exchangeable correlation matrix:
<<ALDII-BtheB-geefit-ex, echo = TRUE, results = hide>>=
btb_gee1 <- gee(bdi ~ bdi.pre + trt + length + drug, 
    data = BtheB_long, id = subject, family = gaussian,
    corstr = "exchangeable")
@
The \Rcmd{summary} method can be used to inspect the fitted models; the
results are shown in Figures~\ref{ALDII-gee-summary} and
\ref{ALDII-gee1-summary}.

\renewcommand{\nextcaption}{\R{} output of the \Rcmd{summary} method 
                            for the \Robject{btb\_gee} model (slightly abbreviated).
                            \label{ALDII-gee-summary}}
\SchunkLabel
<<ALDII-BtheB-geesummary, echo = TRUE>>=
summary(btb_gee)
@
\SchunkRaw

\renewcommand{\nextcaption}{\R{} output of the \Rcmd{summary} method 
                            for the \Robject{btb\_gee1} model (slightly abbreviated).
                            \label{ALDII-gee1-summary}}
\SchunkLabel
<<ALDII-BtheB-gee1summary, echo = TRUE>>=
summary(btb_gee1)
@
\SchunkRaw


\subsection{Respiratory Illness \label{ALDII:resp}}


The baseline status, i.e., the status for \Robject{month == 0}, will enter
the models as an explanatory variable and thus we have to rearrange the
\Rclass{data.frame} \Robject{respiratory} 
in order to create a new variable \Robject{baseline}:
<<ALDII-respiratory-data, echo = TRUE>>=
data("respiratory", package = "HSAUR3")
resp <- subset(respiratory, month > "0")
resp$baseline <- rep(subset(respiratory, month == "0")$status,
                     rep(4, 111))
resp$nstat <- as.numeric(resp$status == "good")
resp$month <- resp$month[, drop = TRUE]
@
<<ALDII-respiratory-names, echo = FALSE, results = hide>>=
names(resp)[names(resp) == "treatment"] <- "trt"
levels(resp$trt)[2] <- "trt"
@

The new variable \Robject{nstat} is simply a dummy coding for a poor
respiratory status. Now we can use the data \Robject{resp} to fit a logistic regression model
and GEE models with an independent and an exchangeable correlation structure
as follows.
<<ALDII-respiratory-fit, echo = TRUE, results = hide>>=
resp_glm <- glm(status ~ centre + trt + gender + baseline 
    + age, data = resp, family = "binomial")
resp_gee1 <- gee(nstat ~ centre + trt + gender + baseline 
    + age, data = resp, family = "binomial", id = subject, 
    corstr = "independence", scale.fix = TRUE, 
    scale.value = 1)
resp_gee2 <- gee(nstat ~ centre + trt + gender + baseline 
    + age, data = resp, family = "binomial", id = subject, 
    corstr = "exchangeable", scale.fix = TRUE, 
    scale.value = 1)
@

\renewcommand{\nextcaption}{\R{} output of the \Rcmd{summary} method
                            for the \Robject{resp\_glm} model.
                            \label{ALDII-resp-glm-summary}}
\SchunkLabel
<<ALDII-resp-glm-summary, echo = TRUE>>=
summary(resp_glm)
@
\SchunkRaw

\renewcommand{\nextcaption}{\R{} output of the \Rcmd{summary} method
                            for the \Robject{resp\_gee1} model (slightly abbreviated).
                            \label{ALDII-resp-gee1-summary}}
\SchunkLabel
<<ALDII-resp-gee1summary, echo = TRUE>>=
summary(resp_gee1)
@
\SchunkRaw

\renewcommand{\nextcaption}{\R{} output of the \Rcmd{summary} method
                            for the \Robject{resp\_gee2} model (slightly abbreviated).
                            \label{ALDII-resp-gee2-summary}}
\SchunkLabel
<<ALDII-resp-gee2-summary, echo = TRUE>>=
summary(resp_gee2)
@
\SchunkRaw



The estimated treatment effect taken from the exchangeable 
structure GEE model is \Sexpr{round(coef(resp_gee2)["trttrt"], 3)} 
which, using the robust standard 
errors, has an associated $95\%$ confidence interval 
<<ALDII-resp-confint, echo = TRUE>>=
se <- summary(resp_gee2)$coefficients["trttrt",
                                      "Robust S.E."]
coef(resp_gee2)["trttrt"] +  
    c(-1, 1) * se * qnorm(0.975)
@
These values reflect effects on the log-odds scale. Interpretation 
becomes simpler if we exponentiate the values to get the effects 
in terms of odds. This gives a treatment effect of
\Sexpr{round(exp(coef(resp_gee2)["trttrt"]), 3)}
and a  $95\%$ confidence interval of 
<<ALDII-resp-confint-exp, echo = TRUE>>=
exp(coef(resp_gee2)["trttrt"] + 
    c(-1, 1) * se * qnorm(0.975))
@
The odds of achieving a `good' respiratory status with the active treatment is between  %'
about twice and seven times the corresponding odds for the placebo. 



\subsection{Epilepsy} 

Moving on to the count data in \Robject{epilepsy} from 
Table~\ref{ALDII-epilepsy-tab}, we begin by calculating 
the means and variances of the number of seizures for all 
interactions between treatment and period:
<<ALDII-epilepsy, echo = TRUE>>=
data("epilepsy", package = "HSAUR3")
itp <- interaction(epilepsy$treatment, epilepsy$period)
tapply(epilepsy$seizure.rate, itp, mean)
tapply(epilepsy$seizure.rate, itp, var)
@
Some of the variances are considerably larger than the corresponding means, which for 
a Poisson variable may suggest that overdispersion may be a problem, see
\Sexpr{ch("GLM")}.

\begin{figure}
\begin{center}
<<ALDII-plot1, echo = TRUE, fig = TRUE, height = 4>>=
layout(matrix(1:2, nrow = 1))
ylim <- range(epilepsy$seizure.rate)
placebo <- subset(epilepsy, treatment == "placebo")
progabide <- subset(epilepsy, treatment == "Progabide")
boxplot(seizure.rate ~ period, data = placebo,
        ylab = "Number of seizures", 
        xlab = "Period", ylim = ylim, main = "Placebo")
boxplot(seizure.rate ~ period, data = progabide,
        main  = "Progabide", ylab = "Number of seizures", 
        xlab = "Period", ylim = ylim)
@
\caption{Boxplots of numbers of seizures in each two-week
         period post randomization for placebo and active treatments.
         \label{ALDII-plot1}}
\end{center}
\end{figure}


\begin{figure}
\begin{center}
<<ALDII-plot2, echo = TRUE, fig = TRUE, height = 4>>=
layout(matrix(1:2, nrow = 1))
ylim <- range(log(epilepsy$seizure.rate + 1))
boxplot(log(seizure.rate + 1) ~ period, data = placebo,
        main = "Placebo", ylab = "Log number of seizures", 
        xlab = "Period", ylim = ylim)
boxplot(log(seizure.rate + 1) ~ period, data = progabide,
        main = "Progabide", ylab = "Log number of seizures", 
        xlab = "Period", ylim = ylim)
@
\caption{Boxplots of log of numbers of seizures in
         each two-week period post randomization for placebo and active 
         treatments. \label{ALDII-plot2}}
\end{center}
\end{figure}


We can now fit a Poisson regression model to the data 
assuming independence using the \Rcmd{glm} function. 
We also use the GEE approach to fit an 
independence structure, followed by an exchangeable structure
using the following \R{} code:
<<ALDII-epilepsy-gee, echo = TRUE, results = hide>>=
per <- rep(log(2),nrow(epilepsy))
epilepsy$period <- as.numeric(epilepsy$period)
names(epilepsy)[names(epilepsy) == "treatment"] <- "trt"
fm <- seizure.rate ~ base + age + trt + offset(per)
epilepsy_glm <- glm(fm, data = epilepsy, family = "poisson")
epilepsy_gee1 <- gee(fm, data = epilepsy, family = "poisson", 
    id = subject, corstr = "independence", scale.fix = TRUE, 
    scale.value = 1)
epilepsy_gee2 <- gee(fm, data = epilepsy, family = "poisson", 
    id = subject, corstr = "exchangeable", scale.fix = TRUE, 
    scale.value = 1)
epilepsy_gee3 <- gee(fm, data = epilepsy, family = "poisson", 
    id = subject, corstr = "exchangeable", scale.fix = FALSE,
    scale.value = 1)
@
As usual we inspect the fitted models using the \Rcmd{summary} method, the
results are given in Figures~\ref{ALDII-epilepsy-glm-summary},
\ref{ALDII-epilepsy-gee1-summary}, \ref{ALDII-epilepsy-gee2-summary}, and 
\ref{ALDII-epilepsy-gee3-summary}.

\renewcommand{\nextcaption}{\R{} output of the \Rcmd{summary} method   
                            for the \Robject{epilepsy\_glm} model.
                            \label{ALDII-epilepsy-glm-summary}}
\SchunkLabel
<<ALDII-espilepsy-glm-summary, echo = TRUE>>=
summary(epilepsy_glm)
@
\SchunkRaw

\renewcommand{\nextcaption}{\R{} output of the \Rcmd{summary} method   
                            for the \Robject{epilepsy\_gee1} model (slightly abbreviated).
                            \label{ALDII-epilepsy-gee1-summary}}
\SchunkLabel
<<ALDII-espilepsy-gee1-summary, echo = TRUE>>=
summary(epilepsy_gee1)
@
\SchunkRaw

\renewcommand{\nextcaption}{\R{} output of the \Rcmd{summary} method   
                            for the \Robject{epilepsy\_gee2} model (slightly abbreviated).
                            \label{ALDII-epilepsy-gee2-summary}}
\SchunkLabel
<<ALDII-espilepsy-gee2-summary, echo = TRUE>>=
summary(epilepsy_gee2)
@
\SchunkRaw

\renewcommand{\nextcaption}{\R{} output of the \Rcmd{summary} method   
                            for the \Robject{epilepsy\_gee3} model (slightly abbreviated).
                            \label{ALDII-epilepsy-gee3-summary}}
\SchunkLabel
<<ALDII-espilepsy-gee3-summary, echo = TRUE>>=
summary(epilepsy_gee3)
@
\SchunkRaw


\section{Analysis Using \R{}: Random Effects}

As an example of using generalized mixed models for the analysis 
of longitudinal data with a non-normal response, the following 
logistic model will be fitted to the respiratory illness data
\begin{eqnarray*}
\text{logit}(\P(\text{status} = \text{good})) & = &
\beta_0 + \beta_1 \text{treatment} + \beta_2 \text{time} + \beta_3 \text{gender} \\%
& & + \beta_4 \text{age} + \beta_5 \text{centre} + 
      \beta_6 \text{baseline} + u
\end{eqnarray*}
where $u$ is a subject-specific random effect.

The necessary \R{} code for fitting the model using the \Rcmd{glmer}
function from package \Rpackage{lme4} \citep{PKG:lme4,HSAUR:Bates2005}
is:
<<ALDII-respiratory-lmer, echo = TRUE>>=
library("lme4")
resp_lmer <- glmer(status ~ baseline + month + 
    trt + gender + age + centre + (1 | subject), 
    family = binomial(), data = resp)
exp(fixef(resp_lmer))
@


The significance of the effects as estimated by this random effects 
model and by the GEE model described in Section~\ref{ALDII:resp} 
is generally similar. 
But as expected from our previous discussion the estimated coefficients 
are substantially larger. While the estimated effect of treatment 
on a randomly sampled individual, given the set of observed covariates, 
is estimated by the marginal model using GEE to increase the log-odds 
of being disease free by $\Sexpr{round(coef(resp_gee2)["trttrt"], 3)}$, 
the corresponding estimate from 
the random effects model is 
$\Sexpr{round(fixef(resp_lmer)["trttrt"], 3)}$. 
These are not inconsistent 
results but reflect the fact that the models are estimating 
different parameters. The random effects estimate is conditional 
upon the patient's random effect, a quantity that is rarely known 
in practice. Were we to examine the log-odds of the average predicted 
probabilities with and without treatment (averaged over the random 
effects) this would give an estimate comparable to that estimated 
within the marginal model.

<<ALDII-resp-lmer-dirty, echo = FALSE>>=
su <- summary(resp_lmer)
if (!interactive()) {
    summary <- function(x) {
        cat("\n...\n")
        cat("Fixed effects:\n")
        lme4V <- packageDescription("lme4")$Version
        if (compareVersion("0.999999-2", lme4V) >= 0) {
            printCoefmat(su@coefs)
        } else {
            printCoefmat(su$coefficients)
        }
        cat("\n...\n")
    }
}
@

\renewcommand{\nextcaption}{\R{} output of the \Rcmd{summary} method
                            for the \Robject{resp\_lmer} model (abbreviated).
                            \label{ALDII-resp-lmer-summary}}
\SchunkLabel
<<ALDII-resp-lmer-summary, echo = TRUE>>=
summary(resp_lmer)
@
\SchunkRaw

\clearpage


\bibliographystyle{LaTeXBibTeX/refstyle}
\bibliography{LaTeXBibTeX/HSAUR}   
\end{document}

\documentclass{chapman}

%%% copy Sweave.sty definitions

%%% keeps `sweave' from adding `\usepackage{Sweave}': DO NOT REMOVE
%\usepackage{Sweave} 


\RequirePackage[T1]{fontenc}
\RequirePackage{graphicx,ae,fancyvrb}
\IfFileExists{upquote.sty}{\RequirePackage{upquote}}{}
\usepackage{relsize}

\DefineVerbatimEnvironment{Sinput}{Verbatim}{}
\DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                              fontshape=it,
                                              fontsize=\relsize{-1}}
\DefineVerbatimEnvironment{Scode}{Verbatim}{}
\newenvironment{Schunk}{}{}

%%% environment for raw output
\newcommand{\SchunkRaw}{\renewenvironment{Schunk}{}{}
    \DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                                  fontshape=it,
                                                  fontsize=\small}
    \rawSinput
}

%%% environment for labeled output
\newcommand{\nextcaption}{}
\newcommand{\SchunkLabel}{
  \renewenvironment{Schunk}{\begin{figure}[ht] }{\caption{\nextcaption}
  \end{figure} }
  \DefineVerbatimEnvironment{Sinput}{Verbatim}{frame = topline}
  \DefineVerbatimEnvironment{Soutput}{Verbatim}{frame = bottomline, 
                                                samepage = true,
                                                fontfamily=courier,
                                                fontshape=it,
                                                fontsize=\relsize{-1}}
}


%%% S code with line numbers
\DefineVerbatimEnvironment{Sinput}
{Verbatim}
{
%%  numbers=left
}

\newcommand{\numberSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{numbers=left}
}
\newcommand{\rawSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{}
}


%%% R / System symbols
\newcommand{\R}{\textsf{R}}
\newcommand{\rR}{{R}}
\renewcommand{\S}{\textsf{S}}
\newcommand{\SPLUS}{\textsf{S-PLUS}}
\newcommand{\rSPLUS}{{S-PLUS}}
\newcommand{\SPSS}{\textsf{SPSS}}
\newcommand{\EXCEL}{\textsf{Excel}}
\newcommand{\ACCESS}{\textsf{Access}}
\newcommand{\SQL}{\textsf{SQL}}
%%\newcommand{\Rpackage}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Robject}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\Rclass}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Rcmd}[1]{\hbox{\rm\texttt{#1}}}
\newcommand{\Rpackage}[1]{\index{#1 package@{\fontseries{b}\selectfont #1} package} {\fontseries{b}\selectfont #1}}
\newcommand{\rpackage}[1]{{\fontseries{b}\selectfont #1}}
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\Rclass}[1]{\index{#1 class@\textit{#1} class}\textit{#1}}
\newcommand{\Rcmd}[1]{\index{#1 function@\texttt{#1} function}\texttt{#1}}
\newcommand{\Roperator}[1]{\texttt{#1}}
\newcommand{\Rarg}[1]{\texttt{#1}}
\newcommand{\Rlevel}[1]{\texttt{#1}}


%%% other symbols
\newcommand{\file}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\stress}[1]{\index{#1}\textit{#1}} 
\newcommand{\stress}[1]{\textit{#1}} 
\newcommand{\booktitle}[1]{\textit{#1}} %%'

%%% Math symbols
\usepackage{amstext}
\usepackage{amsmath}
\newcommand{\E}{\mathsf{E}}   
\newcommand{\Var}{\mathsf{Var}}   
\newcommand{\Cov}{\mathsf{Cov}}   
\newcommand{\Cor}{\mathsf{Cor}}   
\newcommand{\x}{\mathbf{x}}   
\newcommand{\y}{\mathbf{y}}   
\renewcommand{\a}{\mathbf{a}}
\newcommand{\W}{\mathbf{W}}   
\newcommand{\C}{\mathbf{C}}   
\renewcommand{\H}{\mathbf{H}}   
\newcommand{\X}{\mathbf{X}}   
\newcommand{\B}{\mathbf{B}}   
\newcommand{\V}{\mathbf{V}}   
\newcommand{\I}{\mathbf{I}}   
\newcommand{\D}{\mathbf{D}}   
\newcommand{\bS}{\mathbf{S}}   
\newcommand{\N}{\mathcal{N}}   
\renewcommand{\L}{L}   
\renewcommand{\P}{\mathsf{P}}   
\newcommand{\K}{\mathbf{K}}
\newcommand{\m}{\mathbf{m}}
\newcommand{\argmin}{\operatorname{argmin}\displaylimits}
\newcommand{\argmax}{\operatorname{argmax}\displaylimits}

\newcommand{\bx}{\mathbf{x}}
\newcommand{\bbeta}{\mathbf{\beta}}


%%% links
\usepackage{hyperref}

\hypersetup{%
  pdftitle = {A Handbook of Statistical Analyses Using R (3rd Edition)},
  pdfsubject = {Book},
  pdfauthor = {Torsten Hothorn and Brian S. Everitt},
  colorlinks = {black},
  linkcolor = {black},
  citecolor = {black},
  urlcolor = {black},
  hyperindex = {true},
  linktocpage = {true},
}


%%% captions & tables
%% <FIXME>: conflics with figure definition in chapman.cls
%%\usepackage[format=hang,margin=10pt,labelfont=bf]{caption}
%% </FIMXE>
\usepackage{longtable}
\usepackage[figuresright]{rotating}

%%% R symbol in chapter 1
\usepackage{wrapfig}

%%% Bibliography
\usepackage[round,comma]{natbib}
\renewcommand{\refname}{References \addcontentsline{toc}{chapter}{References}}
\citeindexfalse

%%% texi2dvi complains that \newblock is undefined, hm...
\def\newblock{\hskip .11em plus .33em minus .07em}

%%% Example sections
\newcounter{exercise}[chapter]
\setcounter{exercise}{0}
\newcommand{\exercise}{\stepcounter{exercise} \item{Ex.~\arabic{chapter}.\arabic{exercise} }}


%% URLs
\newcommand{\curl}[1]{\begin{center} \url{#1} \end{center}}

%%% for manual corrections
%\renewcommand{\baselinestretch}{2}

%%% plot sizes
\setkeys{Gin}{width=0.95\textwidth}

%%% color
\usepackage{color}

%%% hyphenations
\hyphenation{drop-out}
\hyphenation{mar-gi-nal}

%%% new bidirectional quotes need 
\usepackage[utf8]{inputenc}

%\usepackage{setspace}
\definecolor{sidebox_todo}{rgb}{1,1,0.2}
\newcommand{\todo}[1]{
        \hspace{0pt}%
        \marginpar{% 
                        \fcolorbox{black}{sidebox_todo}{%
                                \parbox{\marginparwidth} {

\raggedright\sffamily\footnotesize{TODO: #1}%
                                }
                        }%
        }
}
\begin{document}

%% Title page

\title{A Handbook of Statistical Analyses Using \R{} --- 3rd Edition}

\author{Torsten Hothorn and Brian S. Everitt}

\maketitle
%%\VignetteIndexEntry{Chapter Principal Component Analysis}
\setcounter{chapter}{18}


\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE} 

<<setup, echo = FALSE, results = hide>>=
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })
@

\pagestyle{headings}
<<singlebook, echo = FALSE>>=
book <- FALSE
@

\chapter[Principal Component Analysis]{Principal Component Analysis: The Olympic Heptathlon \label{PCA}}

\section{Introduction}


\section{Principal Component Analysis}


\section{Analysis Using \R{}}

To begin it will help to score all seven events in the
same direction, so that `large' values are `good'. We will    
recode the running events to achieve this;
<<PCA-heptathlon-recode, echo = TRUE>>=a
data("heptathlon", package = "HSAUR3")
heptathlon$hurdles <- max(heptathlon$hurdles) - 
    heptathlon$hurdles
heptathlon$run200m <- max(heptathlon$run200m) - 
    heptathlon$run200m
heptathlon$run800m <- max(heptathlon$run800m) - 
    heptathlon$run800m
@

\begin{figure}
\begin{center}
<<PCA-heptathlon-scatter, echo = TRUE, fig = TRUE>>=
score <- which(colnames(heptathlon) == "score")
plot(heptathlon[,-score])
@
\caption{Scatterplot matrix for the \Robject{heptathlon} data (all countries). \label{PCA-heptathlon-scatter}}
\end{center}
\end{figure}

Figure~\ref{PCA-heptathlon-scatter} 
shows a scatterplot matrix of the results from all $25$ competitors for the seven events. Most of the scatterplots in 
the diagram suggest that there is a positive relationship between the results for each pairs of events. The exception are the 
plots involving the javelin event which give little evidence of any relationship between the result for this event and the
results from the other six events; we will suggest possible reasons for this below, but first we will examine the numerical 
values of the between pairs events correlations by applying the 
\Rcmd{cor} function
<<PCA-options65, echo = FALSE>>=
w <- options("width")
options(width = 65)
@
<<PCA-heptathlon-cor, echo = TRUE>>=
round(cor(heptathlon[,-score]), 2)
@
<<PCA-optionsw, echo = FALSE>>=
options(width = w$width)
@
Examination of these numerical values confirms that most pairs of events are positively correlated, some moderately (for 
example, high jump and shot) and others relatively highly (for example, high jump and hurdles). And we see that the 
correlations involving the javelin event are all close to zero. One possible explanation for the latter finding is perhaps 
that training for the other six events does not help much in the javelin because it is essentially a `technical' event. An 
alternative explanation is found if we examine the scatterplot matrix in Figure~\ref{PCA-heptathlon-scatter} 
a little more closely. 
It is very clear in this diagram that for all events except the
javelin there is an outlier, the competitor from Papua New Guinea
(PNG), who is much poorer than the other athletes at these six
events and who finished last in the competition in terms of
points scored. But surprisingly in the 
scatterplots involving the javelin it is this competitor who again 
stands out but because she has the third highest value for the event. 
It might be sensible to look again at both the correlation matrix and the 
scatterplot matrix after removing the competitor from PNG; the relevant \R{} 
code is
<<PCA-heptathlon-PNG, echo = TRUE>>=
heptathlon <- heptathlon[-grep("PNG", rownames(heptathlon)),]
@
Now, we again look at the scatterplot and correlation matrix;
\begin{figure}
\begin{center}
<<PCA-heptathlon-scatter2, echo = TRUE, fig = TRUE>>=
score <- which(colnames(heptathlon) == "score")
plot(heptathlon[,-score])
@
\caption{Scatterplot matrix for the \Robject{heptathlon} data 
         after removing observations of 
         the PNG competitor. \label{PCA-heptathlon-scatter2}}
\end{center}
\end{figure}

<<PCA-options65, echo = FALSE>>=
w <- options("width")
options(width = 65)
@
<<PCA-heptathlon-cor2, echo = TRUE>>=
round(cor(heptathlon[,-score]), 2)
@
<<PCA-optionsw, echo = FALSE>>=
options(width = w$width)
@
The correlations change quite substantially and the
new scatterplot matrix in Figure~\ref{PCA-heptathlon-scatter2} does 
not point us to any further extreme observations. In the remainder
of this chapter we analyze the \Robject{heptathlon} data with
the observations of the competitor from Papua New Guinea removed.

<<PCA-options65, echo = FALSE>>=
w <- options("digits")
options(digits = 4)
@

Because the results for the seven heptathlon events are on different
scales we shall extract the principal components from the correlation matrix.
A principal component analysis of the data can be applied
using the \Rcmd{prcomp} function with the \Rcmd{scale} argument
set to \Robject{TRUE} to ensure the analysis is carried out on the correlation
matrix. The result is a list
containing the coefficients defining each component 
(sometimes referred to as \stress{loadings}), 
\index{Loadings}
the principal component scores, etc. The required
code is (omitting the \Robject{score} variable)
<<PCA-heptathlon-pca, echo = TRUE>>=
heptathlon_pca <- prcomp(heptathlon[, -score], scale = TRUE)
print(heptathlon_pca)
@
The \Rcmd{summary} method can be used for further inspection of the details:
<<PCA-heptathlon-summary, echo = TRUE>>=
summary(heptathlon_pca)
@
<<PCA-optionsw, echo = FALSE>>=
options(digits = w$digits)
@
The linear combination for the first principal component is
<<PCA-heptathlon-a1, echo = TRUE>>=
a1 <- heptathlon_pca$rotation[,1]
a1
@
We see that the hurdles and long jump competitions receive the highest weight
but the javelin result is less important.
For computing the first principal component, the data need to be rescaled
appropriately. The center and the scaling used by \Rcmd{prcomp} internally
can be extracted from the \Robject{heptathlon\_pca}
via
<<PCA-heptathlon-scaling, echo = TRUE>>=
center <- heptathlon_pca$center
scale <- heptathlon_pca$scale
@
Now, we can apply the \Rcmd{scale} function to the data and multiply with
the loadings matrix in order to compute the first principal component score 
for each competitor
<<PCA-heptathlon-s1, echo = TRUE>>=
hm <- as.matrix(heptathlon[,-score])
drop(scale(hm, center = center, scale = scale) %*% 
     heptathlon_pca$rotation[,1])
@
or, more conveniently, by extracting the first from all precomputed 
principal components
<<PCA-heptathlon-s1, echo = TRUE>>=
predict(heptathlon_pca)[,1]
@

\begin{figure}
\begin{center}
<<PCA-heptathlon-pca-plot, echo = TRUE, fig = TRUE>>=
plot(heptathlon_pca)
@
\caption{Barplot of the variances explained by the principal components
         (with observations for PNG removed). \label{PCA-heptathlon-pca-plot}}
\end{center}
\end{figure}

<<PCA-heptathlon-sdev, echo = FALSE, results = hide>>=
sdev <- heptathlon_pca$sdev
prop12 <- round(sum(sdev[1:2]^2)/sum(sdev^2)*100, 0)
@
The first two components account for $\Sexpr{prop12}\%$ of the variance. 
A barplot of each component's variance (see %%'
Figure~\ref{PCA-heptathlon-pca-plot}) shows how the first two components dominate.
A plot of the data in the space of the first two principal components, with the points
labeled by the name of the corresponding competitor, can be produced as shown
with Figure~\ref{PCA-heptathlon-biplot}. In addition, the first two loadings for
the events are given in a second coordinate system, also illustrating the special
role of the javelin event. This graphical representation is known as 
\stress{biplot} \citep{HSAUR:Gabriel1971}. \index{Biplot}
A biplot is a graphical representation of the information in an 
$n \times p$ data matrix. The `bi' is a reflection that the technique 
produces a diagram that gives variance and covariance information about 
the variables and information about generalized distances 
between individuals. The coordinates used to produce the biplot can all 
be obtained directly from the principal components analysis of the 
covariance matrix of the data and so the plots can be viewed as an 
alternative representation of the results of such an analysis. Full 
details of the technical details of the biplot are given in 
\cite{HSAUR:Gabriel1981} and in \cite{HSAUR:GowerHand1996}.  
Here we simply construct the biplot for the heptathlon data (without PNG);
the result is shown in Figure~\ref{PCA-heptathlon-biplot}.
The plot clearly shows that the winner of the gold medal, Jackie Joyner-Kersee,
accumulates the majority of her points from the three events
long jump, hurdles, and 200m.

\begin{figure}
\begin{center}
<<PCA-heptathlon-biplot, eval = FALSE>>=
biplot(heptathlon_pca, col = c("gray", "black"))
@
<<PCA-heptathlon-biplot, echo = FALSE, fig = TRUE>>=
tmp <- heptathlon[, -score]
rownames(tmp) <- abbreviate(gsub(" \\(.*", "", rownames(tmp)))
biplot(prcomp(tmp, scale = TRUE), col = c("black", "lightgray"), xlim =
c(-0.5, 0.7))
@
\caption{Biplot of the (scaled) first two principal components
         (with observations for PNG removed).
         \label{PCA-heptathlon-biplot}}
\end{center}
\end{figure}

The correlation between the score
given to each athlete by the standard scoring system used for
the heptathlon and the first principal component score can be   
found from
<<PCA-scorecor, echo = TRUE>>=
cor(heptathlon$score, heptathlon_pca$x[,1])
@
This implies that the first principal component is in good agreement with
the score assigned to the athletes by official Olympic rules; a scatterplot
of the official score and the first principal component is given in 
Figure~\ref{PCA-heptathlonscore}.

\begin{figure}
\begin{center}
<<PCA-heptathlonscore, echo = TRUE, fig = TRUE>>=
plot(heptathlon$score, heptathlon_pca$x[,1])
@
\caption{Scatterplot of the score assigned to each athlete in 1988 and the
first principal component. \label{PCA-heptathlonscore}}
\end{center}
\end{figure}


%%\bibliographystyle{LaTeXBibTeX/refstyle} 
%%\bibliography{LaTeXBibTeX/HSAUR}
\end{document}

\documentclass{chapman}

%%% copy Sweave.sty definitions

%%% keeps `sweave' from adding `\usepackage{Sweave}': DO NOT REMOVE
%\usepackage{Sweave} 


\RequirePackage[T1]{fontenc}
\RequirePackage{graphicx,ae,fancyvrb}
\IfFileExists{upquote.sty}{\RequirePackage{upquote}}{}
\usepackage{relsize}

\DefineVerbatimEnvironment{Sinput}{Verbatim}{}
\DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                              fontshape=it,
                                              fontsize=\relsize{-1}}
\DefineVerbatimEnvironment{Scode}{Verbatim}{}
\newenvironment{Schunk}{}{}

%%% environment for raw output
\newcommand{\SchunkRaw}{\renewenvironment{Schunk}{}{}
    \DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                                  fontshape=it,
                                                  fontsize=\small}
    \rawSinput
}

%%% environment for labeled output
\newcommand{\nextcaption}{}
\newcommand{\SchunkLabel}{
  \renewenvironment{Schunk}{\begin{figure}[ht] }{\caption{\nextcaption}
  \end{figure} }
  \DefineVerbatimEnvironment{Sinput}{Verbatim}{frame = topline}
  \DefineVerbatimEnvironment{Soutput}{Verbatim}{frame = bottomline, 
                                                samepage = true,
                                                fontfamily=courier,
                                                fontshape=it,
                                                fontsize=\relsize{-1}}
}


%%% S code with line numbers
\DefineVerbatimEnvironment{Sinput}
{Verbatim}
{
%%  numbers=left
}

\newcommand{\numberSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{numbers=left}
}
\newcommand{\rawSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{}
}


%%% R / System symbols
\newcommand{\R}{\textsf{R}}
\newcommand{\rR}{{R}}
\renewcommand{\S}{\textsf{S}}
\newcommand{\SPLUS}{\textsf{S-PLUS}}
\newcommand{\rSPLUS}{{S-PLUS}}
\newcommand{\SPSS}{\textsf{SPSS}}
\newcommand{\EXCEL}{\textsf{Excel}}
\newcommand{\ACCESS}{\textsf{Access}}
\newcommand{\SQL}{\textsf{SQL}}
%%\newcommand{\Rpackage}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Robject}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\Rclass}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Rcmd}[1]{\hbox{\rm\texttt{#1}}}
\newcommand{\Rpackage}[1]{\index{#1 package@{\fontseries{b}\selectfont #1} package} {\fontseries{b}\selectfont #1}}
\newcommand{\rpackage}[1]{{\fontseries{b}\selectfont #1}}
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\Rclass}[1]{\index{#1 class@\textit{#1} class}\textit{#1}}
\newcommand{\Rcmd}[1]{\index{#1 function@\texttt{#1} function}\texttt{#1}}
\newcommand{\Roperator}[1]{\texttt{#1}}
\newcommand{\Rarg}[1]{\texttt{#1}}
\newcommand{\Rlevel}[1]{\texttt{#1}}


%%% other symbols
\newcommand{\file}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\stress}[1]{\index{#1}\textit{#1}} 
\newcommand{\stress}[1]{\textit{#1}} 
\newcommand{\booktitle}[1]{\textit{#1}} %%'

%%% Math symbols
\usepackage{amstext}
\usepackage{amsmath}
\newcommand{\E}{\mathsf{E}}   
\newcommand{\Var}{\mathsf{Var}}   
\newcommand{\Cov}{\mathsf{Cov}}   
\newcommand{\Cor}{\mathsf{Cor}}   
\newcommand{\x}{\mathbf{x}}   
\newcommand{\y}{\mathbf{y}}   
\renewcommand{\a}{\mathbf{a}}
\newcommand{\W}{\mathbf{W}}   
\newcommand{\C}{\mathbf{C}}   
\renewcommand{\H}{\mathbf{H}}   
\newcommand{\X}{\mathbf{X}}   
\newcommand{\B}{\mathbf{B}}   
\newcommand{\V}{\mathbf{V}}   
\newcommand{\I}{\mathbf{I}}   
\newcommand{\D}{\mathbf{D}}   
\newcommand{\bS}{\mathbf{S}}   
\newcommand{\N}{\mathcal{N}}   
\renewcommand{\L}{L}   
\renewcommand{\P}{\mathsf{P}}   
\newcommand{\K}{\mathbf{K}}
\newcommand{\m}{\mathbf{m}}
\newcommand{\argmin}{\operatorname{argmin}\displaylimits}
\newcommand{\argmax}{\operatorname{argmax}\displaylimits}

\newcommand{\bx}{\mathbf{x}}
\newcommand{\bbeta}{\mathbf{\beta}}


%%% links
\usepackage{hyperref}

\hypersetup{%
  pdftitle = {A Handbook of Statistical Analyses Using R (3rd Edition)},
  pdfsubject = {Book},
  pdfauthor = {Torsten Hothorn and Brian S. Everitt},
  colorlinks = {black},
  linkcolor = {black},
  citecolor = {black},
  urlcolor = {black},
  hyperindex = {true},
  linktocpage = {true},
}


%%% captions & tables
%% <FIXME>: conflics with figure definition in chapman.cls
%%\usepackage[format=hang,margin=10pt,labelfont=bf]{caption}
%% </FIMXE>
\usepackage{longtable}
\usepackage[figuresright]{rotating}

%%% R symbol in chapter 1
\usepackage{wrapfig}

%%% Bibliography
\usepackage[round,comma]{natbib}
\renewcommand{\refname}{References \addcontentsline{toc}{chapter}{References}}
\citeindexfalse

%%% texi2dvi complains that \newblock is undefined, hm...
\def\newblock{\hskip .11em plus .33em minus .07em}

%%% Example sections
\newcounter{exercise}[chapter]
\setcounter{exercise}{0}
\newcommand{\exercise}{\stepcounter{exercise} \item{Ex.~\arabic{chapter}.\arabic{exercise} }}


%% URLs
\newcommand{\curl}[1]{\begin{center} \url{#1} \end{center}}

%%% for manual corrections
%\renewcommand{\baselinestretch}{2}

%%% plot sizes
\setkeys{Gin}{width=0.95\textwidth}

%%% color
\usepackage{color}

%%% hyphenations
\hyphenation{drop-out}
\hyphenation{mar-gi-nal}

%%% new bidirectional quotes need 
\usepackage[utf8]{inputenc}

%\usepackage{setspace}
\definecolor{sidebox_todo}{rgb}{1,1,0.2}
\newcommand{\todo}[1]{
        \hspace{0pt}%
        \marginpar{% 
                        \fcolorbox{black}{sidebox_todo}{%
                                \parbox{\marginparwidth} {

\raggedright\sffamily\footnotesize{TODO: #1}%
                                }
                        }%
        }
}
\begin{document}

%% Title page

\title{A Handbook of Statistical Analyses Using \R{} --- 3rd Edition}

\author{Torsten Hothorn and Brian S. Everitt}

\maketitle
%%\VignetteIndexEntry{Chapter Cluster Analysis}
%%\VignetteDepends{scatterplot3d,mclust,mvtnorm,lattice}
\setcounter{chapter}{20}


\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE} 

<<setup, echo = FALSE, results = hide>>=
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })
@

\pagestyle{headings}
<<singlebook, echo = FALSE>>=
book <- FALSE
@
%% lower png resolution for vignettes
\SweaveOpts{resolution = 100}

<<thissetup, echo = FALSE, results = hide>>=
library("mclust")
library("mvtnorm")
mai <- par("mai")
options(SweaveHooks = list(rmai = function() { par(mai = mai * c(1,1,1,2))}))
data("pottery", package = "HSAUR3")
@

\chapter[Cluster Analysis]{Cluster Analysis: Classifying Romano-British Pottery and 
                           Exoplanets  \label{CA}}

\section{Introduction}



\section{Cluster Analysis}


\section{Analysis Using \R{}}

\subsection{Classifying Romano-British Pottery}

We start our analysis with computing the dissimilarity matrix
containing the Euclidean distance of the chemical measurements 
on all $\Sexpr{nrow(pottery)}$ pots. The resulting 
$\Sexpr{nrow(pottery)} \times \Sexpr{nrow(pottery)}$ matrix
can be inspected by an \stress{image plot}, here obtained from
\index{Image plot}
function \Rcmd{levelplot} available in package \Rpackage{lattice}
\citep{PKG:lattice, HSAUR:Sarkar2008}. Such a plot associates
each cell of the dissimilarity matrix with a color or a gray
value. We choose a very dark grey for cells with distance zero (i.e.,
the diagonal elements of the dissimilarity matrix) and pale values
for cells with greater Euclidean distance. Figure~\ref{CA-pottery-distplot}
leads to the impression that there are at least three distinct groups
with small inter-cluster differences (the dark rectangles) whereas
much larger distances can be observed for all other cells.

\begin{figure}
\begin{center}
<<CA-pottery-dist, echo = TRUE, results = hide>>=
pottery_dist <- dist(pottery[, colnames(pottery) != "kiln"])
library("lattice")
levelplot(as.matrix(pottery_dist), xlab = "Pot Number", 
          ylab = "Pot Number")
@
<<CA-pottery-distplot, echo = FALSE, fig = TRUE, width = 8, height = 8, pdf = FALSE, png = TRUE>>=
trellis.par.set(standard.theme(color = FALSE))
plot(levelplot(as.matrix(pottery_dist), xlab = "Pot Number", ylab = "Pot Number"))
@
\caption{Image plot of the dissimilarity matrix of the \Robject{pottery} data. 
         \label{CA-pottery-distplot}}
\end{center}
\end{figure}

We now construct three series of partitions using single, complete, and
average linkage hierarchical clustering as introduced in Subsections~\ref{CA:HC} and \ref{CA:diss}. The function \Rcmd{hclust}
performs all three procedures based on the
dissimilarity matrix of the data; its \Rcmd{method} argument is used
to specify how the distance between two clusters is assessed. The
corresponding \Rcmd{plot} method draws a dendrogram; the code and
results are given in Figure~\ref{CA-pottery-hclust}. Again,
all three dendrograms lead to the impression that three clusters
fit the data best (although this judgement is very informal).

\begin{figure}
\begin{center}
<<CA-pottery-hclust, echo = TRUE, fig = TRUE, width = 10, height = 6>>=
pottery_single <- hclust(pottery_dist, method = "single")
pottery_complete <- hclust(pottery_dist, method = "complete")
pottery_average <- hclust(pottery_dist, method = "average")
layout(matrix(1:3, ncol = 3))
plot(pottery_single, main = "Single Linkage", 
     sub = "", xlab = "")
plot(pottery_complete, main = "Complete Linkage", 
     sub = "", xlab = "")
plot(pottery_average, main = "Average Linkage", 
     sub = "", xlab = "")
@
\caption{Hierarchical clustering of \Robject{pottery} data and resulting dendrograms.
         \label{CA-pottery-hclust}}
\end{center}
\end{figure}

From the \Robject{pottery\_average} object representing
the average linkage hierarchical clustering, we derive
the three-cluster solution by cutting the dendrogram at a
height of four (which, based on the right display in 
Figure~\ref{CA-pottery-hclust}
leads to a partition of the data into three groups). Our interest
is now a comparison with the kiln sites at which the pottery was
found.
<<pottery-cluster, echo = TRUE>>=
pottery_cluster <- cutree(pottery_average, h = 4)
xtabs(~ pottery_cluster + kiln, data = pottery)
@
The contingency table shows that cluster 1 contains all
pots found at kiln site number one, cluster 2 contains all pots
from kiln sites number two and three, and cluster three collects the
ten pots from kiln sites four and five. In fact, the five
kiln sites are from three different regions defined by one, two and three, and
four and five, so the clusters actually correspond to pots from
three different regions.

\subsection{Classifying Exoplanets}


\begin{figure}
\begin{center}
<<CA-planets-scatter, echo = TRUE, fig = TRUE, rmai = TRUE>>=
data("planets", package = "HSAUR3")
library("scatterplot3d")
scatterplot3d(log(planets$mass), log(planets$period), 
    log(planets$eccen + ifelse(planets$eccen == 0, 
                               0.001, 0)), 
    type = "h", angle = 55, pch = 16, 
    y.ticklabs = seq(0, 10, by = 2), 
    y.margin.add = 0.1, scale.y = 0.7,
    xlab = "log(mass)", ylab = "log(period)", 
    zlab = "log(eccen)")
@
\caption{3D scatterplot of the logarithms of the three variables available
         for each of the exoplanets. \label{CA-planets-scatter}}
\end{center}
\end{figure}


\begin{figure}
\begin{center}
<<CA-planet-ss, echo = TRUE, fig = TRUE>>=
rge <- apply(planets, 2, max) - apply(planets, 2, min)
planet.dat <- sweep(planets, 2, rge, FUN = "/")
n <- nrow(planet.dat)
wss <- rep(0, 10)
wss[1] <- (n - 1) * sum(apply(planet.dat, 2, var))
for (i in 2:10)
    wss[i] <- sum(kmeans(planet.dat, 
                         centers = i)$withinss)
plot(1:10, wss, type = "b", xlab = "Number of groups",
     ylab = "Within groups sum of squares")
@
\caption{Within-cluster sum of squares for different numbers of clusters for
         the exoplanet data. \label{CA-planets-ss}}
\end{center}
\end{figure}

Sadly Figure~\ref{CA-planets-ss} gives no completely convincing verdict on 
the number of groups we should consider, but using a little imagination `little elbows' can be spotted at the three and five group solutions. %%'
We can find the number of planets in each group 
using
<<CA-planets-kmeans3, echo = TRUE>>=
planet_kmeans3 <- kmeans(planet.dat, centers = 3)
table(planet_kmeans3$cluster)
@
The centers of the clusters for the untransformed data can be computed using
a small convenience function 
<<CA-planets-ccent, echo = TRUE>>=
ccent <- function(cl) {
    f <- function(i) colMeans(planets[cl == i,])
    x <- sapply(sort(unique(cl)), f)
    colnames(x) <- sort(unique(cl))
    return(x)
}
@
which, applied to the three-cluster solution obtained by $k$-means gets
<<CA-planets--kmeans3-ccent, echo = TRUE>>=  
ccent(planet_kmeans3$cluster)
@
@
for the three-cluster solution and, for the five cluster solution using
<<CA-planets-kmeans5, echo = TRUE>>=
planet_kmeans5 <- kmeans(planet.dat, centers = 5)
table(planet_kmeans5$cluster)
ccent(planet_kmeans5$cluster)
@


\subsection{Model-based Clustering in \R{}}

We now proceed to apply model-based clustering to the \Robject{planets} data.
\R{} functions for model-based clustering are available in package 
\Rpackage{mclust} \citep{PKG:mclust,HSAUR:FraleyRaftery2002}.
Here we use the \Rcmd{Mclust} function since this 
selects both the most appropriate model for the data \stress{and}
the optimal number of groups based on the values of the BIC 
computed over several models and a range of 
values for number of groups. The necessary code is:
<<CA-planets-mclust, echo = TRUE>>=
library("mclust")
planet_mclust <- Mclust(planet.dat)
@
and we first examine a plot of BIC values using the \R{} code
that is displayed on top of Figure~\ref{CA-mclust1}.
In this diagram the different plotting symbols refer
to different model assumptions about the shape of clusters:
\begin{description}
\item[EII] spherical, equal volume,
\item[VII] spherical, unequal volume, 
\item[EEI] diagonal, equal volume and shape,
\item[VEI] diagonal, varying volume, equal shape,
\item[EVI] diagonal, equal volume, varying shape, 
\item[VVI] diagonal, varying volume and shape,
\item[EEE] ellipsoidal, equal volume, shape, and orientation, 
\item[EEV] ellipsoidal, equal volume and equal shape,
\item[VEV] ellipsoidal, equal shape, 
\item[VVV] ellipsoidal, varying volume, shape, and orientation
\end{description}  

\begin{figure}
\begin{center}
<<CA-planets-mclust-plot, echo = TRUE, fig = TRUE>>=
plot(planet_mclust, planet.dat, what = "BIC", col = "black", 
     ylab = "-BIC", ylim = c(0, 350))  
@
\caption{Plot of BIC values for a variety of models and a range of number of
clusters. \label{CA-mclust1}}
\end{center}
\end{figure}


The BIC selects model VVI (diagonal varying volume and varying shape) with
three clusters as the best solution as can be
seen from the \Rcmd{print} output:
<<CA-planets-mclust-print, echo = TRUE>>=
print(planet_mclust)
@
This solution can be shown graphically as a scatterplot matrix.
The plot is shown in Figure~\ref{CA-planets-mclust-scatter}. 
Figure~\ref{CA-planets-mclust-scatterclust} depicts the clustering solution
in the three-dimensional space.
\begin{figure}
\begin{center}
<<CA-planets-mclust-scatter, echo = TRUE, fig = TRUE, results = hide>>=
clPairs(planet.dat, 
    classification = planet_mclust$classification, 
    symbols = 1:3, col = "black")
@
\caption{Scatterplot matrix of planets data showing a three-cluster solution
         from \Rcmd{Mclust}. \label{CA-planets-mclust-scatter}}
\end{center}
\end{figure}

\begin{figure}
\begin{center}
<<CA-planets-mclust-scatterclust, echo = TRUE, fig = TRUE, rmai = TRUE>>=
scatterplot3d(log(planets$mass), log(planets$period), 
    log(planets$eccen + ifelse(planets$eccen == 0, 
                               0.001, 0)), 
    type = "h", angle = 55,  scale.y = 0.7, 
    pch = planet_mclust$classification, 
    y.ticklabs = seq(0, 10, by = 2), y.margin.add = 0.1,
    xlab = "log(mass)", ylab = "log(period)", 
    zlab = "log(eccen)")
@
\caption{3D scatterplot of planets data showing a three-cluster solution
         from \Rcmd{Mclust}. \label{CA-planets-mclust-scatterclust}}
\end{center}
\end{figure}


The number of planets in each cluster and the mean vectors of the three clusters
for the untransformed data can now be inspected by using
<<CA-planets-mclust-mu, echo = TRUE>>=
table(planet_mclust$classification)
ccent(planet_mclust$classification)
@
Cluster 1 consists of planets about the same size as Jupiter
with very short periods and eccentricities (similar to the first 
cluster of the $k$-means solution). Cluster 2 consists of slightly 
larger planets with moderate periods and large eccentricities,   
and cluster 3 contains the very large planets with very large    
periods. These two clusters do not match those found by the $k$-means
approach.


\bibliographystyle{LaTeXBibTeX/refstyle}
\bibliography{LaTeXBibTeX/HSAUR}   
\end{document}

\documentclass{chapman}

%%% copy Sweave.sty definitions

%%% keeps `sweave' from adding `\usepackage{Sweave}': DO NOT REMOVE
%\usepackage{Sweave} 


\RequirePackage[T1]{fontenc}
\RequirePackage{graphicx,ae,fancyvrb}
\IfFileExists{upquote.sty}{\RequirePackage{upquote}}{}
\usepackage{relsize}

\DefineVerbatimEnvironment{Sinput}{Verbatim}{}
\DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                              fontshape=it,
                                              fontsize=\relsize{-1}}
\DefineVerbatimEnvironment{Scode}{Verbatim}{}
\newenvironment{Schunk}{}{}

%%% environment for raw output
\newcommand{\SchunkRaw}{\renewenvironment{Schunk}{}{}
    \DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                                  fontshape=it,
                                                  fontsize=\small}
    \rawSinput
}

%%% environment for labeled output
\newcommand{\nextcaption}{}
\newcommand{\SchunkLabel}{
  \renewenvironment{Schunk}{\begin{figure}[ht] }{\caption{\nextcaption}
  \end{figure} }
  \DefineVerbatimEnvironment{Sinput}{Verbatim}{frame = topline}
  \DefineVerbatimEnvironment{Soutput}{Verbatim}{frame = bottomline, 
                                                samepage = true,
                                                fontfamily=courier,
                                                fontshape=it,
                                                fontsize=\relsize{-1}}
}


%%% S code with line numbers
\DefineVerbatimEnvironment{Sinput}
{Verbatim}
{
%%  numbers=left
}

\newcommand{\numberSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{numbers=left}
}
\newcommand{\rawSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{}
}


%%% R / System symbols
\newcommand{\R}{\textsf{R}}
\newcommand{\rR}{{R}}
\renewcommand{\S}{\textsf{S}}
\newcommand{\SPLUS}{\textsf{S-PLUS}}
\newcommand{\rSPLUS}{{S-PLUS}}
\newcommand{\SPSS}{\textsf{SPSS}}
\newcommand{\EXCEL}{\textsf{Excel}}
\newcommand{\ACCESS}{\textsf{Access}}
\newcommand{\SQL}{\textsf{SQL}}
%%\newcommand{\Rpackage}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Robject}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\Rclass}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Rcmd}[1]{\hbox{\rm\texttt{#1}}}
\newcommand{\Rpackage}[1]{\index{#1 package@{\fontseries{b}\selectfont #1} package} {\fontseries{b}\selectfont #1}}
\newcommand{\rpackage}[1]{{\fontseries{b}\selectfont #1}}
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\Rclass}[1]{\index{#1 class@\textit{#1} class}\textit{#1}}
\newcommand{\Rcmd}[1]{\index{#1 function@\texttt{#1} function}\texttt{#1}}
\newcommand{\Roperator}[1]{\texttt{#1}}
\newcommand{\Rarg}[1]{\texttt{#1}}
\newcommand{\Rlevel}[1]{\texttt{#1}}


%%% other symbols
\newcommand{\file}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\stress}[1]{\index{#1}\textit{#1}} 
\newcommand{\stress}[1]{\textit{#1}} 
\newcommand{\booktitle}[1]{\textit{#1}} %%'

%%% Math symbols
\usepackage{amstext}
\usepackage{amsmath}
\newcommand{\E}{\mathsf{E}}   
\newcommand{\Var}{\mathsf{Var}}   
\newcommand{\Cov}{\mathsf{Cov}}   
\newcommand{\Cor}{\mathsf{Cor}}   
\newcommand{\x}{\mathbf{x}}   
\newcommand{\y}{\mathbf{y}}   
\renewcommand{\a}{\mathbf{a}}
\newcommand{\W}{\mathbf{W}}   
\newcommand{\C}{\mathbf{C}}   
\renewcommand{\H}{\mathbf{H}}   
\newcommand{\X}{\mathbf{X}}   
\newcommand{\B}{\mathbf{B}}   
\newcommand{\V}{\mathbf{V}}   
\newcommand{\I}{\mathbf{I}}   
\newcommand{\D}{\mathbf{D}}   
\newcommand{\bS}{\mathbf{S}}   
\newcommand{\N}{\mathcal{N}}   
\renewcommand{\L}{L}   
\renewcommand{\P}{\mathsf{P}}   
\newcommand{\K}{\mathbf{K}}
\newcommand{\m}{\mathbf{m}}
\newcommand{\argmin}{\operatorname{argmin}\displaylimits}
\newcommand{\argmax}{\operatorname{argmax}\displaylimits}

\newcommand{\bx}{\mathbf{x}}
\newcommand{\bbeta}{\mathbf{\beta}}


%%% links
\usepackage{hyperref}

\hypersetup{%
  pdftitle = {A Handbook of Statistical Analyses Using R (3rd Edition)},
  pdfsubject = {Book},
  pdfauthor = {Torsten Hothorn and Brian S. Everitt},
  colorlinks = {black},
  linkcolor = {black},
  citecolor = {black},
  urlcolor = {black},
  hyperindex = {true},
  linktocpage = {true},
}


%%% captions & tables
%% <FIXME>: conflics with figure definition in chapman.cls
%%\usepackage[format=hang,margin=10pt,labelfont=bf]{caption}
%% </FIMXE>
\usepackage{longtable}
\usepackage[figuresright]{rotating}

%%% R symbol in chapter 1
\usepackage{wrapfig}

%%% Bibliography
\usepackage[round,comma]{natbib}
\renewcommand{\refname}{References \addcontentsline{toc}{chapter}{References}}
\citeindexfalse

%%% texi2dvi complains that \newblock is undefined, hm...
\def\newblock{\hskip .11em plus .33em minus .07em}

%%% Example sections
\newcounter{exercise}[chapter]
\setcounter{exercise}{0}
\newcommand{\exercise}{\stepcounter{exercise} \item{Ex.~\arabic{chapter}.\arabic{exercise} }}


%% URLs
\newcommand{\curl}[1]{\begin{center} \url{#1} \end{center}}

%%% for manual corrections
%\renewcommand{\baselinestretch}{2}

%%% plot sizes
\setkeys{Gin}{width=0.95\textwidth}

%%% color
\usepackage{color}

%%% hyphenations
\hyphenation{drop-out}
\hyphenation{mar-gi-nal}

%%% new bidirectional quotes need 
\usepackage[utf8]{inputenc}

%\usepackage{setspace}
\definecolor{sidebox_todo}{rgb}{1,1,0.2}
\newcommand{\todo}[1]{
        \hspace{0pt}%
        \marginpar{% 
                        \fcolorbox{black}{sidebox_todo}{%
                                \parbox{\marginparwidth} {

\raggedright\sffamily\footnotesize{TODO: #1}%
                                }
                        }%
        }
}
\begin{document}

%% Title page

\title{A Handbook of Statistical Analyses Using \R{} --- 3rd Edition}

\author{Torsten Hothorn and Brian S. Everitt}

\maketitle
%%\VignetteIndexEntry{Chapter Missing Values}
%%\VignetteDepends{mice}
\setcounter{chapter}{15}


\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE} 

<<setup, echo = FALSE, results = hide>>=
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })
@

\pagestyle{headings}
<<singlebook, echo = FALSE>>=
book <- FALSE
@


\chapter[Missing Values]{Missing Values: 
Lowering Blood Pressure During Surgery \label{MV}}

\section{Introduction}

\index{Blood pressure}
It is sometimes necessary to lower a patient's blood pressure during
surgery, using a hypotensive drug.  Such drugs are administered continuously
during the relevant phase of the operation; because the duration of this
phase varies so does the total amount of drug administered.  Patients also
vary in the extent to which the drugs succeed in lowering blood pressure. 
The sooner the blood pressure rises again to normal after the drug is
discontinued, the better.  The data in Table~\ref{MV-bp-tab} \citep[a
missing-value version of the data presented
by][]{HSAUR:RobertsonArmitage1959} relate to a particular hypotensive drug
and give the time in minutes before the patient's systolic blood pressure
returned to 100mm of mercury (the recovery time), the logarithm (base 10) of
the dose of drug in milligrams, and the average systolic blood pressure
achieved while the drug was being administered.  The question of interest is
how is the recovery time related to the other two variables?  For some
patients the recovery time was not recorded and the missing values are
indicated as NA in Table~\ref{MV-bp-tab}.

<<MV-bp-tab, echo = FALSE, results = tex>>=
data("bp", package = "HSAUR3")
toLatex(HSAURtable(bp), pcol = 2,
    caption = paste("Blood pressure data."),
    label = "MV-bp-tab")
@


\section{Analyzing Multiply Imputed Data} \label{MI:ana}

From the analysis of each data set we need to look at the estimates of the
quantity of interest, say $Q$, and the variance of the estimates.  We let
$\hat{Q}_i$ be the estimate from the $i$th data set and $S_i$ its
corresponding variance.  The combined estimate of the quantity of interest
is
\begin{eqnarray*}
\bar{Q} = \frac{1}{m}\sum_{i = 1}^m \hat{Q}_i.
\end{eqnarray*}
To find the combined variance involves first calculating the 
within-imputation variance,
\begin{eqnarray*}
\bar{S} = \frac{1}{m}\sum_{i = 1}^m S_i
\end{eqnarray*}
followed by the between-imputation variance,
\begin{eqnarray*}
B = \frac{1}{m - 1} \sum_{i = 1}^m (\hat{Q}_i - \bar{Q})^2
\end{eqnarray*}
then the required total variance can now be found from
\begin{eqnarray*}
T = \bar{S} + (1 + m^{-1}) B
\end{eqnarray*}
This total variance is made up of two components; the first which preserves
the natural variability, $\bar{S}$, is simply the average of the variance
estimates for each imputed data set and is analogous to the variance that
would be suitable if we did not need to account for missing data; the second
component, $B$, estimates uncertainty caused by missing data by measuring
how the point estimates vary from data set to data set.  More explanation of
how the formula for $T$ arises is given in
\cite{HSAUR:vanBuuren2012}.

The overall standard error is simply the square root of $T$. A significance
test for $Q$ and a confidence interval is found from the usual test statistic,
($Q-$ hypothesized value of $Q$)/$\sqrt{T}$, the value of which is referred to a
Student's $t$-distribution.  The question arises however as to what is the appropriate value for the degrees of
freedom of the test, say $v_0$? \cite{HSAUR:Rubin1987} suggests that the answer to this
question is given by;
\begin{eqnarray*}
v_0 = (m - 1) (1 + 1/r^2)
\end{eqnarray*}
where
\begin{eqnarray*}
r = \frac{B + B / m}{\bar{S}}
\end{eqnarray*}
But \cite{HSAUR:BarnardRubin1999} noted that using this value of $v_0$ can produce values that are
larger than the degrees of freedom in the complete data, a result which they
considered `clearly inappropriate'.  Consequently they developed an adapted
version that does not lead to the same problem.  Barnard and Rubin's revised
value for the degrees of freedom of the $t$-test in which we are interested is $v_1$
given by;
\begin{eqnarray*}
v_1 = \frac{v_0 v_2}{v_0 + v_2}
\end{eqnarray*}
where
\begin{eqnarray*}
v_2 = \frac{n(n-1)(1 - \lambda)}{n + 2}
\end{eqnarray*}
and
\begin{eqnarray*}
\lambda = \frac{r}{\sqrt{r^2 + 1}}.
\end{eqnarray*}
The quantity $v_1$ is always less than or equal to the degrees of freedom of
the test applied to the hypothetically complete data.  \citep[For more
details see][]{HSAUR:vanBuuren2012}.
\index{Imputation|)}

\section{Analysis Using \R{}}

To begin we shall analyze the blood pressure data in Table~\ref{MV-bp-tab}
using the complete-case approach, i.e., by simply removing the data for
patients where the recovery time is missing.  To begin we might simply count
the number of missing values using the sapply function as follows:
<<MV-bp-NA, echo = TRUE>>=
sapply(bp, function(x) sum(is.na(x)))
@
So there are ten missing values of recovery time but no missing values
amongst the other two variables.  Now we use the \Rcmd{summary} function to look at
some basic statistics of the complete data for recovery time:
<<MV-bp-msd-cc, echo = TRUE>>=
summary(bp$recovtime, na.rm = TRUE)
@
And next we can calculate the complete data estimate of the standard deviation
of recover time 
<<MV-bp-sd-cc, echo = TRUE>>=
sd(bp$recovtime, na.rm = TRUE)
@
The final numerical results we might be interested in are the correlations
of recovery time with blood pressure and of recovery time with logdose. 
These can be found as follows:
<<MV-bp-cor-cc, echo = TRUE>>= 
with(bp, cor(bloodp, recovtime, use = "complete.obs"))
with(bp, cor(logdose, recovtime, use = "complete.obs"))
@
And a useful graphic of the data is a scatterplot matrix which we can
construct using \Rcmd{pairs}.  The scatterplot matrix is given in
Figure~\ref{MV-bp-pairs-cc}.

\begin{figure}
\begin{center}
<<MV-bp-pairs-cc, echo = TRUE, fig = TRUE, height = 3>>=
layout(matrix(1:3, nrow = 1))
plot(bloodp ~ logdose, data = bp)
plot(recovtime ~ bloodp, data = bp)
plot(recovtime ~ logdose, data = bp)
@
\caption{Scatterplots of the complete cases of the \Robject{bp} data.  
         \label{MV-bp-pairs-cc}}
\end{center}
\end{figure}

To investigate how recovery time is related to blood pressure and logdose we
might begin by fitting a multiple linear regression model (see
Chapter~\ref{MLR}).  The relevant command and the summary of the results is
shown in Figure~\ref{MV-bp-lm-cc}.  Note that this summary output reports
that ten observations with missing values were removed prior to the
analysis; this is default for many models in \R.

\renewcommand{\nextcaption}{\R{} output of the complete-case linear model 
                            for the \Robject{bp} data.
                            \label{MV-bp-lm-cc}}  
\SchunkLabel
<<MV-bp-lm-cc, echo = TRUE>>=
summary(lm(recovtime ~ bloodp + logdose, data = bp))
@
\SchunkRaw

Now let us see what happens when we impute the missing values of the
recovery time variable simply by the mean of the complete case; for this we
will use the \Rpackage{mice} \citep{PKG:mice} package;
<<MV-bp-mice-pkg, echo = TRUE>>=
library("mice")
@
We begin by creating a new data set, \Robject{imp}, which will contain the three
variables log-dose, blood pressure, and recovery time with the missing values
in the latter replaced by the mean recovery time of the complete cases;
<<MV-bp-mice, echo = TRUE>>=
imp <- mice(bp, method = "mean", m = 1, maxit = 1)
@
So now we can find the summary statistics of recovery time to compare with
those given previously
<<MV-bp-imp-summary, echo = TRUE>>=
with(imp, summary(recovtime))
@
Making the comparison we see that only the values of the first and third
quantile and the median have changed.  The minimum and maximum values are
the same and so, of course, is the mean.  But of more interest is what
happens to the sample standard deviation; its value for the imputed data can
be found using:
<<MV-bp-imp-sd, echo = TRUE>>=
with(imp, sd(recovtime))
@
The value for the imputed data, $\Sexpr{round(with(imp, sd(recovtime))[["analyses"]][[1]], 2)}$ 
is, as we would expect, lower than that for the complete data, 
$\Sexpr{round(with(bp, sd(recovtime, na.rm = TRUE)), 2)}$.  
What about the correlations?
<<MV-bp-imp-cor, echo = TRUE>>=      
with(imp, cor(bloodp, recovtime))
with(imp, cor(logdose, recovtime)) 
@
The correlations of blood pression and recovery time are very similar before
($\Sexpr{round(with(bp, cor(bloodp, recovtime, use = "complete.obs")), 2)}$)
after 
($\Sexpr{round(with(imp, cor(bloodp, recovtime))[["analyses"]][[1]], 2)}$)
imputation. For log-dose, imputation changes the correlation from
$\Sexpr{round(with(bp, cor(logdose, recovtime, use = "complete.obs")), 2)}$
to
$\Sexpr{round(with(imp, cor(logdose, recovtime))[["analyses"]][[1]], 2)}$.

The scatterplot of the imputed data is found as given by the code displayed
with Figure~\ref{MV-bp-pairs-imp}.  For mean imputation, the imputed value
of the recovery time is constant for all observations and so they appear as
a series of points along the value of the mean value of the observed
recovery times namely, $\Sexpr{round(with(bp, mean(recovtime, na.rm = TRUE)), 2)}$.

\begin{figure}
\begin{center}
<<MV-bp-pairs-imp, echo = TRUE, fig = TRUE, height = 4>>=
layout(matrix(1:2, nrow = 1))
plot(recovtime ~ bloodp, data = complete(imp), 
     pch = is.na(bp$recovtime) + 1)
plot(recovtime ~ logdose, data = complete(imp), 
     pch = is.na(bp$recovtime) + 1)
legend("topleft", pch = 1:2, bty = "n",
       legend = c("original", "imputed"))
@
\caption{Scatterplots of the imputed \Robject{bp} data. Imputed
         observations are depicted as triangles. 
         \label{MV-bp-pairs-imp}} 
\end{center}
\end{figure}

\renewcommand{\nextcaption}{\R{} output of the mean imputation linear model
                            for the \Robject{bp} data.
                            \label{MV-bp-lm-imp}}
\SchunkLabel
<<MV-bp-lm-imp, echo = TRUE>>=
with(imp, summary(lm(recovtime ~ bloodp + logdose)))
@
\SchunkRaw

Comparison of the multiple linear regression results in
Figure~\ref{MV-bp-lm-imp} with those in Figure~\ref{MV-bp-lm-cc} show some
interesting differences, for example, the standard errors of the regression
coefficients are somewhat lower for the mean imputed data but the
conclusions drawn from the results in each table would be broadly similar.

\index{Predictive mean matching}
The single imputation of a sample mean is not to be recommended and so we
will move on to using a more sophisticated multiple imputation procedure
know as \stress{predictive mean matching}.  The method is described in
detail in \cite{HSAUR:vanBuuren2012} who considers it both easy-to-use and versatile. 
And imputations outside the observed data range will not occur so that
problems with meaningless imputations, for example, a negative recovery
time, will not occur.  The method is labeled \Robject{pmm} in the
\Rpackage{mice} package and here we will apply it to the blood pressure data
with $m = 10$ (we need to fix the seed in order to make the result
reproducible):
<<MV-bp-mice, echo = TRUE>>=
imp_ppm <- mice(bp, m = 10, method = "pmm", 
                print = FALSE, seed = 1)
@

The scatterplot of the imputed data is found as given by the code displayed
with Figure~\ref{MV-bp-pairs-imp-mice}.  We only show the imputed recovery
times from the first iteration ($m = 1$).The imputed recovery times now take
different values.
\begin{figure}
\begin{center}
<<MV-bp-pairs-mice, echo = TRUE, fig = TRUE, height = 4>>=
layout(matrix(1:2, nrow = 1))
plot(recovtime ~ bloodp, data = complete(imp_ppm),      
     pch = is.na(bp$recovtime) + 1)
plot(recovtime ~ logdose, data = complete(imp_ppm),
     pch = is.na(bp$recovtime) + 1)
legend("topleft", pch = 1:2, bty = "n",
       legend = c("original", "imputed"))
@
\caption{Scatterplots of the multiple imputed \Robject{bp} data (first iteration). 
         Imputed observations are depicted as triangles. 
         \label{MV-bp-pairs-imp-mice}} 
\end{center}
\end{figure}  

From the resulting object we can compute the mean and standard deviations of
recovery time for each of the $m = 10$ iterations.  We first extract these
numbers from the \Robject{analyses} element of the returned object, convert
this list to a vector, and use the \Rcmd{summary} function to compute the
usual summary statistics:
<<MV-bp-mice-out, echo = TRUE>>=
summary(unlist(with(imp_ppm, mean(recovtime))$analyses))
summary(unlist(with(imp_ppm, sd(recovtime))$analyses))
@
We do the same with the correlations as follows
<<MV-bp-mice-cor, echo = TRUE>>=
summary(unlist(with(imp_ppm, 
        cor(bloodp, recovtime))$analyses))
summary(unlist(with(imp_ppm, 
        cor(logdose, recovtime))$analyses))
@
The estimate of the mean of the blood pressure data from the multiply
imputed results is $\Sexpr{round(mean(unlist(with(imp_ppm, mean(recovtime))$analyses)) , 2)}$, 
very similar to the values found previously. 
Similarly the estimate of the standard deviation of the data is
$\Sexpr{round(mean(unlist(with(imp_ppm, sd(recovtime))$analyses)) , 2)}$ which
lies between the complete data estimate and the \emph{mean-imputed}
value.  The two correlation estimates are also
very close to the previous values.  The variation in the estimates of mean,
standard deviation, and correlations across the ten imputation is relatively
small apart from that for the correlation between log-dose and recovery
time -- here there is considerable variation in the values for the ten
imputations.

Finally, we will fit a linear model to each of the imputed samples and then
find the summary statistics for the ten sets of regression coefficients: the
results are given in Figure~\ref{MV-bp-lm-cc-mice}:
<<MV-bp-mice-lm, echo = TRUE>>=
fit <- with(imp_ppm, lm(recovtime ~ bloodp + logdose))
@

\renewcommand{\nextcaption}{\R{} output of the multiple imputed linear model
                            for the \Robject{bp} data.
                            \label{MV-bp-lm-cc-mice}}  
\SchunkLabel
<<MV-bp-lm-mice, echo = TRUE>>=
summary(pool(fit))
@
\SchunkRaw

The result for blood pressure is similar to the previous complete data and
mean-imputed results with the regression coefficient for this variable being
highly significant 
$(p = \Sexpr{round(summary(pool(fit))["bloodp", 5], 3)})$.
But the result for log dose differs from
those found previously; for the multiply imputed data the regression
coefficient for log dose is not significant at the $5\%$ level 
$(p = \Sexpr{round(summary(pool(fit))["logdose", 5], 3)})$
whereas in both of the previous two analyses it was significant.  This
finding reflects the greater variation of the value of the correlation
between log dose and recovery time in the ten imputations noted
above. (Remember that the standard errors in Figure~\ref{MV-bp-lm-cc-mice} 
computed by \Rcmd{pool} arise from the formulae given in Section~\ref{MI:ana}.) 

Now suppose we wish to test the hypothesis that in the population from which
the sample data in Table~\ref{MV-bp-tab} arises a mean recovery time of $27$ minutes.
We will test this hypothesis in the usual way using Student's t-test applied to the
complete-data, the singly imputed data, and the multiply imputed data:
<<MI-bp-t, echo = TRUE>>=
with(bp, t.test(recovtime, mu = 27))
with(imp, t.test(recovtime, mu = 27))$analyses[[1]]
@
For the multiply imputed data we need to use the \Rcmd{lm} function to get the
equivalent of the $t$-test by modeling recovery time minus $27$ with an
intercept only and testing for zero intercept.  So the code needed is:
<<MI-mice-t, echo = TRUE>>=
fit <- with(imp_ppm, lm(I(recovtime - 27) ~ 1))
summary(pool(fit))
@
Looking at the results of the three analyses we see that the complete-case
analysis fails to reject the hypothesis at the $5\%$ level whereas the other
two analyses lead to results that are statistically significant at the
level.  This simple (and perhaps rather artificial) example demonstrates
that different conclusions can be reached by the different approaches.


\section{Summary of Findings}

The estimated standard deviation of the blood pressure is lower when
computed from the mean-imputed data than from the complete data.  The
corresponding value from the multiply imputed data lies between these two
values.

The estimate of the mean from the multiply imputed data is very similar
to the value obtained in the complete data analysis.  (The value from the
singly imputed data is, of course, the same as from the complete data.)

The estimates of the correlations between blood pressure and recovery
time and log dose and recovery time are very similar in all three analyses
but the variation in the latter across the ten multiple imputations is
considerable and this results in the regression coefficient for log dose being less significant than in the other two analyses.

Testing the hypothesis that the population mean of recovery time is $27$
minutes using complete-case analysis leads to a different conclusion than is
arrived at by the two multiple imputations approaches.

\section{Final Comments}

Missing values are an ever-present possibility in all types of studies
although everything possible should be done to avoid them.  But when data
contain missing values multiple imputation can be used to provide valid
inferences for parameter estimates from the incomplete data.  If carefully
handled, multiple imputation can cope with missing data in all types of
variables.  In this chapter we have given only a brief account of dealing
with missing values; a detailed account is available in the issue of
\stress{Statistical Methods in Medical Research entitled Multiple Imputation:
Current Perspectives} (Volume 16, Number 3, 2007) and in \cite{HSAUR:vanBuuren2012}.

\section*{Exercises}

\begin{description}


\exercise
The data in Table~\ref{MI-UStemp-tab} give the lowest temperatures (in Fahrenheit) recorded in
various months for cities in the US; missing values are indicated by NA. 
Calculate the correlation matrix of the data using
\begin{enumerate}
\item the complete-case approach, 
\item the available-data approach, and 
\item a multiple-imputation approach.  
\end{enumerate}
Find the principal components of the data using each of three
correlation matrices and plot the cities in the space of the first two
components of each solution.

<<MI-UStemp-tab, echo = FALSE, results = tex>>=
data("UStemp", package = "HSAUR3")
toLatex(HSAURtable(UStemp), 
    caption = "Lowest temperatures in Fahrenheit recorded in various months for cities in the US.",
    label = "MI-UStemp-tab", rownames = TRUE)
@


\exercise
Find $95\%$ confidence intervals for the population means of the lowest
temperature in each month using 
\begin{enumerate}
\item the complete-case approach,
\item the mean value imputation, and
\item a multiple-imputation approach. 
\end{enumerate}

\exercise
Find the correlation matrix for the four months in Table~\ref{MI-UStemp-tab} using complete-case analysis, 
listwise deletion, and multiple imputation.


\end{description}

%%\bibliographystyle{LaTeXBibTeX/refstyle}
%%\bibliography{LaTeXBibTeX/HSAUR}   
\end{document}

\documentclass{chapman}

%%% copy Sweave.sty definitions

%%% keeps `sweave' from adding `\usepackage{Sweave}': DO NOT REMOVE
%\usepackage{Sweave} 


\RequirePackage[T1]{fontenc}
\RequirePackage{graphicx,ae,fancyvrb}
\IfFileExists{upquote.sty}{\RequirePackage{upquote}}{}
\usepackage{relsize}

\DefineVerbatimEnvironment{Sinput}{Verbatim}{}
\DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                              fontshape=it,
                                              fontsize=\relsize{-1}}
\DefineVerbatimEnvironment{Scode}{Verbatim}{}
\newenvironment{Schunk}{}{}

%%% environment for raw output
\newcommand{\SchunkRaw}{\renewenvironment{Schunk}{}{}
    \DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                                  fontshape=it,
                                                  fontsize=\small}
    \rawSinput
}

%%% environment for labeled output
\newcommand{\nextcaption}{}
\newcommand{\SchunkLabel}{
  \renewenvironment{Schunk}{\begin{figure}[ht] }{\caption{\nextcaption}
  \end{figure} }
  \DefineVerbatimEnvironment{Sinput}{Verbatim}{frame = topline}
  \DefineVerbatimEnvironment{Soutput}{Verbatim}{frame = bottomline, 
                                                samepage = true,
                                                fontfamily=courier,
                                                fontshape=it,
                                                fontsize=\relsize{-1}}
}


%%% S code with line numbers
\DefineVerbatimEnvironment{Sinput}
{Verbatim}
{
%%  numbers=left
}

\newcommand{\numberSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{numbers=left}
}
\newcommand{\rawSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{}
}


%%% R / System symbols
\newcommand{\R}{\textsf{R}}
\newcommand{\rR}{{R}}
\renewcommand{\S}{\textsf{S}}
\newcommand{\SPLUS}{\textsf{S-PLUS}}
\newcommand{\rSPLUS}{{S-PLUS}}
\newcommand{\SPSS}{\textsf{SPSS}}
\newcommand{\EXCEL}{\textsf{Excel}}
\newcommand{\ACCESS}{\textsf{Access}}
\newcommand{\SQL}{\textsf{SQL}}
%%\newcommand{\Rpackage}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Robject}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\Rclass}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Rcmd}[1]{\hbox{\rm\texttt{#1}}}
\newcommand{\Rpackage}[1]{\index{#1 package@{\fontseries{b}\selectfont #1} package} {\fontseries{b}\selectfont #1}}
\newcommand{\rpackage}[1]{{\fontseries{b}\selectfont #1}}
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\Rclass}[1]{\index{#1 class@\textit{#1} class}\textit{#1}}
\newcommand{\Rcmd}[1]{\index{#1 function@\texttt{#1} function}\texttt{#1}}
\newcommand{\Roperator}[1]{\texttt{#1}}
\newcommand{\Rarg}[1]{\texttt{#1}}
\newcommand{\Rlevel}[1]{\texttt{#1}}


%%% other symbols
\newcommand{\file}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\stress}[1]{\index{#1}\textit{#1}} 
\newcommand{\stress}[1]{\textit{#1}} 
\newcommand{\booktitle}[1]{\textit{#1}} %%'

%%% Math symbols
\usepackage{amstext}
\usepackage{amsmath}
\newcommand{\E}{\mathsf{E}}   
\newcommand{\Var}{\mathsf{Var}}   
\newcommand{\Cov}{\mathsf{Cov}}   
\newcommand{\Cor}{\mathsf{Cor}}   
\newcommand{\x}{\mathbf{x}}   
\newcommand{\y}{\mathbf{y}}   
\renewcommand{\a}{\mathbf{a}}
\newcommand{\W}{\mathbf{W}}   
\newcommand{\C}{\mathbf{C}}   
\renewcommand{\H}{\mathbf{H}}   
\newcommand{\X}{\mathbf{X}}   
\newcommand{\B}{\mathbf{B}}   
\newcommand{\V}{\mathbf{V}}   
\newcommand{\I}{\mathbf{I}}   
\newcommand{\D}{\mathbf{D}}   
\newcommand{\bS}{\mathbf{S}}   
\newcommand{\N}{\mathcal{N}}   
\renewcommand{\L}{L}   
\renewcommand{\P}{\mathsf{P}}   
\newcommand{\K}{\mathbf{K}}
\newcommand{\m}{\mathbf{m}}
\newcommand{\argmin}{\operatorname{argmin}\displaylimits}
\newcommand{\argmax}{\operatorname{argmax}\displaylimits}

\newcommand{\bx}{\mathbf{x}}
\newcommand{\bbeta}{\mathbf{\beta}}


%%% links
\usepackage{hyperref}

\hypersetup{%
  pdftitle = {A Handbook of Statistical Analyses Using R (3rd Edition)},
  pdfsubject = {Book},
  pdfauthor = {Torsten Hothorn and Brian S. Everitt},
  colorlinks = {black},
  linkcolor = {black},
  citecolor = {black},
  urlcolor = {black},
  hyperindex = {true},
  linktocpage = {true},
}


%%% captions & tables
%% <FIXME>: conflics with figure definition in chapman.cls
%%\usepackage[format=hang,margin=10pt,labelfont=bf]{caption}
%% </FIMXE>
\usepackage{longtable}
\usepackage[figuresright]{rotating}

%%% R symbol in chapter 1
\usepackage{wrapfig}

%%% Bibliography
\usepackage[round,comma]{natbib}
\renewcommand{\refname}{References \addcontentsline{toc}{chapter}{References}}
\citeindexfalse

%%% texi2dvi complains that \newblock is undefined, hm...
\def\newblock{\hskip .11em plus .33em minus .07em}

%%% Example sections
\newcounter{exercise}[chapter]
\setcounter{exercise}{0}
\newcommand{\exercise}{\stepcounter{exercise} \item{Ex.~\arabic{chapter}.\arabic{exercise} }}


%% URLs
\newcommand{\curl}[1]{\begin{center} \url{#1} \end{center}}

%%% for manual corrections
%\renewcommand{\baselinestretch}{2}

%%% plot sizes
\setkeys{Gin}{width=0.95\textwidth}

%%% color
\usepackage{color}

%%% hyphenations
\hyphenation{drop-out}
\hyphenation{mar-gi-nal}

%%% new bidirectional quotes need 
\usepackage[utf8]{inputenc}

%\usepackage{setspace}
\definecolor{sidebox_todo}{rgb}{1,1,0.2}
\newcommand{\todo}[1]{
        \hspace{0pt}%
        \marginpar{% 
                        \fcolorbox{black}{sidebox_todo}{%
                                \parbox{\marginparwidth} {

\raggedright\sffamily\footnotesize{TODO: #1}%
                                }
                        }%
        }
}
\begin{document}

%% Title page

\title{A Handbook of Statistical Analyses Using \R{} --- 3rd Edition}

\author{Torsten Hothorn and Brian S. Everitt}

\maketitle
%%\VignetteIndexEntry{Multiple Linear Regression}
%%\VignetteDepends{wordcloud}
\setcounter{chapter}{5}


\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE} 

<<setup, echo = FALSE, results = hide>>=
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })
@

\pagestyle{headings}
<<singlebook, echo = FALSE>>=
book <- FALSE
@

<<MLR-setup, echo = FALSE, results = hide>>=
library("wordcloud")
@

\chapter[Simple and Multiple Linear Regression]{Simple and Multiple Linear Regression: \\ How Old is the Universe and Cloud Seeding \label{MLR}}

\section{Introduction}


\index{Age of the Universe}
\cite{HSAUR:Freedmanetal2001} give the relative velocity and the distance of $24$ galaxies, 
according to measurements made using the Hubble Space Telescope -- the data
are contained in the \Rpackage{gamair} package accompanying \cite{HSAUR:Wood2006}, see 
Table~\ref{MLR-hubble-tab}. 
Velocities are assessed by measuring the Doppler red shift in the spectrum of 
light observed from the galaxies concerned, although some correction 
for `local' velocity components is required. Distances are measured 
using the known relationship between the period of Cepheid variable 
stars and their luminosity. How can these data be used to estimate 
the age of the universe? Here we shall show how this can be done 
using simple linear regression.

<<MLR-hubble-tab, echo = FALSE, results = tex>>=
data("hubble", package = "gamair")
names(hubble) <- c("galaxy", "velocity", "distance")
toLatex(HSAURtable(hubble, package = "gamair"), pcol = 2,
    caption = paste("Distance and velocity for 24 galaxies."),
    label = "MLR-hubble-tab")
@
\vspace*{-1cm}
\textit{Source}: From Freedman W. L., et al., \textit{The Astrophysical Journal},
553, 47--72, 2001. With permission.
\vspace*{1cm}

\index{Cloud seeding}

{\tabcolsep3.5pt
<<MLR-clouds-tab, echo = FALSE, results = tex>>=
data("clouds", package = "HSAUR3")
names(clouds) <- c("seeding", "time", "sne", "cloudc", "prewet", "EM", "rain")
toLatex(HSAURtable(clouds), pcol = 1, 
    caption = paste("Cloud seeding experiments in Florida -- see text for",
                    "explanations of the variables. Note that the \\Robject{clouds} data set has slightly different variable names."),
    label = "MLR-clouds-tab")
@
}


Weather modification, or cloud seeding, is the treatment of individual 
clouds or storm systems with various inorganic and organic materials 
in the hope of achieving an increase in rainfall. Introduction 
of such material into a cloud that contains supercooled water, 
that is, liquid water colder than zero degrees Celsius, 
has the aim of 
inducing freezing, with the consequent ice particles growing 
at the expense of liquid droplets and becoming heavy enough to 
fall as rain from clouds that otherwise would produce none.

The data shown in Table~\ref{MLR-clouds-tab} were collected in the summer 
of 1975 from an experiment to investigate the use of massive 
amounts of silver iodide ($100$ to $1000$ grams per cloud) in cloud 
seeding to increase rainfall \citep{HSAUR:Woodleyetal1977}. 
In the experiment, which was conducted 
in an area of Florida, 24 days were judged suitable for seeding 
on the basis that a measured suitability criterion, denoted \stress{S-Ne},  
was not less than $1.5$. Here \stress{S} is the `seedability', %' 
the difference between the maximum height of a cloud if seeded 
and the same cloud if not seeded predicted by a suitable cloud 
model, and \stress{Ne} is the number of hours between $1300$ 
and $1600$ G.M.T. with $10$ centimeter echoes in the target; this 
quantity biases the decision for experimentation against naturally 
rainy days. Consequently, optimal days for seeding are those 
on which seedability is large and the natural rainfall early 
in the day is small.

On suitable days, a decision was taken at random as to whether 
to seed or not. For each day the following variables were measured:
\begin{description}
\item[\Robject{seeding}] a factor indicating whether seeding action occurred (yes or no),
\item[\Robject{time}] number of days after the first day of the experiment,
\item[\Robject{cloudc}] the percentage cloud cover in the experimental area, 
                  measured using radar,
\item[\Robject{prewet}] the total rainfall in the target area one hour before seeding 
                  (in cubic meters $\times 10^{7}$), 
\item[\Robject{EM}] a factor showing whether the radar echo was moving or
                             stationary,
\item[\Robject{rain}] the amount of rain in cubic meters $\times 10^{7}$,
\item[\Robject{sne}] suitability criterion, see above.
\end{description}

The objective in analyzing these data is to see how rainfall 
is related to the explanatory variables and, in particular, to 
determine the effectiveness of seeding. The method to be used 
is \stress{multiple linear regression}.


\section{Simple Linear Regression}


\section{Multiple Linear Regression \label{MLR-MLR}}



\subsection{Regression Diagnostics}



\section{Analysis Using \R{}}

\subsection{Estimating the Age of the Universe}

Prior to applying a simple regression to the data it will 
be useful to look at a plot to assess their major features.
The \R{} code given in Figure~\ref{MLR-hubble-plot} produces
a scatterplot of velocity and distance.
\begin{figure}
\begin{center}
<<MLR-hubble-plot, echo = TRUE, fig = TRUE>>=
plot(velocity ~ distance, data = hubble)
@
\caption{Scatterplot of velocity and distance. \label{MLR-hubble-plot}}
\end{center}
\end{figure}
The diagram shows a clear, strong relationship between velocity
and distance. The next step is to fit a simple linear regression model
to the data, but in this case the nature of the data requires a model
without intercept because if distance is zero so is relative speed.
So the model to be fitted to these data is 
\begin{eqnarray*}
\text{velocity} = \beta_1 \text{distance} + \varepsilon.
\end{eqnarray*}
This is essentially what astronomers call Hubble's Law and
$\beta_1$ is known as Hubble's constant; $\beta_1^{-1}$ gives
an approximate age of the universe.

To fit this model we are estimating $\beta_1$ using formula 
(\ref{MLR:beta1}). Although this
operation is rather easy
<<MLR-hubble-beta1, echo = TRUE>>=
sum(hubble$distance * hubble$velocity) / 
    sum(hubble$distance^2)
@
it is more convenient to apply \R's linear modeling function
<<MLR-hubble-lm, echo = TRUE>>=
hmod <- lm(velocity ~ distance - 1, data = hubble)
@
Note that the model formula specifies a model without intercept.
We can now extract the estimated model coefficients via
<<MLR-hubble-lm, echo = TRUE>>=
coef(hmod)
@
and add this estimated regression line to the scatterplot; the
result is shown in Figure~\ref{MLR-hubble-lmplot}. In addition,
we produce a scatterplot of the residuals $y_i - \hat{y}_i$ against
fitted values $\hat{y}_i$ to assess the quality of the model fit.
It seems that for higher distance values the variance of velocity
increases; however, we are interested in only the estimated
parameter $\hat{\beta}_1$ which remains valid under variance 
heterogeneity (in contrast to $t$-tests and associated $p$-values).


Now we can use the estimated value of $\beta_1$ to find an approximate value 
for the age of the universe. The Hubble constant itself has units of 
$\text{km} \times \text{sec}^{-1} \times \text{Mpc}^{-1}$. A mega-parsec (Mpc) 
is $3.09 \times 10^{19}$km, so we need to divide the estimated value of $\beta_1$ 
by this amount in order to obtain Hubble's constant with units of $\text{sec}^{-1}$. 
The approximate age of the universe in seconds will then be the inverse of 
this calculation. Carrying out the necessary computations
<<MLR-hubble-age, echo = TRUE>>=
Mpc <- 3.09 * 10^19
ysec <- 60^2 * 24 * 365.25
Mpcyear <- Mpc / ysec
1 / (coef(hmod) / Mpcyear)
@
gives an estimated age of roughly $12.8$ billion years.

\begin{figure}
\begin{center}
<<MLR-hubble-lmplot, echo = TRUE, fig = TRUE, height = 4>>=
layout(matrix(1:2, ncol = 2))
plot(velocity ~ distance, data = hubble)
abline(hmod)
plot(hmod, which = 1)
@
\caption{Scatterplot of velocity and distance with estimated
         regression line (left) and plot of residuals against fitted values (right). 
         \label{MLR-hubble-lmplot}}
\end{center}
\end{figure}


\subsection{Cloud Seeding}


Again, a graphical display highlighting the most important
aspects of the data will be helpful.
Here we will construct boxplots of the rainfall in each category 
of the dichotomous explanatory variables and scatterplots of 
rainfall against each of the continuous explanatory variables.

\begin{figure}
\begin{center}
<<MLR-clouds-boxplots, echo = TRUE, eval = FALSE>>=
data("clouds", package = "HSAUR3")
layout(matrix(1:2, nrow = 2))
bxpseeding <- boxplot(rain ~ seeding, data = clouds, 
    ylab = "Rainfall", xlab = "Seeding")
bxpecho <- boxplot(rain ~ EM, data = clouds, 
    ylab = "Rainfall", xlab = "Echo Motion")
@
<<MLR-clouds-boxplots, echo = FALSE, fig = TRUE, height = 7, width = 5>>=
layout(matrix(1:2, nrow = 2))
bxpseeding <- boxplot(rain ~ seeding, data = clouds, 
    ylab = "Rainfall", xlab = "Seeding")
bxpecho <- boxplot(rain ~ EM, data = clouds, 
    ylab = "Rainfall", xlab = "Echo Motion")
@
\caption{Boxplots of \Robject{rain}. \label{MLR-rainfall-boxplot}}
\end{center}
\end{figure}

\begin{figure}
\begin{center}
<<MLR-clouds-scatterplots, echo = TRUE, fig = TRUE, width = 7, height = 7>>=
layout(matrix(1:4, nrow = 2))
plot(rain ~ time, data = clouds)
plot(rain ~ cloudc, data = clouds)
plot(rain ~ sne, data = clouds, xlab="S-Ne criterion")
plot(rain ~ prewet, data = clouds)
@
\caption{Scatterplots of \Robject{rain} against the continuous
covariates. \label{MLR-rainfall-scplot}}
\end{center}
\end{figure}

Both the boxplots (Figure~\ref{MLR-rainfall-boxplot}) and the scatterplots 
(Figure~\ref{MLR-rainfall-scplot}) show some evidence 
of outliers. The row names of the extreme observations in the
\Robject{clouds} \Rclass{data.frame} can be identified via
<<MLR-clouds-outliers, echo = TRUE>>=
rownames(clouds)[clouds$rain %in% c(bxpseeding$out, 
                                    bxpecho$out)]
@
where \Robject{bxpseeding} and \Robject{bxpecho} are variables 
created by \Rcmd{boxplot} in Figure~\ref{MLR-rainfall-boxplot}.
Now we shall not remove these observations but bear 
in mind during the modeling process that they may cause problems.

In this example it is sensible to assume that the effect of
some of the other explanatory variables is modified by seeding 
and therefore consider a model that includes seeding as
covariate and, furthermore, allows interaction terms 
\index{Interaction}
for \Robject{seeding} with each of the covariates except \Robject{time}.
This model can be described by the \Rclass{formula}
<<MLR-clouds-formula, echo = TRUE>>=
clouds_formula <- rain ~ seeding + 
    seeding:(sne + cloudc + prewet + EM) + 
    time
@
and the design matrix $\X^\star$ can be computed via
<<MLR-clouds-modelmatrix, echo = TRUE>>=
Xstar <- model.matrix(clouds_formula, data = clouds)
@
By default, treatment contrasts have been applied to the dummy codings of
the factors \Robject{seeding} and \Robject{EM} as can be seen from
the inspection of the \Robject{contrasts} attribute of the model matrix
<<MLR-clouds-contrasts, echo = TRUE>>=
attr(Xstar, "contrasts")
@
The default contrasts can be changed via the \Rarg{contrasts.arg}
argument to \Rcmd{model.matrix} or the \Robject{contrasts} argument to the
fitting function, for example \Rcmd{lm} or \Rcmd{aov} as shown in 
\Sexpr{ch("ANOVA")}.

However, such internals are hidden and performed by high-level model-fitting
functions such as \Rcmd{lm} which will be used to fit the linear model
defined by the \Rclass{formula} \Robject{clouds\_formula}:
<<MLR-clouds-lm, echo = TRUE>>=
clouds_lm <- lm(clouds_formula, data = clouds)
class(clouds_lm)
@
The result of the model fitting is an object of class \Rclass{lm} for which
a \Rcmd{summary} method showing the conventional regression analysis
output is available. The output in Figure~\ref{MLR-clouds-summary}
shows the estimates $\hat{\beta}^\star$ with corresponding standard errors
and $t$-statistics as well as the $F$-statistic with associated $p$-value.

\renewcommand{\nextcaption}{\R{} output of the linear model fit  
                            for the \Robject{clouds} data.
                            \label{MLR-clouds-summary}}
\SchunkLabel
<<MLR-clouds-summary, echo = TRUE>>=
summary(clouds_lm)
@
\SchunkRaw

Many methods are available for extracting components of the fitted model.
The estimates $\hat{\beta}^\star$ can be assessed via

\newpage

<<MLR-clouds-coef, echo = TRUE>>=
betastar <- coef(clouds_lm)
betastar
@
and the corresponding covariance matrix $\Cov(\hat{\beta}^\star)$ is available
from the \Rcmd{vcov} method
<<MLR-clouds-vcov, echo = TRUE>>=
Vbetastar <- vcov(clouds_lm)
@
where the square roots of the diagonal elements are the standard errors as
shown in Figure~\ref{MLR-clouds-summary}
<<MLR-clouds-sd, echo = TRUE>>=
sqrt(diag(Vbetastar))
@


\begin{figure}
\begin{center}
<<MLR-clouds-lmplot, echo = TRUE, fig = TRUE>>=
psymb <- as.numeric(clouds$seeding)
plot(rain ~ sne, data = clouds, pch = psymb, 
     xlab = "S-Ne criterion")
abline(lm(rain ~ sne, data = clouds, 
          subset = seeding == "no"))
abline(lm(rain ~ sne, data = clouds, 
          subset = seeding == "yes"), lty = 2)  
legend("topright", legend = c("No seeding", "Seeding"), 
       pch = 1:2, lty = 1:2, bty = "n")
@
\caption{Regression relationship between S-Ne criterion and rainfall with
and without seeding. \label{MLR-clouds-lmplot}}
\end{center}
\end{figure}



In order to investigate the quality of the model fit, we need access to the
residuals and the fitted values. The residuals can be found by the 
\Rcmd{residuals} method and the fitted values of the response 
from the \Rcmd{fitted} (or \Rcmd{predict}) method
<<MLR-clouds-residfitted, echo = TRUE>>=
clouds_resid <- residuals(clouds_lm)
clouds_fitted <- fitted(clouds_lm)
@
Now the residuals and the fitted values 
can be used to construct diagnostic plots; for example the residual
plot in Figure~\ref{MLR-resid} where each observation is labelled by its
number (using \Rcmd{textplot} from package \Rpackage{wordclouds}). 
Observations $1$ and $15$ give rather large residual values and the
data should perhaps be reanalysed after these two observations are removed.
The normal probability plot of the residuals shown in Figure~\ref{MLR-qqplot} 
shows a reasonable agreement between theoretical and sample
quantiles, however, observations $1$ and $15$ are extreme again.

\begin{figure}
\begin{center}
<<MLR-clouds-residplot, echo = TRUE, fig = TRUE>>=
plot(clouds_fitted, clouds_resid, xlab = "Fitted values", 
     ylab = "Residuals", type = "n", 
     ylim = max(abs(clouds_resid)) * c(-1, 1))
abline(h = 0, lty = 2)
textplot(clouds_fitted, clouds_resid, 
         words = rownames(clouds), new = FALSE)
@
\caption{Plot of residuals against fitted values for \Robject{clouds} seeding data.
\label{MLR-resid}}
\end{center}
\end{figure}

\begin{figure}
\begin{center}
<<MLR-clouds-qqplot, echo = TRUE, fig = TRUE>>=
qqnorm(clouds_resid, ylab = "Residuals")
qqline(clouds_resid)
@
\caption{Normal probability plot of residuals from cloud seeding model
         \Robject{clouds\_lm}. \label{MLR-qqplot}}
\end{center}
\end{figure}


An index plot of the Cook's distances for each observation %'
(and many other plots including those constructed above from
using the basic functions) can be found from applying the \Rcmd{plot} method 
to the object that results from the application
of the \Rcmd{lm} function. 
\begin{figure}
\begin{center}
<<MLR-clouds-cook, echo = TRUE, eval = FALSE>>=
plot(clouds_lm)
@
<<MLR-clouds-cook, echo = FALSE, fig = TRUE>>=
plot(clouds_lm, which = 4, sub.caption = NULL)
@
\caption{Index plot of Cook's distances for cloud seeding data. %'
         \label{MLR-cook}}
\end{center}
\end{figure}
Figure~\ref{MLR-cook} suggests that observations 2 and 18 have undue
influence on the 
estimated regression coefficients, but the two outliers identified
previously do not. Again it may be useful to look at the results
after these two observations have been removed (see Exercise
6.2).
%% \ref{MLR-ex2})
\index{Regression diagnostics|)}

%%\bibliographystyle{LaTeXBibTeX/refstyle}
%%\bibliography{LaTeXBibTeX/HSAUR}   
\end{document}

\documentclass{chapman}

%%% copy Sweave.sty definitions

%%% keeps `sweave' from adding `\usepackage{Sweave}': DO NOT REMOVE
%\usepackage{Sweave} 


\RequirePackage[T1]{fontenc}
\RequirePackage{graphicx,ae,fancyvrb}
\IfFileExists{upquote.sty}{\RequirePackage{upquote}}{}
\usepackage{relsize}

\DefineVerbatimEnvironment{Sinput}{Verbatim}{}
\DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                              fontshape=it,
                                              fontsize=\relsize{-1}}
\DefineVerbatimEnvironment{Scode}{Verbatim}{}
\newenvironment{Schunk}{}{}

%%% environment for raw output
\newcommand{\SchunkRaw}{\renewenvironment{Schunk}{}{}
    \DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                                  fontshape=it,
                                                  fontsize=\small}
    \rawSinput
}

%%% environment for labeled output
\newcommand{\nextcaption}{}
\newcommand{\SchunkLabel}{
  \renewenvironment{Schunk}{\begin{figure}[ht] }{\caption{\nextcaption}
  \end{figure} }
  \DefineVerbatimEnvironment{Sinput}{Verbatim}{frame = topline}
  \DefineVerbatimEnvironment{Soutput}{Verbatim}{frame = bottomline, 
                                                samepage = true,
                                                fontfamily=courier,
                                                fontshape=it,
                                                fontsize=\relsize{-1}}
}


%%% S code with line numbers
\DefineVerbatimEnvironment{Sinput}
{Verbatim}
{
%%  numbers=left
}

\newcommand{\numberSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{numbers=left}
}
\newcommand{\rawSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{}
}


%%% R / System symbols
\newcommand{\R}{\textsf{R}}
\newcommand{\rR}{{R}}
\renewcommand{\S}{\textsf{S}}
\newcommand{\SPLUS}{\textsf{S-PLUS}}
\newcommand{\rSPLUS}{{S-PLUS}}
\newcommand{\SPSS}{\textsf{SPSS}}
\newcommand{\EXCEL}{\textsf{Excel}}
\newcommand{\ACCESS}{\textsf{Access}}
\newcommand{\SQL}{\textsf{SQL}}
%%\newcommand{\Rpackage}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Robject}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\Rclass}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Rcmd}[1]{\hbox{\rm\texttt{#1}}}
\newcommand{\Rpackage}[1]{\index{#1 package@{\fontseries{b}\selectfont #1} package} {\fontseries{b}\selectfont #1}}
\newcommand{\rpackage}[1]{{\fontseries{b}\selectfont #1}}
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\Rclass}[1]{\index{#1 class@\textit{#1} class}\textit{#1}}
\newcommand{\Rcmd}[1]{\index{#1 function@\texttt{#1} function}\texttt{#1}}
\newcommand{\Roperator}[1]{\texttt{#1}}
\newcommand{\Rarg}[1]{\texttt{#1}}
\newcommand{\Rlevel}[1]{\texttt{#1}}


%%% other symbols
\newcommand{\file}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\stress}[1]{\index{#1}\textit{#1}} 
\newcommand{\stress}[1]{\textit{#1}} 
\newcommand{\booktitle}[1]{\textit{#1}} %%'

%%% Math symbols
\usepackage{amstext}
\usepackage{amsmath}
\newcommand{\E}{\mathsf{E}}   
\newcommand{\Var}{\mathsf{Var}}   
\newcommand{\Cov}{\mathsf{Cov}}   
\newcommand{\Cor}{\mathsf{Cor}}   
\newcommand{\x}{\mathbf{x}}   
\newcommand{\y}{\mathbf{y}}   
\renewcommand{\a}{\mathbf{a}}
\newcommand{\W}{\mathbf{W}}   
\newcommand{\C}{\mathbf{C}}   
\renewcommand{\H}{\mathbf{H}}   
\newcommand{\X}{\mathbf{X}}   
\newcommand{\B}{\mathbf{B}}   
\newcommand{\V}{\mathbf{V}}   
\newcommand{\I}{\mathbf{I}}   
\newcommand{\D}{\mathbf{D}}   
\newcommand{\bS}{\mathbf{S}}   
\newcommand{\N}{\mathcal{N}}   
\renewcommand{\L}{L}   
\renewcommand{\P}{\mathsf{P}}   
\newcommand{\K}{\mathbf{K}}
\newcommand{\m}{\mathbf{m}}
\newcommand{\argmin}{\operatorname{argmin}\displaylimits}
\newcommand{\argmax}{\operatorname{argmax}\displaylimits}

\newcommand{\bx}{\mathbf{x}}
\newcommand{\bbeta}{\mathbf{\beta}}


%%% links
\usepackage{hyperref}

\hypersetup{%
  pdftitle = {A Handbook of Statistical Analyses Using R (3rd Edition)},
  pdfsubject = {Book},
  pdfauthor = {Torsten Hothorn and Brian S. Everitt},
  colorlinks = {black},
  linkcolor = {black},
  citecolor = {black},
  urlcolor = {black},
  hyperindex = {true},
  linktocpage = {true},
}


%%% captions & tables
%% <FIXME>: conflics with figure definition in chapman.cls
%%\usepackage[format=hang,margin=10pt,labelfont=bf]{caption}
%% </FIMXE>
\usepackage{longtable}
\usepackage[figuresright]{rotating}

%%% R symbol in chapter 1
\usepackage{wrapfig}

%%% Bibliography
\usepackage[round,comma]{natbib}
\renewcommand{\refname}{References \addcontentsline{toc}{chapter}{References}}
\citeindexfalse

%%% texi2dvi complains that \newblock is undefined, hm...
\def\newblock{\hskip .11em plus .33em minus .07em}

%%% Example sections
\newcounter{exercise}[chapter]
\setcounter{exercise}{0}
\newcommand{\exercise}{\stepcounter{exercise} \item{Ex.~\arabic{chapter}.\arabic{exercise} }}


%% URLs
\newcommand{\curl}[1]{\begin{center} \url{#1} \end{center}}

%%% for manual corrections
%\renewcommand{\baselinestretch}{2}

%%% plot sizes
\setkeys{Gin}{width=0.95\textwidth}

%%% color
\usepackage{color}

%%% hyphenations
\hyphenation{drop-out}
\hyphenation{mar-gi-nal}

%%% new bidirectional quotes need 
\usepackage[utf8]{inputenc}

%\usepackage{setspace}
\definecolor{sidebox_todo}{rgb}{1,1,0.2}
\newcommand{\todo}[1]{
        \hspace{0pt}%
        \marginpar{% 
                        \fcolorbox{black}{sidebox_todo}{%
                                \parbox{\marginparwidth} {

\raggedright\sffamily\footnotesize{TODO: #1}%
                                }
                        }%
        }
}
\begin{document}

%% Title page

\title{A Handbook of Statistical Analyses Using \R{} --- 3rd Edition}

\author{Torsten Hothorn and Brian S. Everitt}

\maketitle
%%\VignetteIndexEntry{Chapter Bayesian Inference}
%%\VignetteDepends{rmeta,coin}
\setcounter{chapter}{17}


\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE} 

<<setup, echo = FALSE, results = hide>>=
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })
@

\pagestyle{headings}
<<singlebook, echo = FALSE>>=
book <- FALSE
@


\chapter[Bayesian Inference]{Incorporating Prior Knowledge via Bayesian Inference: 
Smoking and Lung Cancer \label{BI}}

\section{Introduction}

\index{Smoking and lung cancer|(}
At the beginning of the 20th century, the death toll due to lung cancer was
on the rise and the search for possible causes began.  For lung cancer in pit
workers, animal experiments showed that the so-called `Schneeberg lung
disease' was induced by radiation.  But this could not explain the
increasing incidence of lung cancer in the general population.  The
identification of possible risk factors was a challenge for epidemiology and
statistics, both disciplines being still in their infancy in the 1920s and 1930s.

The first modern controlled epidemiological study on the effect of smoking
on lung cancer was performed by Franz Hermann M\"uller as part of his
dissertation at the University of Cologne in 1939.  The results were
published a year later \citep{HSAUR:Mueller1940}.  M\"uller sent out
questionnaires to the relatives of people who had recently died of lung
cancer, asking about the smoking behavior and its intensity of the deceased
relative.  He also sent the questionnaire to healthy controls to obtain
information about the smoking behavior in a control group, although it is
not clear how this control group was defined.  The number of lung cancer
patients and healthy controls in five different groups (nonsmokers to
extreme smokers) are given in Table~\ref{BI-Smoking_Mueller1940-tab}.

<<BI-Smoking_Mueller1940-tab, echo = FALSE, results = tex>>=
data("Smoking_Mueller1940", package = "HSAUR3")  
toLatex(HSAURtable(Smoking_Mueller1940), 
    caption = paste("Smoking and lung cancer case-control study by M\\\"uller (1940).",
                    "The smoking intensities were defined by the number of",
                    "cigarettes smoked daily:",
                    "1-15 (moderate), 16-25 (heavy), 26-35 (very heavy),",
                    "and more than 35 (extreme)."),
    label = "BI-Smoking_Mueller1940-tab")
@

Four years later Erich Sch\"oninger also wrote his dissertation on the
association between smoking and lung cancer and, together with his
supervisor Eberhard Schairer at the University of Jena, published his
results on a case-control study
\citep{HSAUR:SchairerSchoeninger1944} where he assessed the smoking behavior
of lung cancer patients, patients diagnosed with other forms of cancer, and
also a healthy control group.  The data are given in
Table~\ref{BI-Smoking_SchairerSchoeniger1944-tab}.

<<BI-Smoking_SchairerSchoeniger1944-tab, echo = FALSE, results = tex>>=
x <- as.table(Smoking_SchairerSchoeniger1944[, 
    c("Lung cancer", "Healthy control")])
toLatex(HSAURtable(x, xname = "Smoking_SchairerSchoeniger1944"), 
    caption = paste("Smoking and lung cancer case-control study by Schairer and Sch\\\"oniger (1944). Cancer other than lung cancer omitted.",
                    "The smoking intensities were defined by the number of",
                    "cigarettes smoked daily:",
                    "1-5 (moderate), 6-10 (medium), 11-20 (heavy),",
                    "and more than 20 (very heavy)."),
    label = "BI-Smoking_SchairerSchoeniger1944-tab")
@

Shortly after the war, a Dutch epidemiologist reported on a case-control
study performed in Amsterdam \citep{HSAUR:Wassink1945} and found similar
results as the two German studies; see
Table~\ref{BI-Smoking_Wassink1945-tab}.

<<BI-Smoking_Wassink1945-tab, echo = FALSE, results = tex>>=
data("Smoking_Wassink1945", package = "HSAUR3")  
toLatex(HSAURtable(Smoking_Wassink1945), 
    caption = paste("Smoking and lung cancer case-control study by Wassink (1945).",
                    "Smoking categories correspond to the categories used by M\\\"uller (1940)."),
    label = "BI-Smoking_Wassink1945-tab")
@

In 1950 perhaps the most important, but not the first, case-control study showing
an increasing risk of developing lung cancer with the amount of tobacco
smoked, was published in Great Britain by Richard Doll and Austin Bradford Hill
\citep{HSAUR:DollHill1950}.  We restrict discussion here to data obtained for males
and the data shown in Table~\ref{BI-Smoking_DollHill1950-tab} corresponds to
the most recent amount of tobacco consumed regularly by smokers before
disease onset \citep[Table~V in][]{HSAUR:DollHill1950}.

<<BI-Smoking_DollHill1950-tab, echo = FALSE, results = tex>>=
data("Smoking_DollHill1950", package = "HSAUR3")  
x <- as.table(Smoking_DollHill1950[,,"Male", drop = FALSE])
toLatex(HSAURtable(x, xname = "Smoking_DollHill1950"),
    caption = paste("Smoking and lung cancer case-control study (only males) by Doll and Hill (1950).",
                    "The labels for the smoking categories give the number of cigarettes smoked every day."),
    label = "BI-Smoking_DollHill1950-tab")
@

Although the design of the studies by \cite{HSAUR:Mueller1940} and
\cite{HSAUR:SchairerSchoeninger1944}, especially the selection of their
control groups, can be criticized \citep[see][for a detailed
discussion]{HSAUR:Morabia2013} and the study by \cite{HSAUR:DollHill1950}
was larger than the older studies and more detailed information on the
smoking behavior was obtained by direct patient interviews, the information
provided by the earlier studies was not taken into account by
\cite{HSAUR:DollHill1950}.  They cite \cite{HSAUR:Mueller1940} in their
introduction, but did not compare their findings with his results.  It is
remarkable to see that both \cite{HSAUR:SchairerSchoeninger1944} and
\cite{HSAUR:Wassink1945} extensively made use of the report by
\cite{HSAUR:Mueller1940} and go as far as analyzing the merged data
\citep[Grafiek I, E, and F, in][]{HSAUR:Wassink1945}.  In an informal way,
these authors wanted to use the already available information, in today's
terms called `prior knowledge', to make a stronger case with the new data. 
Formal statistical methods to incorporate prior knowledge into data analysis
as part of the `Bayesian' way of doing statistical analyses were developed
in the second half of the last century, and we will focus on them in the
present chapter.  \index{Smoking and lung cancer|)}


\section{Bayesian Inference}


\section{Analysis Using \R{}}

\subsection{One-by-one Analysis}

For the analysis of the four different case-control studies on smoking and
lung cancer, we will (retrospectively, of course) update our knowledge with
every new study.  We begin with a re-analysis of the data described by
\cite{HSAUR:Mueller1940}.  Using an approximate permutation test introduced in
Chapter~\ref{CI} for the hypothesis of independence of the amount of
tobacco smoked and group membership (lung cancer or healthy control), we get
<<BI-M-it, echo = TRUE>>=
library("coin")
set.seed(29)
independence_test(Smoking_Mueller1940, teststat = "quad",
                  distribution = approximate(100000))
@
and there is clearly a strong association between the number of cigarettes
smoked and incidence of lung cancer.  Because the amount of tobacco smoked
is an ordered categorical variable, it is more appropriate to take this
information into account, for example by means of a linear association test
(see Chapter~\ref{CI}).  Nonsmokers receive a score of zero, and for the
remaining groups we choose the mid-point of the intervals of daily
cigarettes smoked that were used by \cite{HSAUR:Mueller1940} to define his
groups:
<<BI-M40-linit, echo = TRUE>>=
ssc <- c(0, 1 + 14 / 2, 16 + 9 / 2, 26 + 9 / 2, 40)
independence_test(Smoking_Mueller1940, teststat = "quad",
    scores = list(Smoking = ssc), 
    distribution = approximate(100000))
@
The result shows that the data are in favor of an ordered alternative. The
$p$-values obtained from approximate permutation tests are attractive
because no distributional assumptions are required, but it is hard to derive
estimates and confidence intervals for interpretable parameters from such
tests.  We will therefore now switch to logistic regression models as
described in Chapter~\ref{GLM} to model the odds of lung cancer in the
different smoking groups.  Before we start, let us define a small function
for computing odds (for intercept parameters) and odds ratios (for
difference parameters) and corresponding confidence intervals from a
logistic regression model:
<<BI-expconfint, echo = TRUE>>=
eci <- function(model)
    cbind("Odds (Ratio)" = exp(coef(model)), 
          exp(confint(model)))
@
We model the probability of developing lung cancer given the smoking
behavior.  Because our data was obtained from case-control studies where the
groups (lung cancer patients and healthy controls) were defined first and
only after that we observed data on the smoking behavior (in a so-called
\stress{choice-based sampling}), this may seem the wrong model to start
with.  However, the marginal distribution of the two groups only changes the
intercept in such a logistic model and the effects of smoking can still be
interpreted in the way we require \citep[see][for example]{HSAUR:Tutz2012}. 
The formula for specifying a logistic regression model can be set up such
that the response is a matrix with two columns for each smoking group
consisting of the number of lung cancer deaths and the number of healthy
controls.  Although smoking is an ordered factor, we first fit the model
with treatment contrasts, i.e., we can interpret the $\exp$ of the
regression coefficients as odds ratios between each smoking group and
nonsmokers:
<<BI-M40-logreg, echo = TRUE>>=
smoking <- ordered(rownames(Smoking_Mueller1940),
                   levels = rownames(Smoking_Mueller1940))
contrasts(smoking) <- "contr.treatment"
eci(glm(Smoking_Mueller1940 ~ smoking, family = binomial()))
@
We see that all but one of the odds ratios increase with the amount of
tobacco smoked with a maximum of almost $30$ for extreme smokers (more than
$35$ cigarettes per day).  The likelihood confidence intervals are rather
wide due to the limited sample size, but also the lower limit increases with
smoking.

An alternative model formulation can help to compare each smoking group with
the preceding group, the so-called split-coding \citep[for this and other
codings see][]{HSAUR:Tutz2012}:
<<BI-M40-logreg-split, echo = TRUE>>=
K <- diag(nlevels(smoking) - 1)
K[lower.tri(K)] <- 1
contrasts(smoking) <- rbind(0, K)
eci(glm(Smoking_Mueller1940 ~ smoking, family = binomial()))
@
The two largest differences are between moderate smokers and nonsmokers
(\Robject{smoking1}) and between very heavy and heavy smokers
(\Robject{smoking3}).  The latter group difference seems, at least judged by
the confidence interval, to be larger than expected under a model with no
effect of smoking.

For the analysis of the three remaining studies, we first perform
permutation tests for the independence of smoking and the two groups
(lung cancer and healthy controls) in males:
<<BI-SS44-it, echo = TRUE>>=
xSS44 <- as.table(Smoking_SchairerSchoeniger1944[, 
    c("Lung cancer", "Healthy control")])
ap <- approximate(100000)
pvalue(independence_test(xSS44, 
       teststat = "quad", distribution = ap))
pvalue(independence_test(Smoking_Wassink1945, 
       teststat = "quad", distribution = ap))
xDH50 <- as.table(Smoking_DollHill1950[,, "Male"])
pvalue(independence_test(xDH50, 
       teststat = "quad", distribution = ap))
@
All $p$-values indicate that the data are not well-described by the 
independence model.

\subsection{Joint Bayesian Analysis}

For a Bayesian analysis, we first merge the data from all four studies into
one data frame.  In doing so, we also merge the smoking groups in a way that
we only have three groups left: nonsmokers, moderate smokers, and heavy
smokers.  These groups are chosen in a way that the number of daily
cigarettes is comparable.  We first merge the heavy, very heavy, and extreme
smokers from \cite{HSAUR:Mueller1940}
<<BI-data-M, echo = TRUE>>=
(M <- rbind(Smoking_Mueller1940[1:2,], 
            colSums(Smoking_Mueller1940[3:5,])))
@
and proceed with the lung cancer patients and healthy controls from
\cite{HSAUR:SchairerSchoeninger1944} in the same way
<<BI-data-SS, echo = TRUE>>=
SS <- Smoking_SchairerSchoeniger1944[, 
    c("Lung cancer", "Healthy control")]
(SS <- rbind(SS[1,], colSums(SS[2:3,]), colSums(SS[4:5,])))
@
and finally perform the same exercise for the \cite{HSAUR:Wassink1945}
and \cite{HSAUR:DollHill1950} data
<<BI-data-WDH, echo = TRUE>>=
(W <- rbind(Smoking_Wassink1945[1:2,], 
            colSums(Smoking_Wassink1945[3:4,])))
DH <- Smoking_DollHill1950[,, "Male"]
(DH <- rbind(DH[1,], colSums(DH[2:3,]), colSums(DH[4:6,])))
@
The three new groups are now called nonsmokers, moderate smokers, and
heavy smokers, and we set up a data frame that contains
the number of people in each of the possible groups for all studies:
<<BI-data-all, echo = TRUE>>=
smk <- c("Nonsmoker", "Moderate smoker", "Heavy smoker")
x <- expand.grid(Smoking = ordered(smk, levels = smk),
  Diagnosis = factor(c("Lung cancer", "Control")),
  Study = c("Mueller1940", "SchairerSchoeniger1944", 
            "Wassink1945", "DollHill1950"))	
x$weights <- c(as.vector(M), as.vector(SS), 
               as.vector(W), as.vector(DH))
@
Before we fit logistic regression models using the data organized in such a
way, we define the contrasts for the smoking ordered factor and
expand the data in a way that each row corresponds to one person. This is necessary
because the \Rcmd{weights} argument to the \Rcmd{glm} function must not be used
to define case weights:
<<BI-data-contrasts, echo = TRUE>>=
contrasts(x$Smoking) <- "contr.treatment"
x <- x[rep(1:nrow(x), x$weights),]
@

We now compute one logistic regression model for each study for later 
comparisons:
<<BI-models, echo = TRUE>>=  
models <- lapply(levels(x$Study), function(s) 
    glm(Diagnosis ~ Smoking, data = x, family = binomial(),
        subset = Study == s))
names(models) <- levels(x$Study)
@
In 1939, M\"uller was hardly in the position to come up with a reasonable
prior for the odds ratios between moderate or heavy smokers and nonsmokers. So
we also use a noninformative prior and just perform the maximum likelihood analysis:
<<BI-M40, echo = TRUE>>=
eci(models[["Mueller1940"]])
@
Four years later, the maximum likelihood results obtained for the 
\cite{HSAUR:SchairerSchoeninger1944} data
<<BI-SS44, echo = TRUE>>=
eci(models[["SchairerSchoeniger1944"]])
@
could have been improved by using a normal prior for the difference in log odds
whose distribution is the distribution of the maximum likelihood estimator obtained
for M\"uller's data. At least approximately, we can compute posterior 
$90\%$ credibility intervals and the posterior mode from the
Schairer and Sch\"oniger data by analyzing both data sets simultaneously.
We should, however, keep in mind that the odds of developing lung cancer
for nonsmokers is not really interesting for our analysis and that
the four studies may very well differ with respect to this intercept
parameter. Consequently, we don't want to specify a prior for the
intercept. One way to implement such a strategy is to exclude the intercept
term from the joint model while allowing a separate intercept for
each of the studies:
<<BI-M40-SS44, echo = TRUE>>=
mM40_SS44 <- glm(Diagnosis ~ 0 + Study + Smoking, data = x, 
    family = binomial(),
    subset = Study %in% c("Mueller1940", 
                          "SchairerSchoeniger1944"))
eci(mM40_SS44)
@
We observe two important differences between the maximum likelihood and
Bayesian results for the Schairer and Sch\"oniger data: In the Bayesian
analysis, the estimated odds ratio for moderate smokers is closer to the
smaller value obtained from M\"uller's data and, more important, the
credibility intervals are much narrower and, one has to say, more realistic now.
An odds ratio as large as $40$ is hardly something one would expect to see in 
practice.

If Wassink had been aware of Bayesian statistics, he could have used
the posterior distribution of the parameters from
our model \Robject{mM40\_SS44} as a prior distribution for analyzing his
data. The maximum likelihood results for his data
<<BI-M40-SS44-W45-ML, echo = TRUE>>=
eci(models[["Wassink1945"]])    
@
would have changed to 
<<BI-M40-SS44-W45, echo = TRUE>>=
mM40_SS44_W45 <- glm(Diagnosis ~ 0 + Study + Smoking, 
    data = x, family = binomial(),
    subset = Study %in% c("Mueller1940", 
                          "SchairerSchoeniger1944",
                          "Wassink1945"))
eci(mM40_SS44_W45)
@
The rather small odds ratios obtained from the model fitted to the
Wassink data only are now closer to the estimates obtained from the
two previous studies and the variability, as given by the credibility intervals,
is much smaller.

Now, finally, the model for the Doll and Hill data reports rather large
odds ratios with wide confidence intervals: 
<<BI-DH50, echo = TRUE>>=
eci(models[["DollHill1950"]])
@
With a (now rather strong) prior defined by the three earlier studies, we get
from the joint model for all four studies
<<BI-all, echo = TRUE>>=
m_all <- glm(Diagnosis ~ 0 + Study + Smoking, data = x, 
             family = binomial())
eci(m_all)
@
<<BI-all-round, echo = FALSE>>=
r <- eci(m_all)
xM <- round(r["SmokingModerate smoker", 2:3], 1)
xH <- round(r["SmokingHeavy smoker", 2:3], 1)
@
In 1950, the joint evidence based on such an analysis with an odds ratio
between $\Sexpr{xM[1]}$ and $\Sexpr{xM[2]}$ for moderate smokers and between
$\Sexpr{xH[1]}$ and $\Sexpr{xH[2]}$ for heavy smokers compared to
nonsmokers, would have made a much stronger case than any of the single
studies alone.  It is interesting to see that with this strong prior for the
Doll and Hill study, we also get relatively large odds ratios when comparing
heavy to moderate smokers (see row labeled \Rcmd{Smoking2}):
<<BI-results, echo = TRUE>>=
K <- diag(nlevels(x$Smoking) - 1)
K[lower.tri(K)] <- 1
contrasts(x$Smoking) <- rbind(0, K)
eci(glm(Diagnosis ~ 0 + Study + Smoking, data = x, 
        family = binomial()))
@

\subsection{A Comparison with Meta Analysis}

One may ask how the Bayesian approach of progressively updating the estimates
considered here differs from a classical meta analysis described in
Chapter~\ref{MA}. We
first reshape the data into a form suitable for such an analysis
<<BI-meta-data, echo = TRUE>>=
y <- xtabs(~ Study + Smoking + Diagnosis, data = x)
ntrtM <- margin.table(y, 1:2)[,"Moderate smoker"]
nctrl <- margin.table(y, 1:2)[,"Nonsmoker"]
ptrtM <- y[,"Moderate smoker","Lung cancer"]
pctrl <- y[,"Nonsmoker","Lung cancer"]
ntrtH <- margin.table(y, 1:2)[,"Heavy smoker"]
ptrtH <- y[,"Heavy smoker","Lung cancer"]
@
and then compute joint odds ratios and confidence intervals for moderate and
heavy smokers compared to nonsmokers:
<<BI-meta-data, echo = TRUE>>=
library("rmeta")
meta.MH(ntrt = ntrtM, nctrl = nctrl, 
         ptrt = ptrtM, pctrl = pctrl)
meta.MH(ntrt = ntrtH, nctrl = nctrl, 
         ptrt = ptrtH, pctrl = pctrl)
@
For moderate smokers, the effect is a little weaker compared with the
results reported on earlier and for heavy smokers, the meta analysis
identifies a stronger effect for heavy smokers.  Nevertheless, the
differences between the two rather different approaches are negligible and
the conclusions would have been the same.

\section{Summary of Findings}

We have seen that, using a Bayesian approach to incorporate prior knowledge
into a model, the odds of developing lung cancer increase with increased
amounts of smoking.  Of course, our analysis here is very simplistic, because
we ignored that also pipe and cigar smokers were present in the data, we
merged the data based on a very rough assessment of the number of cigarettes
smoked per day, ignored whether or not the smokers inhaled the smoke into
their lungs, or if nonsmokers were subject to passive-smoking, as we call it
today.  Most importantly, we must not misinterpret findings from
case-control studies as casual and, in fact, none of the authors cited here
did so.  The debate on whether smoking, and which kind of smoking, actually
\stress{causes} lung cancer was initiated by the publications cited in this
chapter and many famous statisticians took part in the debate, for example,
Sir Ronald Fisher \citep{HSAUR:Fisher1959}, took the view that the inference
of causation was premature.  In retrospect this was one issue (perhaps the
only one) where Fisher was mistaken.

\section{Final Comments}

There remain a few hard-line opponents of Bayesian inference (just a few)
who reject the method because of the use of subjective prior distributions
which, these opponents feel, have no place in scientific investigations. 
And there are Bayesians who think that the only defense of using
non-Bayesian methods is incompetence.

But for an increasing number of statisticians Bayesian inference is very
attractive, because we can use the posterior distribution of the parameters
to draw conclusions from the data.  Although this requires the specification
of a prior distribution, we have seen in this chapter that, using data from
previous experiments, priors can be defined in a reasonable way.  It is not
absolutely necessary to rely on rather complex numerical procedures to`estimate' a posterior distribution.  When we are willing to cut some
corners, we can implement simple Bayesian approaches using standard
software.  We should also keep in mind that the prior can be interpreted as
a penalty on the parameters, and many penalization approaches therefore
have an (often implicit) connection to the Bayesian way of doing statistics. 
Of course, just picking the prior that `works best' is dangerous and
almost surely inappropriate.

\section*{Exercises}

\begin{description}

\exercise 
Produce a forest plot as introduced in Chapter~\ref{MA} for the four
smoking studies analyzed here.

\exercise
Produce a modified forest plot where one can see how the evidence 
for smoking being related to lung cancer evolved between 1940 and 1950.

\exercise
Use the \Rpackage{INLA} add-on package to perform a similar analysis by
using the coefficients and their standard errors estimated from 
our initial logistic regression model \texttt{m[["Mueller1940"]]} as parameters of a normal prior
for a logistic regression applied to the Schairer and Sch\"oniger data.
Compare the resulting credibility intervals for the two odds-ratios 
with the approximate results obtained in this chapter.


\end{description}

%%\bibliographystyle{LaTeXBibTeX/refstyle}
%%\bibliography{LaTeXBibTeX/HSAUR}   
\end{document}

\documentclass{chapman}

%%% copy Sweave.sty definitions

%%% keeps `sweave' from adding `\usepackage{Sweave}': DO NOT REMOVE
%\usepackage{Sweave} 


\RequirePackage[T1]{fontenc}
\RequirePackage{graphicx,ae,fancyvrb}
\IfFileExists{upquote.sty}{\RequirePackage{upquote}}{}
\usepackage{relsize}

\DefineVerbatimEnvironment{Sinput}{Verbatim}{}
\DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                              fontshape=it,
                                              fontsize=\relsize{-1}}
\DefineVerbatimEnvironment{Scode}{Verbatim}{}
\newenvironment{Schunk}{}{}

%%% environment for raw output
\newcommand{\SchunkRaw}{\renewenvironment{Schunk}{}{}
    \DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                                  fontshape=it,
                                                  fontsize=\small}
    \rawSinput
}

%%% environment for labeled output
\newcommand{\nextcaption}{}
\newcommand{\SchunkLabel}{
  \renewenvironment{Schunk}{\begin{figure}[ht] }{\caption{\nextcaption}
  \end{figure} }
  \DefineVerbatimEnvironment{Sinput}{Verbatim}{frame = topline}
  \DefineVerbatimEnvironment{Soutput}{Verbatim}{frame = bottomline, 
                                                samepage = true,
                                                fontfamily=courier,
                                                fontshape=it,
                                                fontsize=\relsize{-1}}
}


%%% S code with line numbers
\DefineVerbatimEnvironment{Sinput}
{Verbatim}
{
%%  numbers=left
}

\newcommand{\numberSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{numbers=left}
}
\newcommand{\rawSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{}
}


%%% R / System symbols
\newcommand{\R}{\textsf{R}}
\newcommand{\rR}{{R}}
\renewcommand{\S}{\textsf{S}}
\newcommand{\SPLUS}{\textsf{S-PLUS}}
\newcommand{\rSPLUS}{{S-PLUS}}
\newcommand{\SPSS}{\textsf{SPSS}}
\newcommand{\EXCEL}{\textsf{Excel}}
\newcommand{\ACCESS}{\textsf{Access}}
\newcommand{\SQL}{\textsf{SQL}}
%%\newcommand{\Rpackage}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Robject}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\Rclass}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Rcmd}[1]{\hbox{\rm\texttt{#1}}}
\newcommand{\Rpackage}[1]{\index{#1 package@{\fontseries{b}\selectfont #1} package} {\fontseries{b}\selectfont #1}}
\newcommand{\rpackage}[1]{{\fontseries{b}\selectfont #1}}
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\Rclass}[1]{\index{#1 class@\textit{#1} class}\textit{#1}}
\newcommand{\Rcmd}[1]{\index{#1 function@\texttt{#1} function}\texttt{#1}}
\newcommand{\Roperator}[1]{\texttt{#1}}
\newcommand{\Rarg}[1]{\texttt{#1}}
\newcommand{\Rlevel}[1]{\texttt{#1}}


%%% other symbols
\newcommand{\file}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\stress}[1]{\index{#1}\textit{#1}} 
\newcommand{\stress}[1]{\textit{#1}} 
\newcommand{\booktitle}[1]{\textit{#1}} %%'

%%% Math symbols
\usepackage{amstext}
\usepackage{amsmath}
\newcommand{\E}{\mathsf{E}}   
\newcommand{\Var}{\mathsf{Var}}   
\newcommand{\Cov}{\mathsf{Cov}}   
\newcommand{\Cor}{\mathsf{Cor}}   
\newcommand{\x}{\mathbf{x}}   
\newcommand{\y}{\mathbf{y}}   
\renewcommand{\a}{\mathbf{a}}
\newcommand{\W}{\mathbf{W}}   
\newcommand{\C}{\mathbf{C}}   
\renewcommand{\H}{\mathbf{H}}   
\newcommand{\X}{\mathbf{X}}   
\newcommand{\B}{\mathbf{B}}   
\newcommand{\V}{\mathbf{V}}   
\newcommand{\I}{\mathbf{I}}   
\newcommand{\D}{\mathbf{D}}   
\newcommand{\bS}{\mathbf{S}}   
\newcommand{\N}{\mathcal{N}}   
\renewcommand{\L}{L}   
\renewcommand{\P}{\mathsf{P}}   
\newcommand{\K}{\mathbf{K}}
\newcommand{\m}{\mathbf{m}}
\newcommand{\argmin}{\operatorname{argmin}\displaylimits}
\newcommand{\argmax}{\operatorname{argmax}\displaylimits}

\newcommand{\bx}{\mathbf{x}}
\newcommand{\bbeta}{\mathbf{\beta}}


%%% links
\usepackage{hyperref}

\hypersetup{%
  pdftitle = {A Handbook of Statistical Analyses Using R (3rd Edition)},
  pdfsubject = {Book},
  pdfauthor = {Torsten Hothorn and Brian S. Everitt},
  colorlinks = {black},
  linkcolor = {black},
  citecolor = {black},
  urlcolor = {black},
  hyperindex = {true},
  linktocpage = {true},
}


%%% captions & tables
%% <FIXME>: conflics with figure definition in chapman.cls
%%\usepackage[format=hang,margin=10pt,labelfont=bf]{caption}
%% </FIMXE>
\usepackage{longtable}
\usepackage[figuresright]{rotating}

%%% R symbol in chapter 1
\usepackage{wrapfig}

%%% Bibliography
\usepackage[round,comma]{natbib}
\renewcommand{\refname}{References \addcontentsline{toc}{chapter}{References}}
\citeindexfalse

%%% texi2dvi complains that \newblock is undefined, hm...
\def\newblock{\hskip .11em plus .33em minus .07em}

%%% Example sections
\newcounter{exercise}[chapter]
\setcounter{exercise}{0}
\newcommand{\exercise}{\stepcounter{exercise} \item{Ex.~\arabic{chapter}.\arabic{exercise} }}


%% URLs
\newcommand{\curl}[1]{\begin{center} \url{#1} \end{center}}

%%% for manual corrections
%\renewcommand{\baselinestretch}{2}

%%% plot sizes
\setkeys{Gin}{width=0.95\textwidth}

%%% color
\usepackage{color}

%%% hyphenations
\hyphenation{drop-out}
\hyphenation{mar-gi-nal}

%%% new bidirectional quotes need 
\usepackage[utf8]{inputenc}

%\usepackage{setspace}
\definecolor{sidebox_todo}{rgb}{1,1,0.2}
\newcommand{\todo}[1]{
        \hspace{0pt}%
        \marginpar{% 
                        \fcolorbox{black}{sidebox_todo}{%
                                \parbox{\marginparwidth} {

\raggedright\sffamily\footnotesize{TODO: #1}%
                                }
                        }%
        }
}
\begin{document}

%% Title page

\title{A Handbook of Statistical Analyses Using \R{} --- 3rd Edition}

\author{Torsten Hothorn and Brian S. Everitt}

\maketitle
%%\VignetteIndexEntry{Chapter Quantile Regression}
%%\VignetteDepends{lattice,quantreg}
\setcounter{chapter}{11}


\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE} 

<<setup, echo = FALSE, results = hide>>=
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })
@

\pagestyle{headings}
<<singlebook, echo = FALSE>>=
book <- FALSE
@
%% lower png resolution for vignettes
\SweaveOpts{resolution = 80}

<<QR-setup, echo = FALSE, results = hide>>=
library("lattice")
trellis.par.set(list(plot.symbol = list(col=1,pch=20, cex=0.7),
                     box.rectangle = list(col=1),
                     plot.line = list(col = 1, lwd = 1),
                     box.umbrella = list(lty=1, col=1),
                     strip.background = list(col = "white")))
ltheme <- canonical.theme(color = FALSE)     ## in-built B&W theme
ltheme$strip.background$col <- "transparent" ## change strip bg
lattice.options(default.theme = ltheme)
data("db", package = "gamlss.data")
nboys <- with(db, sum(age > 2))
@

\chapter[Quantile Regression]{Quantile Regression: 
Head Circumference for Age\label{QR}}

\section{Introduction}


\section{Quantile Regression}


\section{Analysis Using \R{}}

We begin with a graphical inspection of the influence of age on head
circumference by means of a scatterplot. Plotting all pairs of age and
head circumference in one panel gives more weight to the teens and 20s,
so we produce one plot for younger boys between two and nine years old and
one additional plot for boys older than nine years (or $>108$ months, 
to be precise). The \Rcmd{cut} function is very convenient for constructing
a factor representing these two groups 
<<QR-db, echo = TRUE>>=
summary(db)
db$cut <- cut(db$age, breaks = c(2, 9, 23), 
              labels = c("2-9 yrs", "9-23 yrs"))
@
which can then be used as a 
conditioning variable for conditional scatterplots produced with the
\Rcmd{xyplot} function \citep[package \Rpackage{lattice}]{PKG:lattice}. 
Because we draw $\Sexpr{nboys}$ points in total, we use transparent shading
(via \Rcmd{rgb(.1, .1, .1, .1)}) in order to obtain a clearer picture
for the more populated areas in the plot.

\begin{figure}
\begin{center}
<<QR-db-plot, echo = TRUE, fig = TRUE, pdf = FALSE, png = TRUE, height = 4>>=
db$cut <- cut(db$age, breaks = c(2, 9, 23), 
              labels = c("2-9 yrs", "9-23 yrs"))
xyplot(head ~ age | cut, data = db, xlab = "Age (years)", 
       ylab = "Head circumference (cm)",
       scales = list(x = list(relation = "free")),
       layout = c(2, 1), pch = 19, 
       col = rgb(.1, .1, .1, .1))
@
\caption{Scatterplot of age and head circumference for $\Sexpr{nboys}$ 
         Dutch boys. \label{QR-db-plot}}
\end{center}
\end{figure}

Figure~\ref{QR-db-plot}, as expected, shows that head circumference
increases with age.  It also shows that there is considerable variation and
also quite a number of extremely large or small head circumferences in the
respective age cohorts.  It should be noted that each point corresponds to
one boy participating in the study due to its cross-sectional study design. 
No longitudinal measurements (cf.~Chapter~\ref{ALDI}) were taken and we can
safely assume independence between observations.

We start with a simple linear model, computed separately for the younger and
older boys, for regressing the mean head circumference on age
<<QR-db-lm2.9.23, echo = TRUE>>=
(lm2.9 <- lm(head ~ age, data = db, subset = age < 9))
(lm9.23 <- lm(head ~ age, data = db, subset = age > 9))
@
This approach is equivalent to fitting two intercepts and two slopes in 
the joint model
<<QR-db-lm, echo = TRUE>>=
(lm_mod <- lm(head ~ age:I(age < 9) + I(age < 9) - 1, 
              data = db))
@
while omitting the global intercept. Because the median of the
normal distribution is equal to its mean, the two models can be interpreted
as conditional median models under the normal assumption. The model
states that within one year, the head circumference increases by
$\Sexpr{round(coef(lm_mod)["age:I(age < 9)TRUE"], 3)}$ cm for boys less than nine years old 
and by $\Sexpr{round(coef(lm_mod)["age:I(age < 9)FALSE"], 3)}$ for older boys.

We now relax this distributional assumption and compute a median
regression model using the \Rcmd{rq} function from package \Rpackage{quantreg} 
\citep{PKG:quantreg}:
<<QR-db-median, echo = TRUE>>=
library("quantreg")
(rq_med2.9 <- rq(head ~ age, data = db, tau = 0.5, 
                 subset = age < 9))
(rq_med9.23 <- rq(head ~ age, data = db, tau = 0.5, 
                  subset = age > 9))
@
When we construct confidence intervals for the 
intercept and slope parameters from both models for the younger boys
<<QR-db-lmrq2.9, echo = TRUE>>=
cbind(coef(lm2.9)[1], confint(lm2.9, parm = "(Intercept)"))
cbind(coef(lm2.9)[2], confint(lm2.9, parm = "age"))
summary(rq_med2.9, se = "rank")
@
we see that the two intercepts are almost identical but there seems to be 
a larger slope parameter for age in the median regression model. 
For the older boys, we get the confidence intervals via
<<QR-db-lmrq9.23, echo = TRUE>>=
cbind(coef(lm9.23)[1], confint(lm9.23, parm = "(Intercept)"))
cbind(coef(lm9.23)[2], confint(lm9.23, parm = "age"))
summary(rq_med9.23, se = "rank")
@
with again almost identical intercepts and only a slightly increased
slope for age in the median regression model.

Since one of our aims was the construction of growth curves, we first use the
linear models regressing head circumference on age to plot such curves. 
Based on the two normal linear models, we can compute the quantiles of head
circumference for age.  For the following values of $\tau$
<<QR-db-tau, echo = TRUE>>=
tau <- c(.01, .1, .25, .5, .75, .9, .99)
@
and a grid of age values
<<QR-db-age, echo = TRUE>>=  
gage <- c(2:9, 9:23)
i <- 1:8
@
(the index \Rcmd{i} denoting younger boys), we compute the
standard prediction intervals 
\index{Prediction interval}
taking the randomness of the estimated
intercept, slope, and variance parameters into account. We first set up
a data frame with our grid of age values and then use the \Rcmd{predict}
function for a linear model to compute prediction intervals, here
with a coverage of $50\%$. The lower limit of such a $50\%$ prediction
interval is equivalent to the conditional $25\%$ quantile for the given age
and the upper limit corresponds to the $75\%$ quantile. The conditional 
mean is also reported and is equivalent to the conditional median:
<<QR-db-lm-fit_05, echo = TRUE>>=
idf <- data.frame(age = gage[i])
p <- predict(lm2.9, newdata = idf, level = 0.5,
             interval = "prediction")
colnames(p) <- c("0.5", "0.25", "0.75")
p
@
We now proceed with $80\%$ prediction intervals for constructing the
$10\%$ and $90\%$ quantiles, and with $98\%$ prediction intervals
corresponding to the $1\%$ and $99\%$ quantiles and repeat the exercise
also for the older boys:
<<QR-db-lm-fit, echo = TRUE>>=
p <- cbind(p, predict(lm2.9, newdata = idf, level = 0.8,
                      interval = "prediction")[,-1])
colnames(p)[4:5] <- c("0.1", "0.9")
p <- cbind(p, predict(lm2.9, newdata = idf, level = 0.98, 
                      interval = "prediction")[,-1])
colnames(p)[6:7] <- c("0.01", "0.99")
p2.9 <- p[, c("0.01", "0.1", "0.25", "0.5", 
              "0.75", "0.9", "0.99")]
idf <- data.frame(age = gage[-i])
p <- predict(lm9.23, newdata = idf, level = 0.5, 
             interval = "prediction")
colnames(p) <- c("0.5", "0.25", "0.75")
p <- cbind(p, predict(lm9.23, newdata = idf, level = 0.8, 
                      interval = "prediction")[,-1])
colnames(p)[4:5] <- c("0.1", "0.9")
p <- cbind(p, predict(lm9.23, newdata = idf, level = 0.98, 
                      interval = "prediction")[,-1])
colnames(p)[6:7] <- c("0.01", "0.99")
@
We now reorder the columns of this table and get the following
conditional quantiles, estimated under the normal assumption of
head circumference:
<<QR-db-lm-fit2, echo = TRUE>>=
p9.23 <- p[, c("0.01", "0.1", "0.25", "0.5", 
               "0.75", "0.9", "0.99")]
round((q2.23 <- rbind(p2.9, p9.23)), 3)
@
We can now superimpose these conditional quantiles on our scatterplot.
To do this, we need to write our own little panel function that
produces the scatterplot using the \Rcmd{panel.xyplot} function and then
adds the just computed conditional quantiles by means of the 
\Rcmd{panel.lines} function called for every column of $\Robject{q2.23}$.

Figure~\ref{QR-db-lm-plot} shows parallel lines owing to the fact that the
linear model assumes an error variance independent from age; this is the
so-called variance homogeneity.  Compared to a plot with only a single
(mean) regression line, we plotted a whole bunch of conditional
distributions here, one for each value of age. Of course, we did so
under extremely simplifying assumptions like linearity and variance
homogeneity that we're going to drop now.

\begin{figure}
\begin{center}
<<QR-db-lm-plot, echo = TRUE, fig = TRUE, pdf = FALSE, png = TRUE, height = 4>>=
pfun <- function(x, y, ...) {
    panel.xyplot(x = x, y = y, ...)
    if (max(x) <= 9) {
        apply(q2.23, 2, function(x) 
              panel.lines(gage[i], x[i]))
    } else {
        apply(q2.23, 2, function(x) 
              panel.lines(gage[-i], x[-i]))
    }
    panel.text(rep(max(db$age), length(tau)), 
               q2.23[nrow(q2.23),], label = tau, cex = 0.9) 
    panel.text(rep(min(db$age), length(tau)), 
               q2.23[1,], label = tau, cex = 0.9)
}
xyplot(head ~ age | cut, data = db, xlab = "Age (years)", 
       ylab = "Head circumference (cm)", pch = 19,
       scales = list(x = list(relation = "free")),
       layout = c(2, 1), col = rgb(.1, .1, .1, .1), 
       panel = pfun)
@
\caption{Scatterplot of age and head circumference for $\Sexpr{nboys}$
         Dutch boys with superimposed normal quantiles. 
         \label{QR-db-lm-plot}}     
\end{center}
\end{figure}

For the production of a nonparametric version of our growth curves, 
we start with fitting not only one but multiple quantile regression models,
one for each value of $\tau$. We start with the younger boys
<<QR-db-rq2.9, echo = TRUE>>=
(rq2.9 <- rq(head ~ age, data = db, tau = tau, 
             subset = age < 9))
@
and continue with the older boys
<<QR-db-rq9.23, echo = TRUE>>=
(rq9.23 <- rq(head ~ age, data = db, tau = tau, 
              subset = age > 9))
@
Naturally, the intercept parameters vary but there is also a considerable
variation in the slopes, with the largest value 
for the $1\%$ quantile regression model for younger boys. 
The parameters $\beta_\tau$ have to be interpreted with care.
In general, they cannot be interpreted on an individual-specific level.  A
boy who happens to be at the $\tau \times 100\%$ quantile of head circumference
conditional on his age would not be at the same
quantile anymore when he gets older.  When knowing
$\beta_\tau$, the only conclusion that can be drawn is how the $\tau
\times 100\%$ quantile of a population with a specific age 
differs from the $\tau \times 100\%$ quantile of a population with a
different age.

Because the linear functions estimated by linear quantile regression,
here in model \Robject{rq9.23}, directly correspond to the conditional
quantiles of interest, we can use the \Rcmd{predict} function to compute
the estimated conditional quantiles:
<<QR-db-rq-fit, echo = TRUE>>=
p2.23 <- rbind(predict(rq2.9, 
                   newdata = data.frame(age = gage[i])),
               predict(rq9.23, 
                   newdata = data.frame(age = gage[-i])))
@
It is important to note that these numbers were obtained without assuming
anything about the continuous distribution of head circumference given any
age.  Again, we produce a scatterplot with superimposed quantiles, this time
each line corresponds to a specific model.  For the sake of comparison with
the linear model, we add the linear model quantiles as dashed lines to
Figure~\ref{QR-db-rq-plot}.  For the older boys, there seems to be almost no
difference but the more extreme $1\%$ and $99\%$ quantiles for the younger
boys differ considerably.  So, at least for the younger boys, we might want
to allow for age-specific variability in the distribution of head
circumference.

\begin{figure}
\begin{center}
<<QR-db-rq-plot, echo = TRUE, fig = TRUE, pdf = FALSE, png = TRUE, height = 4>>=
pfun <- function(x, y, ...) {
    panel.xyplot(x = x, y = y, ...)
    if (max(x) <= 9) {
        apply(q2.23, 2, function(x) 
              panel.lines(gage[i], x[i], lty = 2))
        apply(p2.23, 2, function(x) 
              panel.lines(gage[i], x[i]))
    } else {
        apply(q2.23, 2, function(x) 
              panel.lines(gage[-i], x[-i], lty = 2))
        apply(p2.23, 2, function(x) 
              panel.lines(gage[-i], x[-i]))
    }
    panel.text(rep(max(db$age), length(tau)), 
               p2.23[nrow(p2.23),], label = tau, cex = 0.9)
    panel.text(rep(min(db$age), length(tau)), 
               p2.23[1,], label = tau, cex = 0.9)
}
xyplot(head ~ age | cut, data = db, xlab = "Age (years)",
       ylab = "Head circumference (cm)", pch = 19,
       scales = list(x = list(relation = "free")),
       layout = c(2, 1), col = rgb(.1, .1, .1, .1),
       panel = pfun)
@
\caption{Scatterplot of age and head circumference for $\Sexpr{nboys}$
         Dutch boys with superimposed regression quantiles (solid lines) and 
         normal quantiles (dashed lines). \label{QR-db-rq-plot}}     
\end{center}
\end{figure}

Still, with the quantile regression models shown in
Figure~\ref{QR-db-rq-plot} we assume that the quantiles of head
circumference depend on age in a linear way.  Additive quantile regression
is one way to approach the estimation of non-linear quantile functions. By
considering two different models for younger and older boys, we allowed
for a certain type of non-linear function in the results shown so far.
Additive quantile regression should be able to deal with this problem
and we therefore fit these models to all boys simultaneously.
For our different choices of $\tau$, we fit one additive quantile regression model
using the \Rcmd{rqss} function from the \Rpackage{quantreg} and allow
smooth quantile functions of age via the \Rcmd{qss} function in the
right-hand side of the model formula.
Note that we transformed age by the third root prior to model fitting. This
does not affect the model since it is a monotone transformation, however, it
helps to avoid fitting a function with large derivatives for very young
boys resulting in a low penalty parameter $\lambda$:
<<QR-db-rqss-fit, echo = TRUE>>=
rqssmod <- vector(mode = "list", length = length(tau))
db$lage <- with(db, age^(1/3))
for (i in 1:length(tau))
    rqssmod[[i]] <- rqss(head ~ qss(lage, lambda = 1),
                         data = db, tau = tau[i])
@
For the analysis of the head circumference, we choose a penalty parameter
$\lambda = 1$, which is the default for the \Rcmd{qss} function.  Simply
using the default without a careful hyperparameter tuning, for example using
crossvalidation or similar procedures, is almost always a mistake. 
By visual inspection (Figure~\ref{QR-db-rqss-plot}) we find this choice
appropriate but ask the readers to make a second guess (Exercise 3).


For a finer grid of age values, we compute the conditional quantiles
from the \Rcmd{predict} function:
<<QR-db-rqss-pred, echo = TRUE>>=
gage <- seq(from = min(db$age), to = max(db$age), 
            length = 50)
p <- sapply(1:length(tau), function(i) {
    predict(rqssmod[[i]], 
        newdata = data.frame(lage = gage^(1/3)))
})
@

Using very similar code as for plotting linear quantiles, we produce again a
scatterplot of age and head circumference but this time overlaid with
non-linear regression quantiles.  Given that the results from the linear
models presented in Figure~\ref{QR-db-rq-plot} looked pretty convincing, the
quantile curves in Figure~\ref{QR-db-rqss-plot} shed a surprising new light
on the data.  For the younger boys, we expected to see a larger variability
than for boys between two and three years old, but in fact the distribution seems
to be more complex.  The distribution seems to be positively skewed with a
heavy lower tail and the degree of skewness varies with age (note that 
the median is almost linear for boys older than four years).

Also in the right part of Figure~\ref{QR-db-rqss-plot}, we see an age-varying
skewness, although less pronounced as for the younger boys.  The median
increases up to 16 years but then the growth rate is much smaller.  This
does not seem to be the case for the $1\%, 10\%, 90\%$, and $99\%$
quantiles.  Note that the discontinuity in the quantiles between the two age
groups is only due to the overlapping abscissae.

However, the deviations between the growth curves obtained from a linear
model under normality assumption on the one hand and quantile regression on the
other hand as shown in Figures~\ref{QR-db-rq-plot} and \ref{QR-db-rqss-plot} 
are hardly dramatic for the head circumference data. 

\begin{figure}
\begin{center}
<<QR-db-rqss-plot, echo = TRUE, fig = TRUE, pdf = FALSE, png = TRUE, height = 4>>=
pfun <- function(x, y, ...) {
    panel.xyplot(x = x, y = y, ...)
    apply(p, 2, function(x) panel.lines(gage, x))
    panel.text(rep(max(db$age), length(tau)), 
               p[nrow(p),], label = tau, cex = 0.9)
    panel.text(rep(min(db$age), length(tau)), 
               p[1,], label = tau, cex = 0.9)
}
xyplot(head ~ age | cut, data = db, xlab = "Age (years)",
       ylab = "Head circumference (cm)", pch = 19,
       scales = list(x = list(relation = "free")),
       layout = c(2, 1), col = rgb(.1, .1, .1, .1),
       panel = pfun)
@
\caption{Scatterplot of age and head circumference for $\Sexpr{nboys}$
         Dutch boys with superimposed non-linear regression quantiles.
         \label{QR-db-rqss-plot}}     
\end{center}
\end{figure}

\section{Summary of Findings}

We can conclude that the whole distribution of head circumference changes
with age and that assumptions like symmetry and variance homogeneity might be
questionable for such type of analysis.

One alternative to the estimation of conditional quantiles is the estimation
of conditional distributions.  One very interesting parametric approach are
generalized additive models for location, scale, and shape
\citep[GAMLSS,][]{HSAUR:RigbyStasinopoulos2005}.  In
\cite{HSAUR:StasinopoulosRigby2007}, an analysis of the age and head
circumference by means of the \Rpackage{gamlss} package can be found.

One practical problem associated with contemporary methods in quantile
regression is quantile crossing. Because we fitted one quantile regression model
for each of the quantiles of interest, we cannot guarantee that the conditional
quantile functions are monotone, so the $90\%$ quantile may well be larger than the
$95\%$ quantile in some cases. Postprocessing of the estimated quantile curves
may help in this situation \citep{HSAUR:DetteVolgushev2008}.

\section{Final Comments}

When estimating regression models, we have to be aware of the implications
of model assumptions when interpreting the results.  Symmetry, linearity,
and variance homogeneity are among the strongest but common assumptions. 
Quantile regression, both in its linear and additive formulation, is an
intellectually stimulating and practically very useful framework where such
assumptions can be relaxed.  At a more basic level, one should always ask
\stress{Am I really interested in the mean?} before using the regression models
discussed in other chapters of this book.


\bibliographystyle{LaTeXBibTeX/refstyle}
\bibliography{LaTeXBibTeX/HSAUR}   
\end{document}

\documentclass{chapman}

%%% copy Sweave.sty definitions

%%% keeps `sweave' from adding `\usepackage{Sweave}': DO NOT REMOVE
%\usepackage{Sweave} 


\RequirePackage[T1]{fontenc}
\RequirePackage{graphicx,ae,fancyvrb}
\IfFileExists{upquote.sty}{\RequirePackage{upquote}}{}
\usepackage{relsize}

\DefineVerbatimEnvironment{Sinput}{Verbatim}{}
\DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                              fontshape=it,
                                              fontsize=\relsize{-1}}
\DefineVerbatimEnvironment{Scode}{Verbatim}{}
\newenvironment{Schunk}{}{}

%%% environment for raw output
\newcommand{\SchunkRaw}{\renewenvironment{Schunk}{}{}
    \DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                                  fontshape=it,
                                                  fontsize=\small}
    \rawSinput
}

%%% environment for labeled output
\newcommand{\nextcaption}{}
\newcommand{\SchunkLabel}{
  \renewenvironment{Schunk}{\begin{figure}[ht] }{\caption{\nextcaption}
  \end{figure} }
  \DefineVerbatimEnvironment{Sinput}{Verbatim}{frame = topline}
  \DefineVerbatimEnvironment{Soutput}{Verbatim}{frame = bottomline, 
                                                samepage = true,
                                                fontfamily=courier,
                                                fontshape=it,
                                                fontsize=\relsize{-1}}
}


%%% S code with line numbers
\DefineVerbatimEnvironment{Sinput}
{Verbatim}
{
%%  numbers=left
}

\newcommand{\numberSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{numbers=left}
}
\newcommand{\rawSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{}
}


%%% R / System symbols
\newcommand{\R}{\textsf{R}}
\newcommand{\rR}{{R}}
\renewcommand{\S}{\textsf{S}}
\newcommand{\SPLUS}{\textsf{S-PLUS}}
\newcommand{\rSPLUS}{{S-PLUS}}
\newcommand{\SPSS}{\textsf{SPSS}}
\newcommand{\EXCEL}{\textsf{Excel}}
\newcommand{\ACCESS}{\textsf{Access}}
\newcommand{\SQL}{\textsf{SQL}}
%%\newcommand{\Rpackage}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Robject}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\Rclass}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Rcmd}[1]{\hbox{\rm\texttt{#1}}}
\newcommand{\Rpackage}[1]{\index{#1 package@{\fontseries{b}\selectfont #1} package} {\fontseries{b}\selectfont #1}}
\newcommand{\rpackage}[1]{{\fontseries{b}\selectfont #1}}
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\Rclass}[1]{\index{#1 class@\textit{#1} class}\textit{#1}}
\newcommand{\Rcmd}[1]{\index{#1 function@\texttt{#1} function}\texttt{#1}}
\newcommand{\Roperator}[1]{\texttt{#1}}
\newcommand{\Rarg}[1]{\texttt{#1}}
\newcommand{\Rlevel}[1]{\texttt{#1}}


%%% other symbols
\newcommand{\file}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\stress}[1]{\index{#1}\textit{#1}} 
\newcommand{\stress}[1]{\textit{#1}} 
\newcommand{\booktitle}[1]{\textit{#1}} %%'

%%% Math symbols
\usepackage{amstext}
\usepackage{amsmath}
\newcommand{\E}{\mathsf{E}}   
\newcommand{\Var}{\mathsf{Var}}   
\newcommand{\Cov}{\mathsf{Cov}}   
\newcommand{\Cor}{\mathsf{Cor}}   
\newcommand{\x}{\mathbf{x}}   
\newcommand{\y}{\mathbf{y}}   
\renewcommand{\a}{\mathbf{a}}
\newcommand{\W}{\mathbf{W}}   
\newcommand{\C}{\mathbf{C}}   
\renewcommand{\H}{\mathbf{H}}   
\newcommand{\X}{\mathbf{X}}   
\newcommand{\B}{\mathbf{B}}   
\newcommand{\V}{\mathbf{V}}   
\newcommand{\I}{\mathbf{I}}   
\newcommand{\D}{\mathbf{D}}   
\newcommand{\bS}{\mathbf{S}}   
\newcommand{\N}{\mathcal{N}}   
\renewcommand{\L}{L}   
\renewcommand{\P}{\mathsf{P}}   
\newcommand{\K}{\mathbf{K}}
\newcommand{\m}{\mathbf{m}}
\newcommand{\argmin}{\operatorname{argmin}\displaylimits}
\newcommand{\argmax}{\operatorname{argmax}\displaylimits}

\newcommand{\bx}{\mathbf{x}}
\newcommand{\bbeta}{\mathbf{\beta}}


%%% links
\usepackage{hyperref}

\hypersetup{%
  pdftitle = {A Handbook of Statistical Analyses Using R (3rd Edition)},
  pdfsubject = {Book},
  pdfauthor = {Torsten Hothorn and Brian S. Everitt},
  colorlinks = {black},
  linkcolor = {black},
  citecolor = {black},
  urlcolor = {black},
  hyperindex = {true},
  linktocpage = {true},
}


%%% captions & tables
%% <FIXME>: conflics with figure definition in chapman.cls
%%\usepackage[format=hang,margin=10pt,labelfont=bf]{caption}
%% </FIMXE>
\usepackage{longtable}
\usepackage[figuresright]{rotating}

%%% R symbol in chapter 1
\usepackage{wrapfig}

%%% Bibliography
\usepackage[round,comma]{natbib}
\renewcommand{\refname}{References \addcontentsline{toc}{chapter}{References}}
\citeindexfalse

%%% texi2dvi complains that \newblock is undefined, hm...
\def\newblock{\hskip .11em plus .33em minus .07em}

%%% Example sections
\newcounter{exercise}[chapter]
\setcounter{exercise}{0}
\newcommand{\exercise}{\stepcounter{exercise} \item{Ex.~\arabic{chapter}.\arabic{exercise} }}


%% URLs
\newcommand{\curl}[1]{\begin{center} \url{#1} \end{center}}

%%% for manual corrections
%\renewcommand{\baselinestretch}{2}

%%% plot sizes
\setkeys{Gin}{width=0.95\textwidth}

%%% color
\usepackage{color}

%%% hyphenations
\hyphenation{drop-out}
\hyphenation{mar-gi-nal}

%%% new bidirectional quotes need 
\usepackage[utf8]{inputenc}

%\usepackage{setspace}
\definecolor{sidebox_todo}{rgb}{1,1,0.2}
\newcommand{\todo}[1]{
        \hspace{0pt}%
        \marginpar{% 
                        \fcolorbox{black}{sidebox_todo}{%
                                \parbox{\marginparwidth} {

\raggedright\sffamily\footnotesize{TODO: #1}%
                                }
                        }%
        }
}
\begin{document}

%% Title page

\title{A Handbook of Statistical Analyses Using \R{} --- 3rd Edition}

\author{Torsten Hothorn and Brian S. Everitt}

\maketitle
%%\VignetteIndexEntry{Errata}
\setcounter{chapter}{21}


\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE} 

<<setup, echo = FALSE, results = hide>>=
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })
@

\pagestyle{headings}
<<singlebook, echo = FALSE>>=
book <- FALSE
@

\chapter[Errata]{Errata}


%\bibliographystyle{LaTeXBibTeX/refstyle}
%\bibliography{LaTeXBibTeX/HSAUR}   
\end{document}

\documentclass{chapman}

%%% copy Sweave.sty definitions

%%% keeps `sweave' from adding `\usepackage{Sweave}': DO NOT REMOVE
%\usepackage{Sweave} 


\RequirePackage[T1]{fontenc}
\RequirePackage{graphicx,ae,fancyvrb}
\IfFileExists{upquote.sty}{\RequirePackage{upquote}}{}
\usepackage{relsize}

\DefineVerbatimEnvironment{Sinput}{Verbatim}{}
\DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                              fontshape=it,
                                              fontsize=\relsize{-1}}
\DefineVerbatimEnvironment{Scode}{Verbatim}{}
\newenvironment{Schunk}{}{}

%%% environment for raw output
\newcommand{\SchunkRaw}{\renewenvironment{Schunk}{}{}
    \DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                                  fontshape=it,
                                                  fontsize=\small}
    \rawSinput
}

%%% environment for labeled output
\newcommand{\nextcaption}{}
\newcommand{\SchunkLabel}{
  \renewenvironment{Schunk}{\begin{figure}[ht] }{\caption{\nextcaption}
  \end{figure} }
  \DefineVerbatimEnvironment{Sinput}{Verbatim}{frame = topline}
  \DefineVerbatimEnvironment{Soutput}{Verbatim}{frame = bottomline, 
                                                samepage = true,
                                                fontfamily=courier,
                                                fontshape=it,
                                                fontsize=\relsize{-1}}
}


%%% S code with line numbers
\DefineVerbatimEnvironment{Sinput}
{Verbatim}
{
%%  numbers=left
}

\newcommand{\numberSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{numbers=left}
}
\newcommand{\rawSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{}
}


%%% R / System symbols
\newcommand{\R}{\textsf{R}}
\newcommand{\rR}{{R}}
\renewcommand{\S}{\textsf{S}}
\newcommand{\SPLUS}{\textsf{S-PLUS}}
\newcommand{\rSPLUS}{{S-PLUS}}
\newcommand{\SPSS}{\textsf{SPSS}}
\newcommand{\EXCEL}{\textsf{Excel}}
\newcommand{\ACCESS}{\textsf{Access}}
\newcommand{\SQL}{\textsf{SQL}}
%%\newcommand{\Rpackage}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Robject}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\Rclass}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Rcmd}[1]{\hbox{\rm\texttt{#1}}}
\newcommand{\Rpackage}[1]{\index{#1 package@{\fontseries{b}\selectfont #1} package} {\fontseries{b}\selectfont #1}}
\newcommand{\rpackage}[1]{{\fontseries{b}\selectfont #1}}
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\Rclass}[1]{\index{#1 class@\textit{#1} class}\textit{#1}}
\newcommand{\Rcmd}[1]{\index{#1 function@\texttt{#1} function}\texttt{#1}}
\newcommand{\Roperator}[1]{\texttt{#1}}
\newcommand{\Rarg}[1]{\texttt{#1}}
\newcommand{\Rlevel}[1]{\texttt{#1}}


%%% other symbols
\newcommand{\file}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\stress}[1]{\index{#1}\textit{#1}} 
\newcommand{\stress}[1]{\textit{#1}} 
\newcommand{\booktitle}[1]{\textit{#1}} %%'

%%% Math symbols
\usepackage{amstext}
\usepackage{amsmath}
\newcommand{\E}{\mathsf{E}}   
\newcommand{\Var}{\mathsf{Var}}   
\newcommand{\Cov}{\mathsf{Cov}}   
\newcommand{\Cor}{\mathsf{Cor}}   
\newcommand{\x}{\mathbf{x}}   
\newcommand{\y}{\mathbf{y}}   
\renewcommand{\a}{\mathbf{a}}
\newcommand{\W}{\mathbf{W}}   
\newcommand{\C}{\mathbf{C}}   
\renewcommand{\H}{\mathbf{H}}   
\newcommand{\X}{\mathbf{X}}   
\newcommand{\B}{\mathbf{B}}   
\newcommand{\V}{\mathbf{V}}   
\newcommand{\I}{\mathbf{I}}   
\newcommand{\D}{\mathbf{D}}   
\newcommand{\bS}{\mathbf{S}}   
\newcommand{\N}{\mathcal{N}}   
\renewcommand{\L}{L}   
\renewcommand{\P}{\mathsf{P}}   
\newcommand{\K}{\mathbf{K}}
\newcommand{\m}{\mathbf{m}}
\newcommand{\argmin}{\operatorname{argmin}\displaylimits}
\newcommand{\argmax}{\operatorname{argmax}\displaylimits}

\newcommand{\bx}{\mathbf{x}}
\newcommand{\bbeta}{\mathbf{\beta}}


%%% links
\usepackage{hyperref}

\hypersetup{%
  pdftitle = {A Handbook of Statistical Analyses Using R (3rd Edition)},
  pdfsubject = {Book},
  pdfauthor = {Torsten Hothorn and Brian S. Everitt},
  colorlinks = {black},
  linkcolor = {black},
  citecolor = {black},
  urlcolor = {black},
  hyperindex = {true},
  linktocpage = {true},
}


%%% captions & tables
%% <FIXME>: conflics with figure definition in chapman.cls
%%\usepackage[format=hang,margin=10pt,labelfont=bf]{caption}
%% </FIMXE>
\usepackage{longtable}
\usepackage[figuresright]{rotating}

%%% R symbol in chapter 1
\usepackage{wrapfig}

%%% Bibliography
\usepackage[round,comma]{natbib}
\renewcommand{\refname}{References \addcontentsline{toc}{chapter}{References}}
\citeindexfalse

%%% texi2dvi complains that \newblock is undefined, hm...
\def\newblock{\hskip .11em plus .33em minus .07em}

%%% Example sections
\newcounter{exercise}[chapter]
\setcounter{exercise}{0}
\newcommand{\exercise}{\stepcounter{exercise} \item{Ex.~\arabic{chapter}.\arabic{exercise} }}


%% URLs
\newcommand{\curl}[1]{\begin{center} \url{#1} \end{center}}

%%% for manual corrections
%\renewcommand{\baselinestretch}{2}

%%% plot sizes
\setkeys{Gin}{width=0.95\textwidth}

%%% color
\usepackage{color}

%%% hyphenations
\hyphenation{drop-out}
\hyphenation{mar-gi-nal}

%%% new bidirectional quotes need 
\usepackage[utf8]{inputenc}

%\usepackage{setspace}
\definecolor{sidebox_todo}{rgb}{1,1,0.2}
\newcommand{\todo}[1]{
        \hspace{0pt}%
        \marginpar{% 
                        \fcolorbox{black}{sidebox_todo}{%
                                \parbox{\marginparwidth} {

\raggedright\sffamily\footnotesize{TODO: #1}%
                                }
                        }%
        }
}
\begin{document}

%% Title page

\title{A Handbook of Statistical Analyses Using \R{} --- 3rd Edition}

\author{Torsten Hothorn and Brian S. Everitt}

\maketitle
%%\VignetteIndexEntry{Chapter Recursive Partitioning}
%%\VignetteDepends{vcd,lattice,randomForest,partykit}
\setcounter{chapter}{8}


\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE} 

<<setup, echo = FALSE, results = hide>>=
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })
@

\pagestyle{headings}
<<singlebook, echo = FALSE>>=
book <- FALSE
@

<<RP-setup, echo = FALSE, results = hide>>=
library("vcd")
library("lattice")
library("randomForest")
library("partykit")
ltheme <- canonical.theme(color = FALSE)     ## in-built B&W theme  
ltheme$strip.background$col <- "transparent" ## change strip bg  
lattice.options(default.theme = ltheme) 
mai <- par("mai")
options(SweaveHooks = list(nullmai = function() { par(mai = rep(0, 4)) },
                           twomai = function() { par(mai = c(0, mai[2], 0, 0)) },
                           threemai = function() { par(mai = c(0, mai[2], 0.1, 0)) }))
numbers <- c("zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine")
@

\chapter[Recursive Partitioning]{Recursive Partitioning: 
                                 Predicting Body Fat, Glaucoma Diagnosis, and Happiness in China \label{RP}}

\section{Introduction}


\section{Recursive Partitioning}


\section{Analysis Using \R{}}

\subsection{Predicting Body Fat Content}


The \Rcmd{rpart} function from \Rpackage{rpart} can be used to grow a
regression tree. The response variable and the covariates are defined by a
model formula in the same way as for \Rcmd{lm}, say. By default, a large
initial tree is grown, we restrict the number of observations required to
establish a potential binary split to at least ten:
<<RP-bodyfat-rpart, echo = TRUE>>=
library("rpart")
data("bodyfat", package = "TH.data")
bodyfat_rpart <- rpart(DEXfat ~ age + waistcirc + hipcirc + 
    elbowbreadth + kneebreadth, data = bodyfat, 
    control = rpart.control(minsplit = 10))
@
A \Rcmd{print} method for \Rclass{rpart} objects is available; however, a
graphical representation \citep[here utilizing functionality offered 
from package \Rpackage{partykit},][]{PKG:partykit} shown in Figure~\ref{RP-bodyfat-plot} is more
convenient. Observations that satisfy the condition shown for each node 
go to the left and
observations that don't are an element of the right branch in each node. %'
As expected, higher values for waist and hip circumferences and wider knees
correspond to higher values of body fat content. The rightmost terminal node
consists of only three rather extreme observations.

\begin{figure}
\begin{center}
<<RP-bodyfat-plot, echo = TRUE, fig = TRUE, nullmai = TRUE, width = 10, height = 6>>=
library("partykit")
plot(as.party(bodyfat_rpart), tp_args = list(id = FALSE))
@
\caption{Initial tree for the body fat data with the distribution
         of body fat in terminal nodes visualized via boxplots. \label{RP-bodyfat-plot}}
\end{center}
\end{figure}

\index{Cross-validation}
To determine if the tree is appropriate or if some of the branches need to 
be subjected to pruning we can use the \Robject{cptable}
element of the \Rclass{rpart} object:
<<RP-bodyfat-cp, echo = TRUE>>=
print(bodyfat_rpart$cptable)
opt <- which.min(bodyfat_rpart$cptable[,"xerror"])
@
The \Robject{xerror} column contains estimates of cross-validated prediction error
for different numbers of splits (\Robject{nsplit}). The best tree has
\Sexpr{numbers[bodyfat_rpart$cptable[opt, "nsplit"] + 1]}
splits. Now we can prune back the large initial tree using

<<RP-bodyfat-prune, echo = TRUE>>=
cp <- bodyfat_rpart$cptable[opt, "CP"]
bodyfat_prune <- prune(bodyfat_rpart, cp = cp)
@
The result is shown in Figure~\ref{RP-bodyfat-pruneplot}. Note that
the inner nodes three and six have been removed from the tree. Still, the
rightmost terminal node might give very unreliable extreme predictions.

\begin{figure}
\begin{center}
<<RP-bodyfat-pruneplot, echo = TRUE, fig = TRUE, twomai = TRUE, width = 10, height = 6>>=
plot(as.party(bodyfat_prune), tp_args = list(id = FALSE))
@
\caption{Pruned regression tree for body fat data.
         \label{RP-bodyfat-pruneplot}}
\end{center}
\end{figure}

Given this model, one can predict the (unknown, in real circumstances) body fat
content based on the covariate measurements. Here, using the known values of
the response variable, we compare the model predictions with the actually measured
body fat as shown in Figure~\ref{RP-bodyfat-predict}. The three observations
with large body fat measurements in the rightmost terminal node can be identified
easily.
\begin{figure}
\begin{center}
<<RP-bodyfat-predict, echo = TRUE, fig = TRUE>>=
DEXfat_pred <- predict(bodyfat_prune, newdata = bodyfat)
xlim <- range(bodyfat$DEXfat)
plot(DEXfat_pred ~ DEXfat, data = bodyfat, xlab = "Observed", 
     ylab = "Predicted", ylim = xlim, xlim = xlim)
abline(a = 0, b = 1)
@
\caption{Observed and predicted DXA measurements.
         \label{RP-bodyfat-predict}}
\end{center}
\end{figure}


\subsection{Glaucoma Diagnosis}


<<RP-seed-again, echo = FALSE, results = hide>>=
set.seed(290875)
@

<<RP-glaucoma-rpart, echo = TRUE>>=
data("GlaucomaM", package = "TH.data")
glaucoma_rpart <- rpart(Class ~ ., data = GlaucomaM, 
    control = rpart.control(xval = 100))
glaucoma_rpart$cptable
opt <- which.min(glaucoma_rpart$cptable[,"xerror"])
cp <- glaucoma_rpart$cptable[opt, "CP"]
glaucoma_prune <- prune(glaucoma_rpart, cp = cp)
@


\setkeys{Gin}{width = 0.65\textwidth}
\begin{figure}
\begin{center}
<<RP-glaucoma-plot, echo = TRUE, fig = TRUE, nullmai = TRUE, width = 6, height = 6>>=
plot(as.party(glaucoma_prune), tp_args = list(id = FALSE))
@
\caption{Pruned classification tree of the glaucoma data with class
         distribution in the leaves. \label{RP:gl}}
\end{center}
\end{figure}

\setkeys{Gin}{width=0.95\textwidth}

\index{Classification tree!choice of tree size}
\index{Tree size}
As we discussed earlier, the choice of the appropriately sized tree is not a
trivial problem. For the glaucoma data, the above choice of three leaves is
very unstable across multiple runs of cross-validation. As an illustration
of this problem we repeat the very same analysis as shown above and record
the optimal number of splits as suggested by the cross-validation runs.
<<RP-glaucoma-cp, echo = TRUE>>=
nsplitopt <- vector(mode = "integer", length = 25)
for (i in 1:length(nsplitopt)) {
    cp <- rpart(Class ~ ., data = GlaucomaM)$cptable
    nsplitopt[i] <- cp[which.min(cp[,"xerror"]), "nsplit"]
}
@

\newpage

<<RP-glaucoma-cp-print, echo = TRUE>>=
table(nsplitopt)
@
Although for \Sexpr{sum(nsplitopt == 1)} runs of cross-validation a simple
tree with one split only is suggested, larger trees would have been favored
in \Sexpr{sum(nsplitopt > 1)} of the cases. This short analysis shows that
we should not trust the tree in Figure~\ref{RP:gl} too much.

\index{Bagging}
\index{Bootstrap approach!glaucoma diagnosis data}
One way out of this dilemma is the aggregation of multiple trees via bagging. 
In \R{}, the bagging idea can be implemented by three or four lines
of code. Case count or weight vectors representing the bootstrap samples can be drawn from the
multinominal distribution with parameters $n$ and $p_1 = 1/n, \dots, p_n =
1/n$ via the \Rcmd{rmultinom} function. For each weight vector, one large tree is
constructed without pruning and the \Rclass{rpart} objects are stored in a
list, here called \Robject{trees}:
<<RP-glaucoma-bagg, echo = TRUE>>=
trees <- vector(mode = "list", length = 25)
n <- nrow(GlaucomaM)
bootsamples <- rmultinom(length(trees), n, rep(1, n)/n)
mod <- rpart(Class ~ ., data = GlaucomaM, 
             control = rpart.control(xval = 0))
for (i in 1:length(trees))
    trees[[i]] <- update(mod, weights = bootsamples[,i])
@
The \Rcmd{update} function re-evaluates the call of \Robject{mod}, however,
with the weights being altered, i.e., fits a tree to a bootstrap sample
specified by the weights.
It is interesting to have a look at the structures of the multiple trees.
For example, the variable selected for splitting in the root of the tree is
not unique as can be seen by
<<RP-glaucoma-splits, echo = TRUE>>=
table(sapply(trees, function(x) as.character(x$frame$var[1])))
@
Although \Robject{varg} is selected most of the time, other variables such
as \Robject{vari} occur as well -- a further indication that the tree in
Figure~\ref{RP:gl} is
questionable and that hard decisions are not appropriate for the glaucoma
data.

In order to make use of the ensemble of trees in the list \Robject{trees}
we estimate the conditional probability of suffering from glaucoma given the
covariates for each observation in the original data set by
<<RP-glaucoma-baggpred, echo = TRUE>>=
classprob <- matrix(0, nrow = n, ncol = length(trees))
for (i in 1:length(trees)) {
    classprob[,i] <- predict(trees[[i]], 
                             newdata = GlaucomaM)[,1]
    classprob[bootsamples[,i] > 0,i] <- NA
}
@
Thus, for each observation we get \Sexpr{length(trees)} estimates. However,
each observation has been used for growing one of the trees with
probability $0.632$ and thus was not used with probability $0.368$.
Consequently, the estimate from a tree where an observation was not used for
growing is better for judging the quality of the predictions and we label
the other estimates with \Robject{NA}.

Now, we can average the estimates and we vote for glaucoma when the average
of the estimates of the conditional glaucoma probability exceeds $0.5$. The
comparison between the observed and the predicted classes does not suffer from
overfitting since the predictions are computed from those trees for which 
each single observation was \stress{not} used for growing.
<<RP-glaucoma-avg, echo = TRUE>>=
avg <- rowMeans(classprob, na.rm = TRUE)
predictions <- factor(ifelse(avg > 0.5, "glaucoma", 
                                        "normal"))
predtab <- table(predictions, GlaucomaM$Class)
predtab
@
Thus, an honest estimate of the probability of
a glaucoma prediction when the patient is actually suffering from glaucoma is
<<RP-glaucoma-sens, echo = TRUE>>=
round(predtab[1,1] / colSums(predtab)[1] * 100)
@
per cent. For 
<<RP-glaucoma-spez, echo = TRUE>>=
round(predtab[2,2] / colSums(predtab)[2] * 100)
@
percent of normal eyes, the ensemble does not predict glaucomateous
damage.


\begin{figure}
\begin{center}
<<RP-glaucoma-baggplot, echo = TRUE, fig = TRUE, height = 4>>=
library("lattice")
gdata <- data.frame(avg = rep(avg, 2), 
    class = rep(as.numeric(GlaucomaM$Class), 2),
    obs = c(GlaucomaM[["varg"]], GlaucomaM[["vari"]]),
    var = factor(c(rep("varg", nrow(GlaucomaM)), 
                   rep("vari", nrow(GlaucomaM)))))
panelf <- function(x, y) {
           panel.xyplot(x, y, pch = gdata$class)
           panel.abline(h = 0.5, lty = 2)
       }
print(xyplot(avg ~ obs | var, data = gdata, 
       panel = panelf,
       scales = "free", xlab = "", 
       ylab = "Estimated Class Probability Glaucoma"))
@
\caption{Estimated class probabilities depending on two important
         variables. The $0.5$ cut-off for the estimated glaucoma probability
         is depicted as a horizontal line. Glaucomateous eyes are plotted as
         circles and normal eyes are triangles. \label{RP:glplot}}
\end{center}
\end{figure}

\index{Random forest}
The bagging procedure is a special case of a more general approach
called \stress{random forest} \citep{HSAUR:Breiman2001b}. The package
\Rpackage{randomForest} \citep{PKG:randomForest}
can be used to compute such ensembles via
<<RP-glaucoma-rf, echo = TRUE>>=
library("randomForest")
rf <- randomForest(Class ~ ., data = GlaucomaM)
@
and we obtain out-of-bag estimates for the prediction error via
<<RP-glaucoma-rf-oob, echo = TRUE>>=
table(predict(rf), GlaucomaM$Class)
@

\subsection{Trees Revisited}


For the body fat data, such a \stress{conditional inference tree} 
can be computed using
the \Rcmd{ctree} function
\index{Conditional tree}
<<RP-bodyfat-ctree, echo = TRUE>>=
bodyfat_ctree <- ctree(DEXfat ~ age + waistcirc + hipcirc +
    elbowbreadth + kneebreadth, data = bodyfat)
@
This tree doesn't require a pruning procedure because
an internal stop criterion based on formal statistical
tests prevents the procedure from overfitting the data. 
The tree structure is shown in Figure~\ref{RP-bodyfat-ctree-plot}. Although
the structure of this tree and the tree depicted in Figure~\ref{RP-bodyfat-pruneplot}
are rather different, the corresponding predictions don't vary too much.
\begin{figure}
\begin{center}
<<RP-bodyfat-ctree-plot, echo = TRUE, fig = TRUE, width = 10, height = 6>>=
plot(bodyfat_ctree, tp_args = list(id = FALSE))
@
\caption{Conditional inference tree with the distribution 
         of body fat content shown for each terminal leaf.
         \label{RP-bodyfat-ctree-plot}}
\end{center}
\end{figure}


Very much the same code is needed to grow a tree on the glaucoma data:
<<RP-glaucoma-ctree, echo = TRUE>>=
glaucoma_ctree <- ctree(Class ~ ., data = GlaucomaM)
@
and a graphical representation is depicted in Figure~\ref{RP-glaucoma-ctree-plot} showing
both the cutpoints and the $p$-values of the associated independence tests for each node. 
The first split is performed using a cutpoint defined with respect to the
volume of the optic nerve above some reference plane, but in the inferior part of
the eye only (\Robject{vari}).

\begin{figure}
\begin{center}
<<RP-glaucoma-ctree-plot, echo = TRUE, fig = TRUE, width = 10, height = 6>>=
plot(glaucoma_ctree, tp_args = list(id = FALSE))
@
\caption{Conditional inference tree with the distribution 
         of glaucomateous eyes shown for each terminal leaf.
         \label{RP-glaucoma-ctree-plot}}
\end{center}
\end{figure}

\subsection{Happiness in China}

\index{Chinese Health and Family Life Survey}
A conditional inference tree is a simple alternative to the proportional
odds model for the regression analysis of the happiness variable from the
Chinese Health and Family Life Survey.  In each node, a linear association
test introduced in Section~\ref{CI:Lanza} taking the ordering of the
happiness levels into account is applied for selecting variables and
split-points.  Before we fit the tree with the \Rcmd{ctree} function, we
recode the levels of the happiness variable to allow plotting of these
symbols with restricted page space:

\newpage

<<RP-CHFLS-ctree, echo = TRUE>>=
levels(CHFLS$R_happy)
levels(CHFLS$R_happy) <- LETTERS[1:4]
CHFLS_ctree <- ctree(R_happy ~ ., data = CHFLS)
@
The resulting tree is depicted in Figure~\ref{RP-CHFLS-ctree-plot} and very
nicely backs up the results obtained from the proportional odds model in
Chapter~\ref{GLM}.  The distribution of self-reported happiness is shifted
from very unhappy to very happy with increasing values of self-reported
health, i.e., women that reported excellent health (mind the $>$ sign in the right
label of the root split!) were at least somewhat happy with only a few exceptions.
Women with poor or not good health reported being not too happy much more often. There
seems to be further differentiation with respect to geography and also income but the
differences in the distributions depicted in the terminal leaves are negligible.

\begin{figure}
\begin{center}
<<RP-CHFLS-ctree-plot, echo = TRUE, fig = TRUE, width = 12, height = 7>>=
plot(CHFLS_ctree, ep_args = list(justmin = 10), 
     tp_args = list(id = FALSE))
@
\caption{Conditional inference tree with the distribution
         of self-reported happiness shown for each terminal leaf. The levels
         of happiness have been abbreviated (A: very unhappy, B: not too happy,
         C: somewhat happy; D: very happy). The \Rcmd{justmin} argument ensures that
         split descriptions longer than $10$ characters are displayed over two lines.
         \label{RP-CHFLS-ctree-plot}}
\end{center}
\end{figure}


\bibliographystyle{LaTeXBibTeX/refstyle}
\bibliography{LaTeXBibTeX/HSAUR}   
\end{document}

\input{HSAUR_title}

\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE}

<<setup, echo = FALSE, results = hide>>=
source("setup.R")
@

\frame{
\begin{center}
\Large{Part 10: Survival Analysis}
\end{center}

explains how to fit regression models to response variables which are only
incompletely available.

}

\section{Introduction}
\begin{frame}
  \frametitle{Introduction}

\cite{HSAUR:Granaetal2002} report results of a non-randomised clinical trial
investigating a novel radioimmunotherapy in malignant glioma patients. The
overall survival, i.e., the time from the beginning of the therapy to the
disease-caused death
of the patient, is compared for two groups of patients.

Since only some patients die by others survive, the time to death is not completely
observed. Only the time the patient is still alive is known. Such a
time measurement is called \stress{censored}.

The main interest is to investigate whether the 
patients treated with the novel radioimmunothery survive for a longer time.

\end{frame}

\begin{frame}
  \frametitle{Introduction}

The effects of hormonal treatment with Tamoxifen in women suffering from node-positive
breast cancer were investigated in a randomised clinical trial as reported
by \cite{HSAUR:Schumacher1994}. 
Complete data of seven prognostic factors
of $686$ women
are available for prognostic modelling.
Observed hypothetical prognostic factors are age,
menopausal status, tumor size, tumor grade, number of positive lymph nodes,
progesterone receptor, estrogen receptor and the
information of whether or not a hormonal therapy was applied. We are
interested in an assessment of the impact of the covariates on the survival
time of the patients. 

\end{frame}

\section{Survival Analysis}

\begin{frame}
  \frametitle{Survival Analysis}

In many medical studies, the main outcome variable is the
time to the occurrence of a particular event. Such observations are
generally referred to by the generic term \stress{survival data}.
Such data generally require special techniques
for analysis for two main reasons:
\begin{enumerate}
\item Survival data are generally not symmetrically distributed.
\item At the completion of the study, some patients may not have
      reached the endpoint of interest (death, relapse, etc.). Consequently,
      the exact survival times are not known. All that is known is
      that the survival times are greater than the amount of time the
      individual has been in the study. The survival times of these
      individuals are said to be \stress{censored} (precisely, they
      are right-censored).
\end{enumerate}

\end{frame}

\begin{frame}
  \frametitle{Survival and Hazard Function}

Of central importance in the analysis of survival time data
are two functions used to describe their distribution, namely
the \stress{survival} (or \stress{survivor}) \stress{function} and
the \stress{hazard function}.

The survivor function, $S(t)$, is defined as the probability that the
survival time, $T$,
is greater than or equal to some time $t$, i.e.,
\begin{eqnarray*}
S(t) = \P(T \ge t)
\end{eqnarray*}

\end{frame}

\begin{frame}
  \frametitle{Estimation}

When there are no censored observations in the sample of survival times,
a non-parametric survivor function can be estimated simply as
\begin{eqnarray*}
\hat{S}(t) = \frac{\text{number of individuals with survival times} \ge t}
{n}
\end{eqnarray*}
where $n$ is the total number of observations.

This simple method used to estimate the survivor function
when there are no censored observations cannot now be used for
survival times when censored observations are present. In the
presence of censoring, the survivor function is typically estimated
using the \stress{Kaplan-Meier} estimator \citep{HSAUR:KaplanMeier1958}.

\end{frame}

\begin{frame}
  \frametitle{Kaplan-Meier Estimator}

This involves first ordering the survival times from the smallest to the largest
such that $t_{(1)} \le t_{(2)} \le \dots \le t_{(n)}$, where $t_{(j)}$ is
the $j$th largest unique survival time. The Kaplan-Meier estimate
of the survival function is obtained as
\begin{eqnarray*}
\hat{S}(t) = \prod_{j: t_{(j)} \le t} \left( 1 - \frac{d_j}{r_j} \right)
\end{eqnarray*}
where $r_j$ is the number of individuals at risk just before $t_{(j)}$
(including those censored at $t_{(j)}$), and
$d_j$ is the number of individuals
who experience the event of interest (death, etc.) at time $t_{(j)}$.

\end{frame}

\begin{frame}
  \frametitle{Comparing Survival Functions}

A formal test of the equality of the survival curves for
the two groups can be made using the \stress{log-rank test}.
First, the expected number of deaths is computed for each unique
death time, or \stress{failure time}
in the data set, assuming that the chances of dying, given that
subjects are at risk, are the same for both groups. The total
number of expected deaths is then computed for each group by
adding the expected number of deaths for each failure time. The
test then compares the observed number of deaths in each group
with the expected number of deaths using a chi-squared test.

\end{frame}

\begin{frame}
  \frametitle{Hazard Functions}

The hazard function, $h(t)$, is defined as the
probability that an individual experiences the event in a small
time interval, $s$, given that the individual has survived
up to the beginning of the interval, when the size of the time
interval approaches zero; 
\begin{eqnarray*}
h(t) = \lim_{s \rightarrow 0} \frac{\P(t \le T \le t + s | T \ge t)}{s}
\end{eqnarray*}
where $T$ is the individual's survival time. 

For
example, the probability of dying at age $100$ is very small because
most people die before that age; in contrast, the probability
of a person dying at age $100$ who has reached that age is much
greater.


\end{frame}

\begin{frame}
  \frametitle{Hazard and Survival Function}

The hazard function and survivor function are related by
the formula
\begin{eqnarray*}
S(t) = \exp(-H(t))
\end{eqnarray*}
where $H(t)$ is known as the \stress{integrated hazard} or
\stress{cumulative hazard}, and is defined as
follows:
\begin{eqnarray*}
H(t) = \int_0^t h(u) du,
\end{eqnarray*}

\end{frame}

\begin{frame}
  \frametitle{Shapes of Hazard Functions}

In practice the hazard function may increase, decrease, remain
constant or have a more complex shape. The hazard function for
death in human beings, for example, has the `bath tub' shape:

\begin{center}
<<SA-hazard-plot, echo = FALSE, fig = TRUE, height = 4>>=
hazard <- function(x, alpha = 5, theta = 0.1, sigma = 100)
    (alpha*theta*(1 - exp(-(x/sigma)^alpha))^(theta - 1)*
        exp(-(x/sigma)^alpha)*(x/sigma)^(alpha-1))/(sigma*
        (1 - (1 - exp(-(x/sigma)^alpha))^theta))
x <- seq(from = 0.1, to = 100, by = 0.1)
h <- hazard(x, alpha = 5, theta = 0.1, sigma = 100)
plot(x, h, type = "l", xlab = "Time",
     ylab = "Hazard", ylim = c(0, max(h)))
@
\end{center}

\end{frame}

\begin{frame}
  \frametitle{Cox' Proportional Hazards Model}

Modelling the hazard
function directly as a linear function of explanatory variables
is not appropriate since $h(t)$ is restricted
to being positive, however
\begin{eqnarray*}
h(t) = h_0(t) \exp(\beta_1 x_1 + \dots + \beta_q x_q).
\end{eqnarray*}
is appropriate.
Written in this way we see that the model forces the hazard
ratio between two individuals to be constant over time since
\begin{eqnarray*}
\frac{h(t | \x_1)}{h(t | \x_2)} = \frac{\exp(\beta^\top
\x_1)}{\exp(\beta^\top \x_2)}
\end{eqnarray*}
where $\x_1$ and $\x_2$ are vectors of covariate values for two individuals.

\end{frame}

\begin{frame}
  \frametitle{Interpreting Cox' Model}

In the Cox model, the baseline hazard describes the common
shape of the survival time distribution for all individuals,
while the \stress{relative risk function}, $\exp(\beta^\top \x)$,
gives the level of each individual's hazard. The interpretation  %%'
of the parameter $\beta_j$ is that $\exp(\beta_j)$
gives the relative risk change associated with an increase
of one unit in covariate $x_j$,
all other explanatory variables remaining constant.
The parameters in a Cox model can be estimated by maximising
what is known as a \stress{partial likelihood}.

\end{frame}

\section{Analysis Using R}

\begin{frame}[fragile]
  \frametitle{Analysis Using R: Glioma Data}

\small
\begin{center}
<<SA-glioma-KM, echo = TRUE, eval = FALSE>>=
data("glioma", package = "coin")
library("survival")
layout(matrix(1:2, ncol = 2))
g3 <- subset(glioma, histology == "Grade3")
plot(survfit(Surv(time, event) ~ group, data = g3),
    main = "Grade III Glioma", lty = c(2, 1),
    ylab = "Probability",
    xlab = "Survival Time in Month",
    legend.bty = "n", legend.text = c("Control", "Treated")
)
g4 <- subset(glioma, histology == "GBM")
plot(survfit(Surv(time, event) ~ group, data = g4),
    main = "Grade IV Glioma", ylab = "Probability", 
    lty = c(2, 1), xlab = "Survival Time in Month", 
    xlim = c(0, max(glioma$time) * 1.05))
@
\end{center}
\normalsize

\end{frame}

\begin{frame}[fragile]
  \frametitle{Analysis Using R: Glioma Data}

\begin{center}
<<SA-glioma-KM, echo = FALSE, fig = TRUE, height = 4>>=
data("glioma", package = "coin")
library("survival")
layout(matrix(1:2, ncol = 2))
g3 <- subset(glioma, histology == "Grade3")
plot(survfit(Surv(time, event) ~ group, data = g3),
      main = "Grade III Glioma",
      lty = c(2, 1),
      ylab = "Probability",
      xlab = "Survival Time in Month",
      legend.bty = "n", legend.text = c("Control", "Treated")
)
g4 <- subset(glioma, histology == "GBM")
plot(survfit(Surv(time, event) ~ group, data = g4),
     main = "Grade IV Glioma", ylab = "Probability", lty = c(2, 1),
     xlab = "Survival Time in Month", xlim = c(0, max(glioma$time) * 1.05))
@
\end{center}

\end{frame}


\begin{frame}[fragile]
  \frametitle{Comparing Groups}

The figure leads to the impression that patients treated
with the novel radioimmunotherapy survive longer, regardless of the tumor
type. In order to assess if this informal finding is reliable, we may perform a
log-rank test via
<<SA-glioma-logrank, echo = TRUE>>=
survdiff(Surv(time, event) ~ group, data = g3)
@
which indicates that the survival times are indeed different in both groups.

\end{frame}

\begin{frame}[fragile]
  \frametitle{Permutation Testing}

However, the number of patients is rather limited and so it might be
dangerous to rely on asymptotic tests. 
Conditioning on the data and computing the distribution of the test
statistics without additional assumptions is one alternative:
<<SA-glioma-exact, echo = TRUE>>=
library("coin")
surv_test(Surv(time, event) ~ group, data = g3,
    distribution = exact())
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Breast Cancer Survival}

\begin{center}
<<SA-GBSG2-plot, echo = TRUE, eval = FALSE>>=
data("GBSG2", package = "TH.data")
plot(survfit(Surv(time, cens) ~ horTh, data = GBSG2), 
    lty = 1:2, mark.time = FALSE, ylab = "Probability", 
    xlab = "Survival Time in Days")
@
\end{center}

\end{frame}

\begin{frame}[fragile]
  \frametitle{Breast Cancer Survival}

\begin{center}
<<SA-GBSG2-plot, echo = FALSE, fig = TRUE>>=
data("GBSG2", package = "TH.data")
plot(survfit(Surv(time, cens) ~ horTh, data = GBSG2), lty = 1:2,
     mark.time = FALSE,
     ylab = "Probability", xlab = "Survival Time in Days")
legend(250, 0.2, legend = c("yes", "no"), lty = c(2, 1),
       title = "Hormonal Therapy", bty = "n")
@
\end{center}

\end{frame}


\begin{frame}[fragile]
  \frametitle{Fitting Cox' Model}

The response variable is coded as a \Rclass{Surv} object
and Cox' model can be fitted using:
<<SA-GBSG2-coxph, echo = TRUE, eval = FALSE>>=
GBSG2_coxph <- coxph(Surv(time, cens) ~ ., 
    data = GBSG2)
summary(GBSG2_coxph)
@
\end{frame}

\begin{frame}[fragile]
  \frametitle{Fitting Cox' Model}

The response variable is coded as a \Rclass{Surv} object
and Cox' model can be fitted using:
\small
<<SA-GBSG2-coxph, echo = FALSE>>=
GBSG2_coxph <- coxph(Surv(time, cens) ~ ., data = GBSG2)
summary(GBSG2_coxph)
@
\normalsize
\end{frame}

\begin{frame}[fragile]
  \frametitle{Confidence Intervals}

Since we are especially interested in the
relative risk for patients who underwent a hormonal therapy, we can
compute an estimate of the relative risk and a corresponding confidence
interval via
<<SA-GBSG2-coxph-ci, echo = TRUE>>=
ci <- confint(GBSG2_coxph)
exp(cbind(coef(GBSG2_coxph), ci))["horThyes",]
@
This result implies that patients treated with a hormonal therapy had a
lower risk and thus survived longer compared to women who were not treated
this way.

\end{frame}

\begin{frame}[fragile]
  \frametitle{Survival Trees}

A simple prognostic tree model with only
a few terminal nodes might be helpful for relating the risk to certain
subgroups of patients:
\small
<<SA-GBSG2-ctree, echo = TRUE>>=
library("partykit")
ctree(Surv(time, cens) ~ ., data = GBSG2)
@
\normalsize

\end{frame}

\begin{frame}[fragile]
  \frametitle{Visualizing Survival Trees}

\begin{center}
<<SA-GBSG2-ctree-plot, echo = TRUE, fig = TRUE, width = 8>>=
plot(ctree(Surv(time, cens) ~ ., data = GBSG2))
@
\end{center}

\end{frame}

\section{Summary}

\begin{frame}
  \frametitle{Summary}

The analysis of life-time data is complicated by the fact that the time to
some event is not observable for all observations due to censoring. Survival
times are analysed by some estimates of the survival function, for example by a
non-parametric Kaplan-Meier estimate or by semi-parametric proportional
hazards regression models.

\end{frame}

\begin{frame}
  \frametitle{Exercises}

\begin{itemize}
\item
Try to reproduce the analysis presented by
\cite{HSAUR:SauerbreiRoyston1999}, i.e., fit a multivariable fractional
polynomial to the \Robject{GBSG2} data (using package \Rpackage{mfp})!
\item
The \Robject{mastectomy} data 
are the survival times (in months) after
mastectomy of women with breast cancer. The cancers are classified as having
metastised or not based on a histochemical marker. 
Plot the survivor functions of each group, estimated using the Kaplan-Meier estimate,
on the same graph and comment
on the differences. Use a log-rank test to compare the survival experience
of each group more formally.
\end{itemize}

\end{frame}

\begin{frame}
  \frametitle{References}

\tiny
<<bibfiles, echo = FALSE, results = tex>>=   
src <- system.file(package = "HSAUR3")
style <- file.path(src, "LaTeXBibTeX", "refstyle")
bst <- file.path(src, "LaTeXBibTeX", "HSAUR")
cat(paste("\\bibliographystyle{", style, "}", sep = ""), "\n \n")
cat(paste("\\bibliography{", bst, "}", sep = ""), "\n \n")
@
\normalsize

\end{frame}

\end{document}

\input{HSAUR_title}

\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE}

<<setup, echo = FALSE, results = hide>>=
source("setup.R")
@

\frame{
\begin{center}
\Large{Part 7: Logistic Regression and \\ Generalised Linear Models}
\end{center}

explains how to fit regression models to binary response variables and to counts.

}

\section{Introduction}
\begin{frame}
  \frametitle{Introduction}

Ordinary linear regression models assume the response variable to be
(approximately) normal distributed. However, many experiments require
an assessment of the relationship between covariates and a binary response
variable, i.e., a variable measured at only two levels, or counts.

Generalised linear models provide a framework for the estimation of 
regression models with non-normal response variables. The regression
relationship between the covariates and the response is modelled by
a linear combination of the covariates.

\end{frame}

\begin{frame}
  \frametitle{plasma: Erythrocyte sedimentation rate (ESR)}

The erythrocyte sedimentation rate (ESR) is the rate at which
red blood cells (erythrocytes) settle out of suspension in blood
plasma, when measured under standard conditions. If the ESR increases
when the level of certain proteins in the blood plasma rise in
association with conditions such as rheumatic diseases, chronic
infections and malignant diseases, its determination might be
useful in screening blood samples taken from people suspected
of suffering from one of the conditions mentioned. The
absolute value of the ESR is not of great importance, rather it
is whether it is less than 20mm/hr since lower values indicate
a `healthy' individual. 

The question of interest is whether there is any association
between the probability of an ESR reading greater than 20mm/hr
and the levels of the two plasma proteins. If there is not then
the determination of ESR would not be useful for diagnostic purposes.

\end{frame}

\begin{frame}
  \frametitle{womensrols: Women's role in society}

In a survey carried out in 1974/1975 each respondent was
asked if he or she agreed or disagreed with the statement `Women
should take care of running their homes and leave running the
country up to men'. The questions
here are whether the responses of men and women differ and how
years of education affects the response.

\end{frame}

\begin{frame}
  \frametitle{polyps: Colonic polyps}

The data stem from an placebo-controlled trial of a non-steroidal anti-inflammatory
drug in the treatment of familial andenomatous polyposis (FAP).
The trial was halted after a planned interim analysis had suggested
compelling evidence in favour of the treatment. The data 
give the number of colonic polyps after a $12$-month
treatment period. The question of interest is whether the number of polyps
is related to treatment and/or age of patients.

\end{frame}

\section{Logistic Regression and Generalised Linear Models}

\begin{frame}
  \frametitle{Logistic Regression}

The ordinary multiple regression model is described
as $y \sim \N(\mu, \sigma^2)$ where $\mu = \beta_0 + \beta_1 x_1 + \dots + \beta_q x_q$.

This makes it clear that this model is suitable for
continuous response variables with, conditional on the values
of the explanatory variables, a normal distribution with constant
variance. 

So clearly the model would not be suitable for applying
to the erythrocyte sedimentation rate since the response variable is binary.

\end{frame}

\begin{frame}
  \frametitle{Logistic Regression}

For modelling the expected value of the response
directly as a linear function of explanatory variables, a suitable
transformation is modelled. In this case the most suitable transformation
is the \stress{logistic} or \stress{logit}
function of $\pi = P(y = 1)$ leading to the model
\begin{eqnarray*} 
\text{logit}(\pi) = \log\left(\frac{\pi}{1 - \pi}\right) = \beta_0 + \beta_1 x_1 + \dots + \beta_q x_q.
\end{eqnarray*}
The logit of a probability is simply the log of the odds of the response
taking the value one. 

\end{frame}

\begin{frame}
  \frametitle{Logistic Regression}

The logit function can take any real value, but the associated
probability always lies in the required $[0,1]$ interval. In a
logistic regression model, the parameter $\beta_j$
associated with explanatory variable $x_j$ is such
that $\exp(\beta_j)$ is the odds that the response variable
takes the value one when $x_j$ increases by one, conditional on the other
explanatory variables remaining constant. The parameters of the
logistic regression model (the vector of regression coefficients
$\beta$) are estimated by
maximum likelihood.

\end{frame}

\begin{frame}
  \frametitle{The Generalised Linear Model (GLM)}

Essentially GLMs consist of three main features;
\begin{enumerate}
\item An \stress{error distribution} giving the distribution of
      the response around its mean. 
\item A \stress{link function}, $g$, that shows how
      the linear function of the explanatory variables is related to
      the expected value of the response
      \begin{eqnarray*}
      g(\mu) = \beta_0 + \beta_1 x_1 + \dots + \beta_q x_q.
      \end{eqnarray*}
\item The \stress{variance function} that captures how the variance
      of the response variable depends on the mean. 
\end{enumerate}
Estimation of the parameters in a GLM is usually achieved
through a maximum likelihood approach.

\end{frame}

\section{Analysis Using R}

\begin{frame}[fragile]
  \frametitle{ESR and Plasma Proteins: Plot}

At first, we will look at conditional density plots of the response variable given
the two explanatory variables describing
how the conditional distribution of the categorical variable ESR changes
over the numerical variables fibrinogen and gamma globulin.
It appears that higher levels of each protein are
associated with ESR values above $20$ mm/hr.

\end{frame}

\begin{frame}[fragile]
  \frametitle{ESR and Plasma Proteins: Plot}

\begin{center}
<<GLM-plasma-plot, echo = TRUE, fig = TRUE, height = 4>>=
layout(matrix(1:2, ncol = 2))
cdplot(ESR ~ fibrinogen, data = plasma)
cdplot(ESR ~ globulin, data = plasma)
@
\end{center}

\end{frame}

\begin{frame}[fragile]
  \frametitle{ESR and Plasma Proteins: GLM}

We can now fit a logistic regression model to the data using
the \Rcmd{glm} function. We start with a model that includes
only a single explanatory variable, \Robject{fibrinogen}. The
code to fit the model is

<<GLM-plasma-fit1, echo = TRUE>>=
plasma_glm_1 <- glm(ESR ~ fibrinogen, data = plasma, 
    family = binomial())
@

\end{frame}


\begin{frame}[fragile]
  \frametitle{ESR and Plasma Proteins: Summary}

\small
<<GLM-plasma-summary-1, echo = TRUE>>=
summary(plasma_glm_1)
@
\normalsize

\end{frame}

\begin{frame}[fragile]
  \frametitle{ESR and Plasma Proteins: Estimation}

From the summary we
see that the regression
coefficient for fibrinogen is significant at the $5\%$ level.
An increase
of one unit in this variable increases the log-odds in favour
of an ESR value greater than $20$ by an estimated
$\Sexpr{round(coef(plasma_glm_1)["fibrinogen"], 2)}$ with 95\%
confidence interval
<<GLM-plasma-confint, echo = TRUE>>=
confint(plasma_glm_1)["fibrinogen",]
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{ESR and Plasma Proteins: GLM}          

Nevertheless it seems likely that increased values of fibrinogen
lead to a greater probability of an ESR value greater than $20$.
We can now fit a logistic regression model that includes both
explanatory variables using the code
<<GLM-plasma-fit2, echo = TRUE>>=
plasma_glm_2 <- glm(ESR ~ fibrinogen + globulin, 
    data = plasma, family = binomial())
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{ESR and Plasma Proteins: Summary}

\small
<<GLM-plasma-summary-2, echo = TRUE>>=
summary(plasma_glm_2)
@
\normalsize

\end{frame}

\begin{frame}[fragile]
  \frametitle{ESR and Plasma Proteins: Model Comparison}

<<GLM-plasma-anova-hide, echo = TRUE>>=
anova(plasma_glm_1, plasma_glm_2, test = "Chisq")
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{ESR and Plasma Proteins: Prediction}

The estimated conditional probability of a ESR value larger $20$ for all
observations can be computed by
<<GLM-plasma-predict, echo = TRUE>>=
prob <- predict(plasma_glm_1, type = "response")
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{ESR and Plasma Proteins: Plot}

%%\setkeys{Gin}{width = 0.5\textwidth}
\tiny
\begin{center}
<<GLM-plasma-bubble, echo = TRUE, fig = TRUE>>=
plot(globulin ~ fibrinogen, data = plasma, xlim=c(2,6), ylim=c(25,50), pch = ".")
symbols(plasma$fibrinogen, plasma$globulin, circles = prob, add = TRUE)
@
\end{center}
\normalsize

\end{frame}

\begin{frame}[fragile]
  \frametitle{Women's Role in Society: GLM} %'

We first fit a model that includes the two explanatory variables
using the code
<<GLM-womensrole-fit1, echo = TRUE>>=
fm <- cbind(agree,disagree) ~ gender + education
womensrole_glm_1 <- glm(fm,
    data = womensrole, family = binomial())
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Women's Role in Society: Summary} %'           

\small
<<GLM-womensrole-summary-1, echo = TRUE>>=
summary(womensrole_glm_1)
@
\normalsize

\end{frame}

\begin{frame}[fragile]
  \frametitle{Women's Role in Society: Plot}

We now are going to construct a plot comparing the observed proportions of
agreeing with those fitted by our fitted model. Because we will reuse this
plot for another fitted object later on, we define a function which plots
years of education against some fitted probabilities, e.g.,
\tiny
<<GLM-womensrole-probfit, echo = TRUE>>=
role.fitted1 <- predict(womensrole_glm_1, type = "response")
myplot <- function(role.fitted)  {
    f <- womensrole$gender == "Female"
    plot(womensrole$education, role.fitted, type = "n",
         ylab = "Probability of agreeing",
         xlab = "Education", ylim = c(0,1))
    lines(womensrole$education[!f], role.fitted[!f], lty = 1)
    lines(womensrole$education[f], role.fitted[f], lty = 2)
    lgtxt <- c("Fitted (Males)", "Fitted (Females)")
    legend("topright", lgtxt, lty = 1:2, bty = "n")
    y <-  womensrole$agree / (womensrole$agree +   
                              womensrole$disagree)
    size <- womensrole$agree + womensrole$disagree
    size <- size - min(size)
    size <- (size / max(size)) * 3 + 1
    text(womensrole$education, y, ifelse(f, "\\VE", "\\MA"),
         family = "HersheySerif", cex = size)
} 
@
\normalsize

\end{frame}

\begin{frame}[fragile]
  \frametitle{Women's Role in Society: Plot}

\begin{center}
<<GLM-role-fitted1, echo = TRUE, fig = TRUE>>=
myplot(role.fitted1)
@
\end{center}

\end{frame}

\begin{frame}[fragile]
  \frametitle{Women's Role in Society: Interactions} %'

An interaction term for gender and education can be included into the logistic
regression model via
<<GLM-womensrole-fit2, echo = TRUE>>=
fm <- cbind(agree,disagree) ~ gender * education
womensrole_glm_2 <- glm(fm, 
    data = womensrole, family = binomial())
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Women's Role in Society: Interactions} %'

\small
<<GLM-womensrole-summary-2, echo = TRUE>>=
summary(womensrole_glm_2)
@
\normalsize

\end{frame}

\begin{frame}[fragile]
  \frametitle{Women's Role in Society: Plot}

\begin{center}
<<GLM-role-fitted2, echo = TRUE, fig = TRUE>>=
myplot(predict(womensrole_glm_2, type = "response"))
@
\end{center}

\end{frame}

\begin{frame}[fragile]
  \frametitle{Colonic Polyps: Poisson GLM}

We will apply a GLM with a log link function, ensuring that fitted
values are positive, and a Poisson error distribution, i.e.,
\begin{eqnarray*}
\P(y) = \frac{e^{-\lambda}\lambda^y}{y!}.
\end{eqnarray*}
This type of GLM is often known as \stress{Poisson regression}.

\end{frame}

\begin{frame}[fragile]
  \frametitle{Colonic Polyps: Poisson GLM}

<<GLM-polyps-fit1, echo = TRUE>>=
polyps_glm_1 <- glm(number ~ treat + age, 
    data = polyps, family = poisson())
@
(The default link function when the Poisson family is requested
is the log function.)

\end{frame}

\begin{frame}[fragile]
  \frametitle{Colonic Polyps: Summary}

\small
<<GLM-polyps-summary-1, echo = TRUE>>=
summary(polyps_glm_1)
@
\normalsize


\end{frame}

\begin{frame}[fragile]
  \frametitle{Colonic Polyps: Overdispersion}

We see that the regression
coefficients for both age and treatment are highly significant.
But there is a problem with the model, but before we can deal
with it we need a short digression to describe in more detail
the third component
of GLMs mentioned in the previous section, namely their variance
functions, $V(\mu)$.

Both the Poisson and binomial distributions have variance
functions that are completely determined by the mean. 

The phenomenon of greater variability than expected under the model is
observed is called \stress{overdispersion}.

\end{frame}

\begin{frame}[fragile]
  \frametitle{Colonic Polyps: Quasi-Likelihood}

We can deal with overdispersion by using a procedure known
as \stress{quasi-likelihood},
which allows the estimation of
model parameters without fully knowing the error distribution
of the response variable. 

<<GLM-polyp-quasi, echo = TRUE>>=
polyps_glm_2 <- glm(number ~ treat + age, 
    data = polyps, family = quasipoisson())
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Colonic Polyps: Summary}

\small
<<GLM-polyp-quasi-summary, echo = TRUE>>=
summary(polyps_glm_2)
@
\normalsize

\end{frame}

\section{Summary}

\begin{frame}
  \frametitle{Summary}

Generalised linear models provide a very powerful and flexible framework
for the application of regression models to a variety of non-normal
response variables, for example, logistic regression to binary responses
and Poisson regression to count data.

\end{frame}


\section{Exercises}

\begin{frame}
  \frametitle{Exercises}

\begin{itemize}

\item
Construct a perspective plot of the fitted values from
a logistic regression model fitted to the \Robject{plasma} data
in which both fibrinogen and gamma globulin are included as explanatory
variables.
\item
\cite{HSAUR:Collett2003} argues that two outliers need to be removed from
the \Robject{plasma} data. Try to identify those two unusual observations
by means of a scatterplot.
\item 
The \Robject{bladdercancer} data arise from $31$ male patients
who have been treated for superficial bladder cancer
\citep[see][]{HSAUR:Seeber1998}, and give
the number of recurrent tumours during a particular time after
the removal of the primary tumour, along with the size of the
original tumour (whether smaller or larger than $3$ cm). Use Poisson
regression to estimate the effect of size of tumour on the number
of recurrent tumours.
\end{itemize}

\end{frame}

\begin{frame}
  \frametitle{Exercises}
 
\begin{itemize}
\item
The \Robject{leuk} data show the survival times
from diagnosis of patients suffering from leukemia and the values
of two explanatory variables, the white blood cell count (\Robject{wbc})
and the presence or absence of a morphological characteristic
of the white blood cells (\Robject{ag})
\citep[the data are available in package
\Rpackage{MASS},][]{HSAUR:VenablesRipley2002}.
Define a binary outcome variable
according to whether or not patients lived for at least 24 weeks
after diagnosis and then fit a logistic regression model to the
data. It may be advisable to transform the very large white blood
counts to avoid regression coefficients very close to 0 (and
odds ratios very close to 1). And a model that contains only
the two explanatory variables may not be adequate for these data.
Construct some graphics useful in the interpretation of the final
model you fit.
\end{itemize}

\end{frame}

\begin{frame}
  \frametitle{References}
\tiny
<<bibfiles, echo = FALSE, results = tex>>=   
src <- system.file(package = "HSAUR3")
style <- file.path(src, "LaTeXBibTeX", "refstyle")
bst <- file.path(src, "LaTeXBibTeX", "HSAUR")
cat(paste("\\bibliographystyle{", style, "}", sep = ""), "\n \n")
cat(paste("\\bibliography{", bst, "}", sep = ""), "\n \n")
@

\end{frame}

\end{document}

\input{HSAUR_title}

\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE}

<<setup, echo = FALSE, results = hide>>=
source("setup.R")
@


\frame{
\begin{center}
\Large{Part 3: Simple Inference}
\end{center}

focuses on classical statistical test procedures for the
Guessing Lengths, Wave Energy, Water Hardness, Piston Rings,
                           and Rearrests of Juveniles examples.

}


\section{Introduction}

<<SI-setup, echo = FALSE, results = hide>>=
library("vcd")
@

\begin{frame}
  \frametitle{roomwidth: Estimating Room Widths}

Shortly after metric units of length were officially introduced
in Australia in the 1970s, each of a group of 44 students was asked to guess,
to the nearest metre, the width of the lecture hall in which
they were sitting. Another group of 69 students in the same room
was asked to guess the width in feet, to the nearest foot. 
The main question is whether estimation in feet and in metres gives different
results.

\end{frame}

\begin{frame}
  \frametitle{waves: Bending Stress}

In a design study for a device to generate electricity from
wave power at sea, experiments were carried out on scale models
in a wave tank to establish how the choice of mooring method
for the system affected the bending stress produced in part of
the device. The wave tank could simulate a wide range of sea
states and the model system was subjected to the same sample
of sea states with each of two mooring methods, one of which
was considerably cheaper than the other. 
The question of interest is whether bending stress differs
for the two mooring methods.

\end{frame}

\begin{frame}
  \frametitle{water: Mortality and Water Hardness}

The data were collected in an investigation
of environmental causes of disease. They show the annual mortality
per 100,000 for males, averaged over the years 1958--1964, and
the calcium concentration (in parts per million) in the drinking
water for 61 large towns in England and Wales. The higher the
calcium concentration, the harder the water. Towns at least
as far north as Derby are identified in the table. Here there
are several questions that might be of interest including: are
mortality and water hardness related, and do either or both variables
differ between northern and southern towns?

\end{frame}

\begin{frame}
  \frametitle{pistonrings: Piston-ring Failures}

The two-way contingency table shows the number of
piston-ring failures in each of three legs of four steam-driven compressors
located in the same building.
The compressors have identical design and are
oriented in the same way. The question of interest is whether the two
categorical variables (compressor and leg) are independent.

\end{frame}

\begin{frame}
  \frametitle{rearrests: Rearrests of Juveniles}

The data arise from a
sample of juveniles convicted of felony in Florida in 1987.
Matched
pairs were formed using criteria such as age and the number of
previous offences. For each pair, one subject was handled in
the juvenile court and the other was transferred to the adult
court. Whether or not the juvenile was rearrested by the end
of 1988 was then noted. Here the question of interest is whether
the true proportions rearrested were identical for the adult
and juvenile court assignments?

\end{frame}

\section{Statistical Tests}

\begin{frame}
  \frametitle{Statistical Tests}

Inference is the process of 
\begin{itemize}
\item drawing conclusions about a population
\item on the basis of measurements or observations 
\item made on a random (!) sample of individuals from the population.
\end{itemize}
In the following, we shall illustrate the application of the 
most common statistical tests to the examples shown before.

\end{frame}

\subsection{Comparing Normal Populations: Student's $t$-Tests} %'

\begin{frame}
  \frametitle{Comparing Normal Populations}

The independent samples $t$-test is used to test the null hypothesis
that the means of two populations are the same: $H_0: \mu_1 = \mu_2$.

The variable to be compared is assumed to have a normal
distribution with the same standard deviation in both populations. 

Test statistic:
\begin{eqnarray*}
t = \frac{\bar{y}_1 - \bar{y}_2}{s \sqrt{1 / n_1 + 1 / n_2}} \sim t_{n_1 + n_2 - 2}
\end{eqnarray*}

\end{frame}

\begin{frame}
  \frametitle{Unequal Variances}

If the two populations are suspected of having different variances (boxes in boxplots
differ significantly), a
modified form of the $t$ statistic, known as the Welch test, may be used:
\begin{eqnarray*}
t = \frac{\bar{y}_1 - \bar{y}_2}{\sqrt{s_1^2 / n_1 + s_2^2 / n_2}} \sim t_\nu.
\end{eqnarray*}

\end{frame}

\begin{frame}
  \frametitle{Paired Observations}

A paired $t$-test is used to compare the means of two populations
when samples from the populations are available, in which each
individual in one sample is paired with an individual in the
other sample or each individual in the sample is observed twice.

If the values of the variable of interest, $y$,
for the members of the $i$th pair in groups $1$ and $2$ are denoted
as $y_{1i}$ and $y_{2i}$, then the differences $d_i = y_{1i} - y_{2i}$ are
assumed to have a normal distribution with mean $\mu$ and the null
hypothesis here is that the mean difference is zero, i.e., $H_0: \mu = 0$.

The paired $t$-statistic is
\begin{eqnarray*}
t = \frac{\bar{d}}{s / \sqrt{n}} \sim t_{n-1}.
\end{eqnarray*}

\end{frame}

\subsection{Non-parametric Analogues of Independent Samples and Paired
            $t$-Tests}

\begin{frame}
  \frametitle{Wilcoxon-Mann-Whitney Test}

For two independent groups, the Wilcoxon Mann-Whitney
rank sum test applies the $t$-statistic to the joint ranks of all
measurements in both groups instead of the original measurements. The null
hypothesis to be tested is that the two populations
being compared have identical distributions. 

\end{frame}

\begin{frame}
  \frametitle{Wilcoxon-Signed-Rank Test}

The Wilcoxon
signed-rank statistic is based on the ranks of the absolute differences $|d_i|$. The
statistic is defined as the sum of the ranks associated with positive
difference $d_i > 0$. 

It should be noted that this test is only valid when the differences $d_i$ are
symmetrically distributed.

\end{frame}

\subsection{Testing Independence in Contingency Tables}

\begin{frame}
  \frametitle{Contingency Tables}

When a sample of $n$ observations in two nominal (categorical) variables are
available, they can be arranged into a cross-classification
\input{tables/SI_rtimesc}

\end{frame}

\begin{frame}
  \frametitle{$\chi^2$-Test}

Under the null hypothesis of independence of the row variable $x$ and the
column variable $y$, estimated expected
values $E_{jk}$ for cell $(j, k)$ can be computed from the corresponding
margin totals $E_{jk} = n_{j\cdot} n_{\cdot k} / n$. The test statistic
is 
\begin{eqnarray*}
X^2 = \sum_{j = 1}^r \sum_{k = 1}^c \frac{(n_{jk} - E_{jk})^2}{E_{jk}} \sim \chi^2_{(r-1)(c-1)}
\end{eqnarray*}

\end{frame}

\subsection{McNemar's Test} %'

\begin{frame}
  \frametitle{McNemar's Test}

Often categorical
data arise from \stress{paired} observations, for example,
cases matched with controls on variables such as sex, age and
so on, or observations made on the same subjects on two occasions:
\input{tables/SI_mcnemar}
Under the hypothesis that the two populations do not differ in their
probability of having the characteristic present, the test statistic
\begin{eqnarray*}
X^2 = \frac{ (c - b)^2}{c + b} \sim \chi^2_1.
\end{eqnarray*}

\end{frame}

\section{Analysis Using R}
\subsection{Estimating the Width of a Room}

\begin{frame}[fragile]
  \frametitle{Estimating the Width of a Room}

The first step should be to convert the metre estimates into feet:
<<SI-roomwidth-convert, echo = TRUE>>=
convert <- ifelse(roomwidth$unit == "feet", 1, 3.28)
@
Now, we get the usual summary statistics by
<<SI-roomwidth-summary, echo = TRUE>>=
tapply(roomwidth$width * convert, 
    roomwidth$unit, summary)
@

\end{frame}

\begin{frame}[fragile] 
  \frametitle{Boxplots}
\begin{center}
<<SI-roomwidth-boxplot, echo = FALSE, fig = TRUE, height = 7>>=
layout(matrix(c(1,2,1,3), nrow = 2, ncol = 2, byrow = FALSE))
boxplot(I(width * convert) ~ unit, data = roomwidth,
        ylab = "Estimated width (feet)",
        var.width = TRUE, names = c("Estimates in feet",
        "Estimates in metres (converted to feet)"))
feet <- roomwidth$unit == "feet"
qqnorm(roomwidth$width[feet], ylab = "Estimated width (feet)")
qqline(roomwidth$width[feet])
qqnorm(roomwidth$width[!feet], ylab = "Estimated width (metres)")
qqline(roomwidth$width[!feet])
@
\end{center}

\end{frame}

\begin{frame}[fragile] 
  \frametitle{Test for Differences}

The two-sample test problem is specified by a \Rclass{formula} and the $t$-test reads
<<SI-roomwidth-tt-T-hide, echo = TRUE>>=
t.test(I(width * convert) ~ unit, data = roomwidth, 
    var.equal = TRUE)
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Test for Differences}

The Welch-test can be computed via
<<SI-roomwidth-tt-T, echo = TRUE>>=
t.test(I(width * convert) ~ unit, data = roomwidth, 
    var.equal = FALSE)
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Test for Differences}

The Wilcoxon Mann-Whitney test as one alternative test procedure:
<<SI-roomwidth-wt, echo = TRUE>>=
wilcox.test(I(width * convert) ~ unit, 
    data = roomwidth, conf.int = TRUE)
@

\end{frame}

\subsection{Wave Energy Device Mooring}

\begin{frame}[fragile]
  \frametitle{Wave Energy Device Mooring}

The \Robject{waves} data set requires the use of a matched pairs
$t$-test.
This test assumes that the differences between the matched
observations have a normal distribution so we can begin by checking
this assumption by constructing a boxplot and a normal probability
plot

\end{frame}

\begin{frame}

\begin{center}
<<SI-wavese-boxplot, echo = FALSE, fig = TRUE, height = 4>>=
mooringdiff <- waves$method1 - waves$method2
layout(matrix(1:2, ncol = 2))
boxplot(mooringdiff, ylab = "Differences (Newton metres)", main = "Boxplot")
abline(h = 0, lty = 2)
qqnorm(mooringdiff, ylab = "Differences (Newton metres)")
qqline(mooringdiff)
@
\end{center}

\end{frame}

\begin{frame}[fragile]
  \frametitle{Test for Zero Mean}

The paired-$t$-test is performed via
<<SI-waves-tt, echo = TRUE>>=
t.test(mooringdiff)
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Test for Zero Median}

<<SI-waves-wt, echo = TRUE>>=
wilcox.test(mooringdiff)
@

\end{frame}

\subsection{Mortality and Water Hardness}

\begin{frame}[fragile]
  \frametitle{Mortality and Water Hardness}

We will construct a scatterplot
of the data enhanced somewhat by the addition of information
about the marginal distributions of water hardness (calcium concentration)
and mortality, and by adding the estimated linear regression
fit for mortality on hardness.

The scatterplot shows that as hardness increases mortality decreases, and the
histogram for the water hardness shows it has a rather skewed distribution.

\end{frame}

\begin{frame}

\begin{center}
<<SI-water-plot, echo = FALSE, fig = TRUE>>=
nf <- layout(matrix(c(2, 0, 1, 3), 2, 2, byrow = TRUE),
             c(2, 1), c(1, 2), TRUE)
psymb <- as.numeric(water$location)
plot(mortality ~ hardness, data = water, pch = psymb)
abline(lm(mortality ~ hardness, data = water))
legend("topright", legend = levels(water$location), pch = c(1,2), bty = "n")
hist(water$hardness)
boxplot(water$mortality)
@
\end{center}

\end{frame}

\begin{frame}[fragile]
  \frametitle{Testing Correlation}   

We can both calculate the Pearson's correlation coefficient %'
between the two variables and test whether it differs significantly
for zero by using
<<SI-water-cor, echo = TRUE>>=
cor.test(~ mortality + hardness, data = water)
@

\end{frame}

\subsection{Piston-ring Failures}

\begin{frame}[fragile]
  \frametitle{Piston-ring Failures}   

The first step in the analysis of the \Robject{pistonrings} data is
to apply the chi-squared test for independence.
This we can do
in \R{} using
<<SI-pistonrings-chisq, echo = TRUE>>=
chisq.test(pistonrings)
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Inspection Deviations}   

Rather than looking
at the simple differences of observed and expected values for
each cell it
is preferable to consider a \stress{standardised residual}:
<<SI-pistonrings-resid, echo = TRUE>>=
chisq.test(pistonrings)$residuals
@

\end{frame}

\begin{frame}

\begin{center}
<<SI-assoc-plot, echo = FALSE, fig = TRUE>>=
library("vcd")
assoc(pistonrings)
@
\end{center}

\end{frame}

\subsection{Rearrests of Juveniles}

\begin{frame}[fragile]
  \frametitle{Rearrests of Juveniles}   

In \Robject{rearrests} the counts in the four cells refer
to the matched pairs of subjects; for example, in $\Sexpr{rearrests[1,1]}$
pairs both
members of the pair were rearrested. Here, we use McNemar's test:
<<SI-arrests-mcnemar, echo = TRUE>>=
mcnemar.test(rearrests, correct = FALSE)
binom.test(rearrests[2], 
    n = sum(rearrests[c(2,3)]))$p.value
@

\end{frame}

\section*{Exercises}

\begin{frame}[fragile]
  \frametitle{Exercises} 

\begin{itemize}
\item
After the students had made the estimates of the width of
the lecture hall the room width was accurately
measured and found to be $13.1$ metres ($43.0$ feet). Use this additional
information to determine which of the two types of estimates
was more precise.

\item 
For the mortality and water hardness data calculate the correlation
between the two variables in each region, north and south.

\item 
For the data in table \Robject{rearrests} estimate the difference between
the probability of being rearrested after being tried in an adult
court and in a juvenile court, and find a $95\%$ confidence interval
for the population difference.
\end{itemize}

\end{frame}

\end{document}

\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE} 

<<setup, echo = FALSE, results = hide>>=
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })
@

\pagestyle{headings}

\input{HSAUR_title}

\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE}

<<setup, echo = FALSE, results = hide>>=
source("setup.R")
@


\frame{
\begin{center}
\Large{Part 5: Analysis of Variance}
\end{center}

focuses on the analysis of one-way layouts for the 
Weight Gain, Foster
Feeding in Rats, Water Hardness and Male Egyptian Skulls examples.

}

\section{Introduction}

\begin{frame}
  \frametitle{weightgain: Rats Weights}

The data 
arise from an experiment to study the
gain in weight of rats fed on four different diets, distinguished
by amount of protein (low and high) and by source of protein
(beef and cereal). Ten rats are randomised to each of the four
treatments and the weight gain in grams recorded. The question
of interest is how diet affects weight gain.

\end{frame}

\begin{frame}
  \frametitle{foster: Feeding Rats}

The data from a foster feeding experiment
with rat mothers and litters of four different genotypes: A,
B, I and J.

The measurement is the litter weight (in grams) after
a trial feeding period. Here the investigator's interest lies  %'
in uncovering the effect of genotype of mother and litter on
litter weight.

\end{frame}

\begin{frame}
  \frametitle{skulls: Egyptian Skulls}

The data 
give four measurements made on
Egyptian skulls from five epochs. The data has been collected with a view
to deciding if there are any differences between the skulls from
the five epochs. The measurements are:
\begin{description}
\item[\Robject{mb}]: maximum breadths of the skull,
\item[\Robject{bh}]: basibregmatic heights of the skull,
\item[\Robject{bl}]: basialiveolar length of the skull, and
\item[\Robject{nh}]: nasal heights of the skull.
\end{description}
Non-constant measurements of the skulls over time would indicate
interbreeding with immigrant populations.

\end{frame}

\section{Analysis of Variance}

\begin{frame}
  \frametitle{Analysis of Variance}

For each of the data sets described previously,
the question of interest involves assessing whether certain populations
differ in mean value for
a single variable or 
for a set of four variables (\Robject{skulls} data). 

In the first two
cases we shall use \stress{analysis of variance} (ANOVA) and in the
last \stress{multivariate analysis of variance} (MANOVA) method for the
analysis of this data.

\end{frame}

\begin{frame}
  \frametitle{Factorial Designs}

Both the \Robject{weightgain} and \Robject{foster} data sets 
are examples of \stress{factorial designs},
with the factors in the first data set being amount of protein
with two levels, and source of protein also with two levels.

In the second the factors are the genotype of the mother and
the genotype of the litter, both with four levels. The analysis
of each data set can be based on the same model but
the two data sets differ in that the first is \stress{balanced},
i.e., there are the same number of observations in each cell,
whereas the second is \stress{unbalanced} having different
numbers of observations in the 16 cells of the design. 

\end{frame}

\begin{frame}
  \frametitle{ANOVA Model}

The model used in the analysis of each is
\begin{eqnarray*}
y_{ijk} = \mu + \gamma_i + \beta_j + (\gamma\beta)_{ij} + \varepsilon_{ijk}
\end{eqnarray*}
where $y_{ijk}$ represents the $k$th measurement
made in cell $(i,j)$ of the factorial design,
$\mu$ is the overall mean, $\gamma_i$ is the main effect of the first factor,
$\beta_j$ is the main effect of the second factor,
$(\gamma\beta)_{ij}$ is the interaction effect of the two factors and
\index{Interaction}
$\varepsilon_{ijk}$ is the residual or error term assumed to have a
normal distribution with mean zero and variance $\sigma^2$.

\end{frame}

\begin{frame}[fragile]
  \frametitle{Formula Specification in R}

In \R{}, the model is specified by a model \Rclass{formula}.
The \stress{two-way layout with interactions}
specified above reads
<<ANOVA-formula, echo = FALSE>>=
y ~ a + b + a:b
@
where the variable \Robject{a} is the first and the variable \Robject{b} is
the second \Rclass{factor}. The interaction term $(\gamma\beta)_{ij}$
is denoted by \Robject{a:b}. 

\end{frame}

\begin{frame}
  \frametitle{Estimation and Inference}

The model as specified above is overparameterised, i.e., there are
infinitively many solutions to the corresponding estimation equations, and so the
parameters have to be constrained in some way, commonly by requiring
them to sum to zero.

The model given above leads to a partition of the variation in the
observations into parts due to main effects and interaction plus
an error term that enables a series of $F$-tests.
The assumptions made in deriving the $F$-tests are:
\begin{itemize}
\item The observations are independent of each other,
\item The observations in each cell arise from a population having
      a normal distribution, and
\item The observations in each cell are from populations
      having the same variance.
\end{itemize}

\end{frame}

\begin{frame}
  \frametitle{MANOVA}

The linear model used in this case is
\begin{eqnarray*}
y_{ijh} = \mu_h + \gamma_{jh} + \varepsilon_{ijh}
\end{eqnarray*}
where $\mu_h$ is the overall mean for variable $h$, $\gamma_{jh}$
is the effect of the $j$th level of the single factor
on the $h$th variable, and $\varepsilon_{ijh}$
is a random error term. The vector $\varepsilon^\top_{ij} = (\varepsilon_{ij1},
\varepsilon_{ij2}, \dots, \varepsilon_{ijq})$ where $q$
is the number of response variables (four
in the skull example) is assumed to have a multivariate normal
distribution with null mean vector and covariance matrix, $\Sigma$,
assumed to be the same in each level of the grouping factor.
The hypothesis of interest is that the population mean vectors
for the different levels of the grouping factor are the same.

\end{frame}

\begin{frame}
  \frametitle{MANOVA Inference}


A number of different test statistics are available which
may give different results when applied to the same data set,
although the final conclusion is often the same. The principal
test statistics for the multivariate analysis of variance are
\begin{itemize}
\item Hotelling-Lawley trace,
\item Wilks' ratio of determinants
\item Roy's greatest root,
\item Pillai trace.
\end{itemize}

\end{frame}

\section{Analysis Using R}

\subsection{Weight Gain in Rats}

\begin{frame}[fragile]
  \frametitle{Weight Gain in Rats}

We should try to summarise the main features of the data first.
The following \R{} code produces the required summary statistics
<<ANOVA-weightgain-mean-var, echo = TRUE>>=
tapply(weightgain$weightgain, 
    list(weightgain$source, weightgain$type), mean)
tapply(weightgain$weightgain, 
    list(weightgain$source, weightgain$type), sd)
@

\end{frame}

\begin{frame}

\begin{center}
<<ANOVA-weightgain-plot, echo = FALSE, fig = TRUE>>=
plot.design(weightgain)
@
\end{center}

\end{frame}

\begin{frame}[fragile]
  \frametitle{ANOVA}

To apply analysis of variance to the data we can use the \Rcmd{aov}
function in \R{} and then the \Rcmd{summary} method to give
us the analysis of variance table:
<<ANOVA-weightgain-aov, echo = TRUE>>=
summary(wg_aov <- aov(weightgain ~ source * type, 
    data = weightgain))
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{ANOVA}  

The analysis of variance table shows that
the main effect of type is highly significant.
The main effect of source is not
significant. But interpretation of both these main effects is
complicated by the type $\times$ source interaction which approaches
significance at the $5$\% level. 

To try to understand this interaction
effect it will be useful to plot the mean weight gain for low-
and high-protein diets for each level of source of protein, beef
and cereal. 

\end{frame}

\begin{frame}

\begin{center}
<<ANOVA-weightgain-iplot-nice, echo = FALSE, fig = TRUE>>=
interaction.plot(weightgain$type, weightgain$source, weightgain$weightgain,
legend = FALSE)
legend(1.5, 95, legend = levels(weightgain$source), title = "weightgain$source",
       lty = 1:2, bty = "n")
@
\end{center}

\end{frame}

\begin{frame}[fragile]
  \frametitle{ANOVA Results}  

The estimates of the intercept and the main and interaction effects can be
extracted from the model fit by
<<ANOVA-weightgain-coef, echo = TRUE>>=
coef(wg_aov)
@
Note that the model was fitted with the restrictions $\gamma_1 = 0$
(corresponding to \Rlevel{Beef}) and
$\beta_1 = 0$ (corresponding to \Rlevel{High}) because treatment contrasts
were used as default as can be seen from
<<ANOVA-weightgain-contrasts, echo = TRUE>>=
options("contrasts")
@
Thus, the coefficient for \Robject{source} of $\Sexpr{coef(wg_aov)[2]}$
can be interpreted as an estimate of the difference $\gamma_2 - \gamma_1$.

\end{frame}

\subsection{Foster Feeding of Rats of Different Genotype}

\begin{frame}
  \frametitle{Foster Feeding}

\begin{center}
<<ANOVA-foster-plot, echo = FALSE, fig = TRUE>>=
plot.design(foster)
@
\end{center}

\end{frame}

\begin{frame}[fragile]
  \frametitle{Unbalanced ANOVA}  

We can now apply analysis of variance
using the \Rcmd{aov} function, but there is a complication caused
by the unbalanced nature of the data. Here where there are unequal
numbers of observations in the $16$ cells of the two-way layout,
it is no longer possible to partition the variation in the data
into \stress{non-overlapping} or \stress{orthogonal} sums
of squares representing main effects and interactions. In an
unbalanced two-way layout with factors $A$ and $B$ there is a proportion
of the variance of the response variable that can be attributed
to either $A$ or $B$. 

\end{frame}

\begin{frame}[fragile]
  \frametitle{ANOVA Results}  

We can derive the two analyses of variance tables for the
foster feeding example by applying the \R{} code
<<ANOVA-foster-aov-one, echo = TRUE>>=
summary(aov(weight ~ litgen * motgen, data = foster))
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{ANOVA Results}  

and
<<ANOVA-foster-aov-two, echo = TRUE>>=
summary(aov(weight ~ motgen * litgen, data = foster))
@

\end{frame}

\begin{frame}
  \frametitle{Multiple Comparisons}

We can investigate the effect of genotype B on litter weight
in more detail by the use of \stress{multiple comparison procedures}.

Such procedures allow
a comparison of all pairs of levels of a factor whilst maintaining
the nominal significance level at its selected value and producing
adjusted confidence intervals for mean differences. One such
procedure is called \stress{Tukey honest significant differences}
\index{Tukey honest significant differences}
suggested
by \cite{HSAUR:Tukey1953}, see \cite{HSAUR:HochbergTamhane1987} also. 

\end{frame}

\begin{frame}[fragile]
  \frametitle{All-Pair Differences}

Here,
we are interested in simultaneous confidence intervals for the weight
differences between all four genotypes of the mother:
<<ANOVA-foster-aov, echo = TRUE>>=
TukeyHSD(aov(weight ~ litgen * motgen, 
    data = foster), "motgen")
@

\end{frame}

\begin{frame}

\begin{center}
<<ANOVA-foster-tukeyHSDplot, echo = FALSE, fig = TRUE>>=
foster_aov <- aov(weight ~ litgen * motgen, data = foster)
plot(TukeyHSD(foster_aov, "motgen"))
@
\end{center}

\end{frame}

\subsection{Water Hardness and Mortality}

\begin{frame}
  \frametitle{Water Hardness and Mortality}

The water hardness and mortality data for $61$ large towns in England and
Wales was analysed in Part~2 and here
we will extend the analysis by an assessment of the differences of both
hardness and mortality in the North or South. The hypothesis that the
two-dimensional mean-vector of water hardness and mortality is the same for
cities in the North and the South can be tested by \stress{Hotelling-Lawley}
test in a multivariate analysis of variance framework. 

The \R{} function
\Rcmd{manova} can be used to fit such a model and the corresponding
\Rcmd{summary} method performs the test specified by the \Rcmd{test}
argument.

\end{frame}

\begin{frame}[fragile]

<<ANOVA-water-manova, echo = TRUE>>=
summary(manova(cbind(hardness, mortality) ~ location, 
    data = water), test = "Hotelling-Lawley")
@

\end{frame}

\begin{frame}[fragile]

Looking at the sample means
<<ANOVA-water-means, echo = TRUE>>=
tapply(water$hardness, water$location, mean)
tapply(water$mortality, water$location, mean)
@
we see large differences in the two regions both in water hardness and
mortality, where low mortality is associated with hard water in the South
and high mortality with soft water in the North.

\end{frame}

\subsection{Male Egyptian Skulls}

\begin{frame}[fragile]
  \frametitle{Male Egyptian Skulls}

We can begin by looking at a table of mean values for the
four measurements within each of the five epochs:
<<ANOVA-skulls-data, echo = TRUE>>=
means <- aggregate(skulls[,c("mb", "bh", "bl", "nh")], 
    list(epoch = skulls$epoch), mean)
means
@

\end{frame}

\begin{frame}

\begin{center}
<<ANOVA-skulls-fig, echo = FALSE, fig = TRUE>>=
pairs(means[,-1],
    panel = function(x, y) {
        text(x, y, abbreviate(levels(skulls$epoch)))
    })
@
\end{center}

\end{frame}

\begin{frame}[fragile]

There appear to be quite large differences between the epoch
means, at least on some of the four measurements. We can now
test for a difference more formally by using MANOVA with the
following \R{} code to apply each of the four possible test criteria
mentioned earlier;
<<ANOVA-skulls-manova, echo = TRUE>>=
skulls_manova <- manova(cbind(mb, bh, bl, nh) ~ epoch, 
    data = skulls)
sapply(c("Pillai", "Wilks", "Hotelling-Lawley", "Roy"), 
    function(test)
        summary(skulls_manova, test = test)$stats[1,6])
@

\end{frame}

\section*{Exercises}

\begin{frame}
\frametitle{Exercises}

\begin{itemize}

\item 
Examine the residuals ($\text{observed value} - \text{fitted value}$) from fitting
a main effects only model to the \Robject{weightgain} data.
What conclusions do you draw?

\item 
The data \Robject{students} arise from a large study of
risk taking.
Students were randomly assigned to three different
treatments labelled AA, C and NC. Students were administered two
parallel forms of a test called `low' and `high'. Carry out
a test of the equality of the bivariate means of each treatment
population.

\end{itemize}

\end{frame}

\begin{frame}
\frametitle{References}
\tiny
<<bibfiles, echo = FALSE, results = tex>>=   
src <- system.file(package = "HSAUR3")
style <- file.path(src, "LaTeXBibTeX", "refstyle")
bst <- file.path(src, "LaTeXBibTeX", "HSAUR")
cat(paste("\\bibliographystyle{", style, "}", sep = ""), "\n \n")
cat(paste("\\bibliography{", bst, "}", sep = ""), "\n \n")
@

\end{frame}

\end{document}

\input{HSAUR_title}

\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE}

<<setup, echo = FALSE, results = hide>>=
source("setup.R")
@

\frame{
\begin{center}
\Large{Part 1: An Introduction to R}
\end{center}

teaches some \R{} philosophy, explains how to install \R{} 
and how to make the first steps in \R{}.

}


\section{What Is R?} %%\R{}?}

\frame{
    \frametitle{What Is R?}

The \R{} system for statistical computing is an environment for
data analysis and graphics.

The root of \R{} is the \S{} language, developed by John
Chambers and colleagues
at Bell Laboratories starting in the 1960s. 

The \S{} language was designed
and developed as a programming language for data analysis tasks but in fact
it is a full-featured programming language in its current implementations.

The development of the \R{} system for statistical computing is heavily
influenced by the open source idea: The base distribution of \R{}
\index{Base distribution}
and a large number of
user contributed extensions are available under the
terms of the Free Software Foundation's GNU General %%'
Public License in source code form.
\index{GNU General Public License}

}

\frame{

The base distribution of \R{} is maintained by a small group of statisticians,
the \R{} Development Core Team. 

A huge amount of additional functionality is implemented in add-on packages
\index{Add-on packages}
authored and maintained by a large group of
volunteers. 

The main source of information about the \R{} system is the world
wide web with the official home page of the \R{} project being
\curl{http://www.R-project.org} 

}
\section{Installing R} %%\R{}}

\index{Base system|(}

\frame{
    \frametitle{Installing the Base System}

The \R{} system for statistical computing consists of two major parts: the
base system and a collection of user contributed add-on packages. 

A package is a collection of functions, examples and documentation. 

Both the base system and packages are distributed via the Comprehensive \R{} Archive
Network (CRAN) accessible under \curl{http://CRAN.R-project.org} 
as precompiled binary distribution and in source form.

}

\subsection{The Base System and the First Steps \label{AItR:Base}}

\frame{
    \frametitle{First Steps in R}

\begin{columns}
  \begin{column}{3cm}
    \includegraphics[width = 2.5cm]{graphics/Rlogo}
  \end{column}
  \begin{column}{7cm}
Depending on the operating system, \R{} can be started either by typing
`\texttt{R}' on the shell (Unix systems) or by clicking on the %'
\R{} symbol (as shown left) created by the installer (Windows).
\end{column}
\end{columns}

}

\begin{frame}[fragile]
    \frametitle{R as Pocket Calculator}

<<AItR-firstex, echo = TRUE>>=
x <- sqrt(25) + 2
@

The assignment operator
\Roperator{<-} binds the value of its right hand side to a variable name on the
left hand side. The value of the object \Robject{x} can be inspected
simply by typing
<<AItR-firstex-print, echo = TRUE>>=
x
@
which, implicitly, calls the \Rcmd{print} method:
<<AItR-firstex-print, echo = TRUE>>=
print(x)
@

\end{frame}

\subsection{Packages}

\begin{frame}[fragile]
  \frametitle{Important Packages}

The base distribution already comes with some high-priority add-on packages, namely
\begin{center}
\texttt{
<<AItR-recommended, echo = FALSE, results=hide>>=
colwidth <- 4
ip <- installed.packages(priority = "high")
pkgs <- unique(ip[,"Package"])
pkgs <- paste("\\Rpackage{", pkgs, "}", sep = "")
nrows <- ceiling(length(pkgs) / colwidth)
cat(paste(c("\\begin{tabular}{", paste(rep("l", colwidth), collapse=""), "}"), collapse = ""),
    "\n", file = "tables/rec.tex", append = FALSE)
for (i in 1:nrows) {
    cat(paste(pkgs[(1:colwidth) + (i-1)*colwidth], collapse = " & "),
        file = "tables/rec.tex", append = TRUE)
    cat("\\\\ \n", file = "tables/rec.tex", append = TRUE)
}
cat("\\end{tabular}\n", file = "tables/rec.tex", append = TRUE)
rm(ip, nrows)
@
\input{tables/rec}
}
\end{center}
The packages listed here
%% #Z
%% are maintained by members of the \R{} core development team and
implement standard statistical functionality, for example linear models,
classical tests, a huge collection of high-level plotting functions or tools
for survival analysis.

\end{frame}

<<AItR-CRAN, echo = FALSE, results = hide>>=
cp <- available.packages(contriburl = "http://CRAN.r-project.org/src/contrib")
ncp <- sum(!rownames(cp) %in% pkgs)
rm(cp, pkgs)
@

\begin{frame}[fragile]
  \frametitle{User-Contributed Packages}

Packages not included in the base distribution can be installed directly
from the \R{} prompt. Currently, 
$\Sexpr{ncp}$ user contributed packages
covering almost all fields of statistical methodology are available.

<<AItR-rm, echo = FALSE, results = hide>>=
rm(ncp, colwidth, i)
@

A package is installed
by supplying the name of the package to the function \Rcmd{install.packages}.
For example the \Rpackage{sandwich} package can be downloaded and installed via
<<AItR-install-packages, echo = TRUE, eval = FALSE>>=
install.packages("sandwich")
@
The package functionality is available after \stress{attaching} the package
by
<<AItR-library, echo = TRUE, eval = FALSE>>=
library("sandwich")
@
A comprehensive list of available packages can be obtained from
\curl{http://CRAN.R-project.org/}

\end{frame}


\section{Help and Documentation \label{AItR:HDN}}
\index{Help system|(}

\begin{frame}[fragile]
  \frametitle{Help and Documentation}

Three different forms of documentation for the \R{} system for
statistical computing may be distinguished: 
\begin{itemize}
\item online help that comes with the
      base distribution or packages,
\item electronic manuals and 
\item publications work in the form of books etc.
\end{itemize}

The help system is a collection of manual pages describing each
user-visible function and data set that comes with \R{}.

\end{frame}

\begin{frame}[fragile]
  \frametitle{Getting Help in R}

A manual page is shown in a pager or web browser when the name
of the function we would like to get help for is supplied to the \Rcmd{help}
function
<<AItR-help, echo = TRUE, eval = FALSE>>=
help("mean")
@
or, for short,
\begin{Verbatim}
R> ?mean
\end{Verbatim}

The function \Rcmd{help.search} is helpful for searching within
manual pages. An overview on documented topics in an add-on package is given,
for example for the \Rpackage{sandwich} package, by
<<AItR-help-lib, echo = TRUE, eval = FALSE>>=
help(package = "sandwich")
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Package Vignettes}

Often a package comes along with an additional document describing the
package functionality and giving examples. Such a document is called a
\Rclass{vignette} and is viewed in a PDF viewer via
<<AItR-help-lib, echo = TRUE, eval = FALSE>>=
vignette("sandwich", package = "sandwich")
@
All R code contained in a vignette is available from
<<AItR-help-lib, echo = TRUE, eval = FALSE>>=
edit(vignette("sandwich"))
@

\end{frame}

\begin{frame}
  \frametitle{Written Documentation}

For the beginner, at least the first and the second document
of the following four manuals are mandatory:
\begin{description}
\item[An Introduction to R:] A more formal introduction to data analysis
                             with \R{} than this chapter.
\item[R Data Import/Export:] A very useful description of how to read and
                             write various external data formats.
\item[R Installation and Administration:] Hints for installing \R{} on
                                          special platforms.
\item[Writing R Extensions:] The authoritative source on how to write \R{}
                             programs and packages.
\end{description}

\end{frame}

\begin{frame}
  \frametitle{More Documentation on R}

Both printed and online publications are available, the most important ones
are \booktitle{Modern Applied Statistics with \S{}}
\booktitle{Introductory Statistics with \R{}},
\booktitle{\R{} Graphics}
and the \R{} Newsletter, freely available from
\curl{http://CRAN.R-project.org/doc/Rnews/}

In case the electronically available documentation and the answers to
frequently asked questions (FAQ), available from
\curl{http://CRAN.R-project.org/faqs.html}
have been consulted but a problem or question remains unsolved, the
\texttt{r-help} email list is the right place to get answers to well-thought-out
questions. Read the posting guide before starting to ask!

\end{frame}

\section{Data Objects in R} %%\R{}}

\begin{frame}[fragile]
  \frametitle{Data Objects: Forbes 2000 List}

\index{Forbes 2000 ranking|(}
The data handling and manipulation techniques will
be illustrated by means of a data set of $2000$ world leading companies, the
Forbes 2000 list for the year 2004 collected by \booktitle{Forbes Magazine}.

In a first step, we make the data available for computations within
\R. The \Rcmd{data} function searches for data objects of the specified
name (\Robject{"Forbes2000")}
in the package specified via the \Rarg{package} argument and
attaches the data object to the global environment:
\index{Forbes2000 data@\Robject{Forbes2000} data}
<<AItR-Forbes2000, echo = TRUE>>=
data("Forbes2000", package = "HSAUR3")
ls()
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Data Objects: Printing}

<<AItR-Forbes2000-print, echo = TRUE, eval = FALSE>>=
print(Forbes2000)
@
<<AItR-Forbes2000-print, echo = FALSE, eval = TRUE>>=
print(Forbes2000[1:3,])
cat("...\n")
@
will not be particularly helpful.

\end{frame}

\begin{frame}[fragile]
  \frametitle{Inspecting Data Objects}

Better look at a description of their structure:
<<AItR-Forbes2000-str, echo = TRUE, eval = FALSE>>=
str(Forbes2000)
@
<<AItR-Forbes2000-str, echo = FALSE, eval = TRUE>>=
str(Forbes2000, vec.len = 2)
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Data Objects: Forbes 2000}

For each observation, the following eight variables are available:
\begin{description}
\item[\Robject{rank}]: the ranking of the company,
\item[\Robject{name}]: the name of the company,
\item[\Robject{country}]: where the company is situated,
\item[\Robject{category}]: products the company produces,
\item[\Robject{sales}]: the amount of sales of the company,
                        US dollars,
\item[\Robject{profits}]: the profit of the company,
\item[\Robject{assets}]: the assets of the company,
\item[\Robject{marketvalue}]: the market value of the company.
\end{description}

\end{frame}

\begin{frame}[fragile]
  \frametitle{Data Objects: Forbes 2000}


A similar but more detailed description is available from the help page for the
\Robject{Forbes2000} object:
<<AItR-Forbes2000-help, echo = TRUE, eval = FALSE>>=
help("Forbes2000")
@
or
\begin{Verbatim}
R> ?Forbes2000
\end{Verbatim}
All information provided by \Rcmd{str} can be obtained by specialised
functions as well and we will now have a closer look at the most important
of these.

\end{frame}

\begin{frame}[fragile]
  \frametitle{Everything is an Object!}

The \R{} language is an object-oriented programming language,
\index{Object-oriented programming language}
so every object
is an instance of a class:
<<AItR-Forbes2000-df, echo = TRUE>>=
class(Forbes2000)
@

The dimensions of a \Rclass{data.frame} can be
extracted using the \Rcmd{dim} function
<<AItR-Forbes2000-dim, echo = TRUE>>=
dim(Forbes2000)
@
or via
<<AItR-Forbes2000-nrow-ncol, echo = TRUE>>=
nrow(Forbes2000)
ncol(Forbes2000)
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Data Frames: Assessing Variables}

The variable names are accessible from
<<AItR-Forbes2000-names, echo = TRUE>>=
names(Forbes2000)
@
The values of single variables can be extracted from the
\Robject{Forbes2000} object by their names
<<AItR-Forbes2000-rank, echo = TRUE>>=
class(Forbes2000[,"rank"])
@
Brackets \Robject{[]} always indicate a subset
\index{Subset} of a larger object. 

\end{frame}

\begin{frame}[fragile]
  \frametitle{Vectors}

The rankings for all $\Sexpr{nrow(Forbes2000)}$ companies are represented in a \Rclass{vector}
structure the length of which is given by
<<AItR-Forbes2000-length, echo = TRUE>>=
length(Forbes2000[,"rank"])
@
A \Rclass{vector} is the elementary structure for data handling in \R{} and is
a set of simple elements, all being objects of the same class. 
<<AItR-Forbes2000-one-to-three, echo = TRUE>>=
1:3
c(1,2,3)
seq(from = 1, to = 3, by = 1)
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Nominal Variables: Factors}

Nominal measurements are represented by \Rclass{factor} variables in \R,
such as the category of the company's business segment %%'
<<AItR-Forbes2000-category, echo = TRUE>>=
class(Forbes2000[,"category"])
@
Objects of class \Rclass{factor} and \Rclass{character} basically differ in
the way their values are stored internally.
In our case, there are
<<AItR-Forbes2000-nlevels, echo = TRUE>>=
nlevels(Forbes2000[,"category"])
@
different categories:
<<AItR-Forbes2000-levels, echo = TRUE, eval = FALSE>>=
levels(Forbes2000[,"category"])
@
<<AItR-Forbes2000-levels, echo = FALSE>>=
levels(Forbes2000[,"category"])[1:3]
cat("...\n")
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Summarizing Factors}

As a simple summary statistic,
the frequencies of the levels of such a \Rclass{factor} variable can be
found from
<<AItR-Forbes2000-table, echo = TRUE, eval = FALSE>>=
table(Forbes2000[,"category"])
@
<<AItR-Forbes2000-table, echo = FALSE>>=
table(Forbes2000[,"category"])[1:3]
cat("...\n")
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Numeric Variables}

The sales, assets, profits and market value variables are of type
\Robject{numeric}
<<AItR-Forbes2000-sales, echo = TRUE>>=
class(Forbes2000[,"sales"])
@
and simple summary statistics such as the mean, median and range can be
found from
<<AItR-Forbes2000-numsum, echo = TRUE>>=
median(Forbes2000[,"sales"])
mean(Forbes2000[,"sales"])
range(Forbes2000[,"sales"])
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Summary Statistics}

The \Rcmd{summary} method can be applied to
a numeric vector to give a set of useful summary statistics namely
the minimum, maximum, mean, median and the $25\%$ and $75\%$ quartiles;
for example
<<AItR-Forbes2000-summary, echo = TRUE>>=
summary(Forbes2000[,"sales"])
@

\end{frame}

\section{Data Import and Export}
\index{Data import and export|(}

\begin{frame}[fragile]
  \frametitle{Data Import}

The most frequent data formats the data analyst is confronted with are 
\begin{itemize}
\item comma separated files,
\item \EXCEL{} spreadsheets,
\item files in \SPSS{} format and
\item a variety of \SQL{} data base engines.
\end{itemize}
Querying data bases is a non-trivial task and requires additional knowledge
about querying languages and we therefore refer to the \booktitle{\R{} Data
Import/Export} manual.

\end{frame}

<<AItR-Forbes2000-files, echo = FALSE>>=
pkgpath <- system.file(package = "HSAUR3")
mywd <- getwd()
filep <- file.path(pkgpath, "rawdata")
setwd(filep)
@

\begin{frame}[fragile]
  \frametitle{Comma-separated Files}

When the variables are separated by commas and each row begins with a name
(a text format typically created by \EXCEL{}), we can read in the data as
follows using the \Rcmd{read.table} function
<<AItR-Forbes2000-read.table, echo = TRUE>>=
csvForbes2000 <- read.table("Forbes2000.csv",
    header = TRUE, sep = ",", row.names = 1)
@
The function \Rcmd{read.table} by default guesses the class of each variable from the
specified file. 

Files in \SPSS{} format are read in a way similar to reading comma separated files, using the
function \Rcmd{read.spss} from package \Rpackage{foreign}.

\end{frame}

\begin{frame}[fragile]
  \frametitle{Data Export}

A comma separated file
readable by \EXCEL{} can be constructed from a \Rclass{data.frame} object via
<<AItR-Forbes2000-write.table, echo = TRUE>>=
write.table(Forbes2000, file = "Forbes2000.csv", 
    sep = ",", col.names = NA)
@
The function \Rcmd{write.csv} is one alternative.

Alternatively, when data should be saved for later processing in \R{} only,
\R{} objects of arbitrary kind can be stored into an external binary file via
<<AItR-Forbes2000-save, echo = TRUE>>=
save(Forbes2000, file = "Forbes2000.rda")
@
<<AItR-Forbes2000-RODBC, echo = FALSE>>= 
setwd(mywd)
@

\end{frame}


\section{Basic Data Manipulation \label{AItR:BDM}}

\begin{frame}[fragile]
  \frametitle{More on Data Frames}

\index{Data manipulation|(}

Internally, a \Rclass{data.frame} is a \Rclass{list} of vectors
of a common length $n$, the number of rows of the table. Each of those vectors
represents the measurements of one variable and we can access such a variable by its name
<<AItR-Forbes2000-vector-companies, echo = TRUE>>=
companies <- Forbes2000[,"name"]
@
A subset of the elements of the
vector \Robject{companies} can be extracted using the \Rcmd{[]} subset
operator:
<<AItR-Forbes2000-vector-indexing, echo = TRUE>>=
companies[1:3]
@
\end{frame}

\begin{frame}[fragile]
  \frametitle{Subset Indexing}

In contrast to indexing with positive integers, negative indexing returns
all elements which are \stress{not} part of the index vector given in brackets. For
example, all companies except those with numbers four to two-thousand, i.e.,
the top three companies, are again
<<AItR-Forbes2000-vector-negative-indexing, echo = TRUE>>=
companies[-(4:2000)]
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Data Frame Indexing}

Because \Rclass{data.frame}s have a concept of rows and
columns, we need to separate the subsets corresponding to rows and columns
by a comma. The statement
<<AItR-Forbes2000-top-three, echo = TRUE>>=
Forbes2000[1:3, c("name", "sales", "profits", 
    "assets")]
@
extracts four variables for the three largest companies. A
 single variable can be extracted from a \Rclass{data.frame} by
<<AItR-Forbes2000-list-extract, echo = TRUE>>=
companies <- Forbes2000$name
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Data Frame Ordering}

The three top selling companies are to be computed.
First, we need to compute the ordering of the companies' sales %%'
<<AItR-Forbes2000-sales, echo = TRUE>>=
order_sales <- order(Forbes2000$sales)
@
The three companies with the lowest sales are
<<AItR-Forbes2000-sales-small, echo = TRUE>>=
companies[order_sales[1:3]]
@
and the three top sellers are 
<<AItR-Forbes2000-order, echo = TRUE>>=
Forbes2000[order_sales[c(2000, 1999, 1998)], "name"]
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Data Frame Subsetting}

Another way of selecting vector elements is the use of a logical vector
being \Robject{TRUE} when the corresponding element is to be selected and
\Robject{FALSE} otherwise. 

The companies with assets of more than $1000$ billion US dollars are
<<AItR-Forbes2000-logical, echo = TRUE>>=
Forbes2000[Forbes2000$assets > 1000,
    c("name", "sales", "profits")]
table(Forbes2000$assets > 1000)
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Missing Values}

In \R, missing values are treated by a special symbol, \Robject{NA}, indicating
\index{NA symbol@\Robject{NA} symbol}
that this measurement is not available.
\index{Missing values}
The observations with profit information missing can be obtained
via
<<AItR-Forbes2000-NA, echo = TRUE>>=
na_profits <- is.na(Forbes2000$profits)
table(na_profits)
Forbes2000[na_profits, c("name", "profits")]
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Removing Missing Values}

We want to remove all observations with at least one missing value from a
\Rclass{data.frame} object. The function \Rcmd{complete.cases} takes a
\Rclass{data.frame} and returns a logical vector being \Robject{TRUE} when
the corresponding observation does not contain any missing value:
<<AItR-Forbes2000-complete-cases, echo = TRUE>>=
table(complete.cases(Forbes2000))
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Using subset}

Subsetting \Rclass{data.frame}s driven by logical expressions may induce a
lot of typing which can be avoided. The \Rcmd{subset} function takes a
\Rclass{data.frame} as first argument and a logical expression as second
argument:
<<AItR-Forbes2000-UK, echo = TRUE>>=
UKcomp <- subset(Forbes2000, 
    country == "United Kingdom")
dim(UKcomp)
@

\end{frame}

\section{Simple Summary Statistics}

\begin{frame}[fragile]
  \frametitle{str and summary}

Applying the \Rcmd{summary} method to the \Robject{Forbes2000}
<<AItR-Forbes2000-summary-output, echo = TRUE, eval = FALSE>>=
summary(Forbes2000)
@
<<AItR-Forbes2000-summary-output, echo = FALSE>>=
summary(Forbes2000[,1:3])
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{apply and Friends}

The members of the \Rcmd{apply} family help to solve recurring tasks for each
element of a \Rclass{data.frame}, \Rclass{matrix}, \Rclass{list} or for each
level of a factor. 

We compare the profits in each of the 
$\Sexpr{nlevels(Forbes2000$category)}$ categories and first
compute the median profit for each category from
<<AItR-Forbes2000-tapply-category, echo = TRUE>>=
mprofits <- tapply(Forbes2000$profits, 
    Forbes2000$category, median, na.rm = TRUE)
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Sorting}

The three categories with highest median profit are computed from the vector
of sorted median profits
<<AItR-Forbes2000-mprofits, echo = TRUE>>=
rev(sort(mprofits))[1:3]
@
where \Rcmd{rev} rearranges the vector of median profits
\Rcmd{sort}ed from smallest to largest.

\end{frame}

\subsection{Simple Graphics}

\begin{frame}[fragile]
  \frametitle{Simple Graphics: Histograms}

The degree of skewness of a distribution can be investigated by constructing
histograms using the
\Rcmd{hist} function:
<<AItR-Forbes2000-marketvalue, echo = TRUE, eval = FALSE>>=
layout(matrix(1:2, nrow = 2))
hist(Forbes2000$marketvalue)
hist(log(Forbes2000$marketvalue))
@
\end{frame}

\begin{frame}[fragile]
\begin{center}
<<AItR-Forbes2000-marketvalue, echo = FALSE, fig = TRUE>>=
layout(matrix(1:2, nrow = 2))
hist(Forbes2000$marketvalue)
hist(log(Forbes2000$marketvalue))
@
\end{center}

\end{frame}

\begin{frame}[fragile]
  \frametitle{Simple Graphics: Scatterplots}

In \R, regression relationships are specified by
so-called \stress{model formulae} which may look
like
<<AItR-Forbes2000-formula, echo = TRUE>>=
fm <- marketvalue ~ sales
class(fm)
@
with the dependent variable on the left hand side and the independent
variable on the right hand side. The tilde separates left and right hand
side.

\end{frame}

\begin{frame}[fragile]
  \frametitle{Simple Graphics: Scatterplots}

\begin{center}
<<AItR-Forbes2000-marketvalue-sales, echo = TRUE, fig = TRUE>>=
plot(log(marketvalue) ~ log(sales), 
     data = Forbes2000, pch = ".")
@
\end{center}

\end{frame}

\begin{frame}

%%% R CMD build will receive an error from texi2dvi because of pdf version
%%% 1.4 used here -- exclude this piece of code

\begin{center}
<<AItR-Forbes2000-marketvalue-sales-shading, echo = FALSE, fig = FALSE, results = hide>>=
pdf("figures/marketvalue-sales.pdf", version = "1.4")
plot(log(marketvalue) ~ log(sales), data = Forbes2000,
     col = rgb(0,0,0,0.1), pch = 16)
dev.off()
@
\includegraphics{figures/marketvalue-sales}
\end{center}

\end{frame}

\begin{frame}[fragile]
  \frametitle{Simple Graphics: Boxplots}

<<AItR-Forbes2000-country-plot, echo = TRUE, eval = FALSE>>=
boxplot(log(marketvalue) ~ country, data =
    subset(Forbes2000, country %in% c("United Kingdom", 
           "Germany", "India", "Turkey")),
    ylab = "log(marketvalue)", varwidth = TRUE)
@

\end{frame}

\begin{frame}

\begin{center}
<<AItR-Forbes2000-country-plot, echo = FALSE, fig = TRUE>>=
tmp <- subset(Forbes2000, country %in% c("United Kingdom", "Germany",
                                          "India", "Turkey"))
tmp$country <- tmp$country[,drop = TRUE]
boxplot(log(marketvalue) ~ country, data = tmp,
        ylab = "log(marketvalue)", varwidth = TRUE)
@
\end{center}

\end{frame}

\section{Organising an Analysis}

\begin{frame}[fragile]
  \frametitle{Organising an Analysis}

<<AItR-analysis1, echo = FALSE, results = hide>>=
file.create("analysis.R")
@

ALWAYS maintain your R code for an analysis as a separate text
file collecting all steps necessary to perform a certain data analysis task!

Such an \R{} transcript file can be read by
<<AItR-analysis2, echo = TRUE, eval = FALSE>>=
source("analysis.R", echo = TRUE)
@
When all steps of a data analysis, i.e.,
data preprocessing, transformations, simple summary statistics and plots,
model building and inference as well as reporting, are collected in such
an \R{} transcript file, the analysis can be reproduced at any time! 

<<AItR-analysis3, echo = FALSE, results = hide>>=
file.remove("analysis.R")
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Exercises}

\begin{itemize}
\item Calculate the median profit for the companies in the United States and the
median profit for the companies in the UK, France and Germany.

\item Find all German companies with negative profit.

\item 
Which business category are most of the companies situated at the Bermuda
island working in?

\item
For the $50$ companies in the Forbes data set with the highest profits,
plot sales against assets (or some suitable transformation of each
variable), labelling each point with the appropriate country name which may
need to be abbreviated (using \Rcmd{abbreviate}) to avoid making the
plot look too `messy'. %%'

\item
Find the average value of sales for the companies in each country in
the Forbes data set, and find the number of countries in each country with
profits above $5$ billion US dollars.
\end{itemize}

\end{frame}

\end{document}

\input{HSAUR_title}

\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE}

<<setup, echo = FALSE, results = hide>>=
source("setup.R")
@

\frame{
\begin{center}
\Large{Part 6: Multiple Linear Regression}
\end{center}

focuses on the analysis of cloud seeding experiments.

}

\begin{frame}
  \frametitle{clouds: Cloud Seeding}

The data were collected in the summer
of 1975 from an experiment to investigate the use of massive
amounts of silver iodide ($100$ to $1000$ grams per cloud) in cloud
seeding to increase rainfall.

In the experiment 24 days were judged suitable for seeding
on the basis that a measured suitability criterion. 

On suitable days, a decision was taken at random as to whether
to seed or not. 

\end{frame}

\begin{frame}
  \frametitle{Could Seeding Variables} 

\begin{description}
\item[\Robject{seeding}]: a factor indicating whether seeding action occured (yes or no),
\item[\Robject{time}]: number of days after the first day of the experiment,
\item[\Robject{cloudcover}]: the percentage cloud cover in the experimental area,
                  measured using radar,
\item[\Robject{prewetness}]: the total rainfall in the target area one hour before seeding,
\item[\Robject{echomotion}]: a factor showing whether the radar echo was moving or
                             stationary,
\item[\Robject{rainfall}]: the amount of rain,
\item[\Robject{sne}]: suitability criterion.
\end{description}
The objective in analysing these data is to see how rainfall
is related to the explanatory variables and, in particular, to
determine the effectiveness of seeding.

\end{frame}

\section{Multiple Linear Regression}

\begin{frame}
  \frametitle{Multiple Linear Regression}

Assume $y_i$ represents the value of the response variable on the $i$th
individual, and that $x_{i1}, x_{i2}, \dots, x_{iq}$ represents the
individual's values on $q$ explanatory variables, with $i = 1, \dots, n$. 

The multiple linear regression model is given by
\begin{eqnarray*}
y_i = \beta_0 + \beta_1 x_{i1} + \dots + \beta_q x_{iq} + \varepsilon_i.
\end{eqnarray*}

The residual or error terms $\varepsilon_i$, $i = 1, \dots, n$, are assumed
to be independent random variables having a normal distribution with mean
zero and constant variance $\sigma^2$. 

\end{frame}

\begin{frame}
  \frametitle{Multiple Linear Regression}

Consequently, the distribution of the
random response variable, $y$, is also normal with expected value given by
the linear combination of the explanatory variables
\begin{eqnarray*}
\E(y | x_1, \dots, x_q) = \beta_0 + \beta_1 x_{1} + \dots + \beta_q x_{q}
\end{eqnarray*}
and with variance $\sigma^2$.

The parameters of the model $\beta_k$, $k = 1, \dots, q$, are known as
regression coefficients with $\beta_0$ corresponding to the overall mean.

The multiple linear regression model can be written most conveniently for
all $n$ individuals by using matrices and vectors as 
\begin{eqnarray*}
\y = \X \beta + \varepsilon
\end{eqnarray*}

\end{frame}

\begin{frame}
  \frametitle{Model Matrix}

The \stress{design} or \stress{model matrix} $\X$
\index{Design matrix}
\index{Model matrix}
consists of the $q$ continuously measured
explanatory variables and a column of ones corresponding to
the \stress{intercept} term
\input{tables/MLR-Xtab}

\end{frame}

\begin{frame}
  \frametitle{Nominal Variables}

In case one or more of the explanatory variables are nominal or ordinal
variables, they are represented by a zero-one dummy coding.

Assume that
$x_1$ is a factor at $k$ levels, the submatrix of $\X$
corresponding to $x_1$ is a
$n \times k$ matrix of zeros and ones, where the $j$th element in the $i$th
row is one when $x_{i1}$ is at the $j$th level.

\end{frame}

\begin{frame}[fragile]
  \frametitle{Estimation}

The least squares estimator of the parameter vector $\beta$
can be calculated by $\hat{\beta} = (\X^\top\X)^{-1} \X^\top
\y$ with 
\begin{eqnarray*}
\E(\hat{\beta}) & = & \beta \\
& \text{ and } & \\
\Var(\hat{\beta}) & = & \sigma^2 (\X^\top\X)^{-1}
\end{eqnarray*}
when the cross-product $\X^\top\X$ is non-singular.

\end{frame}

\begin{frame}
  \frametitle{Estimation}

If the cross-product $\X^\top\X$ is singular we need to reformulate the
model to $\y = \X \C \beta^\star + \varepsilon$ such that $\X^\star = \X \C$
has full rank. The matrix $\C$ is called \stress{contrast matrix} in \S{}
and \R{} and the result of the model fit is an estimate $\hat{\beta}^\star$. 

For the
theoretical details we refer to \cite{HSAUR:Searle1971}, the implementation
of contrasts in \S{} and \R{} is discussed by
\cite{HSAUR:Chambers+Hastie:1992} and \cite{HSAUR:VenablesRipley2002}.

\end{frame}

\begin{frame}[fragile]
  \frametitle{Inference}

$\hat{y}_i$ is the predicted value of the response variable for the
$i$th individual $\hat{y}_i = \hat{\beta}_0 + \hat{\beta}_1 x_{i1} + \dots +
\hat{\beta}_q x_{q1}$ and $\bar{y} = \sum_{i = 1}^n y_i / n $ is the mean of the response variable.

The mean square ratio
\begin{eqnarray*}
F = \frac{\sum\limits_{i = 1}^n (\hat{y}_i - \bar{y})^2 / q}{
           \sum\limits_{i = 1}^n (\hat{y}_i - y_i)^2 / (n - q - 1)} \sim F_{q, n - q - 1}
\end{eqnarray*}
provides an $F$-test of the general hypothesis
\begin{eqnarray*}
H_0: \beta_1 = \dots = \beta_q = 0.
\end{eqnarray*}

\end{frame}

\begin{frame}[fragile]
  \frametitle{Variance Estimation}

An estimate of the variance $\sigma^2$ is
\begin{eqnarray*}
\hat{\sigma}^2 = \frac{1}{n - q - 1} \sum_{i = 1}^n (y_i - \hat{y_i})^2.
\end{eqnarray*}

Individual regression coefficients can be assessed by using the
ratio $t$-statistics $t_j = \hat{\beta}_j / \sqrt{\Var(\hat{\beta})_{jj}}$,
although these ratios should only be used as rough guides to the `significance' %'
of the coefficients. 

The problem of selecting the `best' subset %'
of variables to be included in a model is one of the most delicate ones in
statistics and we refer to \cite{HSAUR:Miller2002} for the theoretical
details and practical limitations.

\end{frame}

\section{Analysis Using R}

\begin{frame}
  \frametitle{Cloud Seeding}

Prior to applying multiple regression to the data it will
be useful to look at some graphics to assess their major features.

Here we will construct boxplots of the rainfall in each category
of the dichotomous explanatory variables and scatterplots of
rainfall against each of the continuous explanatory variables.

\end{frame}

\begin{frame}

\begin{center}
<<MLR-clouds-boxplots, echo = FALSE, fig = TRUE, width = 8>>=
data("clouds", package = "HSAUR3")
layout(matrix(1:2, nrow = 1))
bxpseeding <- boxplot(rainfall ~ seeding, data = clouds, ylab = "Rainfall",
        xlab = "Seeding")
bxpecho <- boxplot(rainfall ~ echomotion, data = clouds, ylab = "Rainfall",
        xlab = "Echo Motion")
@
\end{center}

\end{frame}

\begin{frame}

\begin{center}
<<MLR-clouds-scatterplots, echo = FALSE, fig = TRUE, width = 7, height = 7>>=
layout(matrix(1:4, nrow = 2))
plot(rainfall ~ time, data = clouds)
plot(rainfall ~ sne, data = clouds, xlab="S-NE criterion")
plot(rainfall ~ cloudcover, data = clouds)
plot(rainfall ~ prewetness, data = clouds)
@
\end{center}

\end{frame}

\subsection{Fitting a Linear Model}

\begin{frame}[fragile]
  \frametitle{Fitting a Linear Model} 

It is sensible to assume that the effect that
some of the other explanatory variables is modified by seeding
and therefore consider a model that allows interaction terms
for \Robject{seeding} with each of the covariates except \Robject{time}.

This model can be described by the \Rclass{formula}
<<MLR-clouds-formula, echo = TRUE>>=
clouds_formula <- rainfall ~ seeding * (sne + 
    cloudcover + prewetness + echomotion) + time
@
and the design matrix $\X^\star$ can be computed via
<<MLR-clouds-modelmatrix, echo = TRUE>>=
Xstar <- model.matrix(clouds_formula, data = clouds)
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Contrast Matrix}

By default, treatment contrasts have been applied to the dummy codings of
the factors \Robject{seeding} and \Robject{echomotion} as can be seen from
the inspection of the \Robject{contrasts} attribute of the model matrix
<<MLR-clouds-contrasts, echo = TRUE>>=
attr(Xstar, "contrasts")
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Fitting a Linear Model}

However, such internals are hidden and performed by high-level model fitting
functions such as \Rcmd{lm} which will be used to fit the linear model
defined by the \Rclass{formula} \Robject{clouds\_formula}:
<<MLR-clouds-lm, echo = TRUE>>=
clouds_lm <- lm(clouds_formula, data = clouds)
class(clouds_lm)
@
A \Rcmd{summary} method can be used to show the conventional regression analysis
output.

\end{frame}

\begin{frame}[fragile]
  \frametitle{Inspecting Results}

The estimates $\hat{\beta}^\star$ can be assessed via
<<MLR-clouds-coef, echo = TRUE, eval = FALSE>>=
coef(clouds_lm)
@
<<MLR-clouds-coef, echo = FALSE>>=
coef(clouds_lm)[1:5]
cat("...\n")
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Inspecting Results}

The corresponding covariance matrix $\Cov(\hat{\beta}^\star)$ is available via
<<MLR-clouds-vcov, echo = TRUE, eval = FALSE>>=
vcov(clouds_lm)
@
<<MLR-clouds-vcov, echo = FALSE>>=
vcov(clouds_lm)[1:5,1:5]
cat("...\n")
@

\end{frame}

\begin{frame}
  \frametitle{Inspecting Results}

The results of the linear model fit
suggest the interaction of seeding with cloud coverage
significantly affects rainfall. 

A suitable graph will help in the interpretation of
this result. We can plot the relationship between rainfall and
S-Ne criterion for seeding and non-seeding days.

\end{frame}

\begin{frame}

\begin{center}
<<MLR-clouds-lmplot, echo = FALSE, fig = TRUE>>=
psymb <- as.numeric(clouds$seeding)
plot(rainfall ~ sne, data = clouds, pch = psymb)
abline(lm(rainfall ~ sne, data = clouds, subset = seeding == "no"))
abline(lm(rainfall ~ sne, data = clouds, subset = seeding == "yes"), lty = 2)
legend("topright", legend = c("No seeding", "Seeding"), pch = 1:2, lty = 1:2, bty = "n")
@
\end{center}

\end{frame}

\subsection{Regression Diagnostics}

\begin{frame}
  \frametitle{Regression Diagnostics}

The possible influence of outliers and the checking of assumptions
made in fitting the multiple regression model, i.e., constant
variance and normality of error terms, can both be undertaken
using a variety of diagnostic tools, of which the simplest and
most well known are the estimated residuals, i.e., the differences
between the observed values of the response and the fitted values of the
response. 

So, after estimation, the next stage in the analysis
should be an examination of
such residuals from fitting the chosen model to check on the normality
and constant variance assumptions and to identify outliers. 

\end{frame}

\begin{frame}
  \frametitle{Diagnostic Plots}

\begin{itemize}
\item A plot of residuals against each explanatory variable in
      the model. The presence of a non-linear relationship, for example,
      may suggest that a higher-order term, in the explanatory variable
      should be considered.
\item A plot of residuals against fitted values. If the variance
      of the residuals appears to increase with predicted value, a
      transformation of the response variable may be in order.
\item A normal probability plot of the residuals. After
      all the systematic variation has been removed from the data,
      the residuals should look like a sample from a standard normal
      distribution. A plot of the ordered residuals against the expected
      order statistics from a normal distribution provides a graphical
      check of this assumption.
\end{itemize}

\end{frame}

\begin{frame}[fragile]
  \frametitle{Residuals and Fitted Values}

We need access to the
residuals and the fitted values. The residuals can be found by the
\Rcmd{residuals} method and the fitted values of the response
from the \Rcmd{fitted} method
<<MLR-clouds-residfitted, echo = TRUE>>=
clouds_resid <- residuals(clouds_lm)
clouds_fitted <- fitted(clouds_lm)
@

\end{frame}

\begin{frame}

\begin{center}
<<MLR-clouds-residplot, echo = FALSE, fig = TRUE>>=
plot(clouds_fitted, clouds_resid, xlab = "Fitted values",
     ylab = "Residuals", ylim = max(abs(clouds_resid)) * c(-1, 1),
     type = "n")
abline(h = 0, lty = 2)
text(clouds_fitted, clouds_resid, labels = rownames(clouds))
@
\end{center}

\end{frame}

\begin{frame}

\begin{center}
<<MLR-clouds-qqplot, echo = FALSE, fig = TRUE>>=
qqnorm(clouds_resid, ylab = "Residuals")
qqline(clouds_resid)
@
\end{center}

\end{frame}

\begin{frame}
  \frametitle{Cook's Distance}


A further diagnostic that is often very useful is an index
plot of the Cook's distances for each observation. This statistic %'
\index{Cook's distance} %%'
is defined as
\begin{eqnarray*}
D_k = \frac{1}{(q + 1)\hat{\sigma}^2} \sum_{i=1}^n (\hat{y}_{i(k)} - y_i)^2
\end{eqnarray*}
where $\hat{y}_{i(k)}$
is the fitted value of the $i$th observation when
the $k$th observation is omitted from the model.

The
values of $D_k$ assess the impact of the $k$th
observation
on the estimated regression coefficients. Values of $D_k$
greater than one are suggestive that the corresponding observation
has undue influence on the estimated regression coefficients.

\end{frame}

\begin{frame}

\begin{center}
<<MLR-clouds-cook, echo = FALSE, fig = TRUE>>=
plot(clouds_lm, which = 4, sub.caption = NULL)
@
\end{center}

\end{frame}

\section*{Exercises}

\begin{frame}
  \frametitle{Exercises}

\begin{itemize}

\item
Investigate refitting the cloud seeding data after removing
any observations which may give cause for concern.

\item 
Show how the analysis of variance for the data \Robject{weightgain}
data 
can be constructed from the results of applying an appropriate
multiple linear regression to the data.

\item 
Investigate the use of the \Rcmd{leaps} function from package
\Rpackage{leaps} for the selecting the `best' %%'
set of variables predicting rainfall in the cloud seeding data.

\end{itemize}

\end{frame}


\begin{frame}
\frametitle{References}
\tiny
<<bibfiles, echo = FALSE, results = tex>>=   
src <- system.file(package = "HSAUR3")
style <- file.path(src, "LaTeXBibTeX", "refstyle")
bst <- file.path(src, "LaTeXBibTeX", "HSAUR")
cat(paste("\\bibliographystyle{", style, "}", sep = ""), "\n \n")
cat(paste("\\bibliography{", bst, "}", sep = ""), "\n \n")
@

\end{frame}

\end{document}

\input{HSAUR_title}

\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE}

<<setup, echo = FALSE, results = hide>>=
source("setup.R")
@

\frame{
\begin{center}
\Large{Part 8: Density Estimation}
\end{center}

focuses on estimating uni- and multivariate densities.

}


<<DE-setup, echo = FALSE, results = hide>>=
x <- library("KernSmooth")
x <- library("flexmix")
x <- library("boot")
data("CYGOB1", package = "HSAUR3")
@

\section{Introduction}

\begin{frame}
  \frametitle{Erupting Geysers}

Old Faithful is the most popular
attraction of Yellowstone National Park, although it is not the
largest or grandest geyser in the park. Old Faithful can vary
in height from 100--180 feet with an average near 130--140 feet.
Eruptions normally last between $1.5$ to $5$ minutes.
From August 1 to August 15, 1985, Old Faithful
was observed and the waiting times between successive eruptions
noted. There were $300$ eruptions observed, so $299$ waiting times were
(in minutes) recorded.

\end{frame}

\begin{frame}
  \frametitle{Star Clusters}


The Hertzsprung-Russell (H-R) diagram forms the basis of
the theory of stellar evolution. The diagram is essentially a
plot of the energy output of stars plotted against their surface
temperature. Data from the H-R diagram of Star Cluster CYG OB1,
calibrated according to \cite{HSAUR:VanismaGreve1972} are given
in \Robject{CYGOB1}.

\end{frame}

\section{Density Estimation}

\begin{frame}
  \frametitle{Density Estimation}

The goal of density estimation is to approximate the probability
density function of a random variable (univariate or multivariate)
given a sample of observations of the variable. 

Univariate histograms
are a simple example of a density estimate; they are often used
for two purposes, counting and displaying the distribution of
a variable, but according to \cite{HSAUR:Wilkinson1992}, they are effective
for neither. 

For bivariate data, two-dimensional histograms can
be constructed, but for small and moderate sized data
sets that is not of any real use for estimating the bivariate
density function, simply because most of the `boxes' in the histogram %'
will contain too few observations, or if the number of boxes
is reduced the resulting histogram will be too coarse a representation
of the density function.

\end{frame}

\begin{frame}
  \frametitle{Density Estimation}

If we are willing to assume a particular form for the variable's %'
distribution, for example, Gaussian, density estimation would
be reduced to estimating the parameters of the assumed distribution.
More commonly, however, we wish to allow the data to speak for
themselves and so one of a variety of non-parametric estimation
procedures that are now available might be used. 

One of the most popular class of procedures is the kernel density
estimators, which we now briefly describe for univariate and
bivariate data.

\end{frame}

\subsection{Kernel Density Estimators}

\begin{frame}
  \frametitle{Kernel Density Estimators}

From the definition of a probability density, if the random $X$ has a
density $f$,
\begin{eqnarray*}
f(x) = \lim_{h \rightarrow 0} \frac{1}{2h} \P(x - h < X < x + h).
\end{eqnarray*}

For any given $h$ a na{\"\i}ve estimator is 
\begin{eqnarray*}
\hat{f}(x) = \frac{1}{2hn} \sum_{i = 1}^n I(x_i \in (x - h, x + h)),
\end{eqnarray*}
i.e., the number of $x_1, \dots, x_n$ falling in the interval $(x - h, x +
h)$ divided by $2hn$. 

\end{frame}

\begin{frame}
  \frametitle{Kernel Density Estimators}


If we introduce a weight function $W$ given by
\begin{eqnarray*}
W(x) = \left\{\begin{array}{lcl} \frac{1}{2} & & |x| < 1 \\\\ %end
                                 0 & & \text{else} \end{array} \right .
\end{eqnarray*}
then the na{\"\i}ve estimator can be rewritten as %"
\begin{eqnarray*}
\hat{f}(x) = \frac{1}{n} \sum_{i = 1}^n \frac{1}{h} W\left(\frac{x -
x_i}{h}\right).
\end{eqnarray*}
but is unfortunately not continuous function.

\end{frame}

\begin{frame}
  \frametitle{Kernel Density Estimators}

Better:
\begin{eqnarray*}
\hat{f}(x) = \frac{1}{hn} \sum_{i = 1}^n K\left(\frac{x -
x_i}{h}\right)
\end{eqnarray*}
where $K$ is known as the \stress{kernel function}
and $h$ as the \stress{bandwidth} or \stress{smoothing parameter}.

The kernel function must satisfy the condition
\begin{eqnarray*}
\int_{-\infty}^\infty K(x)dx = 1.
\end{eqnarray*}
Usually, but not always, the kernel function will be a symmetric
density function for example, the normal.

\end{frame}

\begin{frame}
  \frametitle{Kernel Functions}

\begin{description}
\item[rectangular:]
\begin{eqnarray*}
K(x) = \left\{\begin{array}{lcl} \frac{1}{2} & & |x| < 1 \\\\ %end
0 & & \text{else}
\end{array} \right .
\end{eqnarray*}
\item[triangular:]
\begin{eqnarray*}
K(x) = \left\{\begin{array}{lcl} 1 - |x| & & |x| < 1 \\\\ %end
0 & & \text{else}
\end{array} \right .
\end{eqnarray*}
\item[Gaussian:]
\begin{eqnarray*}
K(x) = \frac{1}{\sqrt{2 \pi}} e^{-\frac{1}{2}x^2}
\end{eqnarray*}
\end{description}

\end{frame}

\begin{frame}[fragile]
  \frametitle{Kernel Functions}

\begin{center}
<<DE-kernel-figs, echo = FALSE, fig = TRUE>>=
rec <- function(x) (abs(x) < 1) * 0.5
tri <- function(x) (abs(x) < 1) * (1 - abs(x))
gauss <- function(x) 1/sqrt(2*pi) * exp(-(x^2)/2)
x <- seq(from = -3, to = 3, by = 0.001)
plot(x, rec(x), type = "l", ylim = c(0,1), lty = 1,
     ylab = expression(K(x)))
lines(x, tri(x), lty = 2)
lines(x, gauss(x), lty = 3)
legend(-3, 0.8, legend = c("Rectangular", 
       "Triangular", "Gaussian"), lty = 1:3, 
       title = "kernel functions", bty = "n")
@
\end{center}

\end{frame}

\begin{frame}[fragile]
  \frametitle{Kernel Functions}

The kernel estimator $\hat{f}$ is a sum of `bumps' placed at the observations. %'
The kernel function determines the shape of the bumps while the
window width $h$ determines their width.
We look at 
the individual bumps $n^{-1}h^{-1} K((x - x_i) / h)$, as well as the estimate $\hat{f}$
obtained by adding them up for an artificial set of data points
<<DE-x-bumps-data, echo = TRUE>>=
x <- c(0, 1, 1.1, 1.5, 1.9, 2.8, 2.9, 3.5)
n <- length(x)
xgrid <- seq(from = min(x) - 1, to = max(x) + 1, 
             by = 0.01)
h <- 0.4
bumps <- sapply(x, function(a) 
                gauss((xgrid - a)/h)/(n * h))
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Kernel Functions}

\small
\begin{center}
<<DE-x-bumps, echo = TRUE, fig = TRUE, leftpar = TRUE>>=
plot(xgrid, rowSums(bumps),  type = "l", xlab = "x",
     ylab = expression(hat(f)(x)), lwd = 2)
rug(x, lwd = 2)
out <- apply(bumps, 2, function(b) lines(xgrid, b))
@
\end{center}
\normalsize

\end{frame}

\subsection{Bivariate Density Estimation}

\begin{frame}
  \frametitle{Bivariate Density Estimation}

The kernel density estimator considered as a sum of `bumps'  %'
centred at the observations has a simple extension to two dimensions
(and similarly for more than two dimensions). The bivariate estimator
for data $(x_1, y_1)$, $(x_2, y_2)$, $\dots$, $(x_n, y_n)$
is defined as
\begin{eqnarray*}
\hat{f}(x, y) = \frac{1}{nh_xh_y} \sum_{i = 1}^n K\left(\frac{x - x_i}{h_x},
\frac{y - y_i}{h_y}\right).
\end{eqnarray*}
In this estimator each coordinate direction has its own smoothing parameter
$h_x$ and $h_y$. An alternative is to scale the data equally for both dimensions
and use a single smoothing parameter.

\end{frame}

\begin{frame}
  \frametitle{Bivariate Kernels}

\begin{description}
\item[Bivariate Normal kernel:]
\begin{eqnarray*}
K(x, y) = \frac{1}{2 \pi}e^{-\frac{1}{2} (x^2 + y^2)}.
\end{eqnarray*}
\item[Bivariate Epanechnikov kernel:]
\begin{eqnarray*}
K(x, y) = \left\{\begin{array}{lcl}
\frac{2}{\pi}(1 - x^2 - y^2) & & x^2 + y^2 < 1 \\\\ %end
0 & & \text{else}
\end{array} \right.
\end{eqnarray*}
\end{description}

\end{frame}

\begin{frame}[fragile]
  \frametitle{Epanechnikov}

\begin{center}
<<DE-epakernel-fig, echo = FALSE, fig = TRUE>>=
epa <- function(x, y)
    ((x^2 + y^2) < 1) * 2/pi * (1 - x^2 - y^2)
x <- seq(from = -1.1, to = 1.1, by = 0.05)
epavals <- sapply(x, function(a) epa(a, x))
persp(x = x, y = x, z = epavals, xlab = "x", 
      ylab = "y", zlab = expression(K(x, y)), 
      theta = -35, axes = TRUE, box = TRUE)
@
\end{center}

\end{frame}

\section{Analysis Using R}

\begin{frame}[fragile]
  \frametitle{Old Faithful}

\begin{center}
<<DE-faithful-density, echo = FALSE, fig = TRUE, height = 4>>=
data("faithful", package = "datasets")
x <- faithful$waiting
layout(matrix(1:3, ncol = 3))
hist(x, xlab = "Waiting times (in min.)", ylab = "Frequency",
     probability = TRUE, main = "Gaussian kernel",
     border = "gray")
lines(density(x, width = 12), lwd = 2)
rug(x)
hist(x, xlab = "Waiting times (in min.)", ylab = "Frequency",
     probability = TRUE, main = "Rectangular kernel",
     border = "gray")
lines(density(x, width = 12, window = "rectangular"), lwd = 2)
rug(x)
hist(x, xlab = "Waiting times (in min.)", ylab = "Frequency",
     probability = TRUE, main = "Triangular kernel",
     border = "gray")
lines(density(x, width = 12, window = "triangular"), lwd = 2)
rug(x)
@
\end{center}

\end{frame}


\begin{frame}[fragile]
  \frametitle{Star Clusters}

\small
\begin{center}
<<DE-CYGOB1-contour, echo = TRUE, fig = TRUE>>=
CYGOB1d <- bkde2D(CYGOB1, bandwidth = sapply(CYGOB1, dpik))
contour(x = CYGOB1d$x1, y = CYGOB1d$x2, 
    z = CYGOB1d$fhat, xlab = "log surface temperature",
    ylab = "log light intensity")
@
\end{center}
\normalsize

\end{frame}

\begin{frame}[fragile]
  \frametitle{Star Clusters}

\begin{center}
<<DE-CYGOB1-persp, echo = TRUE, fig = TRUE>>=
persp(x = CYGOB1d$x1, y = CYGOB1d$x2, z = CYGOB1d$fhat,
      xlab = "log surface temperature",
      ylab = "log light intensity",
      zlab = "estimated density",
      theta = -35, axes = TRUE, box = TRUE)
@
\end{center}

\end{frame}

\subsection{A Parametric Density Estimate for the Old Faithful Data}

\begin{frame}
  \frametitle{Parametric Old Faithful}

Two-component normal mixture distribution
\begin{eqnarray*}
f(x) = p \phi(x, \mu_1, \sigma_1^2) + (1 - p) \phi(x, \mu_2, \sigma^2_2)
\end{eqnarray*}
where $\phi(x, \mu, \sigma^2)$ denotes the normal density.

This distribution had five parameters to estimate, the mixing
proportion, $p$, and the mean and variance of each component
normal distribution. Pearson 100 years ago heroically attempted this by the
method of moments, which required solving a polynomial equation
of the 9$^{\text{th}}$ degree. Nowadays the preferred estimation approach
is maximum likelihood. 

\end{frame}

\begin{frame}[fragile]
  \frametitle{Maximum Likelihood Estimation}

<<DE-faithful-optim, echo = TRUE, results = hide>>=
logL <- function(param, x) {
    d1 <- dnorm(x, mean = param[2], sd = param[3])
    d2 <- dnorm(x, mean = param[4], sd = param[5])
    -sum(log(param[1] * d1 + (1 - param[1]) * d2))
}
startparam <- c(p = 0.5, mu1 = 50, sd1 = 3, mu2 = 80, 
                sd2 = 3)
opp <- optim(startparam, logL, x = faithful$waiting,
             method = "L-BFGS-B",
             lower = c(0.01, rep(1, 4)),
             upper = c(0.99, rep(200, 4)))
opp
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Maximum Likelihood Estimation}

<<DE-faithful-optim-print, echo = FALSE>>=
print(opp[names(opp) != "message"])
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Maximum Likelihood Estimation}

Optimising the appropriate likelihood `by hand' %'
is not very convenient. In fact, (at least) two packages offer high-level
functionality for estimating mixture models. The first one is package
\Rpackage{mclust} \citep{PKG:mclust} implementing the methodology described
in \cite{HSAUR:FraleyRaftery2002}. Here, a Bayesian information criterion
(BIC) is applied to choose the form of the mixture model:
<<DE-attach-mclust, echo = FALSE, results = hide>>=
library("mclust")
@
<<DE-faithful-mclust, echo = TRUE>>=
library("mclust")
mc <- Mclust(faithful$waiting)
mc
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Maximum Likelihood Estimation}


The estimated means are
<<DE-faithful-mclust-mu, echo = TRUE>>=
mc$parameters$mean
@
with estimated standard deviation (found to be equal within both groups)
<<DE-faithful-mclust-para, echo = TRUE>>=
sqrt(mc$parameters$variance$sigmasq)
@
The proportion is $\hat{p} = \Sexpr{round(mc$parameters$pro[1], 2)}$. 

\end{frame}

\begin{frame}[fragile]
  \frametitle{Maximum Likelihood Estimation}

The second package is called
\Rpackage{flexmix}:
<<DE-faithful-flexmix, echo = TRUE>>=
library("flexmix")
fl <- flexmix(waiting ~ 1, data = faithful, k = 2)
@
with $\hat{p} = \Sexpr{round(fl@prior, 2)}$ and estimated parameters
<<DE-faithful-flexmix-parameters, echo = TRUE>>=
parameters(fl, component = 1)
parameters(fl, component = 2)
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{Maximum Likelihood Estimation}

\small
\begin{center}
<<DE-faithful-2Dplot, echo = FALSE, fig = TRUE>>=
opar <- as.list(opp$par)
rx <- seq(from = 40, to = 110, by = 0.1)
d1 <- dnorm(rx, mean = opar$mu1, sd = opar$sd1)
d2 <- dnorm(rx, mean = opar$mu2, sd = opar$sd2)
f <- opar$p * d1 + (1 - opar$p) * d2
hist(x, probability = TRUE, xlab = "Waiting times (in min.)",
     border = "gray", xlim = range(rx), ylim = c(0, 0.06),
     main = "")
lines(rx, f, lwd = 2)
lines(rx, dnorm(rx, mean = mean(x), sd = sd(x)), lty = 2,
      lwd = 2)
legend(50, 0.06, lty = 1:2, bty = "n",
       legend = c("Fitted two-component mixture density",
                  "Fitted single normal density"))
@
\end{center}

\normalsize

\end{frame}

\section{Bootstrap}

\begin{frame}[fragile]
  \frametitle{The Bootstrap}


We can get standard errors for the five parameter estimates
by using a bootstrap approach \citep[see][]{HSAUR:EfronTibshirani1993}.

First, we define a function that,
for a bootstrap sample \Robject{indx}, fits a two-component mixture model
and returns $\hat{p}$ and the estimated means 
<<DE-faithful-boot, echo = TRUE>>=
library("boot")
fit <- function(x, indx) {
    a <- Mclust(x[indx], minG = 2, maxG = 2)$parameters
    if (a$pro[1] < 0.5)
        return(c(p = a$pro[1], mu1 = a$mean[1],
                               mu2 = a$mean[2]))
    return(c(p = 1 - a$pro[1], mu1 = a$mean[2],
                               mu2 = a$mean[1]))
}
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{The Bootstrap}

The function \Rcmd{fit} can now be fed into the \Rcmd{boot} function \citep{PKG:boot}
for bootstrapping (here $1000$ bootstrap samples are drawn)
\begin{Schunk}
\begin{Sinput}
R> bootpara <- boot(faithful$waiting, fit, R = 1000)
\end{Sinput}
\end{Schunk}

<<DE-faithful-bootrun, echo = FALSE>>=
bootparafile <- system.file("cache", "DE-bootpara.rda", package = "HSAUR3")
if (file.exists(bootparafile)) {
    load(bootparafile)
} else {
    bootpara <- boot(faithful$waiting, fit, R = 1000)
}
@

Variability of our estimates $\hat{p}$ (BCa confidence intervals):
<<DE-faithful-p-ci, echo = TRUE>>=
boot.ci(bootpara, type = "bca", index = 1)
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{The Bootstrap}

We see that there is a reasonable variability in the mixture model, however,
the means in the two components are rather stable, as can be seen from
<<DE-faithful-mu1-ci, echo = TRUE>>=
boot.ci(bootpara, type = "bca", index = 2)
@
for $\hat{\mu}_1$ 

\end{frame}

\begin{frame}[fragile]
  \frametitle{The Bootstrap}

and for $\hat{\mu}_2$ from
<<DE-faithful-mu2-ci, echo = TRUE>>=
boot.ci(bootpara, type = "bca", index = 3)
@

\end{frame}

\begin{frame}[fragile]
  \frametitle{The Bootstrap}

Bootstrap-distribution of $\hat{\mu}_1$ and $\hat{\mu}_2$ with BCa confidence intervals:

<<DE-bootplot, echo = FALSE>>=
bootplot <- function(b, index, main = "") {
    dens <- density(b$t[,index])
    ci <- boot.ci(b, type = "bca", index = index)$bca[4:5]
    est <- b$t0[index]
    plot(dens, main = main)
    y <- max(dens$y) / 10
    segments(ci[1], y, ci[2], y, lty = 2)
    points(ci[1], y, pch = "(")
    points(ci[2], y, pch = ")")
    points(est, y, pch = 19)
}
@

\begin{figure}
\begin{center}
<<DE-faithful-boot-plot, echo = FALSE, fig = TRUE, height = 4>>=
layout(matrix(1:2, ncol = 2))
bootplot(bootpara, 2, main = expression(mu[1]))
bootplot(bootpara, 3, main = expression(mu[2]))
@
\end{center}
\end{figure}

\end{frame}

\section{Summary}

\begin{frame}
  \frametitle{Summary}


Histograms and scatterplots are frequently used to give
graphical representations of univariate and bivariate data. But
both can often be improved and made more helpful by adding some
form of density estimate. For scatterplots in particular adding
a contour plot of the estimated bivariate density can be particularly
useful in aiding in the identification of clusters, gaps
and outliers.

\end{frame}

\section*{Exercises}

\begin{frame}
  \frametitle{Exercises}

\begin{itemize}

\item
The \Robject{galaxies} data 
are the velocities of $82$ galaxies
from six well-separated conic sections of space
\citep{HSAUR:Postmanetal1986,HSAUR:Roeder1990}. The data are
intended to shed light on whether or not the observable universe
contains superclusters of galaxies surrounded by large voids.
The evidence for the existence of superclusters would be the
multimodality of the distribution of velocities. Construct a
histogram of the data and add a variety of kernel estimates of
the density function. What do you conclude about the possible
existence of superclusters of galaxies?

\item
The \Robject{birthdeathrates} data 
give the birth and death rates
for 69 countries \citep[from][]{HSAUR:Hartigan1975}.
Produce a scatterplot of the data that shows
a contour plot of the estimated bivariate density. Does the plot
give you any interesting insights into the possible structure
of the data?

\end{itemize}

\end{frame}

\begin{frame}
  \frametitle{Exercises}

\begin{itemize}

\item
A sex difference in the age of onset of schizophrenia was
noted by \cite{HSAUR:Kraepelin1919}. Subsequent epidemiological studies
of the disorder have consistently shown an earlier onset in men
than in women. One model that has been suggested to explain this
observed difference is known as the \stress{subtype model}
which postulates two types of schizophrenia, one characterised by early
onset, typical symptoms and poor premorbid competence, and the
other by late onset, atypical symptoms and good premorbid competence.
The early onset type is assumed to be largely a disorder of men
and the late onset largely a disorder of women. By fitting finite
mixtures of normal densities separately to the onset data for
men and women given in \Robject{schizophrenia}
see if you can produce some
evidence for or against the subtype model.

\end{itemize}

\end{frame}

\begin{frame}
\frametitle{References}
\tiny
<<bibfiles, echo = FALSE, results = tex>>=   
src <- system.file(package = "HSAUR3")
style <- file.path(src, "LaTeXBibTeX", "refstyle")
bst <- file.path(src, "LaTeXBibTeX", "HSAUR")
cat(paste("\\bibliographystyle{", style, "}", sep = ""), "\n \n")
cat(paste("\\bibliography{", bst, "}", sep = ""), "\n \n")
@

\end{frame}

\end{document}

\documentclass{chapman}

%%% copy Sweave.sty definitions

%%% keeps `sweave' from adding `\usepackage{Sweave}': DO NOT REMOVE
%\usepackage{Sweave} 


\RequirePackage[T1]{fontenc}
\RequirePackage{graphicx,ae,fancyvrb}
\IfFileExists{upquote.sty}{\RequirePackage{upquote}}{}
\usepackage{relsize}

\DefineVerbatimEnvironment{Sinput}{Verbatim}{}
\DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                              fontshape=it,
                                              fontsize=\relsize{-1}}
\DefineVerbatimEnvironment{Scode}{Verbatim}{}
\newenvironment{Schunk}{}{}

%%% environment for raw output
\newcommand{\SchunkRaw}{\renewenvironment{Schunk}{}{}
    \DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                                  fontshape=it,
                                                  fontsize=\small}
    \rawSinput
}

%%% environment for labeled output
\newcommand{\nextcaption}{}
\newcommand{\SchunkLabel}{
  \renewenvironment{Schunk}{\begin{figure}[ht] }{\caption{\nextcaption}
  \end{figure} }
  \DefineVerbatimEnvironment{Sinput}{Verbatim}{frame = topline}
  \DefineVerbatimEnvironment{Soutput}{Verbatim}{frame = bottomline, 
                                                samepage = true,
                                                fontfamily=courier,
                                                fontshape=it,
                                                fontsize=\relsize{-1}}
}


%%% S code with line numbers
\DefineVerbatimEnvironment{Sinput}
{Verbatim}
{
%%  numbers=left
}

\newcommand{\numberSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{numbers=left}
}
\newcommand{\rawSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{}
}


%%% R / System symbols
\newcommand{\R}{\textsf{R}}
\newcommand{\rR}{{R}}
\renewcommand{\S}{\textsf{S}}
\newcommand{\SPLUS}{\textsf{S-PLUS}}
\newcommand{\rSPLUS}{{S-PLUS}}
\newcommand{\SPSS}{\textsf{SPSS}}
\newcommand{\EXCEL}{\textsf{Excel}}
\newcommand{\ACCESS}{\textsf{Access}}
\newcommand{\SQL}{\textsf{SQL}}
%%\newcommand{\Rpackage}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Robject}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\Rclass}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Rcmd}[1]{\hbox{\rm\texttt{#1}}}
\newcommand{\Rpackage}[1]{\index{#1 package@{\fontseries{b}\selectfont #1} package} {\fontseries{b}\selectfont #1}}
\newcommand{\rpackage}[1]{{\fontseries{b}\selectfont #1}}
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\Rclass}[1]{\index{#1 class@\textit{#1} class}\textit{#1}}
\newcommand{\Rcmd}[1]{\index{#1 function@\texttt{#1} function}\texttt{#1}}
\newcommand{\Roperator}[1]{\texttt{#1}}
\newcommand{\Rarg}[1]{\texttt{#1}}
\newcommand{\Rlevel}[1]{\texttt{#1}}


%%% other symbols
\newcommand{\file}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\stress}[1]{\index{#1}\textit{#1}} 
\newcommand{\stress}[1]{\textit{#1}} 
\newcommand{\booktitle}[1]{\textit{#1}} %%'

%%% Math symbols
\usepackage{amstext}
\usepackage{amsmath}
\newcommand{\E}{\mathsf{E}}   
\newcommand{\Var}{\mathsf{Var}}   
\newcommand{\Cov}{\mathsf{Cov}}   
\newcommand{\Cor}{\mathsf{Cor}}   
\newcommand{\x}{\mathbf{x}}   
\newcommand{\y}{\mathbf{y}}   
\renewcommand{\a}{\mathbf{a}}
\newcommand{\W}{\mathbf{W}}   
\newcommand{\C}{\mathbf{C}}   
\renewcommand{\H}{\mathbf{H}}   
\newcommand{\X}{\mathbf{X}}   
\newcommand{\B}{\mathbf{B}}   
\newcommand{\V}{\mathbf{V}}   
\newcommand{\I}{\mathbf{I}}   
\newcommand{\D}{\mathbf{D}}   
\newcommand{\bS}{\mathbf{S}}   
\newcommand{\N}{\mathcal{N}}   
\renewcommand{\L}{L}   
\renewcommand{\P}{\mathsf{P}}   
\newcommand{\K}{\mathbf{K}}
\newcommand{\m}{\mathbf{m}}
\newcommand{\argmin}{\operatorname{argmin}\displaylimits}
\newcommand{\argmax}{\operatorname{argmax}\displaylimits}

\newcommand{\bx}{\mathbf{x}}
\newcommand{\bbeta}{\mathbf{\beta}}


%%% links
\usepackage{hyperref}

\hypersetup{%
  pdftitle = {A Handbook of Statistical Analyses Using R (3rd Edition)},
  pdfsubject = {Book},
  pdfauthor = {Torsten Hothorn and Brian S. Everitt},
  colorlinks = {black},
  linkcolor = {black},
  citecolor = {black},
  urlcolor = {black},
  hyperindex = {true},
  linktocpage = {true},
}


%%% captions & tables
%% <FIXME>: conflics with figure definition in chapman.cls
%%\usepackage[format=hang,margin=10pt,labelfont=bf]{caption}
%% </FIMXE>
\usepackage{longtable}
\usepackage[figuresright]{rotating}

%%% R symbol in chapter 1
\usepackage{wrapfig}

%%% Bibliography
\usepackage[round,comma]{natbib}
\renewcommand{\refname}{References \addcontentsline{toc}{chapter}{References}}
\citeindexfalse

%%% texi2dvi complains that \newblock is undefined, hm...
\def\newblock{\hskip .11em plus .33em minus .07em}

%%% Example sections
\newcounter{exercise}[chapter]
\setcounter{exercise}{0}
\newcommand{\exercise}{\stepcounter{exercise} \item{Ex.~\arabic{chapter}.\arabic{exercise} }}


%% URLs
\newcommand{\curl}[1]{\begin{center} \url{#1} \end{center}}

%%% for manual corrections
%\renewcommand{\baselinestretch}{2}

%%% plot sizes
\setkeys{Gin}{width=0.95\textwidth}

%%% color
\usepackage{color}

%%% hyphenations
\hyphenation{drop-out}
\hyphenation{mar-gi-nal}

%%% new bidirectional quotes need 
\usepackage[utf8]{inputenc}

%\usepackage{setspace}
\definecolor{sidebox_todo}{rgb}{1,1,0.2}
\newcommand{\todo}[1]{
        \hspace{0pt}%
        \marginpar{% 
                        \fcolorbox{black}{sidebox_todo}{%
                                \parbox{\marginparwidth} {

\raggedright\sffamily\footnotesize{TODO: #1}%
                                }
                        }%
        }
}
\begin{document}

%% Title page

\title{A Handbook of Statistical Analyses Using \R{} --- 3rd Edition}

\author{Torsten Hothorn and Brian S. Everitt}

\maketitle
%%\VignetteIndexEntry{Chapter Data Analysis using Graphical Displays}
%%\VignetteDepends{lattice, maps, sf, sp}
\setcounter{chapter}{1}



\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE} 

<<setup, echo = FALSE, results = hide>>=
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })
@

\pagestyle{headings}
<<singlebook, echo = FALSE>>=
book <- FALSE
@
%% lower png resolution for vignettes
\SweaveOpts{resolution = 100}


\chapter[Data Analysis Using Graphical Displays]{Data Analysis 
         Using Graphical Displays: Malignant Melanoma in the US and
         Chinese Health and \\ Family Life \label{DAGD}}

\section{Introduction}


\section{Initial Data Analysis}


\section{Analysis Using \R{}}

\subsection{Malignant Melanoma}

\index{Boxplot|(}
\index{Histogram|(}
\index{Scatterplot|(}
We might begin to examine the malignant melanoma data in Table~\ref{DAGD-USmelanoma-tab} 
by constructing a histogram or boxplot for \stress{all} the mortality rates
in Figure~\ref{DAGD-USmelanoma-histbox}.
The \Rcmd{plot}, \Rcmd{hist} and \Rcmd{boxplot} functions have already been introduced in 
\Sexpr{ch("AItR")} and we want to produce a plot where both techniques
are applied at once. The \Rcmd{layout} function organizes two independent plots
on one plotting device, for example on top of each other. Using this
relatively simple technique (more advanced methods will be introduced later)
we have to make sure that the $x$-axis is the same in both graphs. This can be done 
by computing a plausible range of the data, later to be specified in a plot via the \Rcmd{xlim}
argument:
<<DAGD-USmelanoma-histbox, echo = TRUE>>=
xr <- range(USmelanoma$mortality) * c(0.9, 1.1)
xr
@
Now, plotting both the histogram and the boxplot requires setting up the
plotting device with equal space for two independent plots on top 
of each other. Calling the \Rcmd{layout} function on a matrix with
two cells in two rows, containing the numbers one and two, leads to such
a partitioning. The \Rcmd{boxplot} function is called first on the mortality
data and then the \Rcmd{hist} function, where the range of the
$x$-axis in both plots is defined by $(\Sexpr{xr[1]}, \Sexpr{xr[2]})$. One
tiny problem to solve is the size of the margins; their
defaults are too large for such a plot. As with many other graphical
parameters, one can adjust their value for a specific
plot using function \Rcmd{par}. The
\R{} code and the resulting display are given in 
Figure~\ref{DAGD-USmelanoma-histbox}.

\begin{figure}
\begin{center}
<<DAGD-USmelanoma-histbox, echo = TRUE, fig = TRUE, width = 8>>=
layout(matrix(1:2, nrow = 2))
par(mar = par("mar") * c(0.8, 1, 1, 1))
boxplot(USmelanoma$mortality, ylim = xr, horizontal = TRUE, 
        xlab = "Mortality")
hist(USmelanoma$mortality, xlim = xr, xlab = "", main = "", 
     axes = FALSE, ylab = "")
axis(1)
@
\caption{Histogram (top) and boxplot (bottom) of malignant melanoma mortality rates.
         \label{DAGD-USmelanoma-histbox}}
\end{center}
\end{figure}



Both the histogram and the boxplot in Figure~\ref{DAGD-USmelanoma-histbox} indicate
a certain skewness of the mortality distribution.
Looking at the characteristics of all the mortality rates is a useful 
beginning but for these data we might be more interested in comparing 
mortality rates for ocean and non-ocean states. So we might construct 
two histograms or two boxplots. Such a \stress{parallel boxplot}, visualizing
the conditional distribution of a numeric variable in groups as given by
a categorical variable, are easily computed using the \Rcmd{boxplot} function.
The continuous response variable and the categorical independent variable
are specified via a \Rclass{formula} as described in \Sexpr{ch("AItR")}.
Figure~\ref{DAGD-USmelanoma-boxocean} shows such parallel boxplots,
as by default produced the \Rcmd{plot} function for such data,
for the mortality in ocean and non-ocean states and leads to the 
impression that the mortality is increased in east or west coast
states compared to the rest of the country.
\begin{figure}
\begin{center}
<<DAGD-USmelanoma-boxocean, echo = TRUE, fig = TRUE, width = 8>>=
plot(mortality ~ ocean, data = USmelanoma, 
     xlab = "Contiguity to an ocean", ylab = "Mortality")
@
\caption{Parallel boxplots of malignant melanoma mortality rates by contiguity to an ocean.
         \label{DAGD-USmelanoma-boxocean}}
\end{center}
\end{figure}

Histograms are generally used for two purposes: counting and displaying the 
distribution of a variable; according to \cite{HSAUR:Wilkinson1992}, `they are effective for neither'. Histograms can often be misleading for 
displaying distributions because of their dependence on the number of classes chosen. 
An alternative is to formally estimate the density function of a variable and 
then plot the resulting estimate; details of density estimation are 
given in \Sexpr{ch("DE")} but for the ocean and non-ocean states the 
two density estimates can be produced and plotted as shown in 
Figure~\ref{DAGD-USmelanoma-dens} which supports the impression from 
Figure~\ref{DAGD-USmelanoma-boxocean}. For more details on
such density estimates we refer to \Sexpr{ch("DE")}.
\begin{figure}
\begin{center}
<<DAGD-USmelanoma-dens, echo = TRUE, fig = TRUE, width = 8>>=
dyes <- with(USmelanoma, density(mortality[ocean == "yes"]))
dno <- with(USmelanoma, density(mortality[ocean == "no"]))
plot(dyes, lty = 1, xlim = xr, main = "", ylim = c(0, 0.018),
     xlab = "Mortality")
lines(dno, lty = 2)
legend("topleft", lty = 1:2, legend = c("Coastal State", 
       "Land State"), bty = "n")
@
\caption{Estimated densities of malignant melanoma mortality rates by contiguity to an ocean.
         \label{DAGD-USmelanoma-dens}}
\end{center}
\end{figure}

Now we might move on to look at how mortality rates are related to the 
geographic location of a state as represented by the latitude and longitude 
of the center of the state. Here the main graphic will be the scatterplot.
The simple $xy$ scatterplot has been in use since at least the eighteenth 
century and has many virtues -- indeed according to \cite{HSAUR:Tufte1983}:
\begin{quote}
The relational graphic -- in its barest form the scatterplot and its 
variants -- is the greatest of all graphical designs. It links at least two 
variables, encouraging and even imploring the viewer to assess the 
possible causal relationship between the plotted variables. It confronts 
causal theories that $x$  causes $y$ with empirical evidence as to the actual 
relationship between $x$ and $y$.
\end{quote}

Let's begin with simple scatterplots of mortality rate against longitude %%'
and mortality rate against latitude which can be produced by the code
preceding Figure~\ref{DAGD-USmelanoma-xy}. Again, the 
\Rcmd{layout} function is used for partitioning the plotting device, now
resulting in two side-by-side plots. The argument to \Rcmd{layout}
is now a matrix with only one row but two columns containing the 
numbers one and two. In each cell, the \Rcmd{plot} function
is called for producing a scatterplot of the variables given
in the \Rclass{formula}.
\begin{figure}  
\begin{center}
<<DAGD-USmelanoma-xy, echo = TRUE, fig = TRUE, height = 5, width = 8>>=
layout(matrix(1:2, ncol = 2))
plot(mortality ~ longitude, data = USmelanoma, 
     ylab = "Mortality", xlab = "Longitude")
plot(mortality ~ latitude, data = USmelanoma, 
     ylab = "Mortality", xlab = "Latitude")
@
\caption{Scatterplot of malignant melanoma mortality rates by geographical location.
         \label{DAGD-USmelanoma-xy}}
\end{center}
\end{figure} 

Since mortality rate is clearly related only to latitude we can now produce 
scatterplots of mortality rate against latitude separately for ocean and non-ocean 
states. Instead of producing two displays, one can choose different plotting
symbols for either states. This can be achieved by specifying a vector
of integers or characters to the \Rcmd{pch}, where the $i$th element of this
vector defines the plot symbol of the $i$th observation in the data to be plotted.
For the sake of simplicity, we convert the \Robject{ocean} factor to
an \Rclass{integer} vector containing the numbers one for land states and two for 
ocean states. As a consequence, land states can be identified by the dot symbol
and ocean states by triangles. It is useful to add a legend to such a plot,
most conveniently by using the \Rcmd{legend} function. This function takes
three arguments: a string indicating the position of the legend in the plot,
a character vector of labels to be printed and the corresponding plotting
symbols (referred to by integers). In addition, the display of a bounding box
is anticipated (\Rcmd{bty = "n"}).
\begin{figure}  
\begin{center}
<<DAGD-USmelanoma-lat, echo = TRUE, fig = TRUE>>=
plot(mortality ~ latitude, data = USmelanoma, 
     pch = (1:2)[ocean], ylab = "Mortality", 
     xlab = "Latitude")
legend("topright", legend = c("Land state", "Coast state"), 
       pch = 1:2, bty = "n")
@
\caption{Scatterplot of malignant melanoma mortality rates against latitude.
         \label{DAGD-USmelanoma-lat}}
\end{center}
\end{figure}
The scatterplot in Figure~\ref{DAGD-USmelanoma-lat} highlights that
the mortality is lowest in the northern land states. Coastal states show
a higher mortality than land states at roughly the same latitude. The highest
mortalities can be observed for the south coastal states with latitude less than
$32^\circ$, say, that is
<<DAGD-USmelanoma-south, echo = TRUE>>=
subset(USmelanoma, latitude < 32)
@


Alternatively, we also may simply want to look at a color-coded map of the United States, where
each state is plotted in a color that corresponds to its mortality rate. It is fairly simple
to set-up such a plot using the \Rpackage{sp} family of packages \citep{PKG:sp}. We start with
loading a map of the mainland states, basically a number of polygons:
<<DAGD-USmelanoma-long-lat-data, echo = TRUE>>=
library("sp")
library("sf")
library("maps")
states <- map("state", plot = FALSE, fill = TRUE)
@
It is of course important to match the mortality rates to the corresponding
state. We therefore create unique names of the states in lower-case letters for
both the polygons and the mortality data
<<DAGD-USmelanoma-long-lat-names, echo = TRUE>>=                        
IDs <- sapply(strsplit(states$names, ":"), function(x) x[1])
rownames(USmelanoma) <- tolower(rownames(USmelanoma))
@
Now we are ready to merge these two objects into a so-called \Rclass{SpatialPolygonsDataFrame}
object. We first create a \Rclass{SpatialPolygons} object from the map in the
correct reference system (WGS84, in our case) and then merge the polygons with the data
<<DAGD-USmelanoma-long-lat-sp, echo = TRUE>>=          
us1 <- merge(st_as_sf(states), USmelanoma)
us2 <- as(us1, "Spatial")
@
The resulting object \Robject{us2} can now be plotted using the
\Rcmd{spplot} function, see Figure~\ref{DAGD-USmelanoma-long-lat}.  The
colors correspond to the mortality rate, as shown in the color legend to the
right of the map.  We see that darker grey values corresponding to higher
mortality rates appear in the southern costal states, both on the east and the west coast
in good agreement with our earlier results.

\begin{figure}  
\begin{center}
<<DAGD-USmelanoma-long-lat, echo = TRUE, fig = TRUE, height = 4, pdf = FALSE, png = TRUE>>=
spplot(us2, "mortality", col.regions = rev(grey.colors(100)))
@
\caption{Map of the United States of America showing 
         malignant melanoma mortality rates.
         \label{DAGD-USmelanoma-long-lat}}
\end{center}
\end{figure}

Up to now we have primarily focused on the visualization of 
continuous variables. We now extend our focus to the visualization
of categorical variables.

\index{Boxplot|)}
\index{Histogram|)}
\index{Scatterplot|)}


\subsection{Chinese Health and Family Life}


\index{Barchart|(}
\index{Spineplot|(}
\index{Spinogram|(}
One part of the questionnaire the Chinese Health and Family Life
Survey focuses on is the self-reported health status. Two
questions are interesting for us. The first one is `Generally speaking,
do you consider the condition of your health to be excellent,
good, fair, not good, or poor?'.
The second question is `Generally speaking, in the past twelve months,
how happy were you?'. The distribution of such variables is commonly
visualized using barcharts where for each category the
total or relative number of observations is displayed. 
Such a barchart can conveniently be produced by applying the
\Rcmd{barplot} function to a tabulation of the data. The
empirical density of the variable \Robject{R\_happy}
is computed by the \Rcmd{xtabs} function for producing
(contingency) tables; the resulting barchart is given
in Figure~\ref{DAGD-CHFLS-happy}.

\begin{figure}
<<DAGD-CHFLS-happy, echo = TRUE, fig = TRUE, width = 8>>=
barplot(xtabs(~ R_happy, data = CHFLS))
@
\caption{Bar chart of happiness. \label{DAGD-CHFLS-happy}}
\end{figure}

The visualization of two categorical variables could be 
done by conditional barcharts, i.e., barcharts of the
first variable within the categories of the second variable.
An attractive alternative for displaying such two-way tables
are \stress{spineplots} \citep{HSAUR:Friendly1994,HSAUR:HofmannTheus2005,HSAUR:Chenetal2008};
the meaning of the name will become clear
when looking at such a plot in Figure~\ref{DAGD-CHFLS-health_happy}.

Before constructing such a plot, we produce a two-way table of the health status
and self-reported happiness using the \Rcmd{xtabs} function:
<<DAGD-CHFLS-health_happy_xtabs, echo = TRUE>>=
xtabs(~ R_happy + R_health, data = CHFLS)
@
<<DAGD-CHFLS-health_happy_xtabs2, echo = FALSE>>=
hh <- xtabs(~ R_health + R_happy, data = CHFLS)
@

A \stress{spineplot} is a group of rectangles, each representing
one cell in the two-way contingency table. The area of the
rectangle is proportional with the number of observations 
in the cell. Here, we produce a mosaic plot of health status and happiness
in Figure~\ref{DAGD-CHFLS-health_happy}.
\begin{figure}
<<DAGD-CHFLS-health_happy, echo = TRUE, fig = TRUE, width = 8, height = 8>>=
plot(R_happy ~ R_health, data = CHFLS, ylab = "Happiness", 
     xlab = "Health")
@
\caption{Spineplot of health status and happiness. 
         \label{DAGD-CHFLS-health_happy}}
\end{figure}

Consider the right upper cell in Figure~\ref{DAGD-CHFLS-health_happy}, i.e.,
the $\Sexpr{hh["Excellent", "Very happy"]}$ very happy women with
excellent health status. The width of the right-most bar corresponds
to the frequency of women with excellent health status. The length 
of the top-right rectangle corresponds 
to the conditional frequency of very happy women given their health status is
excellent. Multiplying these two quantities gives the area of this
cell which corresponds to the frequency of women who are both
very happy and enjoy an excellent health status. The conditional
frequency of very happy women increases with increasing health status, whereas
the conditional frequency of very unhappy or not too happy women decreases.

When the association of a categorical and a continuous variable
is of interest, say the monthly income and self-reported happiness,
one might use parallel boxplots to visualize the distribution
of the income depending on happiness. If we were studying self-reported
happiness as response and income as independent variable, however, 
this would give a representation of the conditional distribution
of income given happiness, but we are interested in the 
conditional distribution of happiness given income.
One possibility to produce a more appropriate plot
is called \stress{spinogram}. Here, the continuous $x$-variable is
categorized first. Within each of these categories, the conditional
frequencies of the response variable are given by stacked barcharts, 
in a way similar to spineplots. For happiness depending
on log-income (since income is naturally skewed we use a 
log-transformation of the income) 
it seems that the proportion of unhappy and not too
happy women decreases with increasing income whereas the proportion
of very happy women stays rather constant. In contrast
to spinograms, where bins, as in a histogram, are given
on the $x$-axis, a \stress{conditional density plot} uses
the original $x$-axis for a display of the
conditional density of the categorical response given
the independent variable.

\begin{figure}
<<DAGD-CHFLS-happy_income, echo = TRUE, fig = TRUE, width = 8, height = 5>>=
layout(matrix(1:2, ncol = 2))
plot(R_happy ~ log(R_income + 1), data = CHFLS, 
     ylab = "Happiness", xlab = "log(Income + 1)")
cdplot(R_happy ~ log(R_income + 1), data = CHFLS, 
       ylab = "Happiness", xlab = "log(Income + 1)")

@
\caption{Spinogram (left)
         and conditional density plot (right) of happiness depending on log-income.
         \label{DAGD-CHFLS-happy_income}}
\end{figure}

\index{Barchart|)}
\index{Spineplot|)}
\index{Spinogram|)}

\index{Trellis plot|(}
For our last example we return to scatterplots for inspecting
the association between a woman's monthly income and the
income of her partner. Both income variables have been computed
and partially imputed from other self-reported variables and
are only rough assessments of the real income. Moreover, the 
data itself is numeric but heavily tied, making it difficult to
produce `correct' scatterplots because points will overlap.
A relatively easy trick is to jitter the observation
by adding a small random noise to each point in order to
avoid overlapping plotting symbols. In addition, we want to
study the relationship between both monthly incomes conditional
on the woman's education. Such conditioning plots are called
\stress{trellis} plots and are implemented in the package 
\Rpackage{lattice} \citep{PKG:lattice, HSAUR:Sarkar2008}.
We utilize the \Rcmd{xyplot} function from package \Rpackage{lattice}
to produce a scatterplot. The formula reads as already explained with
the exception that a third \stress{conditioning} variable, \Robject{R\_edu}
in our case, is present. For each level of education, a separate 
scatterplot will be produced. The plots are directly comparable since
the axes remain the same for all plots. 

\begin{figure}
<<DAGD-CHFLS-RAincome3, echo = TRUE, eval = FALSE, pdf = FALSE, png = TRUE>>=
library("lattice")
xyplot(jitter(log(R_income + 0.5)) ~ 
       jitter(log(A_income + 0.5)) | R_edu, data = CHFLS,
       pch = 19, col = rgb(.1, .1, .1, .1), 
       ylab = "log(Wife's income + .5)",
       xlab = "log(Husband's income + .5)")
@
<<DAGD-CHFLS-RAincome3, echo = FALSE, fig = TRUE, width = 8, pdf = FALSE, png = TRUE>>=
library("lattice")
trellis.par.set(list(plot.symbol = list(col=1,pch=20, cex=0.7),
                     box.rectangle = list(col=1),
                     plot.line = list(col = 1, lwd = 1),
                     box.umbrella = list(lty=1, col=1),
                     strip.background = list(col = "white")))
ltheme <- canonical.theme(color = FALSE)     ## in-built B&W theme
ltheme$strip.background$col <- "transparent" ## change strip bg
lattice.options(default.theme = ltheme)
xyplot(jitter(log(R_income + 0.5)) ~ jitter(log(A_income + 0.5)) | R_edu, data = CHFLS,
             pch = 19, col = rgb(.1, .1, .1, .1), ylab = "log(Wife's income + .5)", 
             xlab = "log(Husband's income + .5)")
@
\caption{Scatterplot of jittered log-income of wife and husband, conditional on the wife's education.
         \label{DAGD-CHFLS-RAincome3}}
\end{figure}

The plot shown in Figure~\ref{DAGD-CHFLS-RAincome3} reveals several
interesting issues.  Some observations are positioned on a straight line
with slope one, most probably an artifact of missing value imputation by
linear models (as described in the data dictionary, see the documentation
\texttt{?CHFLS}).  Four constellations can be identified: both partners have
zero income, the partner has no income, the woman has no income or both
partners have a positive income.

For couples where the woman has a university degree, the income of
both partners is relatively high (except for two couples where only
the woman has income). A small number of former junior college students
live in relationships where only the man has income, the income
of both partners seems only slightly positively correlated for the
remaining couples. For lower levels of education, all four constellations
are present. The frequency of couples where only the man has some income
seems larger than the other way around. Ignoring the observations
on the straight line, there is almost no association between the income
of both partners.
\index{Trellis plot|)}

\section{Summary of Findings}

Using relatively straightforward graphical techniques only on the two sets
of data considered in this chapter we have been able to uncover a number of
important features of each data set; 
\begin{description}
\item[Melanoma mortality]
Mortality is related
only to the latitude of a state not to its longitude, mortality is higher
for costal states than for land states, and the highest mortality is observed in
the south costal states with latitude less than 32 degrees.
\item[Health and family life]
We saw that happiness depends on health status. Women reported to be very
happy more often when they also reported a good or excellent health status. 
The dependency of happiness on the income of the women seems to be less
clear, but we conclude that, conditional on education, the income of wives
and their husbands is highly correlated.
\end{description}

\section{Final Comments}

Producing publication-quality graphics is one of the major strengths
of the \R{} system and almost anything is possible since graphics
are programmable in \R{}. Naturally, this chapter can be only a very
brief introduction to some commonly used displays and the reader is
referred to specialized books, most important 
\cite{HSAUR:Murrell2005}, \cite{HSAUR:Sarkar2008}, and
\cite{HSAUR:Chenetal2008}. Interactive 3D-graphics are available
from package \Rpackage{rgl} \citep{PKG:rgl}.


\section*{Exercises}

\begin{description}

\exercise 
The data in Table~\ref{DAGD-household-tab} are part of a data set collected 
from a survey of household expenditure and give the expenditure of $20$ single men 
and $20$ single women on four commodity groups. The units of expenditure are 
Hong Kong dollars, and the four commodity groups are
\begin{description}
\item[\Robject{housing}] housing, including fuel and light,
\item[\Robject{food}] foodstuffs, including alcohol and tobacco,
\item[\Robject{goods}] other goods, including clothing, footwear, and durable goods,
\item[\Robject{service}] services, including transport and vehicles.
\end{description}
The aim of the survey was to investigate how the division of household 
expenditure between the four commodity groups depends on total expenditure 
and to find out whether this relationship differs for men and women.
Use appropriate graphical methods to answer these questions
and state your conclusions.

<<DAGD-household-tab, echo = FALSE, results = tex>>=
data("household", package = "HSAUR3")
toLatex(HSAURtable(household), 
  caption = paste("Household expenditure for single men and women."),
  label = "DAGD-household-tab")
@

\exercise 
The data set shown in Table~\ref{DAGD-USstates-tab} contains values 
of seven variables for ten states in the US. The seven variables are
\begin{description}
\item[\Robject{Population}] population size divided by $1000$,
\item[\Robject{Income}] average per capita income,
\item[\Robject{Illiteracy}] illiteracy rate (\% population),
\item[\Robject{Life.Expectancy}] life expectancy (years),
\item[\Robject{Homicide}] homicide rate (per $1000$),
\item[\Robject{Graduates}] percentage of high school graduates,
\item[\Robject{Freezing}] average number of days per below freezing.
\end{description}
With these data
\begin{enumerate}
\item Construct a scatterplot matrix of the data labeling the 
      points by state name (using function \Rcmd{text}).
\item Construct a plot of life expectancy and homicide rate 
      conditional on average per capita income.
\end{enumerate}

\begin{sidewaystable}
\vspace*{12.5cm}
\begin{center}
<<DAGD-USstates-tab, echo = FALSE, results = tex>>=
data("USstates", package = "HSAUR3")
toLatex(HSAURtable(USstates), 
  caption = paste("Socio-demographic variables for ten US states."),
  label = "DAGD-USstates-tab")
@
\end{center}
\end{sidewaystable}

\exercise 
Mortality rates per $100,000$ from male suicides for a number of 
age groups and a number of countries are given in Table~\ref{DAGD-suicides2-tab}. 
Construct side-by-side box plots for the data from different age 
groups, and comment on what the graphic tells us about the data.

<<DAGD-suicides2-tab, echo = FALSE, results = tex>>=
data("suicides2", package = "HSAUR3")
toLatex(HSAURtable(suicides2), 
  caption = paste("Mortality rates per $100,000$ from male suicides."),
  label = "DAGD-suicides2-tab", rownames = TRUE)
@

\exercise
\cite{HSAUR:FluryRiedwyl1988} report data that give various length 
measurements on $200$ Swiss bank notes. The data are available
from package \Rpackage{mclust} \citep{PKG:mclust}; a sample of 
ten bank notes is given in Table~\ref{DAGD-banknote-tab}.

<<DAGD-banknote-tab, echo = FALSE, results = tex>>=
data("banknote", package = "mclust")
banknote$Status <- NULL
banknote <- banknote[c(1:5, 101:200),]
toLatex(HSAURtable(banknote, pkg = "mclust", nrow = 10),
  caption = paste("Swiss bank note data."),
  label = "DAGD-banknote-tab", rownames = FALSE)
@	
Use whatever graphical techniques you think are appropriate
to investigate whether there is any `pattern'
or structure in the data. Do you observe something suspicious?

\exercise
The data in Table~\ref{DAGD-birds-tab} were originally derived from a study
reported in \cite{HSAUR:Vuilleumier1970} which investigated numbers of bird
species in isolated `islands' of paramo vegetation in the northern Andes. 
The aim of the study was to investigate how the number of species (\Robject{N}) is related to four
other variables, \Robject{AR} (area of `island' in thousands of square km), \Robject{EL}
(elevation in thousands of m), \Robject{Dec} (distance from Ecuador in km) and \Robject{DNI}
(distance to the nearest `island' in km).  Begin by constructing a
scatterplot matrix of the data differentiating the islands on each panel by
a different plotting symbol and on each diagonal panel showing the histogram
of the associated variable.  What can you conclude from this plot about how
N is related to the other four variables?

<<DAGD-birds-tab, echo = FALSE, results = tex>>= 
data("birds", package = "HSAUR3")
toLatex(HSAURtable(birds), 
  caption = paste("Birds in paramo vegetation."), label = "DAGD-birds-tab",
  rownames = TRUE)
@       

\end{description}

\bibliographystyle{LaTeXBibTeX/refstyle}
\bibliography{LaTeXBibTeX/HSAUR}
\end{document}

\documentclass{chapman}

%%% copy Sweave.sty definitions

%%% keeps `sweave' from adding `\usepackage{Sweave}': DO NOT REMOVE
%\usepackage{Sweave} 


\RequirePackage[T1]{fontenc}
\RequirePackage{graphicx,ae,fancyvrb}
\IfFileExists{upquote.sty}{\RequirePackage{upquote}}{}
\usepackage{relsize}

\DefineVerbatimEnvironment{Sinput}{Verbatim}{}
\DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                              fontshape=it,
                                              fontsize=\relsize{-1}}
\DefineVerbatimEnvironment{Scode}{Verbatim}{}
\newenvironment{Schunk}{}{}

%%% environment for raw output
\newcommand{\SchunkRaw}{\renewenvironment{Schunk}{}{}
    \DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                                  fontshape=it,
                                                  fontsize=\small}
    \rawSinput
}

%%% environment for labeled output
\newcommand{\nextcaption}{}
\newcommand{\SchunkLabel}{
  \renewenvironment{Schunk}{\begin{figure}[ht] }{\caption{\nextcaption}
  \end{figure} }
  \DefineVerbatimEnvironment{Sinput}{Verbatim}{frame = topline}
  \DefineVerbatimEnvironment{Soutput}{Verbatim}{frame = bottomline, 
                                                samepage = true,
                                                fontfamily=courier,
                                                fontshape=it,
                                                fontsize=\relsize{-1}}
}


%%% S code with line numbers
\DefineVerbatimEnvironment{Sinput}
{Verbatim}
{
%%  numbers=left
}

\newcommand{\numberSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{numbers=left}
}
\newcommand{\rawSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{}
}


%%% R / System symbols
\newcommand{\R}{\textsf{R}}
\newcommand{\rR}{{R}}
\renewcommand{\S}{\textsf{S}}
\newcommand{\SPLUS}{\textsf{S-PLUS}}
\newcommand{\rSPLUS}{{S-PLUS}}
\newcommand{\SPSS}{\textsf{SPSS}}
\newcommand{\EXCEL}{\textsf{Excel}}
\newcommand{\ACCESS}{\textsf{Access}}
\newcommand{\SQL}{\textsf{SQL}}
%%\newcommand{\Rpackage}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Robject}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\Rclass}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Rcmd}[1]{\hbox{\rm\texttt{#1}}}
\newcommand{\Rpackage}[1]{\index{#1 package@{\fontseries{b}\selectfont #1} package} {\fontseries{b}\selectfont #1}}
\newcommand{\rpackage}[1]{{\fontseries{b}\selectfont #1}}
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\Rclass}[1]{\index{#1 class@\textit{#1} class}\textit{#1}}
\newcommand{\Rcmd}[1]{\index{#1 function@\texttt{#1} function}\texttt{#1}}
\newcommand{\Roperator}[1]{\texttt{#1}}
\newcommand{\Rarg}[1]{\texttt{#1}}
\newcommand{\Rlevel}[1]{\texttt{#1}}


%%% other symbols
\newcommand{\file}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\stress}[1]{\index{#1}\textit{#1}} 
\newcommand{\stress}[1]{\textit{#1}} 
\newcommand{\booktitle}[1]{\textit{#1}} %%'

%%% Math symbols
\usepackage{amstext}
\usepackage{amsmath}
\newcommand{\E}{\mathsf{E}}   
\newcommand{\Var}{\mathsf{Var}}   
\newcommand{\Cov}{\mathsf{Cov}}   
\newcommand{\Cor}{\mathsf{Cor}}   
\newcommand{\x}{\mathbf{x}}   
\newcommand{\y}{\mathbf{y}}   
\renewcommand{\a}{\mathbf{a}}
\newcommand{\W}{\mathbf{W}}   
\newcommand{\C}{\mathbf{C}}   
\renewcommand{\H}{\mathbf{H}}   
\newcommand{\X}{\mathbf{X}}   
\newcommand{\B}{\mathbf{B}}   
\newcommand{\V}{\mathbf{V}}   
\newcommand{\I}{\mathbf{I}}   
\newcommand{\D}{\mathbf{D}}   
\newcommand{\bS}{\mathbf{S}}   
\newcommand{\N}{\mathcal{N}}   
\renewcommand{\L}{L}   
\renewcommand{\P}{\mathsf{P}}   
\newcommand{\K}{\mathbf{K}}
\newcommand{\m}{\mathbf{m}}
\newcommand{\argmin}{\operatorname{argmin}\displaylimits}
\newcommand{\argmax}{\operatorname{argmax}\displaylimits}

\newcommand{\bx}{\mathbf{x}}
\newcommand{\bbeta}{\mathbf{\beta}}


%%% links
\usepackage{hyperref}

\hypersetup{%
  pdftitle = {A Handbook of Statistical Analyses Using R (3rd Edition)},
  pdfsubject = {Book},
  pdfauthor = {Torsten Hothorn and Brian S. Everitt},
  colorlinks = {black},
  linkcolor = {black},
  citecolor = {black},
  urlcolor = {black},
  hyperindex = {true},
  linktocpage = {true},
}


%%% captions & tables
%% <FIXME>: conflics with figure definition in chapman.cls
%%\usepackage[format=hang,margin=10pt,labelfont=bf]{caption}
%% </FIMXE>
\usepackage{longtable}
\usepackage[figuresright]{rotating}

%%% R symbol in chapter 1
\usepackage{wrapfig}

%%% Bibliography
\usepackage[round,comma]{natbib}
\renewcommand{\refname}{References \addcontentsline{toc}{chapter}{References}}
\citeindexfalse

%%% texi2dvi complains that \newblock is undefined, hm...
\def\newblock{\hskip .11em plus .33em minus .07em}

%%% Example sections
\newcounter{exercise}[chapter]
\setcounter{exercise}{0}
\newcommand{\exercise}{\stepcounter{exercise} \item{Ex.~\arabic{chapter}.\arabic{exercise} }}


%% URLs
\newcommand{\curl}[1]{\begin{center} \url{#1} \end{center}}

%%% for manual corrections
%\renewcommand{\baselinestretch}{2}

%%% plot sizes
\setkeys{Gin}{width=0.95\textwidth}

%%% color
\usepackage{color}

%%% hyphenations
\hyphenation{drop-out}
\hyphenation{mar-gi-nal}

%%% new bidirectional quotes need 
\usepackage[utf8]{inputenc}

%\usepackage{setspace}
\definecolor{sidebox_todo}{rgb}{1,1,0.2}
\newcommand{\todo}[1]{
        \hspace{0pt}%
        \marginpar{% 
                        \fcolorbox{black}{sidebox_todo}{%
                                \parbox{\marginparwidth} {

\raggedright\sffamily\footnotesize{TODO: #1}%
                                }
                        }%
        }
}
\begin{document}

%% Title page

\title{A Handbook of Statistical Analyses Using \R{} --- 3rd Edition}

\author{Torsten Hothorn and Brian S. Everitt}

\maketitle
%%\VignetteIndexEntry{Chapter Simultaneous Inference and Multiple Comparisons}
%%\VignetteDepends{lme4,multcomp,coin,sandwich}
\setcounter{chapter}{14}


\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE} 

<<setup, echo = FALSE, results = hide>>=
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })
@

\pagestyle{headings}
<<singlebook, echo = FALSE>>=
book <- FALSE
@

<<SIMC-setup, echo = FALSE, results = hide>>=
library("multcomp")
library("coin")
library("sandwich")
library("lme4")
@

\chapter[Simultaneous Inference and Multiple Comparisons]{Simultaneous Inference 
    and Multiple Comparisons: Genetic Components of Alcoholism, 
    Deer Browsing Intensities, and Cloud Seeding \label{SIMC}}

\section{Introduction}


\section{Simultaneous Inference and Multiple Comparisons}


\section{Analysis Using \R{}}

\subsection{Genetic Components of Alcoholism}

We start with a graphical display of the data. Three parallel boxplots
shown in Figure~\ref{SIMC-alpha-data-figure} indicate increasing
expression levels of alpha synuclein mRNA for longer \textit{NACP}-REP1 alleles.

%%\setkeys{Gin}{width=0.6\textwidth}
\begin{figure}[t]
\begin{center}
<<SIMC-alpha-data-figure, echo = TRUE, fig = TRUE, width = 7, height = 5>>=
n <- table(alpha$alength)
levels(alpha$alength) <- abbreviate(levels(alpha$alength), 4)
plot(elevel ~ alength, data = alpha, varwidth = TRUE,
     ylab = "Expression Level", 
     xlab = "NACP-REP1 Allele Length")
axis(3, at = 1:3, labels = paste("n = ", n))
@
\caption{Distribution of levels of expressed alpha synuclein mRNA
         in three groups defined by the \textit{NACP}-REP1 allele lengths.
         \label{SIMC-alpha-data-figure}}
\end{center}
\end{figure}

\index{Tukey honest significant differences|(}
In order to model this relationship, we start fitting a simple one-way ANOVA 
model of the form
$y_{ij} = \mu + \gamma_i + \varepsilon_{ij}$
to the data with independent normal errors $\varepsilon_{ij} \sim \N(0, \sigma^2)$, 
$j \in \{\text{short}, \text{intermediate}, \text{long}\}$, and  
$i = 1, \dots, n_j$. The parameters
$\mu + \gamma_\text{short}$, $\mu + \gamma_\text{intermediate}$ and $\mu + \gamma_\text{long}$
can be interpreted as the mean expression levels in the corresponding groups.
As already discussed in \Sexpr{ch("ANOVA")}, this
model description is overparameterized. A standard approach is to consider a 
suitable re-parameterization. The so-called ``treatment contrast'' vector $%
\theta = (\mu, \gamma_\text{intermediate} - \gamma_\text{short}, \gamma_\text{long} - 
\gamma_\text{short})$ (the default re-parameterization used as  
elemental parameters in \R{}) is one possibility and is equivalent to imposing the restriction 
$\gamma_\text{short} = 0$.

In addition, we define all comparisons among our three groups by
choosing $\K$ such that $\K \theta$ contains all three 
group differences (Tukey's all-pairwise comparisons): %%'
\begin{eqnarray*}
\K_\text{Tukey} = \left(
\begin{array}{rrr}
0 & 1 & 0 \\%% 
0 & 0 & 1 \\%% 
0 & -1 & 1%  
\end{array}  
\right)
\end{eqnarray*}
with parameters of interest
\begin{eqnarray*}
\vartheta_\text{Tukey} = \K_\text{Tukey} \theta = 
(\gamma_\text{intermediate} - \gamma_\text{short}, \gamma_\text{long} - \gamma_\text{short},
\gamma_\text{long} - \gamma_\text{intermediate}).
\end{eqnarray*}

The function \Rcmd{glht} (for generalized linear hypothesis) from package \Rpackage{multcomp} 
\citep{PKG:multcomp,HSAUR:HothornBretzWestfall2008}
takes the fitted \Rclass{aov} object and a description of the matrix 
$\K$. Here, we use the \Rcmd{mcp} function to set up the matrix 
of all pairwise differences for the model parameters associated
with factor \Robject{alength}:
<<SIMC-alpha-aov-tukey, echo = TRUE>>=
library("multcomp")
amod <- aov(elevel ~ alength, data = alpha)
amod_glht <- glht(amod, linfct = mcp(alength = "Tukey"))
@
The matrix $\K$ reads
<<SIMC-alpha-aov-tukey-K, echo = TRUE>>=
amod_glht$linfct
@
The \Robject{amod\_glht} object now contains information
about the estimated linear function $\hat{\vartheta}$ and 
their covariance matrix which can be inspected
via the \Rcmd{coef} and \Rcmd{vcov} methods:
<<SIMC-alpha-aov-coefvcov, echo = TRUE>>=
coef(amod_glht)
vcov(amod_glht)
@
The \Rcmd{summary}
and \Rcmd{confint} methods can be used to compute a
summary statistic including adjusted $p$-values and 
simultaneous confidence intervals, respectively:
<<SIMC-alpha-aov-results, echo = TRUE>>=
confint(amod_glht)
summary(amod_glht)
@

Because of the variance heterogeneity 
that can be observed in Figure~\ref{SIMC-alpha-data-figure}, one might be concerned 
with the validity of the above results stating that there
is no difference between any combination of the three
allele lengths. A sandwich estimator
might be more appropriate in this situation, and
the \Rarg{vcov} argument can be used
to specify a function to compute some alternative 
covariance estimator as follows:
<<SIMC-aov-tukey-sandwich, echo = TRUE>>=
amod_glht_sw <- glht(amod, linfct = mcp(alength = "Tukey"), 
                     vcov = sandwich)
summary(amod_glht_sw)
@
We use the \Rcmd{sandwich} function from package \Rpackage{sandwich}
\citep{PKG:sandwich, HSAUR:Zeileis2006} which provides us with a 
heteroscedasticity-consistent estimator of the covariance matrix.
This result is more in line with previously published findings
for this study
obtained from non-parametric test procedures such as the
Kruskal-Wallis test. A comparison of the simultaneous 
confidence intervals calculated based on the ordinary and
sandwich estimator is given in Figure~\ref{SIMC-alpha-confint-plot}.

%%\setkeys{Gin}{width=0.95\textwidth}
\begin{figure}[h]
\begin{center}
<<SIMC-alpha-confint-plot, echo = TRUE, fig = TRUE, width = 8, height = 3.5>>=
par(mai = par("mai") * c(1, 2.1, 1, 0.5))
layout(matrix(1:2, ncol = 2))
ci1 <- confint(glht(amod, linfct = mcp(alength = "Tukey")))
ci2 <- confint(glht(amod, linfct = mcp(alength = "Tukey"), 
               vcov = sandwich))
ox <- expression(paste("Tukey (ordinary ", bold(S)[n], ")"))
sx <- expression(paste("Tukey (sandwich ", bold(S)[n], ")"))
plot(ci1, xlim = c(-0.6, 2.6), main = ox, 
    xlab = "Difference", ylim = c(0.5, 3.5))
plot(ci2, xlim = c(-0.6, 2.6), main = sx, 
    xlab = "Difference", ylim = c(0.5, 3.5))
@
\caption{Simultaneous confidence intervals for the \Robject{alpha} data based
    on the ordinary covariance matrix (left) and a sandwich estimator (right). 
    \label{SIMC-alpha-confint-plot}}
\end{center}
\end{figure}

It should be noted that this data set is heavily unbalanced;
see Figure~\ref{SIMC-alpha-data-figure}, and therefore the results
obtained from function \Rcmd{TukeyHSD} might be less accurate.
\index{Tukey honest significant differences|)}

\subsection{Deer Browsing}

\index{Generalized linear mixed model|(}
Since we have to take the spatial structure of the deer browsing data into account, we
cannot simply use a logistic regression model as introduced in \Sexpr{ch("GLM")}.
One possibility is to apply a mixed logistic regression model 
\citep[using package \Rpackage{lme4},][]{PKG:lme4}
with random intercept accounting for the spatial variation
of the trees. These models have already been discussed in \Sexpr{ch("ALDII")}.
For each plot nested within a set of five plots
oriented on a 100m transect (the location of the transect  
is determined by a predefined equally spaced lattice of the area under test),
a random intercept is included in the model. Essentially,
trees that are close to each other are handled like repeated
measurements in a longitudinal analysis. We are interested
in probability estimates and confidence intervals for each tree species.
Each of the five fixed parameters of the model corresponds to one species 
(in absence of a global intercept term);
therefore, $\K = \text{diag}(5)$ is the linear function we are interested
in:
<<SIMC-trees-setup, echo = FALSE, results = hide>>=
trees513 <- subset(trees513, !species %in% c("fir", "ash/maple/elm/lime", "softwood (other)"))
trees513$species <- trees513$species[,drop = TRUE]
levels(trees513$species)[nlevels(trees513$species)] <- "hardwood"
@
 
<<SIMC-trees-lmer, echo = TRUE>>=
mmod <- glmer(damage ~ species - 1 + (1 | lattice / plot),
              data = trees513, family = binomial())
K <- diag(length(fixef(mmod)))
K
@
In order to help interpretation, the names of the tree species
and the corresponding sample sizes (computed via \Rcmd{table}) 
are added to $\K$ as row names; this
information will carry through all subsequent steps of our analysis:
<<SIMC-trees-K, echo = TRUE>>=
colnames(K) <- rownames(K) <- 
    paste(gsub("species", "", names(fixef(mmod))),
          " (", table(trees513$species), ")", sep = "")
K
@
Based on $\K$, we first compute simultaneous confidence intervals
for $\K \theta$ and transform these into probabilities.
Note that $\left(1 + \exp(- \hat{\vartheta})\right)^{-1}$ (cf.~Equation~\ref{GLM:logitexp})
is the vector of estimated probabilities;
simultaneous confidence intervals can be transformed to the probability
scale in the same way:
<<SIMC-trees-ci, echo = TRUE>>=
ci <- confint(glht(mmod, linfct = K))
ci$confint <- 1 - binomial()$linkinv(ci$confint)
ci$confint[,2:3] <- ci$confint[,3:2]
@
The result is shown in Figure~\ref{SIMC-trees-plot}. Browsing
is more frequent in hardwood but especially small oak trees are severely
at risk.  Consequently, the local authorities increased the number of roe deers
to be harvested in the following years.
%%The large confidence interval for ash, maple, elm and lime
%%trees is caused by the small sample size.

%%\setkeys{Gin}{width=0.8\textwidth}
\begin{figure}[t]
\begin{center}   
<<SIMC-trees-plot, echo = TRUE, bigleftpar = TRUE, fig = TRUE, width = 7, height = 4.5>>=
plot(ci, xlab = "Probability of Damage Caused by Browsing", 
     xlim = c(0, 0.5), main = "", ylim = c(0.5, 5.5))
@
\caption{Probability of damage caused by roe deer browsing
   for five tree species. Sample sizes are given in brackets. \label{SIMC-trees-plot}}
\end{center}
\end{figure}
\index{Generalized linear mixed model|)}

\subsection{Cloud Seeding}

\index{Confidence band|(}
In \Sexpr{ch("MLR")} we studied the dependency of 
rainfall on S-Ne values by means of linear models. Because the number of observations 
is small, an additional assessment of the variability of the fitted regression
lines is interesting. Here, we are interested in a confidence band around
some estimated regression line, i.e., a confidence region which covers the
true but unknown regression line with probability greater or equal 
$1 - \alpha$. It is straightforward to compute \stress{pointwise} 
confidence intervals but we have to make sure that the type I error
is controlled for all $x$ values simultaneously. Consider the simple
linear regression model
\begin{eqnarray*}
\text{rainfall}_i = \beta_0 + \beta_1 \text{sne}_i + \varepsilon_i
\end{eqnarray*}
where we are interested in a confidence band for the predicted rainfall, i.e.,
the values $\hat{\beta}_0 + \hat{\beta}_1 \text{sne}_i$ for some observations 
$\text{sne}_i$. (Note that the estimates $\hat{\beta}_0$ and $\hat{\beta}_1$
are random variables.)

We can formulate the problem as a linear combination of the
regression coefficients by multiplying a matrix $\K$ to a grid of S-Ne values 
(ranging from $1.5$ to $4.5$, say) from the left to the elemental 
parameters $\theta = (\beta_0, \beta_1)$:
\begin{eqnarray*}
\K \theta = \left(
\begin{array}{rr}
1 & 1.50  \\%% 
1 & 1.75  \\%%    
\vdots & \vdots \\%%
1 & 4.25 \\%%
1 & 4.50 %
\end{array}  
\right)\theta = (\beta_0 + \beta_1 1.50, \beta_0 + \beta_1 1.75, \dots, \beta_0 + \beta_1 4.50) = \vartheta.
\end{eqnarray*}
Simultaneous confidence intervals for all the parameters of interest $\vartheta$ form
a confidence band for the estimated regression line. We implement this idea
for the \Robject{clouds} data writing a small reusable function as follows:
<<SIMC-clouds-confband, echo = TRUE>>=
confband <- function(subset, main) {
    mod <- lm(rainfall ~ sne, data = clouds, subset = subset)
    sne_grid <- seq(from = 1.5, to = 4.5, by = 0.25)
    K <- cbind(1, sne_grid)
    sne_ci <- confint(glht(mod, linfct = K))
    plot(rainfall ~ sne, data = clouds, subset = subset,
         xlab = "S-Ne criterion", main = main, 
         xlim = range(clouds$sne), 
         ylim = range(clouds$rainfall))
    abline(mod)
    lines(sne_grid, sne_ci$confint[,2], lty = 2)
    lines(sne_grid, sne_ci$confint[,3], lty = 2)
}
@
The function \Rcmd{confband} basically fits a linear model using \Rcmd{lm}
to a subset of the data, sets up the matrix $\K$ as shown above and nicely
plots both the regression line and the confidence band. Now, this
function can be reused to produce plots similar to Figure~\ref{MLR-clouds-lmplot}
separately for days with and without cloud seeding in Figure~\ref{SIMC-clouds-lmplot}.
For the days without seeding, there is more uncertainty about the true regression
line compared to the days with cloud seeding. Clearly, this is caused by the larger
variability of the observations in the left part of the figure.

\begin{figure}
\begin{center}
<<SIMC-clouds-lmplot, echo = TRUE, fig = TRUE, height = 4>>=
layout(matrix(1:2, ncol = 2))
confband(clouds$seeding == "no", main = "No seeding")
confband(clouds$seeding == "yes", main = "Seeding")
@
\caption{Regression relationship between S-Ne criterion and rainfall with
and without seeding. The confidence bands cover the area within the dashed curves. 
\label{SIMC-clouds-lmplot}}
\end{center}
\end{figure}
\index{Confidence band|)}

\section{Summary of Findings}

\begin{description}
\item[Genetic components of alcoholism]
We were interested in studying all pairwise differences in expression levels
for three groups of subjects defined by allele length.  Overall, there seem
to be different expression levels for short and long alleles but no
difference between these two groups and the intermediate group.
\item[Deer browsing]
For a number of tree species, the simultaneous confidence intervals
for the probability of browsing damage show that there is rather precise
information about browsing damage for spruce and pine with more variability for
the broad-leaf species. For oak, more than $\Sexpr{round(ci$confint["oak (1258)", 2], 2)}\%$
of the trees are damaged.
\item[Cloud seeding]
Confidence bands for the estimated effects help to identify days where the uncertainty about 
rainfall is largest.
\end{description}


\section{Final Comments}

Multiple comparisons in linear models have been in use for a long time. The
\Rpackage{multcomp} package extends much of the theory to a broad class of parametric and
semi-parametric statistical models, which allows for a unified treatment of
multiple comparisons and other simultaneous inference procedures in
generalized linear models, mixed models, models for censored data,
robust models, etc. Honest decisions based on simultaneous inference
procedures maintaining a pre-specified familywise error rate (at least
asymptotically) can be derived from almost all classical and modern 
statistical models. The technical details and more examples can be found
in \cite{HSAUR:HothornBretzWestfall2008} and the package vignettes of 
package \Rpackage{multcomp} \citep{PKG:multcomp}.

\section*{Exercises}

\begin{description}

\exercise 
Compare the results of \Rcmd{glht} and \Rcmd{TukeyHSD} on the \Robject{alpha}
data.

\exercise
Consider the linear model fitted to the clouds data as summarized 
in Figure~\ref{MLR-clouds-summary}. Set up a matrix $\K$ corresponding
to the global null hypothesis that all interaction terms present in the model
are zero. Test both the global hypothesis and all hypotheses corresponding
to each of the interaction terms. Which interaction remains significant
after adjustment for multiple testing?

\exercise
For the logistic regression model presented in Figure~\ref{GLM-womensrole-summary-2}
perform a multiplicity adjusted test on all regression coefficients (except for the intercept)
being zero. Do the conclusions drawn in \Sexpr{ch("GLM")} remain valid?

\end{description}

\bibliographystyle{LaTeXBibTeX/refstyle}
\bibliography{LaTeXBibTeX/HSAUR}
\end{document}

\documentclass{chapman}

%%% copy Sweave.sty definitions

%%% keeps `sweave' from adding `\usepackage{Sweave}': DO NOT REMOVE
%\usepackage{Sweave} 


\RequirePackage[T1]{fontenc}
\RequirePackage{graphicx,ae,fancyvrb}
\IfFileExists{upquote.sty}{\RequirePackage{upquote}}{}
\usepackage{relsize}

\DefineVerbatimEnvironment{Sinput}{Verbatim}{}
\DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                              fontshape=it,
                                              fontsize=\relsize{-1}}
\DefineVerbatimEnvironment{Scode}{Verbatim}{}
\newenvironment{Schunk}{}{}

%%% environment for raw output
\newcommand{\SchunkRaw}{\renewenvironment{Schunk}{}{}
    \DefineVerbatimEnvironment{Soutput}{Verbatim}{fontfamily=courier,
                                                  fontshape=it,
                                                  fontsize=\small}
    \rawSinput
}

%%% environment for labeled output
\newcommand{\nextcaption}{}
\newcommand{\SchunkLabel}{
  \renewenvironment{Schunk}{\begin{figure}[ht] }{\caption{\nextcaption}
  \end{figure} }
  \DefineVerbatimEnvironment{Sinput}{Verbatim}{frame = topline}
  \DefineVerbatimEnvironment{Soutput}{Verbatim}{frame = bottomline, 
                                                samepage = true,
                                                fontfamily=courier,
                                                fontshape=it,
                                                fontsize=\relsize{-1}}
}


%%% S code with line numbers
\DefineVerbatimEnvironment{Sinput}
{Verbatim}
{
%%  numbers=left
}

\newcommand{\numberSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{numbers=left}
}
\newcommand{\rawSinput}{
    \DefineVerbatimEnvironment{Sinput}{Verbatim}{}
}


%%% R / System symbols
\newcommand{\R}{\textsf{R}}
\newcommand{\rR}{{R}}
\renewcommand{\S}{\textsf{S}}
\newcommand{\SPLUS}{\textsf{S-PLUS}}
\newcommand{\rSPLUS}{{S-PLUS}}
\newcommand{\SPSS}{\textsf{SPSS}}
\newcommand{\EXCEL}{\textsf{Excel}}
\newcommand{\ACCESS}{\textsf{Access}}
\newcommand{\SQL}{\textsf{SQL}}
%%\newcommand{\Rpackage}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Robject}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\Rclass}[1]{\hbox{\rm\textit{#1}}}
%%\newcommand{\Rcmd}[1]{\hbox{\rm\texttt{#1}}}
\newcommand{\Rpackage}[1]{\index{#1 package@{\fontseries{b}\selectfont #1} package} {\fontseries{b}\selectfont #1}}
\newcommand{\rpackage}[1]{{\fontseries{b}\selectfont #1}}
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\Rclass}[1]{\index{#1 class@\textit{#1} class}\textit{#1}}
\newcommand{\Rcmd}[1]{\index{#1 function@\texttt{#1} function}\texttt{#1}}
\newcommand{\Roperator}[1]{\texttt{#1}}
\newcommand{\Rarg}[1]{\texttt{#1}}
\newcommand{\Rlevel}[1]{\texttt{#1}}


%%% other symbols
\newcommand{\file}[1]{\hbox{\rm\texttt{#1}}}
%%\newcommand{\stress}[1]{\index{#1}\textit{#1}} 
\newcommand{\stress}[1]{\textit{#1}} 
\newcommand{\booktitle}[1]{\textit{#1}} %%'

%%% Math symbols
\usepackage{amstext}
\usepackage{amsmath}
\newcommand{\E}{\mathsf{E}}   
\newcommand{\Var}{\mathsf{Var}}   
\newcommand{\Cov}{\mathsf{Cov}}   
\newcommand{\Cor}{\mathsf{Cor}}   
\newcommand{\x}{\mathbf{x}}   
\newcommand{\y}{\mathbf{y}}   
\renewcommand{\a}{\mathbf{a}}
\newcommand{\W}{\mathbf{W}}   
\newcommand{\C}{\mathbf{C}}   
\renewcommand{\H}{\mathbf{H}}   
\newcommand{\X}{\mathbf{X}}   
\newcommand{\B}{\mathbf{B}}   
\newcommand{\V}{\mathbf{V}}   
\newcommand{\I}{\mathbf{I}}   
\newcommand{\D}{\mathbf{D}}   
\newcommand{\bS}{\mathbf{S}}   
\newcommand{\N}{\mathcal{N}}   
\renewcommand{\L}{L}   
\renewcommand{\P}{\mathsf{P}}   
\newcommand{\K}{\mathbf{K}}
\newcommand{\m}{\mathbf{m}}
\newcommand{\argmin}{\operatorname{argmin}\displaylimits}
\newcommand{\argmax}{\operatorname{argmax}\displaylimits}

\newcommand{\bx}{\mathbf{x}}
\newcommand{\bbeta}{\mathbf{\beta}}


%%% links
\usepackage{hyperref}

\hypersetup{%
  pdftitle = {A Handbook of Statistical Analyses Using R (3rd Edition)},
  pdfsubject = {Book},
  pdfauthor = {Torsten Hothorn and Brian S. Everitt},
  colorlinks = {black},
  linkcolor = {black},
  citecolor = {black},
  urlcolor = {black},
  hyperindex = {true},
  linktocpage = {true},
}


%%% captions & tables
%% <FIXME>: conflics with figure definition in chapman.cls
%%\usepackage[format=hang,margin=10pt,labelfont=bf]{caption}
%% </FIMXE>
\usepackage{longtable}
\usepackage[figuresright]{rotating}

%%% R symbol in chapter 1
\usepackage{wrapfig}

%%% Bibliography
\usepackage[round,comma]{natbib}
\renewcommand{\refname}{References \addcontentsline{toc}{chapter}{References}}
\citeindexfalse

%%% texi2dvi complains that \newblock is undefined, hm...
\def\newblock{\hskip .11em plus .33em minus .07em}

%%% Example sections
\newcounter{exercise}[chapter]
\setcounter{exercise}{0}
\newcommand{\exercise}{\stepcounter{exercise} \item{Ex.~\arabic{chapter}.\arabic{exercise} }}


%% URLs
\newcommand{\curl}[1]{\begin{center} \url{#1} \end{center}}

%%% for manual corrections
%\renewcommand{\baselinestretch}{2}

%%% plot sizes
\setkeys{Gin}{width=0.95\textwidth}

%%% color
\usepackage{color}

%%% hyphenations
\hyphenation{drop-out}
\hyphenation{mar-gi-nal}

%%% new bidirectional quotes need 
\usepackage[utf8]{inputenc}

%\usepackage{setspace}
\definecolor{sidebox_todo}{rgb}{1,1,0.2}
\newcommand{\todo}[1]{
        \hspace{0pt}%
        \marginpar{% 
                        \fcolorbox{black}{sidebox_todo}{%
                                \parbox{\marginparwidth} {

\raggedright\sffamily\footnotesize{TODO: #1}%
                                }
                        }%
        }
}
\begin{document}

%% Title page

\title{A Handbook of Statistical Analyses Using \R{} --- 3rd Edition}

\author{Torsten Hothorn and Brian S. Everitt}

\maketitle
%%\VignetteIndexEntry{Chapter Analyzing Longitudinal Data I}
%%\VignetteDepends{lme4,multcomp}
\setcounter{chapter}{12}


\SweaveOpts{prefix.string=figures/HSAUR,eps=FALSE,keep.source=TRUE} 

<<setup, echo = FALSE, results = hide>>=
rm(list = ls())
s <- search()[-1]
s <- s[-match(c("package:base", "package:stats", "package:graphics", "package:grDevices",
                "package:utils", "package:datasets", "package:methods", "Autoloads"), s)]
if (length(s) > 0) sapply(s, detach, character.only = TRUE)
if (!file.exists("tables")) dir.create("tables")
if (!file.exists("figures")) dir.create("figures")
set.seed(290875)
options(prompt = "R> ", continue = "+  ",
    width = 63, # digits = 4, 
    show.signif.stars = FALSE,
    SweaveHooks = list(leftpar = function() 
        par(mai = par("mai") * c(1, 1.05, 1, 1)),
        bigleftpar = function()
        par(mai = par("mai") * c(1, 1.7, 1, 1))))
HSAURpkg <- require("HSAUR3")
if (!HSAURpkg) stop("cannot load package ", sQuote("HSAUR3"))
rm(HSAURpkg)
 ### </FIXME> hm, R-2.4.0 --vanilla seems to need this
a <- Sys.setlocale("LC_ALL", "C")
 ### </FIXME>
book <- TRUE
refs <- cbind(c("AItR", "DAGD", "SI", "CI", "ANOVA", "MLR", "GLM", 
                "DE", "RP", "GAM", "SA", "ALDI", "ALDII", "SIMC", "MA", "PCA", 
                "MDS", "CA"), 1:18)
ch <- function(x) {
    ch <- refs[which(refs[,1] == x),]
    if (book) {
        return(paste("Chapter~\\\\ref{", ch[1], "}", sep = ""))
    } else {
        return(paste("Chapter~", ch[2], sep = ""))
    }
}
if (file.exists("deparse.R"))
    source("deparse.R")

setHook(packageEvent("lattice", "attach"), function(...) {
    lattice.options(default.theme = 
        function()
            standard.theme("pdf", color = FALSE))
    })
@

\pagestyle{headings}
<<singlebook, echo = FALSE>>=
book <- FALSE
@

<<ALDI-setup, echo = FALSE, results = hide>>=
library("lme4")
library("multcomp")
residuals <- function(object) {
    y <- getME(object, 'y')
    y - fitted(object)
}
@

\chapter[Analyzing Longitudinal Data I]{Analyzing Longitudinal Data I: 
         Computerized Delivery of Cognitive
         Behavioral Therapy -- Beat the Blues \label{ALDI}}

\section{Introduction}



\section{Analyzing Longitudinal Data}


\section{Analysis Using \R{}}


\begin{figure}
\begin{center}
<<ALDI-plot-BtheB, echo = TRUE, fig = TRUE, height = 4>>=
data("BtheB", package = "HSAUR3")
layout(matrix(1:2, nrow = 1))
ylim <- range(BtheB[,grep("bdi", names(BtheB))], 
              na.rm = TRUE)
tau <- subset(BtheB, treatment == "TAU")[,
    grep("bdi", names(BtheB))]
boxplot(tau, main = "Treated as Usual", ylab = "BDI", 
        xlab = "Time (in months)", names = c(0, 2, 3, 5, 8), 
        ylim = ylim)
btheb <- subset(BtheB, treatment == "BtheB")[,
    grep("bdi", names(BtheB))]
boxplot(btheb, main = "Beat the Blues", ylab = "BDI", 
        xlab = "Time (in months)", names = c(0, 2, 3, 5, 8), 
        ylim = ylim)
@
\caption{Boxplots for the repeated measures by treatment group for the 
         \Robject{BtheB} data. \label{ALDI:boxplots}}
\end{center}
\end{figure}


We shall fit both random intercept and random intercept and 
slope models to the data including the baseline BDI values
(\Robject{pre.bdi}), \Robject{treatment} group, 
\Robject{drug}, and \Robject{length} as fixed effect covariates. Linear mixed 
effects models are fitted in \R{} by using the \Rcmd{lmer} function 
contained in the \Rpackage{lme4} package
\citep{PKG:lme4,HSAUR:PinheiroBates2000,HSAUR:Bates2005},
but an essential first step is to rearrange the data from the `wide form' in which they appear in the \Robject{BtheB} data frame %%'
into the `long form' in which each separate repeated measurement %%'
and associated covariate values appear as a separate row in a
\Rclass{data.frame}. 
This rearrangement can be made using the following code:
<<ALDI-long-BtheB, echo = TRUE>>=
data("BtheB", package = "HSAUR3")
BtheB$subject <- factor(rownames(BtheB))
nobs <- nrow(BtheB)
BtheB_long <- reshape(BtheB, idvar = "subject", 
    varying = c("bdi.2m", "bdi.3m", "bdi.5m", "bdi.8m"),
    direction = "long") 
BtheB_long$time <- rep(c(2, 3, 5, 8), rep(nobs, 4)) 
@
such that the data are now in the form (here shown for the first three
subjects)
<<ALDI-showlong-BtheB, echo = TRUE>>=
subset(BtheB_long, subject %in% c("1", "2", "3"))
@
The resulting \Rclass{data.frame} \Robject{BtheB\_long} contains a number 
of missing values 
\index{Missing values}
and in applying the \Rcmd{lmer} function these 
will be dropped. But notice it is only the missing values 
that are removed, \stress{not} participants that have at least 
one missing value. All the available data is used in the model 
fitting process. The \Rcmd{lmer} function is used in a similar way to 
the \Rcmd{lm} function met in \Sexpr{ch("MLR")}
with the addition of a random term to identify the source of the 
repeated measurements, here \Robject{subject}. We can fit the two 
models (\ref{ALDI:ModelA}) and (\ref{ALDI:ModelB}) and test which is most 
appropriate using
<<ALDI-fit-BtheB, echo = TRUE>>=
library("lme4")
BtheB_lmer1 <- lmer(bdi ~ bdi.pre + time + treatment + drug + 
    length + (1 | subject), data = BtheB_long, 
    REML = FALSE, na.action = na.omit)
BtheB_lmer2 <- lmer(bdi ~ bdi.pre + time + treatment + drug + 
    length + (time | subject), data = BtheB_long, 
    REML = FALSE, na.action = na.omit)   
anova(BtheB_lmer1, BtheB_lmer2)
@


\renewcommand{\nextcaption}{\R{} output of the linear mixed-effects model fit
                            for the \Robject{BtheB} data.
                            \label{ALDI-BtheB-summary}}
\SchunkLabel
<<ALDI-summary-BtheB, echo = TRUE>>=
summary(BtheB_lmer1)
@
\SchunkRaw

The \Rcmd{summary} method for \Rclass{lmer} objects doesn't print $p$-values
for Gaussian mixed models because the degrees of freedom of the $t$ 
reference distribution are not obvious. However, one can rely on the 
asymptotic normal distribution for computing univariate $p$-values for the 
fixed effects using the \Rcmd{cftest} function from package \Rpackage{multcomp}. 
The asymptotic $p$-values are given in Figure~\ref{ALDI-BtheB-summary-p}.

\renewcommand{\nextcaption}{\R{} output of the asymptotic $p$-values for linear mixed-effects model fit
                            for the \Robject{BtheB} data.
                            \label{ALDI-BtheB-summary-p}}
\SchunkLabel
<<ALDI-summary-BtheB-p, echo = TRUE>>=
cftest(BtheB_lmer1)
@
\SchunkRaw

We can check the assumptions of the final model fitted to
the \Robject{BtheB} data, i.e., the normality of the random effect terms 
and the residuals, by first using the \Rcmd{ranef} method 
to \stress{predict} the former and the \Rcmd{residuals} method  
to calculate the differences between the observed data values 
and the fitted values, and then using normal probability plots 
on each. How the random effects are predicted is explained briefly in 
Section~\ref{ALDI:predictrandom}. 
The necessary \R{} code to obtain the effects, residuals, 
and plots is shown with Figure~\ref{ALDI:qqplots}.
There appear to be no large departures from linearity in either plot.
\begin{figure}
\begin{center}
<<ALDI-qqnorm-BtheB, echo = TRUE, fig = TRUE, height = 4, width = 7>>=
layout(matrix(1:2, ncol = 2))
qint <- ranef(BtheB_lmer1)$subject[["(Intercept)"]]
qres <- residuals(BtheB_lmer1)
qqnorm(qint, ylab = "Estimated random intercepts",
       xlim = c(-3, 3), ylim = c(-20, 20),
       main = "Random intercepts")
qqline(qint)
qqnorm(qres, xlim = c(-3, 3), ylim = c(-20, 20),
       ylab = "Estimated residuals",
       main = "Residuals")
qqline(qres)
@
\caption{Quantile-quantile plots of predicted random intercepts and
residuals for the random intercept model \Robject{BtheB\_lmer1} fitted to the
\Robject{BtheB} data. \label{ALDI:qqplots}}
\end{center}
\end{figure}


\begin{figure}
\begin{center}
<<ALDI-dropout, echo = TRUE, fig = TRUE>>=
bdi <- BtheB[, grep("bdi", names(BtheB))]
plot(1:4, rep(-0.5, 4), type = "n", axes = FALSE, 
     ylim = c(0, 50), xlab = "Months", ylab = "BDI")
axis(1, at = 1:4, labels = c(0, 2, 3, 5))
axis(2)
for (i in 1:4) {
    dropout <- is.na(bdi[,i + 1])
    points(rep(i, nrow(bdi)) + ifelse(dropout, 0.05, -0.05), 
           jitter(bdi[,i]), pch = ifelse(dropout, 20, 1))
}
@
\caption{Distribution of BDI values for patients
         that do (circles) and do not (bullets) attend the next scheduled visit. 
         \label{ALDI-dropout}}
\end{center}
\end{figure}



\bibliographystyle{LaTeXBibTeX/refstyle}
\bibliography{LaTeXBibTeX/HSAUR}
\end{document}

\name{Smoking_Mueller1940}
\alias{Smoking_Mueller1940}
\docType{data}
\title{Smoking and Lung Cancer (I)
}
\description{
Number of smokers in a case-control study.
}
\usage{data(Smoking_Mueller1940)}
\format{
  The format is:
 table [1:5, 1:2] 25 18 13 27 3 4 5 22 41 14
 - attr(*, "dimnames")=List of 2
  ..$ Smoking_type: chr [1:5] "Extreme smoker" "Very heavy smoker" "Heavy smoker" "Moderate smoker" ...
  ..$ Group       : chr [1:2] "Lung cancer" "Healthy control"
}
\details{
Extreme smoker: 10-15 cigars, >35 cigarettes, or >50 g pipe tobacco/day.
Very heavy smoker: 7-9 cigars, 26-35 cigarettes, or 36-50 g pipe tobacco/day.
Heavy smoker: 4-6 cigars, 16-25 cigarettes, or 21-35 g pipe tobacco/day.
Moderate smoker: 1-3 cigars, 1-15 cigarettes, or 1-20 g pipe tobacco/day.

}
\source{

  Franz-Hermann Mueller (1940), Tabakmissbrauch und Lungencarcinom. 
  \emph{Zeitschrift fuer Krebsforschung} \bold{49}(1), 57-85.

}
\references{

  Richard Doll (1998), Uncovering the effects of smoking: 
  historical perspective. \emph{Statistical Methods in Medical Research},
  \bold{7}(87), 87-117

}
\examples{
data(Smoking_Mueller1940)
## maybe str(Smoking_Mueller1940) ; plot(Smoking_Mueller1940) ...
}
\keyword{datasets}

\name{respiratory}
\alias{respiratory}
\docType{data}
\title{ Respiratory Illness Data }
\description{

    The respiratory status of patients recruited for a randomised clinical
    multicenter trial.

}
\usage{data("respiratory")}
\format{
  A data frame with 555 observations on the following 7 variables.
  \describe{
    \item{\code{centre}}{the study center, a factor with levels \code{1} and
                         \code{2}.}
    \item{\code{treatment}}{the treatment arm, a factor with levels \code{placebo}
                            and \code{treatment}.}
    \item{\code{gender}}{a factor with levels \code{female} and \code{male}.}
    \item{\code{age}}{the age of the patient.}
    \item{\code{status}}{the respiratory status (response variable), 
                         a factor with levels \code{poor} and \code{good}.}
    \item{\code{month}}{the month, each patient was examined at months 
                        \code{0}, \code{1}, \code{2}, \code{3} and \code{4}.}
    \item{\code{subject}}{the patient ID, a factor with levels \code{1} to
                          \code{111}.}
  }
}
\details{

    In each of two centres, eligible patients were randomly assigned 
    to active treatment or placebo. During the treatment, the respiratory
    status (categorised \code{poor} or \code{good}) was determined at each
    of four, monthly visits. The trial recruited 111 participants
    (54 in the active group, 57 in the placebo group) and there were
    no missing data for either the responses or the covariates. The
    question of interest is to assess whether the treatment is effective
    and to estimate its effect.

    Note that the data are in long form, i.e, repeated measurments are
    stored as additional rows in the data frame.

}
\source{

    C. S. Davis (1991), Semi-parametric and non-parametric methods
    for the analysis of repeated measurements with applications to
    clinical trials. \emph{Statistics in Medicine}, \bold{10}, 
    1959--1980.

}
\examples{

  data("respiratory", package = "HSAUR3")
  mosaicplot(xtabs( ~ treatment + month + status, data = respiratory))

}
\keyword{datasets}

\name{bp}
\alias{bp}
\docType{data}
\title{
Lowering Blood Pressure Data
}
\description{
Lowering a patient's blood pressure during
surgery, using a hypotensive drug.
}
\usage{data(bp)}
\format{
  A data frame with 53 observations on the following 3 variables.
  \describe{
    \item{\code{logdose}}{the logarithm (base 10) of the dose of drug in milligrams}
    \item{\code{bloodp}}{average systolic blood pressure achieved while the drug was being administered}
    \item{\code{recovtime}}{time in minutes before the patient's systolic blood pressure returned to 100mm of mercury}
  }
}
\source{

  J. D. Robertson and P. Armitage (1959)
  Comparison of Two Hypotensive Agents, \emph{Anaesthesia}, 
  \bold{14}(1), 53--64

}
\keyword{datasets}

\name{plasma}
\alias{plasma}
\docType{data}
\title{ Blood Screening Data }
\description{

  The erythrocyte sedimentation rate and measurements of 
  two plasma proteins (fibrinogen and globulin).

}
\usage{data("plasma")}
\format{
  A data frame with 32 observations on the following 3 variables.
  \describe{
    \item{\code{fibrinogen}}{the fibrinogen level in the blood.}
    \item{\code{globulin}}{the globulin level in the blood.}
    \item{\code{ESR}}{the erythrocyte sedimentation rate, either less or
                      greater 20 mm / hour. }
  }
}
\details{

  The erythrocyte sedimentation rate (ESR) is the rate at which
  red blood cells (erythrocytes) settle out of suspension in blood
  plasma, when measured under standard conditions. If the ESR increases
  when the level of certain proteins in the blood plasma rise in
  association with conditions such as rheumatic diseases, chronic
  infections and malignant diseases, its determination might be
  useful in screening blood samples taken form people suspected
  to being suffering from one of the conditions mentioned. The
  absolute value of the ESR is not of great importance rather it
  is whether it is less than 20mm/hr since lower values indicate
  a healthy individual.

  The question of interest is whether there is any association  
  between the probability of an ESR reading greater than 20mm/hr
  and the levels of the two plasma proteins. If there is not then 
  the determination of ESR would not be useful for diagnostic purposes. 

}
\source{

    D. Collett and A. A. Jemain (1985), 
    Residuals, outliers and influential observations in regression
    analysis. \emph{Sains Malaysiana}, \bold{4}, 493--511.

}
\examples{

  data("plasma", package = "HSAUR3")
  layout(matrix(1:2, ncol = 2))
  boxplot(fibrinogen ~ ESR, data = plasma, varwidth = TRUE)
  boxplot(globulin ~ ESR, data = plasma, varwidth = TRUE)

}
\keyword{datasets}

\name{gardenflowers}
\alias{gardenflowers}
\docType{data}
\title{ Garden Flowers Data}
\description{
    The dissimilarity matrix of 18 species of garden flowers.
}
\usage{data("gardenflowers")}
\format{
  An object of class \code{\link{dist}}.
}
\details{

  The dissimilarity was computed based on certain characteristics of the
  flowers.

}
\source{

    L. Kaufman and P. J. Rousseeuw (1990), \emph{Finding groups in data: 
    an introduction to cluster analysis}, John Wiley & Sons, New York.

}
\examples{

  data("gardenflowers", package = "HSAUR3")
  gardenflowers

}
\keyword{datasets}

\name{clouds}
\alias{clouds}
\docType{data}
\title{ Cloud Seeding Data }
\description{
 
  Data from an experiment investigating the use of massive 
  amounts of silver iodide (100 to 1000 grams per cloud) in cloud
  seeding to increase rainfall.
 
}
\usage{data("clouds")}
\format{
  A data frame with 24 observations on the following 7 variables.
  \describe{
    \item{seeding}{a factor indicating whether seeding action occured (\code{no}
                   or \code{yes}).}
    \item{time}{number of days after the first day of the experiment.}
    \item{sne}{suitability criterion.}
    \item{cloudcover}{the percentage cloud cover in the experimental area,
                  measured using radar.}
    \item{prewetness}{the total rainfall in the target area one hour before
                      seeding (in cubic metres times \code{1e+8}).}
    \item{echomotion}{a factor showing whether the radar echo was
                      \code{moving} or \code{stationary}.}
    \item{rainfall}{the amount of rain in cubic metres times \code{1e+8}.}
  }
}
\details{

Weather modification, or cloud seeding, is the treatment of individual
clouds or storm systems with various inorganic and organic materials
in the hope of achieving an increase in rainfall. Introduction
of such material into a cloud that contains supercooled water,
that is, liquid water colder than zero Celsius, has the aim of 
inducing freezing, with the consequent ice particles growing  
at the expense of liquid droplets and becoming heavy enough to
fall as rain from clouds that otherwise would produce none.

The data available in \code{cloud} were collected in the summer
of 1975 from an experiment to investigate the use of massive 
amounts of silver iodide 100 to 1000 grams per cloud) in cloud
seeding to increase rainfall. 
In the experiment, which was conducted 
in an area of Florida, 24 days were judged suitable for seeding 
on the basis that a measured suitability criterion (\code{SNE}).

}
\source{

    W. L. Woodley, J. Simpson, R. Biondini and J. Berkeley (1977),
    Rainfall results 1970-75: Florida area cumulus experiment.
    \emph{Science} \bold{195}, 735--742.

    R. D. Cook and S. Weisberg (1980), Characterizations of an 
    empirical influence function for detecting influential cases in 
    regression. \emph{Technometrics} \bold{22}, 495--508.

}
\examples{

  data("clouds", package = "HSAUR3")
  layout(matrix(1:2, nrow = 2))
  boxplot(rainfall ~ seeding, data = clouds, ylab = "Rainfall")
  boxplot(rainfall ~ echomotion, data = clouds, ylab = "Rainfall")    

}
\keyword{datasets}

\name{voting}
\alias{voting}
\docType{data}
\title{ House of Representatives Voting Data }
\description{

  Voting results for 15 congressmen from New Jersey.

}
\usage{data("voting")}
\format{
    A 15 times 15 matrix.
}
\details{

Romesburg (1984) gives a set of data that shows the number
of times 15 congressmen from New Jersey voted differently in 
the House of Representatives on 19 environmental bills. Abstentions
are not recorded.

}
\source{

    H. C. Romesburg (1984), \emph{Cluster Analysis for Researchers}.
    Lifetime Learning Publications, Belmont, Canada.

}
\examples{

  data("voting", package = "HSAUR3")
  require("MASS")
  voting_mds <- isoMDS(voting)
  plot(voting_mds$points[,1], voting_mds$points[,2],
       type = "n", xlab = "Coordinate 1", ylab = "Coordinate 2",
       xlim = range(voting_mds$points[,1])*1.2)
  text(voting_mds$points[,1], voting_mds$points[,2], 
       labels = colnames(voting))
  voting_sh <- Shepard(voting[lower.tri(voting)], voting_mds$points)

}
\keyword{datasets}

\name{weightgain}
\alias{weightgain}
\docType{data}
\title{ Gain in Weight of Rats }
\description{

The data arise from an experiment to study the
gain in weight of rats fed on four different diets, distinguished
by amount of protein (low and high) and by source of protein
(beef and cereal).

}
\usage{data("weightgain")}
\format{
  A data frame with 40 observations on the following 3 variables.
  \describe{
    \item{\code{source}}{source of protein given, a factor with levels \code{Beef}
                         and \code{Cereal}.}
    \item{\code{type}}{amount of protein given, a factor with levels \code{High}
                       and \code{Low}.}
    \item{\code{weightgain}}{weigt gain in grams.}
  }
}
\details{

    Ten rats are randomized to each of the four
    treatments. The question
    of interest is how diet affects weight gain.

}
\source{

  D. J. Hand, F. Daly, A. D. Lunn, K. J. McConway and E. Ostrowski (1994).
  \emph{A Handbook of Small Datasets}, Chapman and Hall/CRC, London.

}
\examples{

  data("weightgain", package = "HSAUR3")
  interaction.plot(weightgain$type, weightgain$source, 
                   weightgain$weightgain)

}
\keyword{datasets}

\name{smoking}
\alias{smoking}
\docType{data}
\title{ Nicotine Gum and Smoking Cessation }
\description{

  Data from a meta-analysis on nicotine gum and smoking cessation

}
\usage{data("smoking")}
\format{
  A data frame with 26 observations (studies) on the following 4 variables.
  \describe{
    \item{\code{qt}}{the number of treated subjetcs who stopped
                                  smoking.} 
    \item{\code{tt}}{the totla number of treated subjects.}
    \item{\code{qc}}{the number of  subjetcs who stopped
                                  smoking without being treated.} 
    \item{\code{tc}}{the total number of subject not being treated.}
  }
}
\details{

  Cigarette smoking is the leading cause of preventable death in
  the United States and kills more Americans than AIDS, alcohol,
  illegal drug use, car accidents, fires, murders and suicides
  combined. It has been estimated that 430,000 Americans die from
  smoking every year. Fighting tobacco use is, consequently, one
  of the major public health goals of our time and there are now
  many programs available designed to help smokers quit. One of
  the major aids used in these programs is nicotine chewing gum,
  which acts as a substitute oral activity and provides a source
  of nicotine that reduces the withdrawal symptoms experienced
  when smoking is stopped. But separate randomized clinical trials
  of nicotine gum have been largely inconclusive, leading
  Silagy (2003) to consider combining the results studies
  found from an extensive literature search. The results of these
  trials in terms of numbers of people in the treatment arm and
  the control arm who stopped smoking for at least 6 months after
  treatment are given here. 

}
\source{

  C. Silagy (2003), Nicotine replacement therapy for smoking
  cessation (Cochrane Review). \emph{The Cochrane Library},
  \bold{4}, John Wiley & Sons, Chichester.

}
\examples{

  data("smoking", package = "HSAUR3")
  boxplot(smoking$qt/smoking$tt,
          smoking$qc/smoking$tc,
          names = c("Treated", "Control"), ylab = "Percent Quitters")

}
\keyword{datasets}

\name{planets}
\alias{planets}
\docType{data}
\title{ Exoplanets Data }
\description{

  Data on planets outside the Solar System.

}
\usage{data("planets")}
\format{
  A data frame with 101 observations from 101 exoplanets 
  on the following 3 variables.
  \describe{
    \item{mass}{Jupiter mass of the planet.}
    \item{period}{period in earth days.}
    \item{eccen}{the radial eccentricity of the planet.}
  }
}
\details{

    From the properties of the exoplanets found up to now it        
    appears that the theory of planetary development constructed    
    for the planets of the Solar System may need to be reformulated.
    The exoplanets are not at all like the nine local planets that
    we know so well. A first step in the process of understanding
    the exoplanets might be to try to classify them with respect 
    to their known properties.

}
\source{

  M. Mayor and P. Frei (2003). \emph{New Worlds in the Cosmos: 
  The Discovery of Exoplanets}. Cambridge University Press,
  Cambridge, UK.

}
\examples{

  data("planets", package = "HSAUR3")
  require("scatterplot3d")
  scatterplot3d(log(planets$mass), log(planets$period), log(planets$eccen), 
                type = "h", highlight.3d = TRUE,  angle = 55, 
                scale.y = 0.7, pch = 16)

}
\keyword{datasets}

\name{birthdeathrates}
\alias{birthdeathrates}
\docType{data}
\title{ Birth and Death Rates Data }
\description{
  
  Birth and death rates for 69 countries.

}
\usage{data("birthdeathrates")}
\format{
  A data frame with 69 observations on the following 2 variables.
  \describe{
    \item{\code{birth}}{birth rate.}
    \item{\code{death}}{death rate.}
  }
}
\source{
  
    J. A. Hartigan (1975), \emph{Clustering Algorithms}.
    John Wiley & Sons, New York.

}
\examples{

  data("birthdeathrates", package = "HSAUR3")
  plot(birthdeathrates)

}
\keyword{datasets}

\name{orallesions}
\alias{orallesions}
\docType{data}
\title{ Oral Lesions in Rural India }
\description{

The distribution of the oral
lesion site found in house-to-house surveys in three geographic
regions of rural India.

}
\usage{data("orallesions")}
\format{
A two-way classification, see \code{\link{table}}.
}
\source{

   Cyrus R. Mehta and Nitin R. Patel (2003), 
   \emph{StatXact-6: Statistical Software for Exact Nonparametric
   Inference}, Cytel Software Cooperation, Cambridge, USA.

}
\examples{

  data("orallesions", package = "HSAUR3")
  mosaicplot(orallesions)

}
\keyword{datasets}

\name{meteo}
\alias{meteo}
\docType{data}
\title{ Meteorological Measurements for 11 Years }
\description{

    Several meteorological measurements for a period between 1920 and 1931.

}
\usage{data("meteo")}
\format{
  A data frame with 11 observations on the following 6 variables.
  \describe{
    \item{\code{year}}{the years.}
    \item{\code{rainNovDec}}{rainfall in November and December (mm).}
    \item{\code{temp}}{average July temperature.}
    \item{\code{rainJuly}}{rainfall in July (mm).}
    \item{\code{radiation}}{radiation in July (millilitres of alcohol).}
    \item{\code{yield}}{average harvest yield (quintals per hectare).}
  }
}
\details{

  Carry out a principal components analysis of both the covariance
  matrix and the correlation matrix of the data and compare the
  results. Which set of components leads to the most meaningful
  interpretation? 

}
\source{

  B. S. Everitt and G. Dunn (2001), \emph{Applied Multivariate Data
  Analysis}, 2nd edition, Arnold, London.

}
\examples{

  data("meteo", package = "HSAUR3")
  meteo

}
\keyword{datasets}

\name{agefat}
\alias{agefat}
\docType{data}
\title{ Total Body Composision Data }
\description{
    Age and body fat percentage of 25 normal adults.
}
\usage{data("agefat")}
\format{
  A data frame with 25 observations on the following 3 variables.
  \describe{
    \item{\code{age}}{the age of the subject.}
    \item{\code{fat}}{the body fat percentage.}
    \item{\code{gender}}{a factor with levels \code{female} and \code{male}.}
  }
}
\details{

  The data come from a study investigating a new methods of measuring body 
  composition (see Mazess et al, 1984), and give the body fat percentage 
  (percent fat), age and gender for 25 normal adults aged between 23 and 61 years.  
  The questions of interest are how are age and percent fat related, and is 
  there any evidence that the relationship is different for males and females.

}
\source{

  R. B. Mazess, W. W. Peppler and M. Gibbons (1984), Total body composition by 
  dual-photon (153Gd) absorptiometry. \emph{American Journal of Clinical Nutrition}, 
  \bold{40}, 834--839.

}
\examples{

  data("agefat", package = "HSAUR3")
  plot(fat ~ age, data = agefat)

}
\keyword{datasets}

\name{toenail}
\alias{toenail}
\docType{data}
\title{ Toenail Infection Data }
\description{

  Results of a clinical trial to compare two competing oral antifungal 
  treatments for toenail infection.

}
\usage{data("toenail")}
\format{
  A data frame with 1908 observations on the following 5 variables.
  \describe{
    \item{\code{patientID}}{a unique identifier for each patient in the trial.}
    \item{\code{outcome}}{degree of separation of the nail plate from the nail bed (onycholysis).}
    \item{\code{treatment}}{a factor with levels \code{itraconazole} and \code{terbinafine}.}
    \item{\code{time}}{the time in month when the visit actually took place.}
    \item{\code{visit}}{number of visit attended.}
  }
}
\details{

  De Backer et al. (1998) describe a clinical trial to compare two competing oral antifungal 
  treatments for toenail infection (dermatophyte onychomycosis). A total of 378 patients 
  were randomly allocated into two treatment groups, one group receiving 250mg per 
  day of terbinafine and the other group 200mg per day of itraconazole. 
  Patients were evaluated at seven visits, intended to be at weeks 
  0, 4, 8, 12, 24, 36, and 48 for the degree of separation of the nail 
  plate from the nail bed (onycholysis) dichotomized into \code{moderate or severe} 
  and \code{none or mild}. But patients did not always arrive exactly at the 
  scheduled time and the exact time in months that they did attend was recorded. 
  The data is not balanced since not all patients attended for all seven planned 
  visits.

}
\source{

  M. D. Backer and C. D. Vroey and E. Lesaffre and I. Scheys and P. D. Keyser (1998),
  Twelve weeks of continuous oral therapy for toenail onychomycosis caused by 
  dermatophytes: A double-blind comparative trial of terbinafine 
  250 mg/day versus itraconazole 200 mg/day. \emph{Journal of the American Academy of Dermatology}, 
  \bold{38}, S57--S63.

}

\examples{

  data("toenail", package = "HSAUR3")


}
\keyword{datasets}

\name{Smoking_DollHill1950}
\alias{Smoking_DollHill1950}
\docType{data}
\title{
Smoking and Lung Cancer (IV)
}
\description{
Number of smokers in a case-control study.
}
\usage{data(Smoking_DollHill1950)}
\format{
  The format is:
 table [1:6, 1:2, 1:2] 2 33 250 196 136 32 27 55 293 190 ...
 - attr(*, "dimnames")=List of 3
  ..$ Smoking  : chr [1:6] "Nonsmoker" "1-" "5-" "15-" ...
  ..$ Diagnosis: chr [1:2] "Lung cancer" "Other"
  ..$ Sex      : chr [1:2] "Male" "Female"
}
\details{
This is Table V from Doll and Hill (1950).
}
\source{

  Richard Doll and A. Bradford Hill (1950), Smoking and Carcinoma of the Lung,
  \emph{British Medical Journal}, \bold{2}, 739-748

}
\references{

  Richard Doll (1998), Uncovering the effects of smoking:
  historical perspective. \emph{Statistical Methods in Medical Research},
  \bold{7}(87), 87-117

}
\keyword{datasets}

\name{bladdercancer}
\alias{bladdercancer}
\docType{data}
\title{ Bladder Cancer Data }
\description{

  Data arise from 31 male patients who have been treated for 
  superficial bladder cancer, and give the number of recurrent tumours during 
  a particular time after the removal of the primary tumour, along with the size of the 
  original tumour.

}
\usage{data("bladdercancer")}
\format{
  A data frame with 31 observations on the following 3 variables.
  \describe{
    \item{\code{time}}{the duration.}
    \item{\code{tumorsize}}{a factor with levels \code{<=3cm} and \code{>3cm}.}
    \item{\code{number}}{number of recurrent tumours.}
  }
}
\details{

  The aim is the estimate the effect of size of tumour on the number  
  of recurrent tumours.

}
\source{

    G. U. H. Seeber (1998), Poisson Regression. In: \emph{Encyclopedia of Biostatistics}
    (P. Armitage and T. Colton, eds), John Wiley & Sons, Chichester.

}
\examples{

  data("bladdercancer", package = "HSAUR3")
  mosaicplot(xtabs(~ number + tumorsize, data = bladdercancer))

}
\keyword{datasets}

\name{foster}
\alias{foster}
\docType{data}
\title{ Foster Feeding Experiment }
\description{

The data are from a foster feeding experiment
with rat mothers and litters of four different genotypes.
The measurement is the litter weight after
a trial feeding period.

}
\usage{data("foster")}
\format{
  A data frame with 61 observations on the following 3 variables.
  \describe{
    \item{\code{litgen}}{genotype of the litter, a factor with levels 
                         \code{A}, \code{B}, \code{I}, and \code{J}.}
    \item{\code{motgen}}{genotype of the mother, a factor with levels 
                         \code{A}, \code{B}, \code{I}, and \code{J}.}
    \item{\code{weight}}{the weight of the litter after a feeding period.}
  }
}
\details{

Here the interest lies in uncovering the effect of genotype of mother and litter on 
litter weight.

}
\source{

  D. J. Hand, F. Daly, A. D. Lunn, K. J. McConway and E. Ostrowski (1994).
  \emph{A Handbook of Small Datasets}, Chapman and Hall/CRC, London.

}
\examples{

  data("foster", package = "HSAUR3")
  plot.design(foster)

}
\keyword{datasets}

\name{USairpollution}
\alias{USairpollution}
\docType{data}
\title{ Air Pollution in US Cities }
\description{

  Air pollution data of 41 US cities.
  
}
\usage{data("USairpollution")}
\format{
  A data frame with 41 observations on the following 7 variables.
  \describe{
    \item{\code{SO2}}{SO2 content of air in micrograms per cubic metre.}
    \item{\code{temp}}{average annual temperature in Fahrenheit.}
    \item{\code{manu}}{number of manufacturing enterprises 
                                employing 20 or more workers.}
    \item{\code{popul}}{population size (1970 census); in thousands.}
    \item{\code{wind}}{average annual wind speed in miles per hour.}
    \item{\code{precip}}{average annual precipitation in inches.}
    \item{\code{predays}}{average number of days with precipitation per year.}
  }
}
\details{

  The annual mean concentration of sulphur dioxide, in micrograms per cubic metre, is a 
  measure of the air pollution of the city. The question of interest here is what 
  aspects of climate and human ecology as measured by the other six variables in the 
  data determine pollution?

}
\source{

  R. R. Sokal and F. J. Rohlf (1981), \emph{Biometry},
  W. H. Freeman, San Francisco (2nd edition).

}
\examples{

  data("USairpollution", package = "HSAUR3")

}
\keyword{datasets}

\name{roomwidth}
\alias{roomwidth}
\docType{data}
\title{ Students Estimates of Lecture Room Width }
\description{
  Lecture room width estimated by students in two different units.
}
\usage{data("roomwidth")}
\format{
  A data frame with 113 observations on the following 2 variables.
  \describe{
    \item{unit}{a factor with levels \code{feet} and \code{metres}.}
    \item{width}{the estimated width of the lecture room.}
  }
}
\details{

Shortly after metric units of length were officially introduced
in Australia, each of a group of 44 students was asked to guess,
to the nearest metre, the width of the lecture hall in which 
they were sitting. Another group of 69 students in the same room   
was asked to guess the width in feet, to the nearest foot. The
data were collected by Professor T. Lewis and are taken 
from Hand et al (1994). The main question is whether estimation in feet and 
in metres gives different results.

}
\source{

  D. J. Hand, F. Daly, A. D. Lunn, K. J. McConway and E. Ostrowski (1994).
  \emph{A Handbook of Small Datasets}, Chapman and Hall/CRC, London.

}
\examples{

  data("roomwidth", package = "HSAUR3")
  convert <- ifelse(roomwidth$unit == "feet", 1, 3.28)
  boxplot(I(width * convert) ~ unit, data = roomwidth)

}
\keyword{datasets}

\name{USmelanoma}
\alias{USmelanoma}
\docType{data}
\title{ USA Malignant Melanoma Data }
\description{

USA mortality rates for white males due to malignant 
melanoma 1950-1969.

}
\usage{data("USmelanoma")}
\format{
  A data frame with 48 observations on the following 5 variables.
  \describe{
    \item{\code{mortality}}{number of white males died due to malignant melanoma 1950-1969 
                            per one million inhabitants.}
    \item{\code{latitude}}{latitude of the geographic centre of the state.}
    \item{\code{longitude}}{longitude of the geographic centre of each state.}
    \item{\code{ocean}}{a binary variable indicating contiguity to an ocean at 
                        levels \code{no} or \code{yes}.}
  }
}
\details{

  Fisher and van Belle (1993) report mortality rates due to malignant melanoma of the 
  skin for white males during the period 1950-1969, for each state on the US mainland. 
  Questions of interest about these data include how do the mortality rates 
  compare for ocean and non-ocean states?

}
\source{
Fisher and van Belle (1993)
}
\examples{

  data("USmelanoma", package = "HSAUR3")
}
\keyword{datasets}

\name{Lanza}
\alias{Lanza}
\docType{data}
\title{ Prevention of Gastointestinal Damages }
\description{
  Data from four randomised clinical trials on the prevention of 
  gastointestinal damages by Misoprostol reported by Lanza et al.
  (1987, 1988a,b, 1989).
}
\usage{data("Lanza")}
\format{
  A data frame with 198 observations on the following 3 variables.
  \describe{
    \item{\code{study}}{a factor with levels \code{I}, \code{II},
                        \code{III}, and \code{IV} describing the study number.}
    \item{\code{treatment}}{a factor with levels \code{Misoprostol} \code{Placebo}}
    \item{\code{classification}}{an ordered factor with levels \code{1} < \code{2} < \code{3} < \code{4} < \code{5}
                                 describing an ordered response variable.}
  }
}
\details{

    The response variable is defined by the number of haemorrhages or
    erosions. 

}
\source{

    F. L. Lanza (1987), A double-blind study of prophylactic effect of misoprostol on
    lesions of gastric and duodenal mucosa induced by oral administration of tolmetin 
    in healthy subjects. \emph{British Journal of Clinical Practice}, May
    suppl, 91--101.

    F. L. Lanza, R. L. Aspinall, E. A. Swabb, R. E. Davis, M. F. Rack, A. Rubin
    (1988a), Double-blind, placebo-controlled endoscopic comparison of the
    mucosal protective effects of misoprostol versus cimetidine on
    tolmetin-induced mucosal injury to the stomach and duodenum. 
    \emph{Gastroenterology}, \bold{95}(2), 289--294.

    F. L. Lanza, K. Peace, L. Gustitus, M. F. Rack, B. Dickson (1988b),
    A blinded endoscopic comparative study of misoprostol versus
    sucralfate and placebo in the prevention of aspirin-induced
    gastric and duodenal ulceration. \emph{American Journal of Gastroenterology},
    \bold{83}(2), 143--146.

    F. L. Lanza, D. Fakouhi, A. Rubin, R. E. Davis, M. F. Rack, C. Nissen, S. Geis
    (1989), A double-blind placebo-controlled comparison of the efficacy
    and safety of 50, 100, and 200 micrograms of misoprostol
    QID in the prevention of ibuprofen-induced gastric and
    duodenal mucosal lesions and symptoms. \emph{American Journal of  Gastroenterology},
    \bold{84}(6), 633--636.

}
\examples{

  data("Lanza", package = "HSAUR3")
  layout(matrix(1:4, nrow = 2))
  pl <- tapply(1:nrow(Lanza), Lanza$study, function(indx)
      mosaicplot(table(Lanza[indx,"treatment"], 
                       Lanza[indx,"classification"]),
                 main = "", shade = TRUE))

}
\keyword{datasets}

\name{Forbes2000}
\alias{Forbes2000}
\docType{data}
\title{ The Forbes 2000 Ranking of the World's Biggest Companies (Year 2004) }
\description{

  The Forbes 2000 list is a ranking of the world's biggest
  companies, measured by sales, profits, assets and market
  value.

}
\usage{data("Forbes2000")}
\format{
  A data frame with 2000 observations on the following 8 variables.
  \describe{
    \item{rank}{the ranking of the company.}
    \item{name}{the name of the company.}
    \item{country}{a factor giving the country the company is situated in.}
    \item{category}{a factor describing the products the company produces.}
    \item{sales}{the amount of sales of the company in billion USD.}
    \item{profits}{the profit of the company in billion USD.}
    \item{assets}{the assets of the company in billion USD.}
    \item{marketvalue}{the market value of the company in billion USD.}
  }
}
\source{
    \url{https://www.forbes.com}, assessed on November 26th, 2004.
}
\examples{
data("Forbes2000", package = "HSAUR3")
summary(Forbes2000)
### number of countries
length(levels(Forbes2000$country))
### number of industries
length(levels(Forbes2000$category))
}
\keyword{datasets}

\name{HSAURtable}
\alias{HSAURtable}
\alias{toLatex.tabtab}
\alias{toLatex.dftab}
\alias{HSAURtable.table}
\alias{HSAURtable.data.frame}
\title{ Produce LaTeX Tables }
\description{
    Generate \code{longtable} LaTeX environments.
}
\usage{
HSAURtable(object, ...)
\method{HSAURtable}{table}(object, xname = deparse(substitute(object)), pkg = NULL, 
    ...)
\method{HSAURtable}{data.frame}(object, xname = deparse(substitute(object)), pkg = NULL,
    nrows = NULL,  ...)
\method{toLatex}{tabtab}(object, caption = NULL, label = NULL, 
    topcaption = TRUE, index = TRUE, ...)
\method{toLatex}{dftab}(object, pcol = 1, caption = NULL, 
    label = NULL, rownames = FALSE, topcaption = TRUE, index = TRUE, 
    ...)
}
\arguments{
  \item{object}{ an object of \code{table} or \code{data.frame}. }
  \item{xname}{ the name of the object. }
  \item{pkg}{ the package \code{object} comes from, optionally. }
  \item{nrows}{ the number of rows actually printed for a
                \code{data.frame}.}
  \item{caption}{ the (optional) caption of the table without label. }
  \item{label}{ the (optional) label to be defined for this table. }
  \item{pcol}{ the number of parallel columns. }
  \item{rownames}{ logical, should the rownames be printed in the first
                   row without column name? }
  \item{topcaption}{ logical, should the captions be placed on top (default) 
                     of the table?}
  \item{index}{ logical, should an index entry be generated?}
  \item{\dots}{ additional arguments, currently ignored. }
}
\details{
  Based on the data in \code{object}, an object from which a Latex table 
  (in a \code{longtable} environment) may be  constructed (via 
  \code{\link[utils]{toLatex}}) is generated.
}
\value{
  An object of class \code{tabtab} or \code{dftab} for which
  \code{\link[utils]{toLatex}} methods are available.

  \code{toLatex} produces objects of class \code{Latex}, a character
  vector, essentially.
}
\examples{

  data("rearrests", package = "HSAUR3")
  toLatex(HSAURtable(rearrests), 
          caption = "Rearrests of juvenile felons.", 
          label = "rearrests_tab")

}
\keyword{misc}

\name{suicides}
\alias{suicides}
\docType{data}
\title{ Crowd Baiting Behaviour and Suicides }
\description{

  Data from a study carried out to investigate the
  causes of jeering or baiting behaviour by a crowd when a person
  is threatening to commit suicide by jumping from a high building.

}
\usage{data("suicides")}
\format{
A two-way classification, see \code{\link{table}}.
}
\source{

    L. Mann (1981), The baiting crowd in episodes of threatened suicide.
    \emph{Journal of Personality and Social Psychology}, \bold{41},  703--709.

}
\examples{

  data("suicides", package = "HSAUR3")
  mosaicplot(suicides)

}
\keyword{datasets}

\name{epilepsy}
\alias{epilepsy}
\docType{data}
\title{ Epilepsy Data }
\description{
  
   A randomised clinical trial investigating the effect of an anti-epileptic
   drug.

}
\usage{data("epilepsy")}
\format{
  A data frame with 236 observations on the following 6 variables.
  \describe{
    \item{\code{treatment}}{the treatment group, a factor with levels \code{placebo}
          and \code{Progabide}.}
    \item{\code{base}}{the number of seizures before the trial.}
    \item{\code{age}}{the age of the patient.}
    \item{\code{seizure.rate}}{the number of seizures (response variable).}
    \item{\code{period}}{treatment period, an ordered factor with levels
                         \code{1} to \code{4}.}
    \item{\code{subject}}{the patient ID, a factor with levels \code{1} to
          \code{59}.}
  }
}
\details{

  In this clinical trial, 59
  patients suffering from epilepsy were randomized to groups receiving either 
  the anti-epileptic drug Progabide or a placebo in addition to 
  standard chemotherapy. The numbers of seizures suffered in each 
  of four, two-week periods were recorded for each patient along 
  with a baseline seizure count for the 8 weeks prior to being 
  randomized to treatment and age. The main question of interest 
  is whether taking progabide reduced the number of epileptic seizures  
  compared with placebo.

}
\source{

   P. F. Thall and S. C. Vail (1990),
   Some covariance models for longitudinal count data with
   overdispersion. \emph{Biometrics}, \bold{46}, 657--671.

}
\examples{

  data("epilepsy", package = "HSAUR3")
  library(lattice)
  dotplot(I(seizure.rate / base) ~ period | subject, data = epilepsy, 
          subset = treatment == "Progabide")
  dotplot(I(seizure.rate / base) ~ period | subject, data = epilepsy, 
          subset = treatment == "Progabide")

}
\keyword{datasets}

\name{schooldays}
\alias{schooldays}
\docType{data}
\title{ Days not Spent at School }
\description{

    Data from a sociological study, the number of days absent from school is
    the response variable.

}
\usage{data("schooldays")}
\format{
  A data frame with 154 observations on the following 5 variables.
  \describe{
    \item{\code{race}}{race of the child, a factor with levels 
                       \code{aboriginal} and \code{non-aboriginal}.}
    \item{\code{gender}}{the gender of the child, a factor with levels 
                      \code{female} and \code{male}.}
    \item{\code{school}}{the school type, a factor with levels 
        \code{F0} (primary), \code{F1} (first), \code{F2} (second) and  
        \code{F3} (third form).}
    \item{\code{learner}}{how good is the child in learning things, 
                          a factor with levels \code{average} and
                          \code{slow}.}
    \item{\code{absent}}{number of days absent from school.}
  }
}
\details{

  The data arise from a sociological study
  of Australian Aboriginal and white children reported by
  Quine (1975).
  
  In this study, children of both sexes from four age groups
  (final grade in primary schools and first, second and third form  
  in secondary school) and from two cultural groups were used.
  The children in age group were classified as slow or average 
  learners. The response variable was the number of days absent   
  from school during the school year. (Children who had suffered
  a serious illness during the years were excluded.) 

}
\source{

   S. Quine (1975), Achievement Orientation of Aboriginal and
   White Adolescents. Doctoral Dissertation, 
   Australian National University, Canberra.

}
\examples{

  data("schooldays", package = "HSAUR3")
  plot.design(schooldays)

}
\keyword{datasets}

\name{heptathlon}
\alias{heptathlon}
\docType{data}
\title{ Olympic Heptathlon Seoul 1988 }
\description{

    Results of the olympic heptathlon competition, Seoul, 1988.

}
\usage{data("heptathlon")}
\format{
  A data frame with 25 observations on the following 8 variables.
  \describe{
    \item{\code{hurdles}}{results 100m hurdles.}
    \item{\code{highjump}}{results high jump.}
    \item{\code{shot}}{results shot.}
    \item{\code{run200m}}{results 200m race.}
    \item{\code{longjump}}{results long jump.}
    \item{\code{javelin}}{results javelin.}
    \item{\code{run800m}}{results 800m race.}
    \item{\code{score}}{total score.}
  }
}
\details{

  The first combined Olympic event for women was the pentathlon,
  first held in Germany in 1928. Initially this consisted of the
  shot putt, long jump, 100m, high jump and javelin events held
  over two days. The pentathlon was first introduced into the Olympic
  Games in 1964, when it consisted of the 80m hurdles, shot, high
  jump, long jump and 200m. In 1977 the 200m was replaced by the
  800m and from 1981 the IAAF brought in the seven-event heptathlon
  in place of the pentathlon, with day one containing the events-100m
  hurdles, shot, high jump, 200m and day two, the long jump, javelin
  and 800m. A scoring system is used to assign points to the results
  from each event and the winner is the woman who accumulates the
  most points over the two days. The event made its first Olympic
  appearance in 1984.

  In the 1988 Olympics held in Seoul, the heptathlon was won
  by one of the stars of women's athletics in the USA, Jackie Joyner-Kersee.
  The results for all 25 competitors are given here.

}
\source{

  D. J. Hand, F. Daly, A. D. Lunn, K. J. McConway and E. Ostrowski (1994).
  \emph{A Handbook of Small Datasets}, Chapman and Hall/CRC, London.

}
\examples{

  data("heptathlon", package = "HSAUR3")
  plot(heptathlon)

}
\keyword{datasets}

\name{birds}
\alias{birds}
\docType{data}
\title{
Birds in Paramo Vegetation Data
}
\description{
The data were originally derived from a study 
which investigated numbers of bird species in isolated
islands of paramo vegetation in the northern Andes.
}
\usage{data(birds)}
\format{
  A data frame with 14 observations on the following 5 variables.
  \describe{
    \item{\code{N}}{number of species}
    \item{\code{AR}}{area of island in thousands of square km}
    \item{\code{EL}}{elevation in thousands of m}
    \item{\code{Dec}}{distance from Ecuador in km}
    \item{\code{DNI}}{distance to the nearest island in km}
  }
}
\source{

   F. Vuilleumier (1970), Insular biogeography in continental regions. 
   I. The northern Andes of South America. \emph{The American Naturalist} 
   \bold{104}, 373--388

}
\keyword{datasets}

\name{BCG}
\alias{BCG}
\docType{data}
\title{ BCG Vaccine Data }
\description{

  A meta-analysis on the efficacy of BCG vaccination against tuberculosis (TB).

}
\usage{data("BCG")}
\format{
  A data frame with 13 observations on the following 7 variables.
  \describe{
    \item{\code{Study}}{an identifier of the study.}
    \item{\code{BCGTB}}{the number of subjects suffering from TB after a BCG
                        vaccination.}
    \item{\code{BCGVacc}}{the number of subjects with BCG vaccination.}
    \item{\code{NoVaccTB}}{the number of subjects suffering from TB without
                           BCG vaccination.}
    \item{\code{NoVacc}}{the total number of subjects without BCG
                         vaccination.}
    \item{\code{Latitude}}{geographic position of the place the study was
                           undertaken.}
    \item{\code{Year}}{the year the study was undertaken.}
  }
}
\details{

  Bacille Calmette Guerin (BCG) is the most widely used vaccination
  in the world. Developed in the 1930s and made of a live, weakened
  strain of Mycobacterium bovis, the BCG is the only vaccination
  available against tuberculosis today. Colditz et al. (1994)
  report  data from 13 clinical trials of BCG vaccine each investigating   
  its efficacy in the treatment of tuberculosis. The number of subjects 
  suffering from TB with or without BCG vaccination are 
  given here. 
  In addition, the data contains the values of two other 
  variables for each study, namely, the geographic latitude of
  the place where the study was undertaken and the year of publication.
  These two variables will be used to investigate and perhaps explain
  any heterogeneity among the studies.

}
\source{

  G. A. Colditz, T. F. Brewer, C. S. Berkey, M. E. Wilson,
  E. Burdick, H. V. Fineberg and F. Mosteller (1994),
  Efficacy of BCG vaccine in the prevention of tuberculosis.
  Meta-analysis of the published literature. 
  \emph{Journal of the American Medical Association}, \bold{271}(2),
  698--702.

}
\examples{

  data("BCG", package = "HSAUR3")

  ### sort studies w.r.t. sample size
  BCG <- BCG[order(rowSums(BCG[,2:5])),]

  ### to long format
  BCGlong <- with(BCG, data.frame(Freq = c(BCGTB, BCGVacc - BCGTB, 
                                           NoVaccTB, NoVacc - NoVaccTB),
                  infected = rep(rep(factor(c("yes", "no")), 
                                 rep(nrow(BCG), 2)), 2),
                  vaccined = rep(factor(c("yes", "no")), 
                                 rep(nrow(BCG) * 2, 2)),
                  study = rep(factor(Study, levels = as.character(Study)), 
                              4)))

  ### doubledecker plot
  library("vcd")
  doubledecker(xtabs(Freq ~ study + vaccined + infected, 
                     data = BCGlong))

}
\keyword{datasets}

\name{womensrole}
\alias{womensrole}
\docType{data}
\title{ Womens Role in Society }
\description{
  Data from a survey from 1974 / 1975 asking both female and male
  responders about their opinion on the statement: Women
  should take care of running their homes and leave running the   
  country up to men.

}
\usage{data("womensrole")}
\format{
  A data frame with 42 observations on the following 4 variables.
  \describe{
    \item{\code{education}}{years of education.}
    \item{\code{gender}}{a factor with levels \code{Male} and \code{Female}.}
    \item{\code{agree}}{number of subjects in agreement with the statement.}
    \item{\code{disagree}}{number of subjects in disagreement with the 
                           statement.}
  }
}
\details{

  The data are from Haberman (1973) and also given in
  Collett (2003). The questions here are whether the response of men and women 
  differ.

}
\source{

    S. J. Haberman (1973), The analysis of residuals in cross-classificed
    tables. \emph{Biometrics}, \bold{29}, 205--220.

    D. Collett (2003), \emph{Modelling Binary Data}. Chapman and Hall / CRC,
    London. 2nd edition.

}
\examples{

  data("womensrole", package = "HSAUR3")
  summary(subset(womensrole, gender == "Female"))
  summary(subset(womensrole, gender == "Male"))

}
\keyword{datasets}

\name{household}
\alias{household}
\docType{data}
\title{ Household Expenditure Data }
\description{

  Survey data on household expenditure on four commodity groups.

}
\usage{data("household")}
\format{
  A data frame with 40 observations on the following 5 variables.
  \describe{
    \item{\code{housing}}{expenditure on housing, including fuel and light.}
    \item{\code{food}}{expenditure on foodstuffs, including alcohol and tobacco.}
    \item{\code{goods}}{expenditure on other goods, including clothing, footwear and durable goods.}
    \item{\code{service}}{expenditure on services, including transport and vehicles.}
    \item{\code{gender}}{a factor with levels \code{female} and \code{male}}
  }
}
\details{

  The data are part of a data set collected from a survey of household expenditure 
  and give the expenditure of 20 single men and 20 single women on four commodity groups. 
  The units of expenditure are Hong Kong dollars,

}
\source{
  FIXME
}
\examples{

  data("household", package = "HSAUR3")

}
\keyword{datasets}

\name{waves}
\alias{waves}
\docType{data}
\title{ Electricity from Wave Power at Sea }
\description{
    Measurements of root mean square bending moment by two different mooring
    methods.
}
\usage{data("waves")}
\format{
  A data frame with 18 observations on the following 2 variables.
  \describe{
    \item{method1}{Root mean square bending moment in Newton metres, mooring method 1}
    \item{method2}{Root mean square bending moment in Newton metres, mooring method 2}
  }
}
\details{
In a design study for a device to generate electricity from
wave power at sea, experiments were carried out on scale models
in a wave tank to establish how the choice of mooring method
for the system affected the bending stress produced in part of
the device. The wave tank could simulate a wide range of sea
states and the model system was subjected to the same sample 
of sea states with each of two mooring methods, one of which    
was considerably cheaper than the other.
The question of interest is whether bending stress differs
for the two mooring methods.
}
\source{

  D. J. Hand, F. Daly, A. D. Lunn, K. J. McConway and E. Ostrowski (1994).
  \emph{A Handbook of Small Datasets}, Chapman and Hall/CRC, London.

}
\examples{

  data("waves", package = "HSAUR3")
  plot(method1 ~ method2, data = waves)

}
\keyword{datasets}

\name{men1500m}
\alias{men1500m}
\docType{data}
\title{ Winners of the Olympic Men's 1500m }
\description{

   The data gives the winners of the men's 1500m race 
   for the Olympic Games 1896 to 2004.
}
\usage{data("men1500m")}
\format{
  A data frame with 25 observations on the following 5 variables.
  \describe{
    \item{\code{year}}{the olympic year.}
    \item{\code{venue}}{city where the games took place.}
    \item{\code{winner}}{winner of men's 1500m race.}
    \item{\code{country}}{country the winner came from.}
    \item{\code{time}}{time (in seconds) of the winner.}
  }
}
\examples{

  data("men1500m", package = "HSAUR3")
  op <- par(las = 2)
  plot(time ~ year, data = men1500m, axes = FALSE)
  yrs <- seq(from = 1896, to = 2004, by = 4)
  axis(1, at = yrs, labels = yrs)
  axis(2)
  box()
  par(op)

}
\keyword{datasets}

\name{USstates}
\alias{USstates}
\docType{data}
\title{ US States }
\description{
  Socio-demographic variables for ten US states.
}
\usage{data(USstates)}
\format{
  A data frame with 10 observations on the following 7 variables.
  \describe{
    \item{\code{Population}}{population size divided by 1000}
    \item{\code{Income}}{average per capita income}
    \item{\code{Illiteracy}}{illiteracy rate (per cent population)}
    \item{\code{Life.Expectancy}}{life expectancy (years)}
    \item{\code{Homicide}}{homicide rate (per 1000)}
    \item{\code{Graduates}}{percentage of high school graduates}
    \item{\code{Freezing}}{average number of days per below freezing}
  }
}
\details{

The data set contains values of seven socio-demographic 
variables for ten states in the USA.

}
\keyword{datasets}

\name{Smoking_Wassink1945}
\alias{Smoking_Wassink1945}
\docType{data}
\title{
Smoking and Lung Cancer (III)
}
\description{
Number of smokers in a case-control study.
}
\usage{data(Smoking_Wassink1945)}
\format{
  The format is:
 table [1:4, 1:2] 6 18 36 74 19 36 25 20
 - attr(*, "dimnames")=List of 2
  ..$ Smoking  : chr [1:4] "Nonsmoker" "Moderate smoker" "Heavy smoker" "Very heavy smoker"
  ..$ Diagnosis: chr [1:2] "Lung cancer" "Healthy control"
}
\source{

  W. F. Wassink (1945), Ontstaansvoorwaarden voor Longkanker,
  \emph{Nederlands Tijdschrift voor Geneeskunde}, \bold{92},
  3732--3747

}
\references{

  Richard Doll (1998), Uncovering the effects of smoking:
  historical perspective. \emph{Statistical Methods in Medical Research},
  \bold{7}(87), 87-117

}
\keyword{datasets}

\name{aspirin}
\alias{aspirin}
\docType{data}
\title{ Aspirin Data }
\description{

  Efficacy of Aspirin in preventing death after a myocardial infarct.

}
\usage{data("aspirin")}
\format{
  A data frame with 7 observations on the following 4 variables.
  \describe{
    \item{\code{dp}}{number of deaths after placebo.}
    \item{\code{tp}}{total number subjects treated with placebo.}
    \item{\code{da}}{number of deaths after Aspirin.}
    \item{\code{ta}}{total number of subjects treated with Aspirin.}
  }
}
\details{

    The data were collected for a meta-analysis
    of the effectiveness of Aspirin (versus placebo) in preventing 
    death after a myocardial infarction. 

}
\source{

    J. L. Fleiss (1993), The statistical basis of meta-analysis.
    \emph{Statistical Methods in Medical Research} \bold{2}, 
    121--145.

}
\examples{

  data("aspirin", package = "HSAUR3")
  aspirin

}
\keyword{datasets}

\name{UStemp}
\alias{UStemp}
\docType{data}
\title{ Temperatures in 22 US cities
}
\description{
Lowest temperatures in Fahrenheit in 22 US cities in four months.
}
\usage{data(UStemp)}
\format{
  A data frame with 22 observations on the following 4 variables.
  \describe{
    \item{\code{January}}{lowest temperature in Fahrenheit}
    \item{\code{April}}{lowest temperature in Fahrenheit}
    \item{\code{July}}{lowest temperature in Fahrenheit}
    \item{\code{October}}{lowest temperature in Fahrenheit}
  }
}
\keyword{datasets}

\name{EFT}
\alias{EFT}
\docType{data}
\title{
Embedded Figures Test Data
}
\description{
Embedded figures test for 24 school children.
}
\usage{data(EFT)}
\format{
  A data frame with 24 observations on the following 3 variables.
  \describe{
    \item{\code{group}}{a factor with levels \code{row} \code{corner}}
    \item{\code{time}}{time to complete the pattern}
    \item{\code{EFT}}{Embedded Figures Test}
  }
}
\source{

  M. Aitkin, D. Anderson, B. Francis, and J. Hinde (1989),
  \emph{Statistical Modelling in GLIM}, Oxford University Press,
  New York, USA

}
\keyword{datasets}

\name{toothpaste}
\alias{toothpaste}
\docType{data}
\title{ Toothpaste Data }
\description{

    Meta-analysis of studies comparing two different toothpastes.

}
\usage{data("toothpaste")}
\format{
  A data frame with 9 observations on the following 7 variables.
  \describe{
    \item{\code{Study}}{the identifier of the study.}
    \item{\code{nA}}{number of subjects using toothpaste A.}
    \item{\code{meanA}}{mean DMFS index of subjects using toothpaste A.}
    \item{\code{sdA}}{standard deviation of DMFS index of subjects 
                      using toothpaste A.}
    \item{\code{nB}}{number of subjects using toothpaste B.}
    \item{\code{meanB}}{mean DMFS index of subjects using toothpaste B.}
    \item{\code{sdB}}{standard deviation of DMFS index of subjects 
                      using toothpaste B.}
  }
}
\details{

    The data are the results of nine randomised trials comparing
    two different toothpastes for the prevention of caries development.
    The outcomes in each trial was the change, from baseline, in
    the decayed, missing (due to caries) and filled surface dental
    index (DMFS).

}
\source{

    B. S. Everitt and A. Pickles (2000), 
    \emph{Statistical Aspects of the Design and Analysis of Clinical
    Trials}, Imperial College Press, London.

}
\examples{

  data("toothpaste", package = "HSAUR3")
  toothpaste

}
\keyword{datasets}

\name{pistonrings}
\alias{pistonrings}
\docType{data}
\title{ Piston Rings Failures }
\description{
  Number of failures of piston rings in three legs of four steam-driven
  compressors. 
}
\usage{data("pistonrings")}
\format{
A two-way classification, see \code{\link{table}}.
}
\details{

    The data are given in form of a \code{\link{table}}. 
    The table gives the number of piston-ring failures in each
    of three legs of four steam-driven compressors located in the
    same building. The compressors have identical design and are
    oriented in the same way. The question of interest is whether
    the two classification variables (compressor and leg) are independent.
}
\source{

    S. J. Haberman (1973), The analysis of residuals in cross-classificed
    tables. \emph{Biometrics} \bold{29}, 205--220.

}
\examples{
  
  data("pistonrings", package = "HSAUR3")
  mosaicplot(pistonrings)

}
\keyword{datasets}

\name{backpain}
\alias{backpain}
\docType{data}
\title{ Driving and Back Pain Data}
\description{

  A case-control study to investigate whether driving a car is a risk factor for 
  low back pain resulting from acute herniated lumbar intervertebral discs (AHLID).

}
\usage{data("backpain")}
\format{
  A data frame with 434 observations on the following 4 variables.
  \describe{
    \item{\code{ID}}{a factor which identifies matched pairs.}
    \item{\code{status}}{a factor with levels \code{case} and \code{control}.}
    \item{\code{driver}}{a factor with levels \code{no} and \code{yes}.}
    \item{\code{suburban}}{a factor with levels \code{no} and \code{yes} indicating a suburban resident.}
  }
}
\details{

These data arise from a study reported in Kelsey and Hardy (1975) which was designed to 
investigate whether driving a car is a risk factor for low back pain resulting from 
acute herniated lumbar intervertebral discs (AHLID). A case-control study was used 
with cases selected from people who had recently had X-rays taken of the lower back 
and had been diagnosed as having AHLID. The controls were taken from patients admitted 
to the same hospital as a case with a condition unrelated to the spine. Further matching 
was made on age and sex and a total of 217 matched pairs were recruited, consisting of 
89 female pairs and 128 male pairs.
}
\source{

  Jennifer L. Kelsey and Robert J. Hardy (1975), 
  Driving of Motor Vehicles as a Risk Factor for Acute
  Herniated Lumbar Intervertebral Disc. 
  \emph{American Journal of Epidemiology}, \bold{102}(1), 63--73.
}

\examples{

  data("backpain", package = "HSAUR3")
  summary(backpain)

}
\keyword{datasets}

\name{phosphate}
\alias{phosphate}
\docType{data}
\title{ Phosphate Level Data }
\description{

  Plasma inorganic phosphate levels from 33 subjects.

}
\usage{data("phosphate")}
\format{
  A data frame with 33 observations on the following 9 variables.
  \describe{
    \item{\code{group}}{a factor with levels \code{control} and
                        \code{obese}.}
    \item{\code{t0}}{baseline phosphate level},
    \item{\code{t0.5}}{phosphate level after 1/2 an hour.}
    \item{\code{t1}}{phosphate level after one an hour.}
    \item{\code{t1.5}}{phosphate level after 1 1/2 hours.}
    \item{\code{t2}}{phosphate level after two hours.}
    \item{\code{t3}}{phosphate level after three hours.}
    \item{\code{t4}}{phosphate level after four hours.}
    \item{\code{t5}}{phosphate level after five hours.}
  }
}
\source{

    C. S. Davis (2002), \emph{Statistical Methods for the Analysis 
    of Repeated Measurements}, Springer, New York.

}
\examples{

  data("phosphate", package = "HSAUR3")
  plot(t0 ~ group, data = phosphate)

}
\keyword{datasets}

\name{skulls}
\alias{skulls}
\docType{data}
\title{ Egyptian Skulls }
\description{

  Measurements made on Egyptian skulls from five epochs.

}
\usage{data("skulls")}
\format{
  A data frame with 150 observations on the following 5 variables.
  \describe{
    \item{\code{epoch}}{the epoch the skull as assigned to, 
                        a factor with levels \code{c4000BC} \code{c3300BC},
                        \code{c1850BC},  \code{c200BC}, and  \code{cAD150},
                        where the years are only given approximately, of
                        course.}
    \item{\code{mb}}{maximum breaths of the skull.}
    \item{\code{bh}}{basibregmatic heights of the skull.}
    \item{\code{bl}}{basialiveolar length of the skull.}
    \item{\code{nh}}{nasal heights of the skull.}
  }
}
\details{

  The question is whether the measurements change over time.
  Non-constant measurements of the skulls over time would indicate
  interbreeding with immigrant populations.

}
\source{

  D. J. Hand, F. Daly, A. D. Lunn, K. J. McConway and E. Ostrowski (1994).
  \emph{A Handbook of Small Datasets}, Chapman and Hall/CRC, London.

}
\examples{

  data("skulls", package = "HSAUR3")
  means <- tapply(1:nrow(skulls), skulls$epoch, function(i)
               apply(skulls[i,colnames(skulls)[-1]], 2, mean))
  means <- matrix(unlist(means), nrow = length(means), byrow = TRUE)
  colnames(means) <- colnames(skulls)[-1]
  rownames(means) <- levels(skulls$epoch)
  pairs(means,
      panel = function(x, y) {
          text(x, y, levels(skulls$epoch))
      })

}
\keyword{datasets}

\name{pottery}
\alias{pottery}
\docType{data}
\title{ Romano-British Pottery Data }
\description{

    Chemical composition of Romano-British pottery.

}
\usage{data("pottery")}
\format{
  A data frame with 45 observations on the following 9 chemicals.
  \describe{
    \item{Al2O3}{aluminium trioxide.}
    \item{Fe2O3}{iron trioxide.}
    \item{MgO}{magnesium oxide.}
    \item{CaO}{calcium oxide.}
    \item{Na2O}{natrium oxide.}
    \item{K2O}{calium oxide.}
    \item{TiO2}{titanium oxide.}
    \item{MnO}{mangan oxide.}
    \item{BaO}{barium oxide.}
    \item{kiln}{site at which the pottery was found.}
  }
}
\details{

  The data gives the chemical composition of 
  specimens of Romano-British pottery, determined by atomic 
  absorption spectrophotometry, for nine oxides.

}
\source{

    A. Tubb and N. J. Parker and G. Nickless (1980),
    The analysis of Romano-British pottery by atomic
    absorption spectrophotometry. \emph{Archaeometry}, \bold{22}, 
    153--171.

}
\examples{

  data("pottery", package = "HSAUR3")
  plot(pottery)

}
\keyword{datasets}

\name{CHFLS}
\alias{CHFLS}
\docType{data}
\title{ Chinese Health and Family Life Survey }
\description{

  The Chinese Health and Family Life Survey sampled
  $60$ villages and urban neighborhoods chosen in such a way
  as to represent the full geographical and socioeconomic
  range of contemporary China.

}
\usage{data("CHFLS")}
\format{
  A data frame with 1534 observations on the following 10 variables.
  \describe{
    \item{\code{R_region}}{a factor with levels \code{Coastal South}, \code{Coastal East},
          \code{Inlands}, \code{North}, \code{Northeast}, \code{Central West}.}
    \item{\code{R_age}}{age of the responding woman.}
    \item{\code{R_edu}}{education level of the responding woman, 
          an ordered factor with levels \code{Never attended school} < \code{Elementary school} 
          < \code{Junior high school} < \code{Senior high school} < \code{Junior college} 
          < \code{University}.}
    \item{\code{R_income}}{monthly income of the responding woman.}
    \item{\code{R_health}}{self-reported health status, an ordered factor with levels 
          \code{Poor} < \code{Not good} < \code{Fair} < \code{Good} < \code{Excellent}.}
    \item{\code{R_height}}{height of the responding woman.}
    \item{\code{R_happy}}{self-reportet happiness of the responding woman, 
          an ordered factor with levels \code{Very unhappy} < \code{Not too happy} < 
          \code{Somewhat happy} < \code{Very happy}.}
    \item{\code{A_height}}{height of the woman's partner.}
    \item{\code{A_edu}}{level of education of the woman's partner, an ordered factor with 
          levels \code{Never attended school} < \code{Elementary school} < 
          \code{Junior high school} < \code{Senior high school} < \code{Junior college} 
          < \code{University}.}
    \item{\code{A_income}}{montjly income of the woman's partner.}
  }
}
\details{

Contemporary China is on the leading edge of a sexual revolution, with tremendous
regional and generational differences that provide unparalleled natural experiments
for analysis of the antecedents and outcomes of sexual behavior. 
The Chinese Health and Family Life Study, conducted 1999--2000 as a collaborative
research project of the Universities of Chicago, Beijing, and North Carolina, provides
a baseline from which to anticipate and track future changes.
Specifically, this study produces a baseline set of results on sexual behavior
and disease patterns, using a nationally representative probability sample.   
The Chinese Health and Family Life Survey sampled
60 villages and urban neighborhoods chosen in such a way
as to represent the full geographical and socioeconomic   
range of contemporary China excluding Hong Kong and
Tibet. Eighty-three individuals were chosen at random for
each location from official registers of adults aged between
20 and 64 years to target a sample of 5000 individuals in
total. Here, we restrict our attention to women with current male partners
for whom no information was missing, leading to a sample
of 1534 women. The data have been extracted as given in the example section.

}
\source{

  \url{https://sscs.uchicago.edu}

}
\references{

  William L. Parish, Edward O. Laumann, Myron S. Cohen, Suiming Pan, Heyi Zheng, 
  Irving Hoffman, Tianfu Wang, and Kwai Hang Ng. (2003), Population-Based Study of 
  Chlamydial Infection in China: A Hidden Epidemic. \emph{Journal of the American
  Medican Association}, \bold{289}(10), 1265--1273.

}
\examples{

\dontrun{

    ### for a description see http://popcenter.uchicago.edu/data/chfls.shtml
    library("TH.data")
    load(file.path(path.package(package="TH.data"), "rda", "CHFLS.rda"))

    tmp <- chfls1[, c("REGION6", "ZJ05", "ZJ06", "A35", "ZJ07", "ZJ16M", "INCRM",
                      "JK01", "JK02", "JK20", "HY04", "HY07", "A02", "AGEGAPM", 
                      "A07M", "A14", "A21", "A22M", "A23", "AX16", "INCAM", "SEXNOW", "ZW04")]

     names(tmp) <- c("Region",
                "Rgender",               ### gender of respondent
                "Rage",                  ### age of respondent
		"RagestartA",		 ### age of respondent at beginning of relationship 
                                         ### with partner A
                "Redu",                  ### education of respondent
                "RincomeM",              ### rounded monthly income of respondent
		"RincomeComp",		 ### inputed monthly income of respondent
                "Rhealth",               ### health condition respondent
                "Rheight",               ### respondent's height
                "Rhappy",                ### respondent's happiness
                "Rmartial",              ### respondent's marital status
                "RhasA",                 ### R has current A partner
                "Agender",               ### gender of partner A
                "RAagegap",              ### age gap
                "RAstartage",            ### age at marriage
                "Aheight",               ### height of partner A
                "Aedu",                  ### education of partner A
                "AincomeM",              ### rounded partner A income
                "AincomeEst",            ### estimated partner A income
                "orgasm",                ### orgasm frequency
                "AincomeComp",           ### imputed partner A income
                "Rsexnow",               ### has sex last year
                "Rhomosexual")           ### R is homosexual

    ### code missing values
    tmp$AincomeM[tmp$AincomeM < 0] <- NA
    tmp$RincomeM[tmp$RincomeM < 0] <- NA
    tmp$Aheight[tmp$Aheight < 0] <- NA

    olevels <- c("never", "rarely", "sometimes", "often", "always")
    tmpA <- subset(tmp, Rgender == "female" & Rhomosexual != "yes" & orgasm \%in\% olevels)

    ### 1534 subjects
    dim(tmpA)

    CHFLS <- tmpA[, c("Region", "Rage", "Redu", "RincomeComp", "Rhealth", "Rheight", "Rhappy",
                      "Aheight", "Aedu", "AincomeComp")]
    names(CHFLS) <- c("R_region", "R_age", "R_edu", "R_income", "R_health", "R_height", 
                      "R_happy", "A_height", "A_edu", "A_income")
    levels(CHFLS$R_region) <- c("Coastal South", "Coastal Easth", "Inlands", "North", 
                                "Northeast", "Central West")

    CHFLS$R_edu <- ordered(as.character(CHFLS$R_edu), levels = c("no school", "primary", 
                           "low mid", "up mid", "j col", "univ/grad"))
    levels(CHFLS$R_edu) <- c("Never attended school", "Elementary school", "Junior high school", 
                             "Senior high school", "Junior college", "University")
    CHFLS$A_edu <- ordered(as.character(CHFLS$A_edu), levels = c("no school", "primary", 
                           "low mid", "up mid", "j col", "univ/grad"))
    levels(CHFLS$A_edu) <- c("Never attended school", "Elementary school", "Junior high school", 
                             "Senior high school", "Junior college", "University")

    CHFLS$R_health <- ordered(as.character(CHFLS$R_health), levels = c("poor", "not good", 
                              "fair", "good", "excellent"))
    levels(CHFLS$R_health) <- c("Poor", "Not good", "Fair", "Good", "Excellent")

    CHFLS$R_happy <- ordered(as.character(CHFLS$R_happy), levels = c("v unhappy", "not too", 
                             "relatively", "very"))
    levels(CHFLS$R_happy) <- c("Very unhappy", "Not too happy", "Relatively happy", "Very happy")
}

}
\keyword{datasets}

\name{water}
\alias{water}
\docType{data}
\title{ Mortality and Water Hardness }
\description{
    The mortality and drinking water hardness for 61 cities in England and
    Wales.
}
\usage{data("water")}
\format{
  A data frame with 61 observations on the following 4 variables.
  \describe{
    \item{location}{a factor with levels \code{North} and \code{South} indicating
                    whether the town is as north as Derby.}
    \item{town}{the name of the town.}
    \item{mortality}{averaged annual mortality per 100.000 male inhabitants.}
    \item{hardness}{calcium concentration (in parts per million).}
  }
}
\details{

The data were collected in an investigation
of environmental causes of disease. They show the annual mortality
per 100,000 for males, averaged over the years 1958-1964, and
the calcium concentration (in parts per million) in the drinking
water for 61 large towns in England and Wales. The higher the 
calcium concentration, the harder the water. Towns at least   
as far north as Derby are identified in the table. Here there
are several questions that might be of interest including, are
mortality and water hardness related, and do either or both variables
differ between northern and southern towns?

}
\source{

  D. J. Hand, F. Daly, A. D. Lunn, K. J. McConway and E. Ostrowski (1994).
  \emph{A Handbook of Small Datasets}, Chapman and Hall/CRC, London.

}
\examples{

  data("water", package = "HSAUR3")
  plot(mortality ~ hardness, data = water, 
       col = as.numeric(water$location))

}
\keyword{datasets}

\name{BtheB}
\alias{BtheB}
\docType{data}
\title{ Beat the Blues Data }
\description{

    Data from a clinical trial of an interactive multimedia program called 
    `Beat the Blues'.

}
\usage{data("BtheB")}
\format{
  A data frame with 100 observations of 100 patients 
  on the following 8 variables.
  \describe{
    \item{drug}{did the patient take anti-depressant
                drugs (\code{No} or \code{Yes}).}
    \item{length}{the length of the current episode of depression, 
                  a factor with levels \code{<6m} (less than six months) and 
                  \code{>6m} (more than six months).}
    \item{treatment}{treatment group, 
                     a factor with levels \code{TAU} (treatment as usual)
                     and  \code{BtheB} (Beat the Blues)}
    \item{bdi.pre}{Beck Depression Inventory
                   II before treatment.}
    \item{bdi.2m}{Beck Depression Inventory II after two months.}
    \item{bdi.3m}{Beck Depression Inventory II after one month follow-up.}
    \item{bdi.5m}{Beck Depression Inventory II after three months follow-up.}
    \item{bdi.8m}{Beck Depression Inventory II after six months follow-up.}
  }
}
\details{

Longitudinal data from a clinical trial of 
an interactive, multimedia program known as "Beat the Blues" 
designed to deliver cognitive behavioural therapy 
to depressed patients via a computer terminal. 
Patients with depression recruited in primary       
care were randomised to either the Beating the Blues program,       
or to "Treatment as Usual (TAU)". 

Note that the data are stored in the wide form, i.e., repeated measurments
are represented by additional columns in the data frame.

}
\source{

  J. Proudfoot, D. Goldberg, A. Mann, B. S. Everitt, I. Marks and J. A. Gray, (2003). 
  Computerized, interactive, multimedia cognitive-behavioural program for 
  anxiety and depression in general practice.
  \emph{Psychological Medicine}, \bold{33}(2), 217--227.

}
\examples{

  data("BtheB", package = "HSAUR3")
  layout(matrix(1:2, nrow = 1))   
  ylim <- range(BtheB[,grep("bdi", names(BtheB))], na.rm = TRUE)
  boxplot(subset(BtheB, treatment == "TAU")[,grep("bdi", names(BtheB))],
          main = "Treated as usual", ylab = "BDI", 
          xlab = "Time (in months)", names = c(0, 2, 3, 5, 8), ylim = ylim)
  boxplot(subset(BtheB, treatment == "BtheB")[,grep("bdi", names(BtheB))], 
          main = "Beat the Blues", ylab = "BDI", xlab = "Time (in months)",
          names = c(0, 2, 3, 5, 8), ylim = ylim)

}
\keyword{datasets}

\name{students}
\alias{students}
\docType{data}
\title{ Student Risk Taking }
\description{

 Students were administered two parallel forms of a test after a random
 assignment to three different treatments.

}
\usage{data("students")}
\format{
  A data frame with 35 observations on the following 3 variables.
  \describe{
    \item{\code{treatment}}{a factor with levels \code{AA}, \code{C}, and
                            \code{NC}.}
    \item{\code{low}}{the result of the first test.}
    \item{\code{high}}{the result of the second test.}
  }
}
\details{

The data arise from a large study of risk taking (Timm, 2002).
Students were randomly assigned to three different
treatments labelled AA, C and NC. Students were administered two   
parallel forms of a test called \code{low} and \code{high}. The aim is to 
carry out a test of the equality of the bivariate means of each treatment
population.

}
\source{

    N. H. Timm (2002), \emph{Applied Multivariate Analysis}. Springer, New York.

}
\examples{

  data("students", package = "HSAUR3")
  layout(matrix(1:2, ncol = 2))
  boxplot(low ~ treatment, data = students, ylab = "low")
  boxplot(high ~ treatment, data = students, ylab = "high")

}
\keyword{datasets}

\name{rearrests}
\alias{rearrests}
\docType{data}
\title{ Rearrests of Juvenile Felons }
\description{
  Rearrests of juventile felons by type of court in which they were tried.
}
\usage{data("rearrests")}
\format{
 A two-way classification, see \code{\link{table}}.
}
\details{

The data (taken from Agresti, 1996) arise from a 
sample of juveniles convicted of felony in Florida in 1987. Matched
pairs were formed using criteria such as age and the number of
previous offences. For each pair, one subject was handled in
the juvenile court and the other was transferred to the adult
court. Whether or not the juvenile was rearrested by the end 
of 1988 was then noted. Here the question of interest is whether
the true proportions rearrested were identical for the adult 
and juvenile court assignments?

}
\source{

    A. Agresti (1996). \emph{An Introduction to Categorical Data Analysis}. 
    Wiley, New York.

}
\examples{

  data("rearrests", package = "HSAUR3")
  rearrests

}
\keyword{datasets}

\name{schizophrenia2}
\alias{schizophrenia2}
\docType{data}
\title{ Schizophrenia Data }
\description{

  Though disorder and early onset of schizophrenia.

}
\usage{data("schizophrenia2")}
\format{
  A data frame with 220 observations on the following 4 variables.
  \describe{
    \item{\code{subject}}{the patient ID, a factor with levels \code{1} to
                          \code{44}.}
    \item{\code{onset}}{the time of onset of the disease, 
                        a factor with levels \code{< 20 yrs} and 
                        \code{> 20 yrs}.}
    \item{\code{disorder}}{whether thought disorder was \code{absent} or
                           \code{present}, the response variable.}
    \item{\code{month}}{month after hospitalisation.}
  }
}
\details{

    The data were collected in a follow-up study
    of women patients with schizophrenia. The binary response recorded
    at 0, 2, 6, 8 and 10 months after hospitalisation was thought
    disorder (absent or present). The single covariate is the factor 
    indicating whether a patient had suffered early or late
    onset of her condition (age of onset less than 20 years or
    age of onset 20 years or above). The question of interest is
    whether the course of the illness differs between patients with
    early and late onset?

}
\source{

    Davis (2002), \emph{Statistical Methods for the Analysis of 
    Repeated Measurements}, Springer, New York.

}
\examples{

  data("schizophrenia2", package = "HSAUR3")
  mosaicplot(xtabs( ~ onset + month + disorder, data = schizophrenia2))

}
\keyword{datasets}

\name{schizophrenia}
\alias{schizophrenia}
\docType{data}
\title{ Age of Onset of Schizophrenia Data }
\description{

  Data on sex differences in the age of onset of schizophrenia.

}
\usage{data("schizophrenia")}
\format{
  A data frame with 251 observations on the following 2 variables.
  \describe{
    \item{\code{age}}{age at the time of diagnosis.}
    \item{\code{gender}}{a factor with levels \code{female} and \code{male}}
  }
}
\details{

  A sex difference in the age of onset of schizophrenia was
  noted by Kraepelin (1919). Subsequently epidemiological studies
  of the disorder have consistently shown an earlier onset in men 
  than in women. One model that has been suggested to explain this
  observed difference is know as the subtype model
  which postulates two type of schizophrenia, one characterised by early
  onset, typical symptoms and poor premorbid competence, and the
  other by late onset, atypical symptoms, and good premorbid competence.
  The early onset type is assumed to be largely a disorder of men  
  and the late onset largely a disorder of women.

}
\source{

    E. Kraepelin (1919), \emph{Dementia Praecox and Paraphrenia}.
    Livingstone, Edinburgh.

}
\examples{

  data("schizophrenia", package = "HSAUR3")
  boxplot(age ~ gender, data = schizophrenia)

}
\keyword{datasets}

\name{polyps}
\alias{polyps}
\docType{data}
\title{ Familial Andenomatous Polyposis }
\description{

  Data from a placebo-controlled trial of a non-steroidal anti-inflammatory  
  drug in the treatment of familial andenomatous polyposis (FAP).

}
\usage{data("polyps")}
\format{
  A data frame with 20 observations on the following 3 variables.
  \describe{
    \item{\code{number}}{number of colonic polyps at 12 months.}
    \item{\code{treat}}{treatment arms of the trail, a factor with 
                        levels \code{placebo} and \code{drug}.}
    \item{\code{age}}{the age of the patient.}
  }
}
\details{

  Giardiello et al. (1993) and Piantadosi (1997) describe the
  results of a placebo-controlled trial of a non-steroidal anti-inflammatory  
  drug in the treatment of familial andenomatous polyposis (FAP). 
  The trial was halted after a planned interim analysis had suggested
  compelling evidence in favour of the treatment. 
  Here we are interested in assessing whether the number of colonic polyps at 
  12 months is related to treatment and age of patient.

}
\source{

  F. M. Giardiello, S. R. Hamilton, A. J. Krush, S. Piantadosi, L. M. Hylind,
  P. Celano, S. V. Booker, C. R. Robinson and G. J. A. Offerhaus (1993), 
  Treatment of colonic and rectal adenomas with sulindac 
  in familial adenomatous polyposis. \emph{New England Journal of Medicine},
  \bold{328}(18), 1313--1316.

  S. Piantadosi (1997), \emph{Clinical Trials: A Methodologic Perspective}.
  John Wiley & Sons, New York.

}
\examples{

  data("polyps", package = "HSAUR3")
  plot(number ~ age, data = polyps, pch = as.numeric(polyps$treat))
  legend(40, 40, legend = levels(polyps$treat), pch = 1:2, bty = "n")

}
\keyword{datasets}

\name{suicides2}
\alias{suicides2}
\docType{data}
\title{ Male Suicides Data }
\description{
  Number of suicides in different age groups and countries.
}
\usage{data("suicides2")}
\format{
  A data frame with 15 observations on the following 5 variables.
  \describe{
    \item{\code{A25.34}}{number of suicides (per 100000 males) between 25 and 34 years old.}
    \item{\code{A35.44}}{number of suicides (per 100000 males) between 35 and 44 years old.}
    \item{\code{A45.54}}{number of suicides (per 100000 males) between 45 and 54 years old.}
    \item{\code{A55.64}}{number of suicides (per 100000 males) between 55 and 64 years old.}
    \item{\code{A65.74}}{number of suicides (per 100000 males) between 65 and 74 years old.}
  }
}
\details{
  Each of the numbers gives the number of suicides per 100000 male inhabitants
  of the countries given by the row names.
}
\keyword{datasets}

\name{GHQ}
\alias{GHQ}
\docType{data}
\title{ General Health Questionnaire }
\description{
  Data from an psychiatric screening questionnaire 
}
\usage{data("GHQ")}
\format{
  A data frame with 22 observations on the following 4 variables.
  \describe{
    \item{\code{GHQ}}{the General Health Questionnaire score.}
    \item{\code{gender}}{a factor with levels \code{female} and \code{male}}
    \item{\code{cases}}{the number of diseased subjects.}
    \item{\code{non.cases}}{the number of healthy subjects.}
  }
}
\details{

  The data arise from a study of a psychiatric screening questionnaire 
  called the GHQ (General Health Questionnaire, see Goldberg, 1972). 
  Here the main question of interest is to see how caseness is related to 
  gender and GHQ score.

}
\source{

  D. Goldberg (1972). \emph{The Detection of Psychiatric Illness by Questionnaire}, 
  Oxford University Press, Oxford, UK.

}
\examples{

  data("GHQ", package = "HSAUR3")
  male <- subset(GHQ, gender == "male")
  female <- subset(GHQ, gender == "female")
  layout(matrix(1:2, ncol = 2))
  barplot(t(as.matrix(male[,c("cases", "non.cases")])), main = "Male", xlab = "GHC score")
  barplot(t(as.matrix(male[,c("cases", "non.cases")])), main = "Female", xlab = "GHC score")

}
\keyword{datasets}

\name{mastectomy}
\alias{mastectomy}
\docType{data}
\title{ Survival Times after Mastectomy of Breast Cancer Patients }
\description{
  Survival times in months after mastectomy of women with breast cancer. 
  The cancers are classified as having metastized or not based on a 
  histochemical marker. 
}
\usage{data("mastectomy")}
\format{
  A data frame with 42 observations on the following 3 variables.
  \describe{
    \item{time}{survival times in months.}
    \item{event}{a logical indicating if the event was observed (\code{TRUE})
                 or if the survival time was censored (\code{FALSE}).}
    \item{metastasized}{a factor at levels \code{yes} and \code{no}.}
  }
}
\source{

    B. S. Everitt and S. Rabe-Hesketh (2001),
    \emph{Analysing Medical Data using S-PLUS}, Springer, New York, USA.

}
\examples{

  data("mastectomy", package = "HSAUR3")
  table(mastectomy$metastasized)
}
\keyword{datasets}

\name{CYGOB1}
\alias{CYGOB1}
\docType{data}
\title{ CYG OB1 Star Cluster Data }
\description{

  Energy output and surface termperature for Star Cluster CYG OB1.

}
\usage{data("CYGOB1")}
\format{
  A data frame with 47 observations on the following 2 variables.
  \describe{
    \item{\code{logst}}{log survface termperature of the star.}
    \item{\code{logli}}{log light intensity of the star.}
  }
}
\details{

  The Hertzsprung-Russell (H-R) diagram forms the basis of
  the theory of stellar evolution. The diagram is essentially a 
  plot of the energy output of stars plotted against their surface
  temperature. Data from the H-R diagram of Star Cluster CYG OB1, 
  calibrated according to VanismaGreve1972 are given here.

}
\source{

    F. Vanisma and J. P. De Greve (1972), Close binary systems 
    before and after mass transfer. \emph{Astrophysics and Space Science},
    \bold{87}, 377--401.

    D. J. Hand, F. Daly, A. D. Lunn, K. J. McConway and E. Ostrowski (1994).
    \emph{A Handbook of Small Datasets}, Chapman and Hall/CRC, London.
  
}
\examples{

  data("CYGOB1", package = "HSAUR3")
  plot(logst ~ logli, data = CYGOB1)

}
\keyword{datasets}

\name{polyps3}
\alias{polyps3}
\docType{data}
\title{ Familial Andenomatous Polyposis }
\description{

  Data from a placebo-controlled trial of a non-steroidal anti-inflammatory
  drug in the treatment of familial andenomatous polyposis (FAP).

}
\usage{data("polyps3")}
\format{
  A data frame with 22 observations on the following 5 variables.
  \describe{
    \item{\code{gender}}{a factor with levels \code{female} and \code{male}.}
    \item{\code{treatment}}{a factor with levels \code{placebo} and \code{active}.}
    \item{\code{baseline}}{the baseline number of polyps.}
    \item{\code{age}}{the age of the patient.}
    \item{\code{number3m}}{the number of polyps after three month.}
  }
}
\details{

  The data arise from the same study as the \code{\link{polyps}} data. Here, 
  the number of polyps after three months are given.

}
\source{

  F. M. Giardiello, S. R. Hamilton, A. J. Krush, S. Piantadosi, L. M. Hylind,
  P. Celano, S. V. Booker, C. R. Robinson and G. J. A. Offerhaus (1993),
  Treatment of colonic and rectal adenomas with sulindac
  in familial adenomatous polyposis. \emph{New England Journal of Medicine},
  \bold{328}(18), 1313--1316.

  S. Piantadosi (1997), \emph{Clinical Trials: A Methodologic Perspective}.
  John Wiley & Sons, New York.

}
\examples{

  data("polyps3", package = "HSAUR3")
  plot(number3m ~ age, data = polyps3, pch = as.numeric(polyps3$treatment))
  legend("topright", legend = levels(polyps3$treatment), pch = 1:2, bty = "n")

}
\keyword{datasets}

\name{Smoking_SchairerSchoeniger1944}
\alias{Smoking_SchairerSchoeniger1944}
\docType{data}
\title{
Smoking and Lung Cancer (II)
}
\description{
Number of smokers in a case-control study.
}
\usage{data(Smoking_SchairerSchoeniger1944)}
\format{
  The format is:
 table [1:5, 1:7] 3 11 31 19 29 2 0 4 6 3 ...
 - attr(*, "dimnames")=List of 2
  ..$ Smoking  : chr [1:5] "Nonsmoker" "Moderate smoker" "Medium smoker" "Heavy smoker" ...
  ..$ Diagnosis: chr [1:7] "Lung cancer" "Lip cancer" "Throat cancer" "Stomach cancer" ...
}
\source{

  E. Schairer and E. Sch\"oninger (1944), Lungenkrebs und Tabakverbrauch,
  \emph{Zeitschrift fuer Krebsforschung}, \bold{54}(4), 261-269

}
\references{

  Richard Doll (1998), Uncovering the effects of smoking:
  historical perspective. \emph{Statistical Methods in Medical Research},
  \bold{7}(87), 87-117

}
\keyword{datasets}

\name{watervoles}
\alias{watervoles}
\docType{data}
\title{ Water Voles Data }
\description{

    Percentage incidence of the 13 characteristics of water voles in 14
    areas.

}
\usage{data("watervoles")}
\format{
  A dissimilarity matrix for the following 14 variables, i.e,
  areas:
  \code{Surrey},
  \code{Shropshire},
  \code{Yorkshire},
  \code{Perthshire},
  \code{Aberdeen},
  \code{Elean Gamhna},
  \code{Alps},
  \code{Yugoslavia},
  \code{Germany},
  \code{Norway},
  \code{Pyrenees I},
  \code{Pyrenees II},
  \code{North Spain}, and
  \code{South Spain}.
}
\details{

  Corbet et al. (1970) report a study of water voles (genus Arvicola)
  in which the aim was to compare British populations of these
  animals with those in Europe, to investigate whether more than
  one species might be present in Britain. The original data consisted
  of observations of the presence or absence of 13 characteristics
  in about 300 water vole skulls arising from six British populations
  and eight populations from the rest of Europe.
  The data are the percentage incidence of the 13 characteristics
  in each of the 14 samples of water vole skulls.

}
\source{

    G. B. Corbet, J. Cummins, S. R. Hedges, W. J. Krzanowski (1970),
    The taxonomic structure of British water voles, genus \emph{Arvicola}.
    \emph{Journal of Zoology}, \bold{61}, 301--316.

}
\examples{

  data("watervoles", package = "HSAUR3")
  watervoles

}
\keyword{datasets}
